unit AG32Form;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs, Math,
  ComCtrls, StdCtrls, Buttons, ExtCtrls, { AppEvnts, }
  Grids, Menus, ImgList, JPeg, PNGImage, ExtDlgs,Clipbrd,
  G32_Interface,
  GR32,GR32_Polygons,
  GR32_Layers, GR32_Blend,
  GR32_Transforms,  GR32_ByteMaps,
  GR32_Filters, AG32RotL,
  AG32NewI,
  AG32RGBA,
  GR32_Image, GR32_RangeBars;

type
  TG32Form = class(TForm)
    ImgView: TImgView32;
    MenuImageList: TImageList;
    PolyBitmapList: TBitmap32List;
    OpenPictureDialog1: TOpenPictureDialog;
    ImgViewMenu: TMainMenu;
    MenuItem1: TMenuItem;
    mnFileNew: TMenuItem;
    mnFileOpen: TMenuItem;
    mnLayers: TMenuItem;
    mnNewBitmapLayer: TMenuItem;
    mnNewBitmapRGBA: TMenuItem;
    mnNewCustomLayer: TMenuItem;
    mnSimpleDrawing: TMenuItem;
    mnMagnifier: TMenuItem;
    N4: TMenuItem;
    mnFlatten: TMenuItem;
    mnArrange: TMenuItem;
    mnBringFront: TMenuItem;
    mnSendBack: TMenuItem;
    MenuItem2: TMenuItem;
    mnLevelUp: TMenuItem;
    mnLevelDown: TMenuItem;
    N2: TMenuItem;
    mnScaled: TMenuItem;
    mnDelete: TMenuItem;
    mnSave: TMenuItem;
    Exit1: TMenuItem;
    Edit3: TMenuItem;
    mnCopy: TMenuItem;
    N1: TMenuItem;
    Paste1: TMenuItem;
    Help1: TMenuItem;
    HelpG321: TMenuItem;
    About1: TMenuItem;

    PageControl1: TPageControl;
    MagnifierTS: TTabSheet;
    SpriteTS: TTabSheet;
    Image32: TTabSheet;
    ImgView32: TTabSheet;
    Polygons: TTabSheet;
    NewLineBtn: TButton;
    Antialiase: TCheckBox;
    Label29: TLabel;
    LineAlpha: TScrollBar;
    Label30: TLabel;
    FillAlpha: TScrollBar;
    FillMode: TRadioGroup;
    OutlineThicknessLabel: TLabel;
    ThickOutline: TCheckBox;
    LineThickness: TScrollBar;
    SpritesClear: TButton;
    SpritesAdd: TButton;
    SpritesEdit: TEdit;
    Label32: TLabel;
    Label6: TLabel;
    pnlImage: TPanel;
    Label24: TLabel;
    ScaleCombo: TComboBox;
    ImageInterpolate: TCheckBox;
    rgStretchFilter: TRadioGroup;
    ScaleBar: TGaugeBar;
    Label9: TLabel;
    Angle: TGaugeBar;
    Label5: TLabel;
    PnlMagni: TPanel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    MagnOpacity: TGaugeBar;
    MagnMagnification: TGaugeBar;
    MagnRotation: TGaugeBar;
    MagnInterpolate: TCheckBox;
    GaugeBar3: TGaugeBar;
    Label3: TLabel;
    GaugeBar2: TGaugeBar;
    Label2: TLabel;
    GaugeBar1: TGaugeBar;
    Label1: TLabel;
    LayerScaledCB: TCheckBox;
    ColorDialog1: TColorDialog;
    FontDialog1: TFontDialog;
    LayerOpacity: TGaugeBar;
    LayerInterpolate: TCheckBox;
    Cropped: TCheckBox;
    LayerRescale: TButton;
    LayerResetScale: TButton;
    PolygonGoBtn: TSpeedButton;
    PCRG: TRadioGroup;
    PaletteCombo: TComboBox;
    Label8: TLabel;
    ByteNewBtn: TSpeedButton;
    ScrollBar1: TScrollBar;
    Label34: TLabel;
    Refresh1: TMenuItem;
    OpacRG: TRadioGroup;
    ResetImageBtn: TSpeedButton;
    RDSPatternRG: TRadioGroup;
    RDSBtn: TSpeedButton;
    RotZoom: TGaugeBar;
    Label4: TLabel;
    SetOuterColorBtn: TSpeedButton;
    MagnifierOnBtn: TSpeedButton;
    N3: TMenuItem;
    OnlyImage1: TMenuItem;
    Label18: TLabel;
    SavePictureDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    PolyAngle: TGaugeBar;
    Label7: TLabel;
    Contrast: TGaugeBar;
    Label10: TLabel;
    Panel3: TPanel;
    TabSheet1: TTabSheet;
    TextAARG: TRadioGroup;
    TextEdit: TEdit;
    TextSetBtn: TSpeedButton;
    TextFontBtn: TSpeedButton;
    trackAngle: TTrackBar;
    lbAngle: TLabel;
    trackXSkew: TTrackBar;
    lbXSkew: TLabel;
    trackYSkew: TTrackBar;
    lbYSkew: TLabel;
    trackXScale: TTrackBar;
    lbXScale: TLabel;
    trackYScale: TTrackBar;
    lbYScale: TLabel;
    Panel2: TPanel;
    cbFilling: TCheckBox;
    cbAntialising: TCheckBox;
    TextSetABtn: TSpeedButton;

    procedure FormCreate(Sender: TObject);
procedure RefreshAll;
    procedure FormShow(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure HelpG321Click(Sender: TObject);
    procedure About1Click(Sender: TObject);

    procedure AngleChange(Sender: TObject);
    procedure GaugeBar1Change(Sender: TObject);
    procedure GaugeBar2Change(Sender: TObject);
    procedure LayerScaledCBClick(Sender: TObject);
    procedure CroppedClick(Sender: TObject);
    procedure LayerInterpolateClick(Sender: TObject);
    procedure LayerRescaleClick(Sender: TObject);
    procedure LayerResetScaleClick(Sender: TObject);
    procedure MagnMagnificationChange(Sender: TObject);
    procedure LayerOpacityChange(Sender: TObject);
    procedure mnDeleteClick(Sender: TObject);
    procedure mnFileNewClick(Sender: TObject);
    procedure mnFileOpenClick(Sender: TObject);
    procedure mnMagnifierClick(Sender: TObject);
    procedure mnNewBitmapLayerClick(Sender: TObject);
    procedure mnNewBitmapRGBAClick(Sender: TObject);
    procedure mnBringFrontClick(Sender: TObject);
    procedure mnSimpleDrawingClick(Sender: TObject);
    procedure ScaleComboChange(Sender: TObject);
    procedure mnLayersClick(Sender: TObject);
    procedure mnArrangeClick(Sender: TObject);
    procedure mnScaledClick(Sender: TObject);
    procedure ImgViewMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
    procedure ImgViewMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer; Layer: TCustomLayer);
    procedure ImgViewMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);

    procedure ImgViewMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure ImgViewMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure ImgViewPaintStage(Sender: TObject; Buffer: TBitmap32;
      StageNum: Cardinal);
    procedure mnFlattenClick(Sender: TObject);
    procedure LineAlphaChange(Sender: TObject);
    procedure LineThicknessChange(Sender: TObject);
    procedure NewLineBtnClick(Sender: TObject);

    procedure PaletteComboChange(Sender: TObject);
    procedure ByteNewBtnClick(Sender: TObject);
    procedure ScaleBarChange(Sender: TObject);
    procedure mnCopyClick(Sender: TObject);
    procedure mnSaveClick(Sender: TObject);
    procedure PCRGClick(Sender: TObject);
    procedure SpritesAddClick(Sender: TObject);
    procedure SpritesClearClick(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure rgStretchFilterClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure TextAARGClick(Sender: TObject);
    procedure TextSetBtnClick(Sender: TObject);
    procedure TextFontBtnClick(Sender: TObject);
    procedure PolygonGoBtnClick(Sender: TObject);
    procedure PolyAngleChange(Sender: TObject);
procedure UpdateImage;
    procedure Paste1Click(Sender: TObject);
    procedure Refresh1Click(Sender: TObject);
    procedure ResetImageBtnClick(Sender: TObject);
    procedure RDSBtnClick(Sender: TObject);
    procedure RotZoomChange(Sender: TObject);
    procedure SetOuterColorBtnClick(Sender: TObject);
    procedure OnlyImage1Click(Sender: TObject);
{NEW TEXT}
    procedure trackAngleChange(Sender: TObject);
    procedure cbFillingClick(Sender: TObject);
    procedure cbAntialisingClick(Sender: TObject);
    procedure TextEditChange(Sender: TObject);
    procedure ImgViewResize(Sender: TObject);
procedure TextFormPaint;
    procedure TextSetABtnClick(Sender: TObject);
    procedure Panel2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    {ImgView}
    FSelection: TPositionedLayer;
    {Polygon}
    Polygon: TPolygon32;
    Outline: TPolygon32;
    PolygonGo,
    UseOutlinePoly: Boolean;
    LineSize: Double;

    { Private TEXT declarations }
    G32FileName,
    fText : string;
    fBuffer : tBitmap32Ex;
    fDrawingOptions : tPolygonDrawOptions;
    fAT : TAffineTransformation;
    {Was public}
      MouseX,MouseY:Integer;
    RotLX,RotLY:Integer;
    RotL: TRotLayer;    {RotateLayerTS}
        {ByteMaps}
    DataSet: TByteMap;
    palGrayscale: TPalette32;
    palGreens: TPalette32;
    palReds: TPalette32;
    palRainbow: TPalette32;
    OldMousePos: TPoint;
    SpritesActive, MagnifierOn,
    MouseDragging: Boolean;
    {Pixel Combine}
    PatCount: Integer;
    BmL: TBitmapLayer;
   {Sprites}
    Velocities: TArrayOfFloatPoint;
     {Render Text}
    AALevel: Integer;
    SetAText,    SetText: Boolean;
     {Image32}
    {Time: Double; }
    SrcBitmapHeight, SrcBitmapWidth: Integer;
    {New Polys}
    LastPoint: TFixedPoint;
    {IsDragging: Boolean;}
{    procedure RenderFittedText(fBuffer: tBitmap32Ex);  }
    {TEXT}
    procedure SetSelection(Value: TPositionedLayer);
    procedure WMEraseBkgnd(var Msg: TMessage); message WM_ERASEBKGND;
    {Polygon}
    procedure Build;
    procedure Draw;
  protected
    RBLayer: TRubberbandLayer;
    function CreatePositionedLayer: TPositionedLayer;
    procedure LayerMouseDown(Sender: TObject; Buttons: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure PaintMagnifierHandler(Sender: TObject; Buffer: TBitmap32);
    procedure PaintSimpleDrawingHandler(Sender: TObject; Buffer: TBitmap32);
    procedure RBResizing(Sender: TObject; const OldLocation: TFloatRect; var NewLocation: TFloatRect; DragState: TDragState; Shift: TShiftState);

        {Pixel Combine}
procedure PC_None(F: TColor32; var B: TColor32; M: TColor32);
    procedure PC_Add(F: TColor32; var B: TColor32; M: TColor32);
    procedure PC_Sub(F: TColor32; var B: TColor32; M: TColor32);
    procedure PC_Modulate(F: TColor32; var B: TColor32; M: TColor32);
    procedure PC_Min(F: TColor32; var B: TColor32; M: TColor32);
    procedure PC_Max(F: TColor32; var B: TColor32; M: TColor32);
    procedure PC_Pattern(F: TColor32; var B: TColor32; M: TColor32);
  public
    { Public declarations }

    procedure ScaleRot(Alpha: Double);{RotateExTS}
    procedure FillBitmap(B: TBitmap32; N: Integer);{RotateLayerTS}
procedure FillBitmapG(B: TBitmap32);
procedure FillBitmapS(B: TBitmap32);
        {ImageView}
    procedure CreateNewImage(AWidth, AHeight: Integer; FillColor: TColor32);
    procedure OpenImage(const FileName: string);
    property Selection: TPositionedLayer read FSelection write SetSelection;
        {ByteMaps}
    procedure GenPalettes;
    procedure GenSampleData(W, H: Integer);
    procedure PaintData;
   {Sprites}
    procedure IdleHandler(Sender: TObject; var Done: Boolean);
   {Lines}
    procedure Spiral(X, Y: Integer);

    { Public TEXT declarations }
    procedure UpdateOptions;
    procedure UpdateTransform;
  end;

var
  G32Form: TG32Form;

implementation

uses TongGlobals, TongsFrm, PicAbout;
{New Polys}
type
  TPolygonAccess = class(TPolygon32);

  procedure DrawPolyBevel(Bitmap: TBitmap32; Polygon: TPolygon32;
  Contrast: Integer = 50; LightPos: Integer = 135);
var
{  ContourCount, Contour: Integer;}
  C, E: Integer;
{  N: TFixedPoint;}
  Lx, Ly: Integer;

  procedure PaintEdge(const N, Dst: TFixedPoint);
  var
    DotProduct: Integer;
  begin
    with N do
      DotProduct := (X * Lx div 256 + Y * Ly div 256) div 256;
      DotProduct := DotProduct * Contrast div 100;

    if DotProduct >= 0 then
    begin
      if DotProduct > 255 then DotProduct := 255;
      Bitmap.PenColor := DotProduct shl 24;
    end
    else
    begin
      DotProduct := -DotProduct;
      if DotProduct > 255 then DotProduct := 255;
      Bitmap.PenColor := DotProduct shl 24 or $00FFFFFF;
    end;

    with Dst do Bitmap.LineToXS(X, Y);
  end;

begin
  Polygon.Normals := nil;
  TPolygonAccess(Polygon).BuildNormals;

  Lx := Round(256 * Cos(LightPos * 3.1415926535897 / 180));
  Ly := -Round(256 * Sin(LightPos * 3.1415926535897 / 180));

  with Polygon do
    for C := 0 to High(Normals) do
      if Length(Normals[C]) > 2 then
      begin
        with Points[C][0] do Bitmap.MoveToX(X, Y);
        for E := 0 to High(Points[C]) - 1 do
          PaintEdge(Normals[C][E], Points[C][E + 1]);

        if Closed then
          PaintEdge(Normals[C][High(Normals[C])], Points[C][0]);
      end;
end;
{New Polys}

{$R *.DFM}
(*************************************************************)
(*************************************************************)

(*************************************************************)
(*************************************************************)
procedure TG32Form.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  G32FormX := G32Form.left;
  G32FormY:= G32Form.top;
end;

procedure TG32Form.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TG32Form.FormDestroy(Sender: TObject);
begin
{ImageView}
  Selection := nil;
  RBLayer := nil;
  fBuffer.Free;
  fAT.Free;{Text}
   {Polygon}
  Outline.Free;
  Polygon.Free;
        {ByteMaps}
  DataSet.Free;
  PolyBitmapList.Bitmaps[0].Bitmap.Clear;
end;
(*************************************************************)
(*************************************************************)

(*************************************************************)
(*************************************************************)
procedure TG32Form.FormCreate(Sender: TObject);
begin
  with ImgView do
  begin
    Selection := nil;
    RBLayer := nil;
    Layers.Clear;
    Scale := 1;
  end;
  SrcBitmapHeight:=0;
  SrcBitmapWidth:=0;
  {text}
   MouseX:=10;
   MouseY:=10;
  SetText:=False;
  SetAText:=False;
  fBuffer := tBitmap32Ex.Create;
{ImageView}
  // by default, PST_CLEAR_BACKGND is executed at this stage,
  // which, in turn, calls ExecClearBackgnd method of ImgView.
  // Here I substitute PST_CLEAR_BACKGND with PST_CUSTOM,
  // so force ImgView to call the OnPaintStage event
  // instead of performing default action.
  with ImgView.PaintStages[0]^ do
  begin
    if Stage = PST_CLEAR_BACKGND then Stage := PST_CUSTOM;
  end;
  SpritesActive:=False;

 {Polygon}
  Polygon := TPolygon32.Create;
  PolygonGo:=False;
  MagnifierOn:=False;
  Randomize;
end;

procedure TG32Form.FormShow(Sender: TObject);
begin
  left := G32FormX;
  top := G32FormY;
{  showmessage('here');}
  PolyBitmapList.Bitmaps[0].Bitmap:=ImgView.Bitmap;
  {Text}
  fBuffer.SetSize(ImgView.Bitmap.Width,ImgView.Bitmap.Height );

        {ByteMaps}
  PaletteCombo.ItemIndex := 0;
  GenPalettes;
  DataSet := TByteMap.Create;
   {Sprites and GradLines}
  Application.OnIdle := IdleHandler;
  RefreshAll;
end;

procedure TG32Form.Refresh1Click(Sender: TObject);
begin
RefreshAll;
end;

procedure TG32Form.RefreshAll;
var
  I, J: Integer;{Pixel Combine}
begin
  ImgView.Layers.Clear;
  Velocities := nil;
  SpritesEdit.Text := '0 layers';
  SpritesActive:=False;
  SetText:=False;
  PolygonGo:=False;
  ImgView.Color := clWhite;
{  ImgView.SetupBitmap(True, clGray32); }
  ImgView.Bitmap.Draw(0, 0, PolyBitmapList.Bitmaps[0].Bitmap);
  with ImgView do
  begin
    Selection := nil;
    RBLayer := nil;
    Layers.Clear;
    Scale := 1;
  end;
  SrcBitmapHeight:=ImgView.Bitmap.Height;
  SrcBitmapWidth:=ImgView.Bitmap.Width;
  ImgView.Bitmap.Font := TextEdit.Font;
  fBuffer.Font := TextEdit.Font;
  fText := TextEdit.text;
{  UpdateOptions;}{NEW TEXT}
  UpdateOptions;
  fAT  := TAffineTransformation.Create;
  ImgView.Bitmap.OuterColor:=$00000000;
  {RotateExTS}
  ImgView.Bitmap.SetSize(PolyBitmapList.Bitmaps[0].Bitmap.Width,
                      PolyBitmapList.Bitmaps[0].Bitmap.Height);
  // erase the transparency of edge pixels
  SetBorderTransparent(PolyBitmapList.Bitmaps[0].Bitmap,
      Rect(0, 0, PolyBitmapList.Bitmaps[0].Bitmap.Width - 1,
                 PolyBitmapList.Bitmaps[0].Bitmap.Height - 1));
  // show the picture
  ScaleRot(0);{RotateExTS}
  {RotateLayerTS}
  RotLX:=(ImgView.Bitmap.Width div 2){128};
  RotLY:=(ImgView.Bitmap.Height div 2){96};
  RotL := TRotLayer.Create(ImgView.Layers);
  RotL.Bitmap := TBitmap32.Create;
  with RotL.Bitmap do
  begin
    BeginUpdate;
    SetSize(RotLX, RotLY);{100, 60);}
    RotL.BitmapCenter := FloatPoint(Width / 2, Height / 2);
    FillBitmap(RotL.Bitmap, 127);
    SetBorderTransparent(RotL.Bitmap, Rect(0, 0, Width - 1, Height - 1));
    DrawMode := dmBlend;
    StretchFilter := sfLinear;
    EndUpdate;
    Changed;
  end;
  RotL.Scaled := True;
{  RotL.Position := FloatPoint(100, 100);}
  RotL.Position := FloatPoint(0, 0);
        {Pixel Combine}
  BmL := TBitmapLayer.Create(ImgView.Layers);
  BmL.Bitmap.SetSize(ImgView.Bitmap.Width,ImgView.Bitmap.Height );
  BmL.Bitmap.DrawMode := dmCustom;
  BmL.Location := FloatRect(0,0,ImgView.Bitmap.Width-1,ImgView.Bitmap.Height-1);
{  ((ImgView.Width-ImgView.Bitmap.Width)div 2),
  ((ImgView.Width-ImgView.Bitmap.Width)div 2),
  ImgView.Bitmap.Width+((ImgView.Width-ImgView.Bitmap.Width)div 2) ,
  ImgView.Bitmap.Height+((ImgView.Width-ImgView.Bitmap.Width)div 2) );}
  for J := 0 to (ImgView.Bitmap.Height-1 ) do
    for I := 0 to (ImgView.Bitmap.Width-1 ) do
      BmL.Bitmap[I, J] :=
      Gray32(Round(((Sin(I / 10) + Sin(J / 10)) * 0.25 + 0.5) * 255));
  BmL.Bitmap.OnPixelCombine := PC_Modulate{nil}; // none by default
end;

procedure TG32Form.SetOuterColorBtnClick(Sender: TObject);
begin
  with ColorDialog1 do
  begin
    Color := ImgView.Bitmap.OuterColor;
    if Execute then ImgView.Bitmap.OuterColor := Color;
  end;{ImgView.Bitmap.OuterColor:=$00000000; }
end;

procedure TG32Form.IdleHandler(Sender: TObject; var Done: Boolean);
var
  R: TFloatRect;
{  R: TRect;  }
  I: Integer;
begin
If SpritesActive=True then
Begin
  if ImgView.Layers.Count = 0 then Exit;
  ImgView.BeginUpdate;
  for I := 0 to ImgView.Layers.Count - 1 do
  begin
    with TBitmapLayer(ImgView.Layers[I]) do
    begin
      Bitmap.MasterAlpha := (Bitmap.MasterAlpha + 1) mod 256;
      R := Location;
      with Velocities[I] do
      begin
        OffsetRectF(R, X, Y);
        X := X + (Random - 0.5) * 0.1;
        Y := Y + (Random - 0.5) * 0.1;
        if (R.Left < 0) and (X < 0) then X := 1;
        if (R.Top < 0) and (Y < 0) then Y := 1;
        if (R.Right > ImgView.Width) and (X > 0) then X := -1;
        if (R.Bottom > ImgView.Height) and (Y > 0) then Y := -1;
      end;
      Location := R;
    end;
  end;
  ImgView.EndUpdate;
  ImgView.Invalidate;
End;{Sprites}
end;


(*************************************************************)
(*************************************************************)
procedure TG32Form.WMEraseBkgnd(var Msg: TMessage);
begin
  // disable form background cleaning
    { Accelerate repainting of the form a little bit }
  Msg.Result := -1;
end;

procedure TG32Form.HelpG321Click(Sender: TObject);
begin
  Application.HelpContext(12000);
end;

procedure TG32Form.About1Click(Sender: TObject);
begin
  PicAboutBox.Init(7);
  PicAboutBox.ShowModal;
end;

procedure TG32Form.mnCopyClick(Sender: TObject);
begin
  Clipboard.Assign(ImgView.Bitmap);
    if Clipboard.HasFormat(CF_BITMAP) then
  begin
    Paste1.Enabled := True;
  end
  else begin
    Paste1.Enabled := False;
  end;
end;
procedure TG32Form.Paste1Click(Sender: TObject);
begin
 if Clipboard.HasFormat(CF_BITMAP) then
 { is there a bitmap on the Clipboard? }
 begin
   ImgView.Bitmap.Assign(Clipboard);
   RefreshAll;
 end;
end;
procedure TG32Form.mnSaveClick(Sender: TObject);
var  PNG: TPNGObject;
  Bitmap: TBitmap;
begin
  Application.ProcessMessages;
  if not ImgView.Bitmap.Empty then
  begin
  SavePictureDialog1.DefaultExt:='.png';
  SavePictureDialog1.InitialDir:=ImagePath;
  SavePictureDialog1.Filename:= ChangeFileExt(ImagePath+G32FileName,'.png');{ImagePath+TempName}
  If SavePictureDialog1.Execute then
  begin
  If (lowercase(ExtractFileExt(SavePictureDialog1.FileName))='.png') then
  begin
    PNG := TPNGObject.Create;
    Bitmap := TBitmap.Create;
    try
    Bitmap.Assign(ImgView.Bitmap);
    PNG.Assign(Bitmap);
    PNG.SaveToFile(ChangeFileExt(SavePictureDialog1.FileName, '.png'));
    finally
    Bitmap.Free;
    PNG.Free;
    end;
    {ImgView.Bitmap.SaveToFile(ChangeFileExt(SavePictureDialog1.FileName, '.png'));}
  end;
  end;
  end;
end;

//-----------------------------------------------------
{ImgView    G32NewImage   G32RGBALoader   }
//-----------------------------------------------------
{ ImgView }
procedure TG32Form.CreateNewImage(AWidth, AHeight: Integer; FillColor: TColor32);
begin
  with ImgView do
  begin
    Selection := nil;
    RBLayer := nil;
    Layers.Clear;
    Scale := 1;
    Bitmap.SetSize(AWidth, AHeight);
    Bitmap.Clear(FillColor);
    pnlImage.Visible := not Bitmap.Empty;
  end;
end;

function TG32Form.CreatePositionedLayer: TPositionedLayer;
var
  P: TPoint;
begin
  // get coordinates of the center of viewport
  with ImgView.GetViewportRect do
    P := ImgView.ControlToBitmap(Point((Right + Left) div 2, (Top + Bottom) div 2));

  Result := TPositionedLayer.Create(ImgView.Layers);
  Result.Location := FloatRect(P.X - 32, P.Y - 32, P.X + 32, P.Y + 32);
  Result.Scaled := True;
  Result.MouseEvents := True;
  Result.OnMouseDown := LayerMouseDown;
end;




procedure TG32Form.CroppedClick(Sender: TObject);
begin
  if Selection is TBitmapLayer then
    TBitmapLayer(Selection).Cropped := Cropped.Checked;
end;

procedure TG32Form.LayerInterpolateClick(Sender: TObject);
const
  STRETCH_FILTER: array [Boolean] of TStretchFilter = (sfNearest, sfLinear);
begin
  if Selection is TBitmapLayer then
  begin
    TBitmapLayer(Selection).Bitmap.StretchFilter := STRETCH_FILTER[LayerInterpolate.Checked];
  end;
end;

procedure TG32Form.LayerMouseDown(Sender: TObject; Buttons: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Sender <> nil then Selection := TPositionedLayer(Sender);
end;

procedure TG32Form.LayerRescaleClick(Sender: TObject);
var
  T: TBitmap32;
  DstRect: TRect;
begin
  // resize the layer's bitmap to the size of the layer
  if Selection is TBitmapLayer then
    with TBitmapLayer(Selection) do
    begin
      T := TBitmap32.Create;
      T.Assign(Bitmap);
      DstRect := MakeRect(Location);
      with DstRect{Rect(Location)} do
        Bitmap.SetSize(Right - Left, Bottom - Top);
      T.StretchFilter := sfLinear;
      T.DrawMode := dmOpaque;
      T.DrawTo(Bitmap, Rect(0, 0, Bitmap.Width, Bitmap.Height));
      T.Free;
      LayerResetScaleClick(Self);
    end;
end;


procedure TG32Form.LayerResetScaleClick(Sender: TObject);
var
  L: TFloatRect;
begin
  // resize the layer to the size of its bitmap
  if Selection is TBitmapLayer then
    with RBLayer, TBitmapLayer(Selection).Bitmap do
    begin
      L := Location;
      L.Right := L.Left + Width;
      L.Bottom := L.Top + Height;
      Location := L;
      Changed;
    end;
end;

procedure TG32Form.MagnMagnificationChange(Sender: TObject);
begin
  ImgView.Invalidate;
end;

procedure TG32Form.LayerOpacityChange(Sender: TObject);
begin
  if Selection is TBitmapLayer then
    TBitmapLayer(Selection).Bitmap.MasterAlpha :=
     LayerOpacity.Position
  else
  begin
    case OpacRG.ItemIndex of
    0:  RotL.Bitmap.MasterAlpha :=LayerOpacity.Position;
    1:  Bml.Bitmap.MasterAlpha :=LayerOpacity.Position;
    2:  ImgView.Bitmap.MasterAlpha :=LayerOpacity.Position;
    end;{case}
  end;
end;

procedure TG32Form.mnArrangeClick(Sender: TObject);
var
  B: Boolean;
begin
  B := Selection <> nil;
  mnBringFront.Enabled := B and (Selection.Index < ImgView.Layers.Count - 2);
  mnSendBack.Enabled := B and (Selection.Index > 0);
  mnLevelUp.Enabled := B and (Selection.Index < ImgView.Layers.Count - 2);
  mnLevelDown.Enabled := B and (Selection.Index > 0);
  mnScaled.Enabled := B;
  mnScaled.Checked := B and Selection.Scaled;
  mnDelete.Enabled := B;
end;

procedure TG32Form.mnDeleteClick(Sender: TObject);
var
  ALayer: TPositionedLayer;
begin
  if Selection <> nil then
  begin
    ALayer := Selection;
    Selection := nil;
    ALayer.Free;
  end;
end;

procedure TG32Form.mnFileNewClick(Sender: TObject);
begin
  G32NewImageForm:=TG32NewImageForm.Create(Application);
  try
  with G32NewImageForm do
  begin
    ShowModal;
    if ModalResult = mrOK then
    begin
      CreateNewImage(UpDown1.Position,
                     UpDown2.Position,
                     Color32(Panel1.Color));
      mnSave.Enabled := True;
      mnCopy.Enabled := True;
      RefreshAll;
    end;
  end;
  finally
    G32NewImageForm.Free;
  end;
end;

procedure TG32Form.mnFileOpenClick(Sender: TObject);
begin
If OpenWithPreview then
begin
  OpenPictureDialog1.InitialDir:=ImagePath;
 // OpenPictureDialog1.FileName:=TempName;
  with OpenPictureDialog1 do
    if Execute then OpenImage(FileName);
end else
begin
  OpenDialog1.Filter:=
  'All (*.png;*.jpg;*.jpeg;*.bmp;*.ico;*.emf;*.wmf)|*.png;*.jpg;*.jpeg;*.bmp;*.ico;*.emf;*.wmf'+
    '|Portable Network Graphics (*.png)|*.png|JPEG Image File (*.jpg)|*.jpg|JPEG Image File (*.jpeg)|*.jpeg|Bitmaps (*.bmp)|*.bmp|Icons (*.ico)|*.ico|Enhanced Metafiles (*.emf)|*.emf|Metafiles (*.wmf)|*.wmf|Morph List Text|*.mlt';
  OpenDialog1.InitialDir:=ImagePath;
  //OpenDialog1.FileName:=TempName;
  with OpenDialog1 do
    if Execute then OpenImage(FileName);
end;
end;

procedure TG32Form.OpenImage(const FileName: string);
var  {Bytemap}
  B: TBitmap32;
begin
  G32FileName:=FileName;
  with ImgView do
  try
    Selection := nil;
    RBLayer := nil;
    Layers.Clear;
    Scale := 1;
    Bitmap.LoadFromFile(FileName);
    SrcBitmapHeight:=Bitmap.Height;
    SrcBitmapWidth:=Bitmap.Width;
    PolyBitmapList.Bitmaps[0].Bitmap:=ImgView.Bitmap;    
RefreshAll;
    mnSave.Enabled := True;
    mnCopy.Enabled := True;
   {Bytemap}
   Application.ProcessMessages;
      { Create a temporary bitmap }
      B := TBitmap32.Create;
      try
        B.LoadFromFile(FileName);
        { Convert it to grayscale values and store it into the byte map }
        DataSet.ReadFrom(B, ctWeightedRGB);
      finally
        B.Free;
      end;
     { PaintData;
      mnSave.Enabled := True;
      mnCopy.Enabled := True;}
  finally
{    pnlImage.Visible := not Bitmap.Empty;}
  end;
end;

procedure TG32Form.mnLayersClick(Sender: TObject);
var
  B: Boolean;
begin
  B := not ImgView.Bitmap.Empty;
  mnNewBitmapLayer.Enabled := B;
  mnNewBitmapRGBA.Enabled := B;
  mnNewCustomLayer.Enabled := B;
  mnFlatten.Enabled := B and (ImgView.Layers.Count > 0);
end;



procedure TG32Form.mnMagnifierClick(Sender: TObject);
var
  L: TPositionedLayer;
begin
  MagnifierOn:=(not MagnifierOn);
  If MagnifierOn then
  begin
  L := CreatePositionedLayer;
  L.OnPaint := PaintMagnifierHandler;
  L.Tag := 2;
  Selection := L;
  MagnifierOn:=True;
  end;
end;

procedure TG32Form.mnNewBitmapLayerClick(Sender: TObject);
var
  B: TBitmapLayer;
  P: TPoint;
  W, H: Double;
begin
  with OpenPictureDialog1 do
    if Execute then
    begin
      B := TBitmapLayer.Create(ImgView.Layers);
      with B do
      try
        Bitmap.LoadFromFile(FileName);
        Bitmap.DrawMode := dmBlend;

        with ImgView.GetViewportRect do
          P := ImgView.ControlToBitmap(Point((Right + Left) div 2, (Top + Bottom) div 2));

        W := Bitmap.Width / 2;
        H := Bitmap.Height / 2;

        with ImgView.Bitmap do
          Location := FloatRect(P.X - W, P.Y - H, P.X + W, P.Y + H);

        Scaled := True;
        OnMouseDown := LayerMouseDown;
      except
        Free;
        raise;
      end;
      Selection := B;
    end;
end;


procedure TG32Form.mnNewBitmapRGBAClick(Sender: TObject);
var
  B: TBitmapLayer;
  P: TPoint;
  Tmp: TBitmap32;
  W, H: Double;
begin
  G32RGBALoaderForm:=TG32RGBALoaderForm.Create(Application);
  try
  with G32RGBALoaderForm do
  begin
    ImgRGB.Bitmap.Delete;
    ImgRGB.Scale := 1;
    ImgAlpha.Bitmap.Delete;
    ImgAlpha.Scale := 1;
    ShowModal;
    if (ModalResult = mrOK) and not ImgRGB.Bitmap.Empty then
    begin
      B := TBitmapLayer.Create(ImgView.Layers);
      B.Bitmap := ImgRGB.Bitmap;
      B.Bitmap.DrawMode := dmBlend;

      if not ImgAlpha.Bitmap.Empty then
      begin
        Tmp := TBitmap32.Create;
        try
          Tmp.SetSize(B.Bitmap.Width, B.Bitmap.Height);
          ImgAlpha.Bitmap.DrawTo(Tmp, Rect(0, 0, Tmp.Width, Tmp.Height));

          // combine Alpha into already loaded RGB colors
          IntensityToAlpha(B.Bitmap, Tmp);
        finally
          Tmp.Free;
        end;
        ImgAlpha.Bitmap.Delete;{me}
      end;

      with ImgView.GetViewportRect do
        P := ImgView.ControlToBitmap(Point((Right + Left) div 2, (Top + Bottom) div 2));

      with B do
      begin
        W := Bitmap.Width / 2;
        H := Bitmap.Height / 2;

        with ImgView.Bitmap do
          Location := FloatRect(P.X - W, P.Y - H, P.X + W, P.Y + H);

        Scaled := True;
        OnMouseDown := LayerMouseDown;
      end;
      Selection := B;
      ImgRGB.Bitmap.Delete;{me}
    end;{modaled}
  end;{with}
  finally
    G32RGBALoaderForm.Free;
  end;{try}
end;


procedure TG32Form.mnBringFrontClick(Sender: TObject);
begin
  // note that the top-most layer is occupied with the rubber-banding layer
  if Selection <> nil then
    case TMenuItem(Sender).Tag of
      1: // Bring to front, do not use BringToFront here, see note above
        Selection.Index := ImgView.Layers.Count - 2;
      2: Selection.SendToBack;
      3: Selection.Index := Selection.Index + 1; // up one level
      4: Selection.Index := Selection.Index - 1; // down one level
    end;
end;

procedure TG32Form.mnSimpleDrawingClick(Sender: TObject);
var
  L: TPositionedLayer;
begin
  L := CreatePositionedLayer;
  L.OnPaint := PaintSimpleDrawingHandler;
  L.Tag := 1;
  Selection := L;
end;


procedure TG32Form.PaintMagnifierHandler(Sender: TObject; Buffer: TBitmap32);
var
  Magnification, Rotation: Double;
  SrcRect: TFloatRect;
DstRect,  R: TRect;
  T: TAffineTransformation;
  B: TBitmap32;
  W2, H2: Double;
  I: Integer;
begin
  if Sender is TPositionedLayer then
    with TPositionedLayer(Sender) do
    begin
      Magnification := Power(10, (MagnMagnification.Position / 50));
      Rotation := -MagnRotation.Position;
DstRect := MakeRect(GetAdjustedLocation);
{      DstRect := GetAdjustedLocation;}
      R := MakeRect(GetAdjustedLocation);
{      Rect(DstRect);}
      B := TBitmap32.Create;
      try
        with R do
        begin
          B.SetSize(Right - Left, Bottom - Top);
          W2 := (Right - Left) / 2;
          H2 := (Bottom - Top) / 2;
        end;

{        SrcRect := DstRect;}
        with SrcRect do
        begin
          Left := (Left - H2);
          Right := (Right + H2);
          Top := (Top - W2);
          Bottom := (Bottom + W2);
        end;

        T := TAffineTransformation.Create;
        try
          T.SrcRect := SrcRect;
          T.Translate(-R.Left, -R.Top);

          T.Translate(-W2, -H2);
          T.Scale(Magnification, Magnification);
          T.Rotate(0, 0, Rotation);
          T.Translate(W2, H2);

          if MagnInterpolate.Checked then
          begin
            Buffer.BeginUpdate;
            Buffer.StretchFilter := sfLinear;
            Transform(B, Buffer, T);
            Buffer.StretchFilter := sfNearest;
            Buffer.EndUpdate;
          end
          else
             Transform(B, Buffer, T);

          B.ResetAlpha;
          B.DrawMode := dmBlend;
          B.MasterAlpha := MagnOpacity.Position;
          B.DrawTo(Buffer, R);

          // draw frame
          for I := 0 to 4 do
          begin
             with R do Buffer.RaiseRectTS(Left, Top, Right, Bottom, 35 - I * 8);
             InflateRect(R, -1, -1);
          end;
        finally
          T.Free;
        end;
      finally
        B.Free;
      end;
    end;
end;

procedure TG32Form.PaintSimpleDrawingHandler(Sender: TObject; Buffer: TBitmap32);
var
  Cx, Cy: Double;
  W2, H2: Double;
  I: Integer;
begin
  if Sender is TPositionedLayer then
    with TPositionedLayer(Sender).GetAdjustedLocation do
    begin
      W2 := (Right - Left) / 2;
      H2 := (Bottom - Top) / 2;
      Cx := Left + W2;
      Cy := Top + H2;
      Buffer.PenColor := clRed32;
      Buffer.MoveToF(Cx,Cy);
      for I := 0 to 240 do
      begin
        Buffer.LineToFS(Cx + W2 * I / 200 * Cos(I / 8), Cy + H2 * I / 200 * Sin(I / 8));
      end;
    end;
end;

procedure TG32Form.ScaleBarChange(Sender: TObject);
var
  NewScale: Double;
begin
  NewScale := Power(10, ScaleBar.Position / 100);
  ScaleBar.Repaint; // update the scale bar before the image is repainted
  ImgView.Scale := NewScale;
end;

procedure TG32Form.ScaleComboChange(Sender: TObject);
var
  S: string;
  I: Integer;
begin
  S := ScaleCombo.Text;
  S := StringReplace(S, '%', '', [rfReplaceAll]);
  S := StringReplace(S, ' ', '', [rfReplaceAll]);
  if S = '' then Exit;
  I := StrToIntDef(S, -1);
  if (I < 1) or (I > 2000) then I := Round(ImgView.Scale * 100)
  else ImgView.Scale := I / 100;
  ScaleCombo.Text := IntToStr(I) + '%';
  ScaleCombo.SelStart := Length(ScaleCombo.Text) - 1;
end;

procedure TG32Form.ImgViewMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
var
  s: Double;
begin
  s := ImgView.Scale / 1.1;
  if s < 0.2 then s := 0.2;
  ImgView.Scale := s;
  ScaleCombo.Text := IntToStr(Round(s * 100)) + '%';
end;

procedure TG32Form.ImgViewMouseWheelDown(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
var
  s: Double;
begin
  s := ImgView.Scale * 1.1;
  if s > 20 then s := 20;
  ImgView.Scale := s;
  ScaleCombo.Text := IntToStr(Round(s * 100)) + '%';
end;

procedure TG32Form.rgStretchFilterClick(Sender: TObject);
const
  SF_CONSTS: array [0..4] of TStretchFilter =
   (sfNearest, sfLinear, sfSpline, sfLanczos, sfMitchell);
    {(sfNearest, sfLinear, sfLinear2, sfSpline);}
begin
  ImgView.Bitmap.StretchFilter := SF_CONSTS[rgStretchFilter.ItemIndex];
end;

procedure TG32Form.SetSelection(Value: TPositionedLayer);
begin
  if Value <> FSelection then
  begin
    if RBLayer <> nil then
    begin
      RBLayer.ChildLayer := nil;
      RBLayer.LayerOptions := LOB_NO_UPDATE;
{      pnlBitmapLayer.Visible := False;}
{      pnlMagn.Visible := False;}
      ImgView.Invalidate;
    end;

    FSelection := Value;

    if Value <> nil then
    begin
      if RBLayer = nil then
      begin
        RBLayer := TRubberBandLayer.Create(ImgView.Layers);
        RBLayer.MinHeight := 1;
        RBLayer.MinWidth := 1;
      end
      else RBLayer.BringToFront;
      RBLayer.ChildLayer := Value;
      RBLayer.LayerOptions := LOB_VISIBLE or LOB_MOUSE_EVENTS or LOB_NO_UPDATE;
      RBLayer.OnResizing := RBResizing;

      if Value is TBitmapLayer then
        with TBitmapLayer(Value) do
        begin
{          pnlBitmapLayer.Visible := True;}
          LayerOpacity.Position := Bitmap.MasterAlpha;
          LayerInterpolate.Checked := Bitmap.StretchFilter = sfLinear;
        end
      else if Value.Tag = 2 then
      begin
        // tag = 2 for magnifiers
          MagnifierOn:=True;
{        pnlMagn.Visible := True;}
      end;
    end;
  end;
end;


procedure TG32Form.mnScaledClick(Sender: TObject);
begin
  if Selection <> nil then
     Selection.Scaled := not Selection.Scaled;
  RBLayer.Scaled := Selection.Scaled;
  mnScaled.Checked:= Selection.Scaled;
{  LayerScaledCB.Checked:= Selection.Scaled; }
end;


//-----------------------------------------------------
{RenderTextTS}
//-----------------------------------------------------
procedure TG32Form.TextAARGClick(Sender: TObject);
begin
  AALevel :=TextAARG.Itemindex;
end;

procedure TG32Form.Panel2Click(Sender: TObject);
begin
  ColorDialog1.Color:=Panel2.Color;
  if ColorDialog1.Execute  then
  begin
    Panel2.Color := ColorDialog1.Color;
    TextEdit.Font.Color := Color;
{    fBuffer.Font.Color :=TextEdit.Font.Color ;}
    Repaint;
  end;
end;

procedure TG32Form.TextSetBtnClick(Sender: TObject);
begin
  SetText:=(not SetText);
  TextSetBtn.Down:=SetText;
  If SetText then
  begin
  SetAText:=False;
  TextSetABtn.Down:=False;
  end;
end;

procedure TG32Form.TextFontBtnClick(Sender: TObject);
begin
  with FontDialog1 do
  begin
    Font := TextEdit.Font;
    if Execute then
    begin
    TextEdit.Font := Font;
    ImgView.Bitmap.Font := Font;
    fBuffer.Font := Font;
    Repaint;
    end;
  end;
end;

{NEW FONTS STUFF}
procedure TG32Form.TextSetABtnClick(Sender: TObject);
begin
  SetAText:=(not SetAText);
  TextSetABtn.Down:=SetAText;
  If SetAText then
  begin
  UpdateOptions;
  SetText:=False;
  TextSetBtn.Down:=False;
  end;
 {  ImgView.Bitmap.RenderText(X, Y, TextEdit.Text,
 TextAARG.Itemindex,TextEdit.Font.Color);}
end;

procedure TG32Form.trackAngleChange(Sender: TObject);
begin
  lbAngle.Caption := format('angle (%d)' ,[trackAngle.Position]);
  lbXSkew.Caption := format('xSkew (%8.2f)' ,[trackXSkew.Position/5]);
  lbYSkew.Caption := format('ySkew (%8.2f)' ,[trackYSkew.Position/5]);
  lbXScale.Caption := format('xScale (%8.2f)' ,[trackXScale.Position/5]);
  lbYScale.Caption := format('yScale (%8.2f)' ,[trackYScale.Position/5]);
  UpdateTransform;
  TextFormPaint;
end;

procedure TG32Form.UpdateTransform;
var
  DegAngle : integer;
  xSkew, ySkew : single;
  xScale, yScale : single;
begin
   fAT.Clear;
   fAT.Matrix[1, 1] := -1;
   xScale := trackXScale.Position/5;
   yScale := trackyScale.Position/5;
   fAT.Scale(xScale, yScale);
   xSkew := trackXSkew.Position/5;
   ySkew := trackYSkew.Position/5;
   fAT.Skew(xSkew, ySkew);
   DegAngle := trackAngle.Position;
   fAT.Rotate(0,0, DegAngle);
   fBuffer.SelectFontTransform(fAT.Matrix);
end;

procedure TG32Form.cbFillingClick(Sender: TObject);
begin
  UpdateOptions;
  TextFormPaint;
end;

procedure TG32Form.cbAntialisingClick(Sender: TObject);
begin
  UpdateOptions;
  TextFormPaint;
end;

procedure TG32Form.TextEditChange(Sender: TObject);
begin
  if fText <> TextEdit.text then
    begin
      fText := TextEdit.text;
      TextFormPaint;
    end;
end;

procedure TG32Form.UpdateOptions;
begin
  fDrawingOptions := 0;
  if cbAntialising.Checked then fDrawingOptions := pdoFloat;
  if cbFilling.Checked then fDrawingOptions := fDrawingOptions or pdoFilling;
end;

procedure TG32Form.TextFormPaint;
begin
If SetAText then
  begin
  fBuffer.BeginUpdate;
{  fBuffer.FillRect(0, 0, fBuffer.Width, fBuffer.Height, clBlack32);}
  ImgView.Bitmap.DrawTo(fBuffer, 0, 0);
{    fText:=TextEdit.Text; }
    fBuffer.RenderTextEx({MouseX,MouseY,}
                    Fixed(MouseX),
                    Fixed(MouseY),
                    fText,
                    Color32(Panel2.Color),
                    fDrawingOptions);

    fBuffer.EndUpdate;
    fBuffer.DrawTo({Canvas.Handle}ImgView.Bitmap, 0, 0);
  end;
end;

procedure TG32Form.ImgViewResize(Sender: TObject);
begin
  fBuffer.SetSize(ImgView.Width, ImgView.Height);
end;
(*
procedure TfmMain.btnDrawManyClick(Sender: TObject);
var
  i : integer;
begin
  fBuffer.FillRect(0, 0, fBuffer.Width, fBuffer.Height, clBlack32);
  Screen.Cursor := crHourGlass;
    for I := 0 to 100 do
      begin
      fBuffer.RenderTextEx(
        Fixed(Random(Width - 40)),
        Fixed(Random(Height - 40)),
        IntToStr(Random(100)),
        Color32(Random(255), Random(255), Random(255), Random(255)),
        fDrawningOptions);
     end;
  Screen.Cursor := crDefault;
  fBuffer.DrawTo(Canvas.Handle, 0, 0);
end;*)
//-----------------------------------------------------

//-----------------------------------------------------
procedure TG32Form.ImgViewMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
begin
  If SetText then
  begin
    ImgView.Bitmap.RenderText(X, Y, TextEdit.Text,
             TextAARG.Itemindex,
             Color32(TextEdit.Font.Color));
    ImgView.Update;
  end;
  If SetAText then
  begin
    MouseX:=X;
    MouseY:=Y;
{    Fixed(MouseX),
    Fixed(MouseY),}
    TextFormPaint; 
  end;
  if Layer = nil then
  begin
    Selection := nil;
    ReleaseCapture;
  end;
{Polygon}
If PolygonGo then
begin
  if Button = mbLeft then Polygon.Add(FixedPoint(X, Y))
  else Polygon.Clear;
  Build;
  Draw;
{
  if Button = mbLeft then
  begin
    LastPoint := FixedPoint(X, Y);
    P.Add(LastPoint);
    UpdateImage;
  end
  else
  begin
    P.NewLine;
  end;
  SetCaptureControl(nil);
}
end;
{Bytemaps  PAge}
  if ((Button = mbLeft) and (not MagnifierOn ))then
  begin
    OldMousePos := Point(X, Y);
    MouseDragging := True;
    ImgView.Cursor := crSizeAll;
  end
  else ReleaseCapture;
end;
{procedure TForm1.ImageResize(Sender: TObject);
begin
  Image.SetupBitmap;
  Build;
  Draw;
end;}
procedure TG32Form.ImgViewMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer; Layer: TCustomLayer);
begin
  if MouseDragging then
  begin
    ImgView.Scroll(OldMousePos.X - X, OldMousePos.Y - Y);
    OldMousePos := Point(X, Y);
    ImgView.Update;
  end;
end;

procedure TG32Form.ImgViewMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
begin
  if ((Button = mbLeft ) and (not MagnifierOn ))then
  begin
    MouseDragging := False;
    ImgView.Cursor := crDefault;
  end;
end;


procedure TG32Form.ImgViewPaintStage(Sender: TObject; Buffer: TBitmap32;
  StageNum: Cardinal);
const
  Colors: array [Boolean] of TColor32 = ($FFFFFFFF, $FFB0B0B0);
var
{  W: Integer;}
  I, J: Integer;
  P: PColor32;
  OddY: Integer;
begin
  with ImgView.Buffer do
  begin
    Clear;
    P := PixelPtr[0, 0];
    for J := 0 to Height - 1 do
    begin
      OddY := (J shr 3) and $1;
      for I := 0 to Width - 1 do
      begin
        P^ := Colors[(I shr 3) and $1 = OddY];
        Inc(P);
      end;
    end;
  end;
end;

procedure TG32Form.RBResizing(Sender: TObject;
  const OldLocation: TFloatRect; var NewLocation: TFloatRect;
  DragState: TDragState; Shift: TShiftState);
var
  w, h, cx, cy: Double;
  nw, nh{, r}: Double;
begin
  if DragState = dsMove then Exit; // we are interested only in scale operations
  if Shift = [] then Exit; // special processing is not required
  if ssCtrl in Shift then
  begin
    { make changes symmetrical }
    with OldLocation do
    begin
      cx := (Left + Right) / 2;
      cy := (Top + Bottom) / 2;
      w := Right - Left;
      h := Bottom - Top;
    end;
    with NewLocation do
    begin
      nw := w / 2;
      nh := h / 2;
      case DragState of
        dsSizeL: nw := cx - Left;
        dsSizeT: nh := cy - Top;
        dsSizeR: nw := Right - cx;
        dsSizeB: nh := Bottom - cy;
        dsSizeTL: begin nw := cx - Left; nh := cy - Top; end;
        dsSizeTR: begin nw := Right - cx; nh := cy - Top; end;
        dsSizeBL: begin nw := cx - Left; nh := Bottom - cy; end;
        dsSizeBR: begin nw := Right - cx; nh := Bottom - cy; end;
      end;
      if nw < 2 then nw := 2;
      if nh < 2 then nh := 2;
      Left := cx - nw;
      Right := cx + nw;
      Top := cy - nh;
      Bottom := cy + nh;
    end;
  end;
end;


procedure TG32Form.mnFlattenClick(Sender: TObject);
var
  B: TBitmap32;
  W, H: Integer;
begin
  { deselect everything }
  Selection := nil;
  W := ImgView.Bitmap.Width;
  H := ImgView.Bitmap.Height;
  { Create a new bitmap to store a flattened image }
  B := TBitmap32.Create;
  try
    B.SetSize(W, H);
    ImgView.PaintTo(B, Rect(0, 0, W, H));

    { destroy all the layers of the original image... }
    ImgView.Layers.Clear;
    RBLayer := nil; // note that RBLayer reference is destroyed here as well.
                    // The rubber band will be recreated during the next
                    // SetSelection call. Alternatively, you can delete
                    // all the layers except the rubber band.
    { ...and overwrite it with the flattened one }
    ImgView.Bitmap := B;
  finally
    B.Free;
  end;
end;



//-----------------------------------------------------
 {ImgView }
//-----------------------------------------------------

(******************************************************)
(******************************************************)
//-----------------------------------------------------
{RotateTS}
//-----------------------------------------------------
procedure TG32Form.ScaleRot(Alpha: Double);
var
  SrcR: Integer;
  SrcB: Integer;
  T: TAffineTransformation;
  Sx, Sy, Scale: Double;
begin
  SrcR := SrcBitmapWidth - 1;
  SrcB := SrcBitmapHeight - 1;
  T := TAffineTransformation.Create;
  T.SrcRect := FloatRect(0, 0, SrcR + 1, SrcB + 1);
  try
    // shift the origin
    T.Clear;
    // move the origin to a center for scaling and rotation
    T.Translate(-SrcR / 2, -SrcB / 2);
    T.Rotate(0, 0, Alpha);
    Alpha := Alpha * 3.14159265358979 / 180;

    // get the width and height of rotated image (without scaling)
    Sx := Abs(SrcR * Cos(Alpha)) + Abs(SrcB * Sin(Alpha));
    Sy := Abs(SrcR * Sin(Alpha)) + Abs(SrcB * Cos(Alpha));

    // calculate a new scale so that the image fits in original boundaries
    Sx := SrcBitmapWidth / Sx;
    Sy := SrcBitmapHeight / Sy;
    scale := Min(Sx, Sy);

    T.Scale(Scale, Scale);

    // move the origin back
    T.Translate(SrcR / 2, SrcB / 2);

    // transform the bitmap
{   PolyBitmapList.Bitmaps[0].Bitmap:=ImgView.Bitmap}

    ImgView.Bitmap.BeginUpdate;
    ImgView.Bitmap.Clear(clGray32);
    Transform(ImgView.Bitmap, PolyBitmapList.Bitmaps[0].Bitmap, T);
    ImgView.Bitmap.EndUpdate;
    ImgView.Repaint;
  finally
    T.Free;
  end;
end;

procedure TG32Form.AngleChange(Sender: TObject);
begin
  ScaleRot(-Angle.Position);
end;
//-----------------------------------------------------
{ end RotateTS}
//-----------------------------------------------------


//-----------------------------------------------------
{RotateLayerTS  on Layer page}
procedure TG32Form.RDSBtnClick(Sender: TObject);
begin
Case RDSPatternRG.ItemIndex of
0: If OpacRG.ItemIndex=0 then
      FillBitmapG(RotL.Bitmap)
      else FillBitmapG(BmL.Bitmap);
1: If OpacRG.ItemIndex=0 then
      FillBitmap(RotL.Bitmap,Random(127))
      else FillBitmap(BmL.Bitmap,Random(127));
2: If OpacRG.ItemIndex=0 then
      FillBitmapS(RotL.Bitmap)
      else FillBitmapS(BmL.Bitmap);
end;{case}
{If OpacRG.ItemIndex=0 then
      RotL.Bitmap.Invalidate
      else BmL.Bitmap.Invalidate;}
end;
//-----------------------------------------------------
procedure TG32Form.FillBitmap(B: TBitmap32; N: Integer);
var
  X, Y: Integer;
begin
  for Y := 0 to B.Height - 1 do
    for X := 0 to B.Width - 1 do
      B[X, Y] := Color32(Random(127) + N,
                        Random(127) + N,
                        Random(127) + N,
                        Random(127) + N);
end;
procedure TG32Form.FillBitmapG(B: TBitmap32);
var
  X, Y: Integer;
begin
  for Y := 0 to B.Height - 1 do
    for X := 0 to B.Width - 1 do
      B[X, Y] :=
      Gray32(Round(((Sin(X / 10) + Sin(Y / 10))
              * 0.25 + 0.5)
               * 255));
{  for J := 0 to (ImgView.Bitmap.Width )-1 do
    for I := 0 to (ImgView.Bitmap.Height )-1 do
      BmL.Bitmap[I, J] :=
      Gray32(Round(((Sin(I / 10) + Sin(J / 10)) * 0.25 + 0.5) * 255));}
end;

procedure TG32Form.FillBitmapS(B: TBitmap32);
var
  i, j: Integer;
  function Clamp(FloatVal: Extended): Byte;
  begin
    if FloatVal <= 0 then Result := 0
    else if FloatVal >= 1 then Result := 255
    else Result := Round(FloatVal * 255);
  end;
begin
  for j := 0 to B.Height - 1 do
    for i := 0 to B.Width - 1 do
      B[i, j] :=
        Clamp(0.5 +
        0.5 * Sin(i + Random(10)) / 100 +
        0.5 * Cos(j / 11) +
        0.2 * Sin((i + j) / 3));
end;
procedure TG32Form.GenSampleData(W, H: Integer);
var
  i, j: Integer;
  function Clamp(FloatVal: Extended): Byte;
  begin
    if FloatVal <= 0 then Result := 0
    else if FloatVal >= 1 then Result := 255
    else Result := Round(FloatVal * 255);
  end;
begin
  DataSet.SetSize(W, H);
  for j := 0 to H - 1 do
    for i := 0 to W - 1 do
    begin
      // just some noise
      DataSet[i, j] := Clamp(0.5 +
        0.5 * Sin(i + Random(10)) / 100 +
        0.5 * Cos(j / 11) +
        0.2 * Sin((i + j) / 3));
    end;
end;



procedure TG32Form.RotZoomChange(Sender: TObject);
var
{  Tempx, Tempy,     }
  NewScale: Double;
begin
  NewScale := Power(10, RotZoom.Position / 100);
  RotZoom.Repaint; // update the scale bar before the image is repainted
  with RotL.Bitmap do
  begin
    BeginUpdate;
{    Tempx:=RotL.Bitmap.Width;
    Tempy:=RotL.Bitmap.Height;}
    RotL.Bitmap.Width:=Round(RotLX* NewScale);
    RotL.Bitmap.Height:=Round(RotLY* NewScale);
    {SetSize(100, 60);}
    RotL.BitmapCenter := FloatPoint(Width / 2, Height / 2);
    Case RDSPatternRG.ItemIndex of
     0: FillBitmapG(RotL.Bitmap);
     1: FillBitmap(RotL.Bitmap,Random(127));
     2: FillBitmapS(RotL.Bitmap);
    end;{case}
    EndUpdate;
    Changed;
 end;
end;

procedure TG32Form.GaugeBar1Change(Sender: TObject);
begin
  RotL.Angle := GaugeBar1.Position;
end;

procedure TG32Form.GaugeBar2Change(Sender: TObject);
var
  P: TFloatPoint;
begin
  P := RotL.Position;
  P.X := GaugeBar2.Position;
  P.Y := GaugeBar3.Position;
  RotL.Position := P;
end;

procedure TG32Form.LayerScaledCBClick(Sender: TObject);
begin
  RotL.Scaled := not RotL.Scaled;
  LayerScaledCB.Checked:=  RotL.Scaled;
end;
//-----------------------------------------------------
{end of RotateLayerTS}
//-----------------------------------------------------


//-----------------------------------------------------
{PolygonsTS }
//-----------------------------------------------------
procedure TG32Form.PolygonGoBtnClick(Sender: TObject);
begin
  PolygonGo:=(not PolygonGo);
  PolygonGoBtn.Down:=PolygonGo;
 NewLineBtn.Enabled:=PolygonGo;
 Antialiase.Enabled:=PolygonGo;
 LineAlpha.Enabled:=PolygonGo;
 FillAlpha.Enabled:=PolygonGo;
 FillMode.Enabled:=PolygonGo;
 ThickOutline.Enabled:=PolygonGo;
 LineThickness.Enabled:=PolygonGo;
 Contrast.Enabled:=PolygonGo;
 PolyAngle.Enabled:=PolygonGo;
If PolygonGo then
   PolyBitmapList.Bitmaps[0].Bitmap:=ImgView.Bitmap
   else
   ImgView.Bitmap.Draw(0, 0, PolyBitmapList.Bitmaps[0].Bitmap);
end;

procedure TG32Form.Build;
var
  TmpPoly: TPolygon32;
begin
  Outline.Free;
  Outline := nil;
  if UseOutlinePoly then
  begin
    TmpPoly := Polygon.Outline;
    Outline := TmpPoly.Grow(Fixed(LineSize / 2), 0.5);
    Outline.FillMode := pfWinding;
    TmpPoly.Free;
  end;
  if UseOutlinePoly then
    OutlineThicknessLabel.Caption := Format('(%.1f)', [LineSize])
  else
    OutlineThicknessLabel.Caption := '(1)';
end;

procedure TG32Form.Draw;
begin
  ImgView.Bitmap.BeginUpdate;
  ImgView.Bitmap.Clear(clWhite32);
  ImgView.Bitmap.Draw(0, 0, PolyBitmapList.Bitmaps[0].Bitmap);
  Polygon.Antialiased := Antialiase.Checked;
  if UseOutlinePoly then Outline.Antialiased := Antialiase.Checked;
  if FillMode.ItemIndex = 0 then Polygon.FillMode := pfAlternate else Polygon.FillMode := pfWinding;

  Polygon.DrawFill(ImgView.Bitmap, SetAlpha(clGreen32, FillAlpha.Position));

  if UseOutlinePoly then
    Outline.DrawFill(ImgView.Bitmap, SetAlpha(clBlack32, LineAlpha.Position))
  else
    Polygon.DrawEdge(ImgView.Bitmap, SetAlpha(clBlack32, LineAlpha.Position));

  ImgView.Bitmap.EndUpdate;
  ImgView.Bitmap.Changed;
  ImgView.Refresh; // force repaint
end;


procedure TG32Form.LineAlphaChange(Sender: TObject);
begin
  Draw;
end;

procedure TG32Form.LineThicknessChange(Sender: TObject);
begin
  UseOutlinePoly := ThickOutline.Checked;
  LineSize := LineThickness.Position / 10;
  Build;
  Draw;
end;

procedure TG32Form.NewLineBtnClick(Sender: TObject);
begin
  Polygon.NewLine;
end;
{ADDED polylines }
procedure TG32Form.PolyAngleChange(Sender: TObject);
begin
  UpdateImage;
end;
procedure TG32Form.UpdateImage;
begin
  ImgView.Bitmap.Clear(clGray32);
  DrawPolyBevel(ImgView.Bitmap, Polygon,
                Round(Contrast.Position),
                 -Round(Angle.Position));  // SetPixelXS  SetPixelTS
  with LastPoint do ImgView.Bitmap.SetPixelTS(X, Y, clLime32);
end;
//-----------------------------------------------------
{ByteMaps  on Sprite page}
//-----------------------------------------------------
procedure TG32Form.GenPalettes;
var
  i: Integer;
  f: Double;
begin
  for i := 0 to 255 do
  begin
    f := i / 255;
    palGrayscale[i] := HSLtoRGB(0, 0, f * 0.9 + 0.1);
    palGreens[i] := HSLtoRGB(f * 0.4, 0.5, f * 0.4 + 0.2);
    palReds[i] := HSLtoRGB(0.8 + f * 0.3 , 0.7 + f * 0.3, f * 0.85 + 0.1);
    palRainbow[i] := HSLtoRGB(0.66 - f * 0.7, 1, 0.4 + 0.4 * f);
  end;
end;

procedure TG32Form.PaintData;
var
  P: PPalette32;
begin
  case PaletteCombo.ItemIndex of
    0: P := @palGrayScale;
    1: P := @palGreens;
    2: P := @palReds;
  else
    P := @palRainbow;
  end;
  DataSet.WriteTo(ImgView.Bitmap, P^);
end;

procedure TG32Form.PaletteComboChange(Sender: TObject);
begin
  PaintData;
end;

procedure TG32Form.ByteNewBtnClick(Sender: TObject);
begin
  DataSet.ReadFrom(ImgView.Bitmap{B}, ctWeightedRGB);
{  GenSampleData(ImgView.Bitmap.Width,ImgView.Bitmap.Height);}
  PaintData;
end;
//-----------------------------------------------------
{end of Bytemaps }
//-----------------------------------------------------

//-----------------------------------------------------
{PixelCombineTS on Layer page}
//-----------------------------------------------------
procedure TG32Form.PC_None(F: TColor32; var B: TColor32; M: TColor32);
begin
  B := F;
end;
procedure TG32Form.PC_Add(F: TColor32; var B: TColor32; M: TColor32);
begin
  B := ColorAdd(F, B);
end;
procedure TG32Form.PC_Max(F: TColor32; var B: TColor32; M: TColor32);
begin
  B := ColorMax(F, B);
end;
procedure TG32Form.PC_Min(F: TColor32; var B: TColor32; M: TColor32);
begin
  B := ColorMin(F, B);
end;
procedure TG32Form.PC_Modulate(F: TColor32; var B: TColor32; M: TColor32);
begin
  B := ColorModulate(F, B);
end;
procedure TG32Form.PC_Pattern(F: TColor32; var B: TColor32; M: TColor32);
begin
  PatCount := 1 - PatCount;
  if PatCount = 0 then B := F;
end;
procedure TG32Form.PC_Sub(F: TColor32; var B: TColor32; M: TColor32);
begin
  B := ColorSub(F, B);
end;
procedure TG32Form.PCRGClick(Sender: TObject);
begin
  case PCRG.ItemIndex of
{    0:BmL.Bitmap.OnPixelCombine := PC_None}{? hide layer}
    0: BmL.Bitmap.MasterAlpha:=0;{Visible:=False;}
    1: BmL.Bitmap.OnPixelCombine := nil;
    2: BmL.Bitmap.OnPixelCombine := PC_Sub;
    3: BmL.Bitmap.OnPixelCombine := PC_Add;
    4: BmL.Bitmap.OnPixelCombine := PC_Min;
    5: BmL.Bitmap.OnPixelCombine := PC_Max;
    6: BmL.Bitmap.OnPixelCombine := PC_Pattern;
    7: BmL.Bitmap.OnPixelCombine := PC_Modulate;
  end;
  BmL.Bitmap.Changed;
end;
{end Pixel Combine}

//-----------------------------------------------------
{LinesTS  on Sprite page}
//-----------------------------------------------------
procedure TG32Form.ScrollBar1Change(Sender: TObject);
var
  Step: Double;
begin
  Step := ScrollBar1.Position / 100;
  with ImgView.Bitmap do
  begin
    BeginUpdate;
    Clear(clBlack32);
    SetStipple([clWhite32, clWhite32, clWhite32, clWhite32, 0, 0, 0, 0]);
    StippleStep := Step;
    Spiral(50, 50);

    SetStipple([clWhite32, $00FFFFFF]);
    Spiral(150, 50);

    SetStipple([clWhite32, clRed32, clGreen32, 0, 0, 0]);
    Spiral(50, 150);

    SetStipple([clGreen32, clGreen32, clGreen32, 0, 0, clWhite32, 0, 0]);
    Spiral(150, 150);
    EndUpdate;
  end;
  ImgView.Repaint;
end;

procedure TG32Form.Spiral(X, Y: Integer);
var
  Theta: Double;
begin
  Theta := 0;
  ImgView.Bitmap.MoveToF(X, Y);
  while Theta < 15 * 3.1415926535 do
  begin
    ImgView.Bitmap.LineToFSP(X + Cos(Theta) * Theta, Y + Sin(Theta) * Theta);
    Theta := Theta + 0.2;
  end;
end;

//-----------------------------------------------------
{SpritesTS}
//-----------------------------------------------------

procedure TG32Form.SpritesAddClick(Sender: TObject);
var
  X: Integer;
  ALayer: TBitmapLayer;
  L: TFloatRect;
  I: Integer;
begin
  SpritesActive:=True;
  ImgView.BeginUpdate;
  for X := 0 to 49 do
  begin
    // create a new layer...
    ALayer := TBitmapLayer.Create(ImgView.Layers);
    with ALayer do
    begin
{      Bitmap := PolyBitmapList.Bitmaps[Random(SpriteBitmapList.Bitmaps.Count)].Bitmap;}
      Bitmap := PolyBitmapList.Bitmaps[Random(3)+1].Bitmap;
      Bitmap.DrawMode := dmBlend;
      Bitmap.MasterAlpha := Random(255);
      // put it somethere
      L.Left := Random(ImgView.Width);
      L.Top := Random(ImgView.Height);
      L.Right := L.Left + Bitmap.Width;
      L.Bottom := L.Top + Bitmap.Height;
      ALayer.Location := L;

      I := Length(Velocities);
      SetLength(Velocities, I + 1);
      Velocities[I] := FloatPoint(Random - 0.5, Random - 0.5);
    end;
      Label6.Caption:=IntToStr(ImgView.Layers.Count);
  end;
  ImgView.EndUpdate;
  ImgView.Changed;
  Label6.Caption:='Sprites';
  SpritesEdit.Text := IntToStr(ImgView.Layers.Count) + ' layers';
end;

procedure TG32Form.SpritesClearClick(Sender: TObject);
begin
  ImgView.Layers.Clear;
  Velocities := nil;
  SpritesEdit.Text := '0 layers';
  SpritesActive:=False;
end;

procedure TG32Form.ResetImageBtnClick(Sender: TObject);
begin
  RefreshAll;
end;

procedure TG32Form.OnlyImage1Click(Sender: TObject);
begin
OnlyImage1.Checked:= (not OnlyImage1.Checked);
If OnlyImage1.Checked then
begin    {  alClient    alBottom   alNone}
PageControl1.Visible:= False;
end else
begin
ImgView.Align:= alNone;
PageControl1.Visible:=True;
PageControl1.Align:= alBottom;
ImgView.Align:= alClient;
end;
end;















end.
