unit DevILFrm;

{All contents of this file are intellectual property
 of Denton Woods copyright 2001-2003.}
{http://openil.sourceforge.net/   http://www.imagelib.org}
{http://sourceforge.net/project/showfiles.php?group_id=4470&release_id=100723}
{By Denton Woods, aka DooMWiz}
{Logo and Icons from link: Angus Dorbie, Denton Woods respectively }
{To debug Delphi apps with DevIL,
 you must define OPENIL_DEBUG and rebuild your project.
   Do not define OPENIL_DEBUG for release builds.
   Sorry for the inconvenience.
  - Denton Woods and Alexander Blach}


{This demo cludged by ILH, from the DevIL Windows demo,
  currently has many commented out portions}
{ Nearest filter - ILU_NEAREST
 Linear filter - ILU_LINEAR
 Bilinear filter - ILU_BILINEAR
 Box filter - ILU_SCALE_BOX
 Triangle filter - ILU_SCALE_TRIANGLE
 Bell filter - ILU_SCALE_BELL
 B Spline filter - ILU_SCALE_BSPLINE
 Lanczos filter - ILU_SCALE_LANCZOS3
 Mitchell filter - ILU_SCALE_MITCHELL}
interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ComCtrls, Menus, Printers,
  OpenIL, OpenILU, OpenILUT;

type
  TDDevILForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Load1: TMenuItem;
    Save1: TMenuItem;
    Exit1: TMenuItem;
    N2: TMenuItem;
    StatusBar1: TStatusBar;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Help1: TMenuItem;
    Help2: TMenuItem;
    About1: TMenuItem;
    Image1: TImage;
    N1: TMenuItem;
    Print1: TMenuItem;
    Edit1: TMenuItem;
    Resize1: TMenuItem;
    Commandos1: TMenuItem;
    Rotate1: TMenuItem;
    Sharpen1: TMenuItem;
    Gamma1: TMenuItem;
    BLURGAUSSIAN1: TMenuItem;
    BLURAVERAGE1: TMenuItem;
    Wave1: TMenuItem;
    Noise1: TMenuItem;
    Pixelize1: TMenuItem;
    UndoLevels1: TMenuItem;
    SetUndos1: TMenuItem;
    Undo1: TMenuItem;
    SetLevels1: TMenuItem;
    SelectLevel1: TMenuItem;
    SetMipMaps1: TMenuItem;
    SelectMipmap1: TMenuItem;
    ColorContainment1: TMenuItem;
    RGB1: TMenuItem;
    RGBA1: TMenuItem;
    BGR1: TMenuItem;
    BGRA1: TMenuItem;
    Lumina1: TMenuItem;
    Alpha1: TMenuItem;
    Filters1: TMenuItem;
    Flip1: TMenuItem;
    Mirror1: TMenuItem;
    Emboss1: TMenuItem;
    Equalize1: TMenuItem;
    Alienify1: TMenuItem;
    Negative1: TMenuItem;
    EdgeDetectE1: TMenuItem;
    EdgeDetectS1: TMenuItem;
    EdgeDetectP1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Tools1: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    ofColors1: TMenuItem;
    ImageInfo1: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    SetinTongs1: TMenuItem;
    N5: TMenuItem;
    procedure FormCreate(Sender: TObject);
procedure AppEnabled(Switch:Boolean);
{procedure AppException(Sender: TObject; E: Exception);}
    procedure Exit1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

    procedure Help2Click(Sender: TObject);
    procedure About1Click(Sender: TObject);

    procedure Load1Click(Sender: TObject);
procedure SetImage;
    procedure DisplayErrorMessage;
    procedure Save1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
procedure EditProcesses(Sender: TObject);
procedure CommandoDialog(Command:Integer);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ofColors1Click(Sender: TObject);
    procedure ImageInfo1Click(Sender: TObject);
    procedure Resize1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure Undo1Click(Sender: TObject);
    procedure SetinTongs1Click(Sender: TObject);
  private
    { Private declarations }
    //id,
    //Width, Height, Depth,  // Main image
    //XOff, YOff,
    NumUndosAllowed, UndoSize: TILint;
    //Animations,
    Undos: Array of TILuint;

    //last_elapsed, cur_elapsed, elapsed:TILdouble;
    MouseDown,
    FileLoaded:Boolean;
    PrevMouse:TPoint;
  public
    { Public declarations }
 CurFileName,
IDC_ABOUT_VER_STRING, IDC_ABOUT_VENDOR:String;
IDC_PROP_WIDTH,IDC_PROP_HEIGHT,IDC_PROP_DEPTH,IDC_PROP_SIZE,
IDC_ABOUT_VER_NUM:Integer;
  FilterParamFloat:Double;
  FilterParamString:String;
  FilterParamResult:Boolean;
  end;

var
  DDevILForm: TDDevILForm;


implementation

uses DevILAboutFrm, TongGlobals, DevILDialogFrm, DevILInfoFrm, TongsFrm;

{$R *.DFM}

procedure TDDevILForm.FormCreate(Sender: TObject);
begin
  left := DDevILFormX;
  top := DDevILFormY;
 { Application.OnException := AppException;} {Cribbed from somewhere}
  {Make sure Dlls Exist ?}
  If ((ilGetInteger(IL_VERSION_NUM) < IL_VERSION) or
     (ilGetInteger(ILU_VERSION_NUM) < ILU_VERSION) or
     (ilGetInteger(ILUT_VERSION_NUM) < ILUT_VERSION))then
     begin ShowMessage('Lesser Dll Error'); end;
  NumUndosAllowed := 4;
  UndoSize := 0;
  SetLength(Undos,NumUndosAllowed);
    ilInit();
    iluInit();
    ilutRenderer(IL_WIN32);
// GL cannot use palettes anyway, so convert early.
//ilEnable(IL_CONV_PAL);
// Gets rid of dithering on some nVidia-based cards.
//ilutEnable(ILUT_OPENGL_CONV);
      (*ilutRenderer(IL_OPENGL);  // Switch the renderer
        TexID = ilutGLBindTexImage();*)
    {procedure ilGenImages(Num: TILsizei; Images: PILuint);}
    ilGenImages(1,@Undos[0]);{ @id);}
    {procedure ilBindImage(Image: TILuint);}
    ilBindImage(Undos[0]);{id);}
  // Is there a file to load from the command-line?

  {If ParamCount>0 then
    If (ilLoadImage(PChar(ExtractFilePath(Application.Exename)+ParamStr(1)))=1)then
    begin
      StatusBar1.Panels[0].Text := ExtractFilePath(Application.Exename)+ParamStr(1);
      CurFileName:=ExtractFilePath(Application.Exename)+ParamStr(1);
      SetImage;
      FileLoaded:=True;
    end else} FileLoaded:=False;
    AppEnabled(FileLoaded);
    DisplayErrorMessage;
end;

procedure TDDevILForm.AppEnabled(Switch:Boolean);
begin
  Save1.Enabled:=Switch;
  ImageInfo1.Enabled:=Switch;
  ofColors1.Enabled:=Switch;
  Print1.Enabled:=Switch;
  Edit1.Enabled:=Switch;
    Resize1.Enabled:=false;
  Tools1.Enabled:=Switch;
    SetLevels1.Enabled:=false;
    SelectLevel1.Enabled:=false;
    SetMipMaps1.Enabled:=false;
    SelectMipmap1.Enabled:=false;
  {LoadfromZip1.Enabled:=false;
  LoadFromRar1.Enabled:=false; }
  {Animation   }
End;

{procedure TDDevILForm.AppException(Sender: TObject; E: Exception);
begin
  Application.ShowException(E);
  Application.Terminate;
end; }

procedure TDDevILForm.Exit1Click(Sender: TObject);
begin
  Close;
end;
procedure TDDevILForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  DDevILFormX := DDevILForm.left;
  DDevILFormY := DDevILForm.top;
  {glDeleteTextures(1, &TexID);}
  ilDeleteImages(UndoSize, @Undos);
  SetLength(Undos,0);
end;

procedure TDDevILForm.SetinTongs1Click(Sender: TObject);
var name,ext:String;
{  Bitmap: TBitmap;}
begin
{      Bitmap := TBitmap.Create;
      Bitmap.Width := ilGetInteger(IL_IMAGE_WIDTH);
      Bitmap.Height := ilGetInteger(IL_IMAGE_HEIGHT);
      Bitmap.PixelFormat := pf24bit;//MyPixelFormat;
      Bitmap:=Image1.Picture.Bitmap;
      TongsForm.Image1.Picture.Bitmap:=Bitmap;
      Bitmap.Free;}
     TongsForm.Image1.Picture.Bitmap:=
      Image1.Picture.Bitmap;
     {TongsForm.Image1.Picture.Graphic:=
      Image1.Picture.Graphic;}
      {Change name..ext}
      ext:=lowercase(ExtractFileExt(CurFileName));
  If ( (ext='.bmp') or (ext='.png')or (ext='.jpg')
  or (ext='.tga') or (ext='.tif'))then
  begin
    name:= ExtractFileName(CurFileName);
  end else
  begin
    name:= ExtractFileName(ChangeFileExt(CurFileName,'.bmp'));
  end;
  {Call a Something Changed... }
  TongFilename :=name;
  ImagePath := ExtractFilePath(CurFileName);
  TongsForm.SetFormCaption;
end;

procedure TDDevILForm.Help2Click(Sender: TObject);
begin
  Application.HelpContext(86257);
end;

procedure TDDevILForm.About1Click(Sender: TObject);
begin
  DevILAboutForm.ShowModal;
end;

procedure TDDevILForm.SetImage;
var
{ CopyName, CurName, CurImg, CurMip,  }
{  hInstance:HINSTANCE;}
 MyhBitmap:HBitmap;
{ MyBmpInfo:BITMAPINFOHEADER;   }
 MyHWnd:HWND;
{ MyhMemDC,}
 MyhDC :HDC;
 BitMap1 : TBitMap;
Begin
      {Then you can do something with the image,
       such as sending it to OpenGL as a texture:
       	// Lets ILUT know to use its OpenGL functions.
	ilutRenderer(ILUT_OPENGL);
	// Goes through all steps of sending the image to OpenGL.
	TexID = ilutGLBindTexImage();}
       {function ilutWinLoadImage(FileName: PChar; DC: HDC):}
      {ilutRenderer(IL_WIN32);  }
      MyHWnd:=0;
      MyhDC := GetDC(MyHWnd);
	{MyhMemDC := CreateCompatibleDC(MyhDC);
	CurName := ilGetInteger(IL_CUR_IMAGE);
	CurImg := ilGetInteger(IL_ACTIVE_IMAGE);
	CurMip := ilGetInteger(IL_ACTIVE_MIPMAP);
	CopyName := ilCloneCurImage;
	ilBindImage(CopyName);
	ilConvertImage(IL_BGR, IL_UNSIGNED_BYTE);}
      MyhBitmap := ilutConvertToHBitmap(MyhDC);
      {This is probably the wrong way to do this... duplicates image?}
      BitMap1 := TBitMap.Create;
      BitMap1.Width := ilGetInteger(IL_IMAGE_WIDTH);
      BitMap1.Height := ilGetInteger(IL_IMAGE_HEIGHT);
      BitMap1.Handle:= MyhBitmap;
      try
        Image1.Picture.Assign(BitMap1);
        {Image1.Width :=ilGetInteger(IL_IMAGE_WIDTH);
         Image1.Height := ilGetInteger(IL_IMAGE_HEIGHT); }
        {Image1.Canvas.Draw(0,0,BitMap1);}
      finally
        BitMap1.ReleaseHandle;
        BitMap1.Free;
      end;
        {ilutGetBmpInfo((@MyBmpInfo));
	DeleteObject(SelectObject(MyhMemDC, MyhBitmap));
	ilBindImage(CurName);
	if (CurImg)>0 then ilActiveImage(CurImg);
	if (CurMip)>0 then ilActiveMipmap(CurMip);
	ilDeleteImages(1, @CopyName);}
End;

procedure TDDevILForm.Load1Click(Sender: TObject);

begin
  OpenDialog1.InitialDir := ImagePath;
  {OpenDialog1.InitialDir:=ExtractFilePath(Application.Exename);}
  {		"Graphics Interchange Format (*.gif)", "*.gif",}
  OpenDialog1.Filter:=
'Image Files (All Supported Types)|*.dds;*.jpe;*.jpg;*.jpeg;*.lif;*.bmp;*.ico;*.pbm;*.pgm;*.pnm;*.ppm;*.png;*.bw;*.rgb;*.rgba;*.sgi;*.tga;*.tif;*.tiff;*.pcx;*.xpm;*.psp;*.psd;*.pix;*.pxr;*.cut;*.dcx|'+
'Alias Wavefront Files (*.pix)|*.pix|'+
'Cut Files (*.cut)|*.cut"|'+
'dcx Files (*.dcx)|.dcx|'+
'Half-Life Model Files (*.mdl)|.mdl|'+
'Homeworld Image Files (*.lif)|.lif|'+
'Jpeg Files (*.jpe, *.jpg, *.jpeg)|.jpe;*.jpg;*.jpeg|'+
'Kodak Photo CD Files (*.pcd)|.pcd|'+
'Microsoft Bitmap Files (*.bmp)|.bmp|'+
'Microsoft DirectDraw Surface (*.dds)|.dds|'+
'Microsoft Icon Files (*.ico, *.cur)|.ico, *.cur|'+
'Multiple Network Graphics Files (*.mng)|.mng|'+
'Paint Shop Pro Files (*.psp)|.psp|'+
'PhotoShop Files (*.psd)|.psd|'+
'Pic Files (*.pic)|.pic|'+
'Pixar Files (*.pix)|.pix|'+
'Portable AnyMap Files (*.pbm, *.pgm, *.pnm, *.ppm)|.pbm;*.pgm;*.pnm;*.ppm|'+
'Portable Network Graphics Files (*.png)|.png|'+
'Sgi Files (*.sgi)|.bw;*.rgb;*.rgba;*.sgi|'+
'Targa Files (*.tga, *.vda, *.icb, *.vst)|.tga;*.vda;*.icb;*.vst|'+
'Tiff Files (*.tif)|.tif;*.tiff|'+
'Quake Wal Files (*.wal)|.wal|'+
'X PixelMap (*.xpm)|.xpm|'+
'ZSoft Pcx Files (*.pcx)|*.pcx';
  if OpenDialog1.Execute then          { Display Open dialog box }
  begin  {Image1}
    ImagePath := ExtractFilePath(OpenDialog1.Filename);
    ilDeleteImages(UndoSize, @Undos);
    UndoSize := 0;
    SetLength(Undos,UndoSize);
    SetLength(Undos,NumUndosAllowed);
    {XOff := 0;
     YOff := 0;}
    ilGenImages(1, @Undos[0]);
    ilBindImage(Undos[0]);

    {function ilLoadImage(FileName: PChar):  }
     // Loads into the current bound image
    If (ilLoadImage(PChar(OpenDialog1.FileName))=1)then
    begin
      StatusBar1.Panels[0].Text := OpenDialog1.FileName;
      CurFileName:=OpenDialog1.FileName;
      SetImage;
      FileLoaded:=True;
    end else
    begin
      FileLoaded:=False;
      DisplayErrorMessage;
    end;
  End;
  AppEnabled(FileLoaded);
end;

procedure TDDevILForm.DisplayErrorMessage;
var
  Error: TILuint;
  EString:String;
Begin   {and then i read the Manual... }
  Repeat
    begin
      Error := ilGetError;
      {1282: Out Of Memory... Crash.. No memory to Make the dialog box even}
      If Error=1282 then Application.Terminate;
      If Error <> 0 then
      begin
         EString:=iluErrorString(Error);
         ShowMessage(EString);
      end;
    end;
  until Error=0;
End;



procedure TDDevILForm.Save1Click(Sender: TObject);
begin  {Image1}
  If FileLoaded then
  begin
    SaveDialog1.InitialDir:=OpenDialog1.InitialDir;
    SaveDialog1.Filter:=
'Image Files (All Supported Types)|*.jpg;*.jpeg;*.bmp;*.dds;*.psd;*.pbm;*.pgm;*.ppm;*.png;*.bw;*.rgb;*.rgba;*.sgi;*.tga;*.tif;*.tiff;*.pcx|'+
'Jpeg Files (*.jpe, *.jpg, *.jpeg|*.jpe;*.jpg;*.jpeg|'+
'Microsoft Bitmap Files (*.bmp)|*.bmp|'+
'Microsoft DirectDraw Surface (*.dds)|*.dds|'+
'PhotoShop Files (*.psd)|*.psd|'+
'Portable AnyMap Files (*.pbm, *.pgm, *.ppm)|*.pbm;*.pgm;*.ppm|'+
'Portable Network Graphics Files (*.png)|*.png|'+
'Sgi Files (*.sgi)|*.bw;*.rgb;*.rgba;*.sgi|'+
'Targa Files (*.tga)|*.tga|'+
'Tiff Files (*.tif)|*.tif|'+
'ZSoft Pcx Files (*.pcx)|*.pcx';
    SaveDialog1.FileName:=OpenDialog1.FileName;
    if SaveDialog1.Execute then
    begin
      {KEEP the Devil Image and use to SAVE}
      ilEnable(IL_FILE_OVERWRITE);
      ilSaveImage(PChar(SaveDialog1.FileName));
      StatusBar1.Panels[0].Text := SaveDialog1.FileName;
    end;
  end;
end;


procedure TDDevILForm.Print1Click(Sender: TObject);
begin
  If FileLoaded then
  Begin     {Print the Image}
    with Printer do
    begin
        if (((PageWidth - Image1.Picture.Bitmap.Width) > 0) and
          ((PageHeight - Image1.Picture.Bitmap.Height) > 0))
          then
      begin
      BeginDoc;
      Canvas.Draw((PageWidth - Image1.Picture.Bitmap.Width) div 2,
                  (PageHeight - Image1.Picture.Bitmap.Height) div 2,
                  Image1.Picture.Bitmap);
      EndDoc;
      end else showmessage('too big');
    end;
  End;
end;

procedure TDDevILForm.Undo1Click(Sender: TObject);
begin
  Case TComponent(Sender).Tag of
   70:{Undo1}
     Begin
       If UndoSize > 0 then
       begin
         ilDeleteImages(1, @Undos[UndoSize]);
         dec(UndoSize);
         ilBindImage(Undos[UndoSize]);
         SetImage;
       end;
     End;
   71:{SetUndos1}CommandoDialog(TComponent(Sender).Tag);
   72:{SetLevels1};
   73:{SelectLevel1};
   74:{SetMipMaps1};
   75:{SelectMipmap1};
   {Animations}
  end;
end;


procedure TDDevILForm.EditProcesses(Sender: TObject);
var i:Integer;
Begin {Do Image Undo stuff BEFORE Processing Curent Image}
  {NumUndosAllowed UndoSize}
  inc(UndoSize);
  if ((UndoSize) > NumUndosAllowed) then
  if (NumUndosAllowed > 0) then
  begin
    UndoSize := NumUndosAllowed;
    ilDeleteImages(1, @Undos[0]);
    {memcpy(Undos, Undos+1, NumUndosAllowed * sizeof(ILuint));}
    For i:= UndoSize downto 1 do
    begin
      ilGenImages(1, @Undos[i]);
      ilBindImage(Undos[i]);
      ilCopyImage(Undos[i-1]);
    end;
    ilBindImage(Undos[UndoSize]);
  end;

  if (NumUndosAllowed > 0) then
  begin
    ilGetIntegerv(IL_ACTIVE_IMAGE, {(ILint * )}@Undos[UndoSize]);
    Undos[UndoSize] := ilCloneCurImage();
    ilBindImage(Undos[UndoSize]);
  end;

  Case TComponent(Sender).Tag of
  0:;
  1:iluFlipImage;
  2:iluMirror;
  3:iluEmboss;
{  4:iluEqualize; division by 0 error so commented out}
  5:iluAlienify;
  6:iluNegative;
  7:iluEdgeDetectE;
  8:iluEdgeDetectS;
  9:iluEdgeDetectP;
  21..28:CommandoDialog(TComponent(Sender).Tag);
  {RGB RGBA BGR BGRA Lumina Alpha}
  51:ilConvertImage(IL_RGB, ilGetInteger(IL_IMAGE_TYPE));
  52:ilConvertImage(IL_RGBA, ilGetInteger(IL_IMAGE_TYPE));
  53:ilConvertImage(IL_BGR, ilGetInteger(IL_IMAGE_TYPE));
  54:ilConvertImage(IL_BGRA, ilGetInteger(IL_IMAGE_TYPE));
  55:ilConvertImage(IL_LUMINANCE, ilGetInteger(IL_IMAGE_TYPE));
  {56:ilConvertImage(IL_LUMINANCE_ALPHA, ilGetInteger(IL_IMAGE_TYPE));}
(*case ID_CONVERT_PALETTE:
ilConvertImage(IL_COLOUR_INDEX, IL_UNSIGNED_BYTE);*)
(*case ID_EDIT_VIEWALPHA:
Origin = ilGetInteger(IL_ORIGIN_MODE);
AlphaChannel = ilGetAlpha(IL_UNSIGNED_BYTE);
ilTexImage(ilGetInteger(IL_IMAGE_WIDTH), ilGetInteger(IL_IMAGE_HEIGHT),
ilGetInteger(IL_IMAGE_DEPTH), 1, IL_LUMINANCE, IL_UNSIGNED_BYTE, AlphaChannel);
free(AlphaChannel);
ilRegisterOrigin(Origin);
break;
*)
  End;
  SetImage;
End;

procedure TDDevILForm.CommandoDialog(Command:Integer);
var i:Integer;
Begin
  Case Command of
  21:   {Rotate}
    Begin
      FilterParamFloat:=0.0;
      FilterParamString:='Number of degress to rotate: X.X';
      DevILDialogForm.ShowModal;
      If FilterParamResult then
      iluRotate(Round(FilterParamFloat)) else
      StatusBar1.Panels[1].Text :='Rotate failed';
    End;
  22:   {ID_FILTER_SHARPEN}
    Begin
      FilterParamFloat:=1.0;
      FilterParamString:='Sharpening factor: X.X';
      DevILDialogForm.ShowModal;
      If FilterParamResult then
      iluSharpen(FilterParamFloat, 1) else
      StatusBar1.Panels[1].Text :='Sharpen failed';
    End;
  23:   {gamma}
    Begin
      FilterParamFloat:=1.0;
      FilterParamString:='Amount of gamma correction: X.X';
      DevILDialogForm.ShowModal;
      If FilterParamResult then
      iluGammaCorrect(FilterParamFloat) else
      StatusBar1.Panels[1].Text :='gamma failed';
    End;
  24:   {blur g}
    Begin
      FilterParamFloat:=1;
      FilterParamString:='Number of iterations: X';
      DevILDialogForm.ShowModal;
      If FilterParamResult then
      iluBlurGaussian(Round(FilterParamFloat)) else
      StatusBar1.Panels[1].Text :='blurg failed';
     (*iluMatrixMode(ILU_CONVOLUTION_MATRIX);
      iluLoadFilter(ILU_FILTER_GAUSSIAN_5X5);
	iluApplyMatrix();*)
    End;
  25:   {blur a}
    Begin
      FilterParamFloat:=1;
      FilterParamString:='Number of iterations: X';
      DevILDialogForm.ShowModal;
      If FilterParamResult then
      iluBlurAvg(Round(FilterParamFloat)) else
      StatusBar1.Panels[1].Text :='blura failed';
    End;
  26:   {wave}
    Begin
      FilterParamFloat:=0.0;
      FilterParamString:='Angle of wave to apply: X.X';
      DevILDialogForm.ShowModal;
      If FilterParamResult then
      iluWave(FilterParamFloat)else
      StatusBar1.Panels[1].Text :='wave failed';
    End;
  27:   {noise}
    Begin
      FilterParamFloat:=1.0;
      FilterParamString:='Amount of noise threshold: X.X';
      DevILDialogForm.ShowModal;
      If FilterParamResult then
      iluNoisify(Round(FilterParamFloat))else
      StatusBar1.Panels[1].Text :='noise failed';
    End;
  28:   {pixelized}
    Begin
      FilterParamFloat:=1;
      FilterParamString:='Width of pixelized block: X';
      DevILDialogForm.ShowModal;
      If FilterParamResult then
      iluPixelize(Round(FilterParamFloat))else
      StatusBar1.Panels[1].Text :='pixelized failed';
    End;
  71:   {set undo}
    Begin
      FilterParamFloat:=NumUndosAllowed;
      FilterParamString:='Set level of undo: X (Max 10)';
      DevILDialogForm.ShowModal;
      If (Round(FilterParamFloat) < NumUndosAllowed) then
      begin
      If (UndoSize>Round(FilterParamFloat)) then UndoSize := Round(FilterParamFloat);
        For i:=NumUndosAllowed downto Round(FilterParamFloat) do
        ilDeleteImages(1, @Undos);
        NumUndosAllowed:=Round(FilterParamFloat);
        SetLength(Undos,NumUndosAllowed);
        {ilGenImages(1, @Undos[UndoSize]); }
        ilBindImage(Undos[UndoSize]);
        SetImage;
      end else
      begin
        NumUndosAllowed:=Round(FilterParamFloat);
      end;
    End;
{Set level of undo:" NumUndosAllowed UndoSize );
Enter image number:");  0
Enter mipmap number:");  0
Enter url of image:");    ''
}        
  End;
End;

procedure TDDevILForm.Image1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  MouseDown := TRUE;
  PrevMouse.x:=x;
  PrevMouse.y:=y;
end;

procedure TDDevILForm.Image1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin   // Moves the "viewport"  or could 'Cut'
if not MouseDown then exit;
{XOff += CurMouse.x - PrevMouse.x;
YOff += CurMouse.y - PrevMouse.y;
PrevMouse.x = CurMouse.x;
PrevMouse.y = CurMouse.y;
InvalidateRect(hWnd, NULL, FALSE);}
end;

procedure TDDevILForm.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  MouseDown := FALSE;
end;

procedure TDDevILForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key=VK_ESCAPE) then
  begin
    If Printer.Printing then
    begin
      Printer.Abort;
      MessageDlg('Printing aborted', mtInformation, [mbOK],0);
    end;
    Close;
  end;
end;

procedure TDDevILForm.ofColors1Click(Sender: TObject);
var Colours:Integer;
begin
  Colours := iluColoursUsed();
  Application.MessageBox(
    PChar('The number of colours in this image is: '+Inttostr(Colours)),
    PChar('Colour Count'),
    MB_OK);
end;

procedure TDDevILForm.ImageInfo1Click(Sender: TObject);
begin
  IDC_ABOUT_VENDOR:= ilGetString(IL_VENDOR);
  IDC_ABOUT_VER_STRING:= ilGetString(IL_VERSION);
  IDC_ABOUT_VER_NUM:= ilGetInteger(IL_VERSION_NUM);

  IDC_PROP_WIDTH:= ilGetInteger(IL_IMAGE_WIDTH);
  IDC_PROP_HEIGHT:= ilGetInteger(IL_IMAGE_HEIGHT);
  IDC_PROP_DEPTH:= ilGetInteger(IL_IMAGE_DEPTH);
  IDC_PROP_SIZE:= ilGetInteger(IL_IMAGE_SIZE_OF_DATA);
  DevILInfoDlg.showmodal;
end;

procedure TDDevILForm.Resize1Click(Sender: TObject);
begin
(* Resizer... ?
	// Make sure the window is in the same proportions as the image.
	//  Generate the appropriate width x height less than or equal to MAX_X x MAX_Y.
	//	Instead of just clipping Width x Height to MAX_X x MAX_Y, we scale to
	//	an appropriate size, so the image isn't stretched/squished.
	Width  = ilGetInteger(IL_IMAGE_WIDTH);
	Height = ilGetInteger(IL_IMAGE_HEIGHT);
	if (Width > 0) {  // Don't want a divide by 0...
		if (Width > MAX_X) {
			Width = MAX_X;
			Height = (ILuint)(MAX_X / (ILfloat)ilGetInteger(IL_IMAGE_WIDTH) * Height);
		}
	}
	if (Height > 0) {  // Don't want a divide by 0...
		if (Height > MAX_Y) {
			Height = MAX_Y;
			Width = (ILuint)(MAX_Y / (ILfloat)ilGetInteger(IL_IMAGE_HEIGHT) * Width);
		}
	}
*)
end;

procedure TDDevILForm.Copy1Click(Sender: TObject);
begin
  ilutSetWinClipboard();
end;

procedure TDDevILForm.Paste1Click(Sender: TObject);
var  Test:TILuint;
begin
  ilGenImages(1, @Test);
  ilBindImage(Test);
  // Check if there's anything in the clipboard.
  if (ilutGetWinClipboard=0) then
  begin
    ilDeleteImages(1, @Test);
    StatusBar1.Panels[1].Text :='clipboard FAILURE';
    exit;
  end;
  ilDeleteImages(1, @Test);
  ilDeleteImages(UndoSize, @Undos);
  UndoSize := 0;
  {XOff = 0;
  YOff = 0; }
     ilGenImages(1, @Undos[0]);
     ilBindImage(Undos[0]);
  ilutGetWinClipboard;
  CurFileName:= 'Clipboard Paste';
  StatusBar1.Panels[0].Text := CurFileName;
  SetImage;
  //ilConvertImage(IL_BGRA);
  //ilutRenderer(IL_WIN32);
end;





end.
