unit GPOF;

interface

uses
  Windows, Dialogs, StdCtrls, Buttons, Controls,Graphics,
  Sysutils{Filestuff},
  FileCtrl{SelectDirectory},
  ExtCtrls, ComCtrls, Forms, Classes;

type
  TPOFForm = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Bevel1: TBevel;
    Label1: TLabel;
    Label4: TLabel;
    MessageBtn: TSpeedButton;
    POHelpBtn: TSpeedButton;
    POM_ResetMenuBtn: TSpeedButton;
    InfoCB: TCheckBox;
    ConfirmationCB: TCheckBox;
    ErrorsCB: TCheckBox;
    WarningCB: TCheckBox;
    CompletionCB: TCheckBox;
    BeepOrWavCB: TCheckBox;
    MessageXEdit: TEdit;
    MessageYEdit: TEdit;
    CloseBitBtn: TBitBtn;
    RecordReader: TTabSheet;
    ProjectsBtn: TSpeedButton;
    ShapeBtn: TSpeedButton;
    BaseImagesBtn: TSpeedButton;
    DLGBtn: TSpeedButton;
    VectorDbBtn: TSpeedButton;
    DXFBtn: TSpeedButton;
    TigerBtn: TSpeedButton;
    SDTSBtn: TSpeedButton;
    DotBtn: TSpeedButton;
    Label3: TLabel;
    Label2: TLabel;
    Label50: TLabel;
    Label51: TLabel;
    Label25: TLabel;
    Label17: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label49: TLabel;
    DotEdit: TEdit;
    SDTSEdit: TEdit;
    TigerEdit: TEdit;
    DXFEdit: TEdit;
    VectorDbEdit: TEdit;
    DLGEdit: TEdit;
    BaseImagesEdit: TEdit;
    ShapeEdit: TEdit;
    ProjectsEdit: TEdit;
    OpenDialog1: TOpenDialog;
    TabSheet2: TTabSheet;
    SOSMAPBtn: TSpeedButton;
    SOSMAPEdit: TEdit;
    VoiceEdit: TEdit;
    VoiceBtn: TSpeedButton;
    TracerBtn: TSpeedButton;
    TracerEdit: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    VRGISBtn: TSpeedButton;
    VRGISEdit: TEdit;
    ILHEdit: TEdit;
    LifeEdit: TEdit;
    Fractal3DEdit: TEdit;
    DTMEdit: TEdit;
    GripIceEdit: TEdit;
    GripIceBtn: TSpeedButton;
    DTMBtn: TSpeedButton;
    Fractal3DBtn: TSpeedButton;
    LifeBtn: TSpeedButton;
    ILHBtn: TSpeedButton;
    MapBtn: TSpeedButton;
    MapEdit: TEdit;
    MapLabel: TLabel;
    PrintBigCB: TCheckBox;
    ThumbnailsTS: TTabSheet;
    ThumbBtn: TSpeedButton;
    ThumbEdit: TEdit;
    Label15: TLabel;
    WidthEdit: TEdit;
    SizeUpDown: TUpDown;
    Label18: TLabel;
    Shape1: TShape;
    FillColorBtn: TSpeedButton;
    ColorDialog: TColorDialog;
    Label20: TLabel;
    Skip32BitNoticeCB: TCheckBox;
    TabSheet3: TTabSheet;
    ExtMemo: TMemo;
    ExtDefaults: TSpeedButton;
    ExtOpen: TSpeedButton;
    ExtSave: TSpeedButton;
    ExtensionSetRG: TRadioGroup;
    ClearExtBtn: TSpeedButton;
    TestSoundRG: TRadioGroup;
    UseThumbnailsCB: TCheckBox;
    SkipIntroScreenCB: TCheckBox;
    Label14: TLabel;
    NoNamePathBtn: TSpeedButton;
    NoNameEdit: TEdit;
    FilePreviewsCB: TCheckBox;
    DeleteThumbnailsBtn: TSpeedButton;
    KillAllThumbsBtn: TSpeedButton;

    procedure MessageBtnClick(Sender: TObject);
    procedure POHelpBtnClick(Sender: TObject);
    procedure POM_ResetMenuBtnClick(Sender: TObject);
    procedure CloseBitBtnClick(Sender: TObject);
    procedure ProjectsBtnClick(Sender: TObject);
    procedure ShapeBtnClick(Sender: TObject);
    procedure BaseImagesBtnClick(Sender: TObject);
    procedure DLGBtnClick(Sender: TObject);
    procedure VectorDbBtnClick(Sender: TObject);
    procedure DXFBtnClick(Sender: TObject);
    procedure TigerBtnClick(Sender: TObject);
    procedure SDTSBtnClick(Sender: TObject);
    procedure DotBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
procedure Showem;
    procedure BeepOrWavCBClick(Sender: TObject);
    procedure VRGISBtnClick(Sender: TObject);
    procedure ILHBtnClick(Sender: TObject);
    procedure LifeBtnClick(Sender: TObject);
    procedure Fractal3DBtnClick(Sender: TObject);
    procedure DTMBtnClick(Sender: TObject);
    procedure GripIceBtnClick(Sender: TObject);
    procedure TracerBtnClick(Sender: TObject);
    procedure VoiceBtnClick(Sender: TObject);
    procedure SOSMAPBtnClick(Sender: TObject);
    procedure FillColorBtnClick(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure ThumbBtnClick(Sender: TObject);
    procedure SizeUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure ExtOpenClick(Sender: TObject);
    procedure ExtSaveClick(Sender: TObject);
    procedure ExtDefaultsClick(Sender: TObject);
    procedure ClearExtBtnClick(Sender: TObject);
    procedure TestSoundRGClick(Sender: TObject);
    procedure MapBtnClick(Sender: TObject);
    procedure UseThumbnailsCBClick(Sender: TObject);
    procedure NoNamePathBtnClick(Sender: TObject);
    procedure DeleteThumbnailsBtnClick(Sender: TObject);
    procedure KillAllThumbsBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  POFForm: TPOFForm;

implementation

{$R *.DFM}

uses Globals;

procedure TPOFForm.CloseBitBtnClick(Sender: TObject);
begin
Close;
end;

procedure TPOFForm.FormClose(Sender: TObject; var Action: TCloseAction);
var code: Integer;
begin
  POFFormY := POFForm.top;
  POFFormX := POFForm.left;
  ErrorBeepOn := ErrorsCB.Checked;
  WarningBeepOn := WarningCB.Checked;
  InfoBeepOn := InfoCB.Checked;
  ConfirmBeepOn := ConfirmationCB.Checked;
  CompletedBeepOn := CompletionCB.Checked;
  Skip32BitNotice:=   Skip32BitNoticeCB.Checked;
  SkipIntroScreen:=   SkipIntroScreenCB.Checked;
  PrintBigChecked:=  PrintBigCB.Checked;
{Get the Thumbnail data}
  {ThumbPath}
  UseThumbnails:= UseThumbnailsCB.Checked;
  ThumbSize:=SizeUpDown.Position;   {ThumbWidth }
  {ThumbColor }
{Get the Message locations}
  val(MessageXEdit.Text, MessageX, Code);
  val(MessageYEdit.Text, MessageY, Code);
  DoSaver;
end;


procedure TPOFForm.FormCreate(Sender: TObject);
begin
  top := POFFormY;
  left := POFFormX;
  OpenDialog1.InitialDir := ProjectPath;
end;

procedure TPOFForm.MessageBtnClick(Sender: TObject);
begin
  MessageX := StrtoInt(MessageXEdit.Text);
  MessageY := StrtoInt(MessageYEdit.Text);
  DoMessages(9999);
end;

procedure TPOFForm.POHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(50);
end;

procedure TPOFForm.POM_ResetMenuBtnClick(Sender: TObject);
begin
  PrintBigCB.Checked:=True;
  PrintBigChecked:=True;
  ErrorBeepOn := False;
  WarningBeepOn := False;
  InfoBeepOn := False;
  FilePreviews:=True;
  ConfirmBeepOn := False;
  UseThumbnails:= False;
  ThumbSize:=128;
  ThumbColor:=clWhite;
  CompletedBeepOn := False;
  MessageX := 123;
  MessageY := 123;
 Skip32BitNotice:=False;
{Reset Directories defaults  }
  VRMProgramPath := {ExtractFilePath}(ParamStr(0));
  Fractal3DPath:=VRMProgramPath;
  LifePath:=VRMProgramPath;
  SOSMAPPath:=VRMProgramPath;
  VRMProgramPath:=VRMProgramPath;
  DigitizerPath:=VRMProgramPath;
  VRGISPath:=VRMProgramPath;
  DTMPath:=VRMProgramPath;
  VoicePath:=VRMProgramPath;
  RasterPath:=VRMProgramPath;
  ILHProgram:=VRMProgramPath;
  NoNamePath:=VRMProgramPath;
  ProjectName:=VRMProgramPath;
  MapName:=VRMProgramPath;

  ProjectPath := ExtractFilePath(ParamStr(0));
  ProjectPath := ProjectPath;
  ImagePath := ProjectPath;
  TigerPath := ProjectPath;
  MapsPath:=ProjectPath;
  DotPath := ProjectPath;
  SDTSPath := ProjectPath;
  DLGPath := ProjectPath;
  DXFPath := ProjectPath;
  ShapePath := ProjectPath;
  VRMDatabase:= ProjectPath;
  ThumbPath:=ProjectPath;
  Showem;
end;

procedure TPOFForm.FormShow(Sender: TObject);
begin
  Showem;
end;

procedure TPOFForm.Showem;
var ShowString: string;
begin
{Set all the boxes and edits}
  ErrorsCB.Checked:=ErrorBeepOn;
  WarningCB.Checked:=WarningBeepOn;
  InfoCB.Checked:=InfoBeepOn;
  ConfirmationCB.Checked:=ConfirmBeepOn;
  CompletionCB.Checked:=CompletedBeepOn;
  PrintBigCB.Checked:=PrintBigChecked;
  FilePreviewsCB.Checked:=FilePreviews;
  Skip32BitNoticeCB.Checked:=Skip32BitNotice;
  UseThumbnailsCB.Checked:=UseThumbnails;
  str(MessageX, ShowString);
  MessageXEdit.Text := ShowString;
  str(MessageY, ShowString);
  MessageYEdit.Text := ShowString;
{  VRMProgramPath := ExtractFilePath(ParamStr(0)); }
  Fractal3DEdit.Text:=Fractal3DPath;
  LifeEdit.Text:=LifePath;
  SOSMAPEdit.Text:=SOSMAPPath;
  TracerEdit.Text:=DigitizerPath;
  VRGISEdit.Text:=VRGISPath;
  DTMEdit.Text:=DTMPath;
  VoiceEdit.Text:=VoicePath;
  GripIceEdit.Text:=RasterPath;
  ILHEdit.Text:=ILHProgram;
{  ProjectNameEdit.Text:=ProjectName;}
{  MapNameEdit.Text:=MapName;}
  ProjectsEdit.Text := ProjectPath;
  NoNameEdit.Text := NoNamePath;
  TigerEdit.Text := TigerPath;
  DotEdit.Text := DotPath;
  MapEdit.Text:=MapsPath;
  SDTSEdit.Text := SDTSPath;
  DLGEdit.Text := DLGPath;
  DXFEdit.Text := DXFPath;
  ShapeEdit.Text := ShapePath;
  VectorDbEdit.Text := VRMDatabase;
  BaseImagesEdit.Text := ImagePath;
  ThumbEdit.Text :=ThumbPath;
  SizeUpDown.Position:=ThumbSize;   {ThumbWidth }
  Shape1.Brush.Color:=ThumbColor ;
end;




procedure TPOFForm.ProjectsBtnClick(Sender: TObject);
begin
  TransSearchDir:= ProjectPath;
      if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
        begin
    ProjectPath := TransSearchDir;
    ProjectsEdit.Text := ProjectPath;
  end {else DoMessages(1)};
end;

procedure TPOFForm.MapBtnClick(Sender: TObject);
begin
  TransSearchDir:= MapsPath;
      if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
        begin
    MapsPath := TransSearchDir;
    MapEdit.Text := MapsPath;
  end {else DoMessages(1)};
end;

procedure TPOFForm.ShapeBtnClick(Sender: TObject);
begin
  TransSearchDir:= ShapePath;
      if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
        begin
      ShapePath := TransSearchDir;
      ShapeEdit.Text := ShapePath;
    end {else DoMessages(8)};
end;

procedure TPOFForm.BaseImagesBtnClick(Sender: TObject);
begin
  TransSearchDir:= ImagePath;
      if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
        begin
      ImagePath := TransSearchDir;
        BaseImagesEdit.Text := ImagePath;
    end {else DoMessages(13)};
end;

procedure TPOFForm.DLGBtnClick(Sender: TObject);
begin
  TransSearchDir:= DLGPath;
      if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
        begin
      DLGPath := TransSearchDir;
      DLGEdit.Text := DLGPath;
    end{ else DoMessages(10)};
end;

procedure TPOFForm.VectorDbBtnClick(Sender: TObject);
begin
  TransSearchDir:= VRMDatabase;
      if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
        begin
      VRMDatabase := TransSearchDir;
      VectorDbEdit.Text := VRMDatabase;
    end {else DoMessages(12)};
end;

procedure TPOFForm.DXFBtnClick(Sender: TObject);
begin
  TransSearchDir:= DXFPath;
      if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
        begin
      DXFPath := TransSearchDir;
      DXFEdit.Text := DXFPath;
    end {else DoMessages(11)};
end;


procedure TPOFForm.TigerBtnClick(Sender: TObject);
begin
  TransSearchDir:= TigerPath;
      if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
        begin
    TigerPath := TransSearchDir;
    TigerEdit.Text := TigerPath;
  end; {else DoMessages(3);}
end;

procedure TPOFForm.SDTSBtnClick(Sender: TObject);
begin
  TransSearchDir:= SDTSPath;
      if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
        begin
      SDTSPath := TransSearchDir;
      SDTSEdit.Text := SDTSPath;
  end;{ else DoMessages(4);}
end;

procedure TPOFForm.DotBtnClick(Sender: TObject);
begin
  TransSearchDir:= DotPath;
      if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
        begin
      DotPath :=TransSearchDir;
      DotEdit.Text := DotPath;
  end;{ else DoMessages(9);}
end;

procedure TPOFForm.VRGISBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'VRGIS Program (*.exe)|*.exe';
  OpenDialog1.InitialDir := VRGISPath;
  OpenDialog1.Filename:='vrgis.exe';
  if OpenDialog1.execute then
  begin
    VRGISPath := (OpenDialog1.filename);
    VRGISEdit.Text := VRGISPath;
  end;
end;

procedure TPOFForm.ILHBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'ILH Program (*.exe)|*.exe';
  OpenDialog1.InitialDir := ILHProgram;
  OpenDialog1.Filename:='Image.exe';
  if OpenDialog1.execute then
  begin
    ILHProgram := (OpenDialog1.filename);
    ILHEdit.Text := ILHProgram;
  end;
end;

procedure TPOFForm.LifeBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Life Program (*.exe)|*.exe';
  OpenDialog1.InitialDir := LifePath;
  OpenDialog1.Filename:='Life.exe';
  if OpenDialog1.execute then
  begin
    LifePath := (OpenDialog1.filename);
    LifeEdit.Text := LifePath;
  end;
end;

procedure TPOFForm.Fractal3DBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Fractal3D Program (*.exe)|*.exe';
  OpenDialog1.InitialDir := Fractal3DPath;
  OpenDialog1.Filename:='Fractl3D.exe';
  if OpenDialog1.execute then
  begin
    Fractal3DPath := (OpenDialog1.filename);
    Fractal3DEdit.Text := Fractal3DPath;
  end;
end;

procedure TPOFForm.DTMBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'DTM Program (*.exe)|*.exe';
  OpenDialog1.InitialDir := DTMPath;
  OpenDialog1.Filename:='dtm.exe';
  if OpenDialog1.execute then
  begin
    DTMPath := (OpenDialog1.filename);
    DTMEdit.Text := DTMPath;
  end;
end;

procedure TPOFForm.GripIceBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'GripIce Program (*.exe)|*.exe';
  OpenDialog1.InitialDir := RasterPath;
  OpenDialog1.Filename:='grip.exe';
  if OpenDialog1.execute then
  begin
    RasterPath := (OpenDialog1.filename);
    GripIceEdit.Text := RasterPath;
  end;
end;


procedure TPOFForm.TracerBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Tracer Program (*.exe)|*.exe';
  OpenDialog1.InitialDir := DigitizerPath;
  OpenDialog1.Filename:='Tracer.exe';
  if OpenDialog1.execute then
  begin
    DigitizerPath := (OpenDialog1.filename);
    TracerEdit.Text := DigitizerPath;
  end;
end;

procedure TPOFForm.VoiceBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Voice Program (*.exe)|*.exe';
  OpenDialog1.InitialDir := VoicePath;
  OpenDialog1.Filename:='Voice.exe';
  if OpenDialog1.execute then
  begin
    VoicePath := (OpenDialog1.filename);
    VoiceEdit.Text := VoicePath;
  end;
end;

procedure TPOFForm.SOSMAPBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'SOSMAP Program (*.exe)|*.exe';
  OpenDialog1.InitialDir := SOSMAPPath;
  OpenDialog1.Filename:='sosmap.exe';
  if OpenDialog1.execute then
  begin
    SOSMAPPath := (OpenDialog1.filename);
    SOSMAPEdit.Text := SOSMAPPath;
  end;
end;
procedure TPOFForm.NoNamePathBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'NoName Program (*.exe)|*.exe';
  OpenDialog1.InitialDir := NoNamePath;
  OpenDialog1.Filename:='*.exe';
  if OpenDialog1.execute then
  begin
    NoNamePath := (OpenDialog1.filename);
    NoNameEdit.Text := NoNamePath;
  end;
end;
{NoNamePath  NoNameEdit}
(*
procedure TForm1.CreateButtonClick(Sender: TObject);
var
  i: Integer;
  InFileName, OutFileName: string;
  FilePath, FileName: string;
begin
  for i:=0 to FilesListBox.Items.Count-1 do
  begin
    InFileName:=FilesListBox.Items[i];
    FilePath:=ExtractFilePath(InFileName);
    FileName:=ExtractFileName(InFileName);
    if OutDirEdit.Text<>'' then
      FilePath:=IncludeTrailingBackSlash(OutDirEdit.Text);
                                        {ThumbPath}
    OutFileName:=Concat(FilePath,
    PrefixEdit.Text,                  {ThmPrefix  max 5}
    FileName);
    CreateThumbnail(InFileName,OutFileName,
    WidthUpDown.Position,             {ThumbWidth }
      HeightUpDown.Position,           {ThumbHeight }
      Shape1.Brush.Color);             {ThumbColor }
    Application.ProcessMessages;
    StatusBar1.SimpleText:=
    'Done '+IntToStr(i+1)+' of '+IntToStr(FilesListBox.Items.count);
  end;
end;
*)
{  UseThumbnailsCB.Checked:=UseThumbnails;}
procedure TPOFForm.UseThumbnailsCBClick(Sender: TObject);
begin
  UseThumbnails:=(not UseThumbnails);
  UseThumbnailsCB.Checked:=UseThumbnails;
end;

procedure TPOFForm.FillColorBtnClick(Sender: TObject);
begin
  ColorDialog.Color:=ThumbColor;
  if ColorDialog.Execute then
      ThumbColor:=ColorDialog.Color;
  Shape1.Brush.Color:=ThumbColor;
end;

procedure TPOFForm.DeleteThumbnailsBtnClick(Sender: TObject);
var
  I: integer;
  F: File;
begin
  OpenDialog1.Options := [ofAllowMultiSelect, ofFileMustExist];
  OpenDialog1.InitialDir := ThumbPath;
  OpenDialog1.Filter := 'bmp files (*.bmp)|*.bmp';
  OpenDialog1.FilterIndex := 1;
  OpenDialog1.Filename:='*.bmp';
  if OpenDialog1.Execute then
    with OpenDialog1.Files do
      for I := 0 to Count - 1 do
      begin
        AssignFile(F, Strings[I]);
        Erase(F);
      end;
  OpenDialog1.Options := [ofHideReadOnly,ofEnableSizing];
end;

procedure TPOFForm.KillAllThumbsBtnClick(Sender: TObject);
var
  FileAttrs: Integer;
  sr: TSearchRec;
  root:String;
  I:Integer;
  aStringList: TStringList;
begin
  If (ThumbPath <> ExtractFilePath(ParamStr(0))) then
  Begin
   aStringList := TStringList.Create;	{ construct the list object }
   try
   FileAttrs := faReadOnly + faHidden+faSysFile;
   root:=ThumbPath;
   if root [Length (root)] <> '\' then root := root + '\';
   if FindFirst (root+'*.*', FileAttrs, sr) = 0 then
   begin
     aStringList.Add(root+sr.Name);    {s.Name;}
     while FindNext(sr) = 0 do
     begin
       aStringList.Add(root+sr.Name);  {FindClose(sr);}
     end;
   end;
   Application.ProcessMessages;
   for I := 0 to aStringList.Count - 1 do
   begin
     If (ExtractFileName(aStringList[I])<>'index.dat' )then
     if FileExists(aStringList[I]) then
     If DeleteFile(aStringList[I]) then
     begin end else
     Showmessage('Boo boo '+aStringList[I]);
   end;
   aStringList.Clear;
   Application.ProcessMessages;
   finally
     aStringList.Free;	{ destroy the list object }
   end;
 End else
 Showmessage('Please Set Thumbnail directory in Program Options');
end;

procedure TPOFForm.ThumbBtnClick(Sender: TObject);
begin
  TransSearchDir:= ThumbPath;
      if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
  begin
    ThumbPath := TransSearchDir;
    ThumbEdit.Text := ThumbPath;
  end;
end;

procedure TPOFForm.SizeUpDownClick(Sender: TObject; Button: TUDBtnType);
begin
If ((Button = btNext) and  (SizeUpDown.Position <200)) then
   begin
   Shape1.Width:=SizeUpDown.Position+1;
   Shape1.Height:=SizeUpDown.Position+1;
   end   else  {287w 190h}
If ((Button = btPrev) and  (SizeUpDown.Position >11)) then
   begin
   Shape1.Width:=SizeUpDown.Position-1;
   Shape1.Height:=SizeUpDown.Position-1;
   end;
end;
(*If ((Button = btNext) and  (HeightUpDown.Position <190)) then
   Shape1.Height:=HeightUpDown.Position+1
   else  {287w 190h}
If ((Button = btPrev) and  (HeightUpDown.Position >2)) then
   Shape1.Height:=HeightUpDown.Position-1;*)
{The Button parameter specifies how the value of Position
 is about to change.
 When Button is btNext, the Up or Right arrow was clicked,
 and the value of Position is about to increase by Increment.
  When Button is btPrev, the Down or Left arrow was clicked,
  and the value of Position is about to decrease by Increment.  }
procedure TPOFForm.ExtOpenClick(Sender: TObject);
var
ExtFileName:String;
begin

Case ExtensionSetRG.ItemIndex of
0:ExtFileName:='Grafext.et0';
1:ExtFileName:='Grafext.et1';
2:ExtFileName:='Grafext.et2';
3:ExtFileName:='Grafext.et3';
4:ExtFileName:='Grafext.et4';
5:ExtFileName:='Grafext.et5';
6:ExtFileName:='Grafext.et6';
end;{case}
If FileExists(ProgramPath+ExtFileName) then
  ExtMemo.Lines.LoadFromFile(ProgramPath+ExtFileName)
  else
  begin
  Tempname:=ProgramPath+ExtFileName;
  DoMessages(39997);
  end;
end;

procedure TPOFForm.ExtSaveClick(Sender: TObject);
var
ExtFileName:String;
begin
Case ExtensionSetRG.ItemIndex of
0:ExtFileName:='Grafext.et0';
1:ExtFileName:='Grafext.et1';
2:ExtFileName:='Grafext.et2';
3:ExtFileName:='Grafext.et3';
4:ExtFileName:='Grafext.et4';
5:ExtFileName:='Grafext.et5';
6:ExtFileName:='Grafext.et6';
end;{case}
  ExtMemo.Lines.SaveToFile(ProgramPath+ExtFileName)
end;

procedure TPOFForm.ExtDefaultsClick(Sender: TObject);
begin
Case ExtensionSetRG.ItemIndex of
0:begin
{ExtMemo}
  ExtMemo.Lines.Add('*.shp');
  ExtMemo.Lines.Add('*.shx');
  ExtMemo.Lines.Add('*.sbx');
  ExtMemo.Lines.Add('*.dbf');
  ExtMemo.Lines.Add('*.dxf');
  ExtMemo.Lines.Add('*.dlg');
  ExtMemo.Lines.Add('*.vrm');
end;
1:begin
    // internally register Delphi's "built in" formats,
    //these will not be unregistered on exit and
    // also not registered with TPicture (because they are already or will soon be)
  ExtMemo.Lines.Add('*.png');
  ExtMemo.Lines.Add('*.bmp');
  ExtMemo.Lines.Add('*.ico');
  ExtMemo.Lines.Add('*.wmf');
  ExtMemo.Lines.Add('*.emf');
  ExtMemo.Lines.Add('*.jfif');
  ExtMemo.Lines.Add('*.jpg');
  ExtMemo.Lines.Add('*.jpe');
  ExtMemo.Lines.Add('*.jpeg');

    // register our own formats
  ExtMemo.Lines.Add('*.rle');
  ExtMemo.Lines.Add('*.dib');

    {.$ifdef TargaGraphic}
  ExtMemo.Lines.Add('*.win');
  ExtMemo.Lines.Add('*.vst');
  ExtMemo.Lines.Add('*.vda');
  ExtMemo.Lines.Add('*.tga');
  ExtMemo.Lines.Add('*.icb');
    {.$endif}

    {.$ifdef TIFFGraphic}
  ExtMemo.Lines.Add('*.tiff');
  ExtMemo.Lines.Add('*.tif');
  ExtMemo.Lines.Add('*.fax');
      {.$ifdef EPSGraphic}
  ExtMemo.Lines.Add('*.eps');
      {.$endif}
    {.$endif}

    {.$ifdef PCXGraphic}
  ExtMemo.Lines.Add('*.pcx');
  ExtMemo.Lines.Add('*.pcc');
  ExtMemo.Lines.Add('*.scr');
    {.$endif}

    {.$ifdef RLAGraphic}
  ExtMemo.Lines.Add('*.rpf');
  ExtMemo.Lines.Add('*.rla');
    {.$endif}

    {.$ifdef SGIGraphic}
  ExtMemo.Lines.Add('*.sgi');
  ExtMemo.Lines.Add('*.rgba');
  ExtMemo.Lines.Add('*.rgb');
  ExtMemo.Lines.Add('*.bw');
    {.$endif}

    {.$ifdef PhotoshopGraphic}
  ExtMemo.Lines.Add('*.psd');
  ExtMemo.Lines.Add('*.pdd');
    {.$endif}

    {.$ifdef PortableMapGraphic}
  ExtMemo.Lines.Add('*.ppm');
  ExtMemo.Lines.Add('*.pgm');
  ExtMemo.Lines.Add('*.pbm');
    {.$endif}

    {.$ifdef AutodeskGraphic}
  ExtMemo.Lines.Add('*.cel');
  ExtMemo.Lines.Add('*.pic');
    {.$endif}

    {.$ifdef PCDGraphic}
  ExtMemo.Lines.Add('*.pcd');
    {.$endif}

    {$ifdef GIFGraphic}
  ExtMemo.Lines.Add('*.gif');
    {$endif}

    {.$ifdef CUTGraphic}
  ExtMemo.Lines.Add('*.cut');
    {.$endif}

    {.$ifdef PaintshopProGraphic}
  ExtMemo.Lines.Add('*.psp');
    {.$endif}

    {.$ifdef PortableNetworkGraphic}
  ExtMemo.Lines.Add('*.png');
    {.$endif}
end;     
2:begin
  ExtMemo.Lines.Add( '*.bt');
  ExtMemo.Lines.Add( '*.dem');
  ExtMemo.Lines.Add( '*.bin');
  ExtMemo.Lines.Add( '*.bit');
  ExtMemo.Lines.Add( '*.htf');
end;
3:begin
  ExtMemo.Lines.Add(      '*.tmp');
  ExtMemo.Lines.Add(      '~*.*');
  ExtMemo.Lines.Add(      '*.~*');
  ExtMemo.Lines.Add(      '*.?~?');
  ExtMemo.Lines.Add(      '*.aps');
  ExtMemo.Lines.Add(      '*.bak');
  ExtMemo.Lines.Add(      '*.bk?');
  ExtMemo.Lines.Add(      '*.bsc');
  ExtMemo.Lines.Add(      '*.dmp');
  ExtMemo.Lines.Add(      '*.dsm');
  ExtMemo.Lines.Add(      '*.ilk');
  ExtMemo.Lines.Add(      '*.pch');
  ExtMemo.Lines.Add(      '*.rws');
  ExtMemo.Lines.Add(      '*.sbr');
  ExtMemo.Lines.Add(      'backup*.wbk');
  ExtMemo.Lines.Add(      '*.fts');
  ExtMemo.Lines.Add(      '*.gid');
  ExtMemo.Lines.Add(      '*.$$$');
end;
4:begin  {Words}
  ExtMemo.Lines.Add(      '*.doc');
  ExtMemo.Lines.Add(      '*.txt');
  ExtMemo.Lines.Add(      '*.wpd');
  ExtMemo.Lines.Add(      '*.html');
  ExtMemo.Lines.Add(      '*.htm');
end;
5:begin  {Mine}
  ExtMemo.Lines.Add(      '*.db');
  ExtMemo.Lines.Add(      '*.dbf');
end;
6:begin {Other}
  ExtMemo.Lines.Add(      '*.dih');
  ExtMemo.Lines.Add(      '*.dvh');
  ExtMemo.Lines.Add(      '*.vlh');
  ExtMemo.Lines.Add(      '*.deh');
  ExtMemo.Lines.Add(      '*.dth');
  ExtMemo.Lines.Add(      '*.vrh');
  ExtMemo.Lines.Add(      '*.fth');
  ExtMemo.Lines.Add(      '*.idt');
  ExtMemo.Lines.Add(      '*.idf');
  ExtMemo.Lines.Add(      '*.plc');
  ExtMemo.Lines.Add(      '*.hmd');
  ExtMemo.Lines.Add(      '*.hfd');
end;
end;
end;

procedure TPOFForm.ClearExtBtnClick(Sender: TObject);
begin
  ExtMemo.Clear;
end;

procedure TPOFForm.TestSoundRGClick(Sender: TObject);
begin
   Case TestSoundRG.ItemIndex of
   0:DoMessages(9998);  {info}
   1:DoMessages(19999);{ mtConfirmation}
   2:DoMessages(29999);{warn}
   3:DoMessages(39996);{error}
   4:DoMessages(40001);{done}
   end;{case}
end;

procedure TPOFForm.BeepOrWavCBClick(Sender: TObject);
begin
  InfoBeepOn := InfoCB.Checked;
  ConfirmBeepOn := ConfirmationCB.Checked;
  WarningBeepOn := WarningCB.Checked;
  ErrorBeepOn := ErrorsCB.Checked;
  CompletedBeepOn := CompletionCB.Checked;
  VoicesON:=BeepOrWavCB.Checked;
end;

procedure TPOFForm.PageControl1Change(Sender: TObject);
begin
  if ((Sender as TPageControl).ActivePage = ThumbnailsTS)
  then
  begin
  {Use to store the Thumbnail Info}
  {ThumbPath}
  ThumbSize:=SizeUpDown.Position;   {ThumbSize }
  {ThumbColor }
  end;
end;









end.
