unit GTreefrm;
interface

uses
  Windows, Messages, SysUtils, Classes,GraphicEx,
  Graphics, Controls, Forms, Dialogs, printers,
  StdCtrls, ExtCtrls, Buttons, ComCtrls, FileCtrl, Gauges;

type
  TTreeForm = class(TForm)
    INameTreeEdit: TEdit;
    TV: TTreeView;
    Label5: TLabel;
    ITClearBtn: TSpeedButton;
    ImageTreeOpen: TSpeedButton;
    ImageTreeSave: TSpeedButton;
    ITPrintBtn: TSpeedButton;
    ITShowBox: TCheckBox;
    ITMoveBox: TCheckBox;
    ITAddBox: TCheckBox;
    ITDeleteBox: TCheckBox;
    TreeNodeTypeRG: TRadioGroup;
    ComboBox1: TComboBox;
    FileListBox1: TFileListBox;
    DirectoryListBox1: TDirectoryListBox;
    DriveComboBox1: TDriveComboBox;
    ImageFileLabel: TLabel;
    ITLocateBox: TCheckBox;
    Label3: TLabel;
    ITULXEdit: TEdit;
    Label1: TLabel;
    ITULYEdit: TEdit;
    Label4: TLabel;
    ITLRXEdit: TEdit;
    Label2: TLabel;
    ITLRYEdit: TEdit;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Image1: TImage;
    TVIndexSEdit: TEdit;
    TAIndexSEdit: TEdit;
    btnHelp: TSpeedButton;
    btnInfo: TSpeedButton;
    ITPrintBox: TCheckBox;
    TreeFileTypesRG: TRadioGroup;
    DBCB: TCheckBox;
    ActivateDBBtn: TSpeedButton;
    procedure TVDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure TVDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure TVMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ITClearBtnClick(Sender: TObject);
    procedure ImageTreeOpenClick(Sender: TObject);
    procedure ImageTreeSaveClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox1Click(Sender: TObject);
    procedure DriveComboBox1Click(Sender: TObject);
    procedure DriveComboBox1Change(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure DirectoryListBox1Click(Sender: TObject);
    procedure FileListBox1Change(Sender: TObject);
    procedure FileListBox1Click(Sender: TObject);
    procedure FileListBox1DblClick(Sender: TObject);
    procedure FileListBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FileListBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ITPrintBtnClick(Sender: TObject);
Procedure DumpTreeviewToTextfile( Var F: Textfile; tree: TTreeview );
    procedure btnHelpClick(Sender: TObject);
    procedure btnInfoClick(Sender: TObject);
procedure SETTreeFileTypesRG;
    procedure ActivateDBBtnClick(Sender: TObject);
  private
    { Private declarations }
    Working: Boolean;
    WantToBreak: Boolean;
    TreeType:Integer;
  public
    { Public declarations }
    initial: boolean;
    DbFileName,
    ReturnName: string;
  end;

  type
  PMyNDRec = ^TMyNDRec;
  TMyNDRec = record
    BitFileName, TVIndexS, AnIndexS,
      ULX, ULY, LRX, LRY: string[255];
  end;
  PMyTLRec = ^TMyTLRec;
  TMyTLRec = record
    BitFileName, TVIndexS, AnIndexS,
      ULX, ULY, Dir: string[255];
  end;
  PMyVARec = ^TMyVARec;
  TMyVARec = record
    BitFileName, TVIndexS, AnIndexS: string[255];
  end;
var
  TreeForm: TTreeForm;
  MyNDRec: TMyNDRec;
  MyTLRec: TMyTLRec;
  MyVARec: TMyVARec;
  NodeCounter: Integer;

implementation

uses   TongGlobals, PicView, DBAFrm,
       Preprint, Tongsfrm, PicAbout;
       
{$R *.DFM}

procedure TTreeForm.FormCreate(Sender: TObject);
begin
  top := TreeFormY;
  left := TreeFormX;
  NodeCounter := 0;
  TreeType:= 0;
    ActivateDBBtn.Visible:=False;
    ActivateDBBtn.Enabled:=False;
    DBCB.Visible:=False;
  DbFileName:='';
end;

procedure TTreeForm.FormClose(Sender: TObject; var Action: TCloseAction);
{var
  CurItem: TTreeNode;
  aTMyTVRec: TMyTVRec;  }
begin
  TreeFormY := TreeForm.top;
  TreeFormX := TreeForm.left;
{  if TV.Items.Count > 0 then
  begin
    TV.Items.BeginUpdate;
      Screen.Cursor := CRHOURGLASS;
      CurItem := TV.Items.GetFirstNode;
      while CurItem <> nil do
      begin
        Dispose(PMyTVRec(CurItem.Data)^);
        CurItem := CurItem.GetNext;
      end;
      TV.Items.EndUpdate;
      Screen.Cursor := crDefault;
  end;}
end;
(*
var MyTVRecPtr: PMyTVRec; i: Integer;
begin
  New(MyTVRecPtr); {Shutup compiler}
  inc(NodeCounter);
  for i := 1 to NodeCounter do
  begin
    Dispose(MyTVRecPtr);
  end;
  TreeFormY := TreeForm.top;
  TreeFormX := TreeForm.left;
end;*)

procedure TTreeForm.TVDragDrop(Sender, Source: TObject; X, Y: Integer);
var
  AnItem: TTreeNode;
  AttachMode: TNodeAttachMode;
  HT: THitTests;
  ExtString: string;
begin
  if TV.Selected = nil then Exit;
  HT := TV.GetHitTestInfoAt(X, Y);
  AnItem := TV.GetNodeAt(X, Y);
  if (Source is TFileListBox) then
  begin
    if (htOnItem in HT) then
    begin
      if TFileListBox(Source).Name = 'FileListBox1' then
      begin
        ExtString := ExtractFileName(FileListBox1.FileName);
        if (AnItem.Data <> nil) then
        begin
          if (TreeNodeTypeRG.Itemindex = 1) then
          begin
            AnItem.Text := INameTreeEdit.Text;
            Case TreeType of
            0: PMyNDRec(AnItem.Data)^.BitFileName :=
              FileListBox1.FileName;
            1: Begin
                 PMyTLRec(AnItem.Data)^.BitFileName :=
                     FileListBox1.FileName;
                 {$ifdef ImageDB}
                 If (DbFileName<>'') then
                    DBAForm.AddToDbTree(
                    PMyTLRec(AnItem.Data)^.ULX,
                    PMyTLRec(AnItem.Data)^.ULY,
                    PMyTLRec(AnItem.Data)^.Dir,
                    FileListBox1.FileName);
                 {$endif} // ImageDB
               End;
            2: PMyVARec(AnItem.Data)^.BitFileName :=
              FileListBox1.FileName;
            end;
            INameTreeEdit.Text := AnItem.Text;
          end else
          begin
            AnItem.Text := ExtString;
            Case TreeType of
            0: PMyNDRec(AnItem.Data)^.BitFileName :=
              FileListBox1.FileName;
            1: PMyTLRec(AnItem.Data)^.BitFileName :=
              FileListBox1.FileName;
            2: PMyVARec(AnItem.Data)^.BitFileName :=
              FileListBox1.FileName;
            end;
          end;

        end else showmessage('This tree cannot accept bitmaps');
      end;
    end;
  end else if (Source is TTreeView) then
  begin
    if (HT - [htOnItem, htOnIcon, htNowhere, htOnIndent] <> HT) then
    begin
      AttachMode := naAdd; {shutup compiler}
      if (htOnItem in HT) or (htOnIcon in HT) then
        AttachMode := naAddChild
      else if htNowhere in HT then AttachMode := naAdd
      else if htOnIndent in HT then AttachMode := naInsert;
      TV.Selected.MoveTo(AnItem, AttachMode);
        {naAdd	Adds the node to the end of the list.
        naAddFirst	Adds the node at the beginning of the list.
        naAddChild	Adds the node as a child of the destination at the end of the child list.
        naAddChildFirst	Adds the node as a child at the beginning of the child list of the destination.
        naInsert	Insert the node before the destination node.}
    end;
  end;

end;


procedure TTreeForm.TVDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin {Accept File from the File list or Tree-node mover}
  if (Source is TTreeView) then begin
    if (TTreeView(Source).Name = 'TV') then
      Accept := true else Accept := False;
  end else
    if (Source is TFileListBox) then begin
      if (TFileListBox(Source).Name = 'FileListBox1') then
        Accept := true else Accept := False;
    end
    else Accept := False;
end;


procedure TTreeForm.TVMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  AdjustWidth,AdjustHeight,
  largW, altH, dim:integer;
  Target,blob,mybit:tbitmap;
  HT: THitTests;
  MyTreeNode2: TTreeNode;
  MyNDRecPtr: PMyNDRec;
  MyTLRecPtr: PMyTLRec;
  MyVARecPtr: PMyVARec;
  GraphicClass: TGraphicExGraphicClass;
  Graphic: TGraphic;
  {Make an internal function to get image if available}
  procedure GetMyImage(InName:String);
  Begin
  if fileExists(ThumbPath+'\'+ExtractFileName(InName)) then
  begin
    Image1.Picture.LoadFromFile(ThumbPath+'\'+ExtractFileName(InName))
  end else
  begin
    Screen.Cursor := CRHOURGLASS;
    Application.ProcessMessages;
    GraphicClass := FileFormatList.GraphicFromContent(InName);
    if GraphicClass = nil then Image1.Picture.LoadFromFile(InName)
    else
    begin
        // GraphicFromContent always returns TGraphicExGraphicClass
      Graphic := GraphicClass.Create;
      Graphic.LoadFromFile(InName);
      Image1.Picture.Graphic := Graphic;
    end;
    if (not(Image1.Picture.Graphic is TBitmap)) then
    begin
      Target := TBitmap.Create;
      Target.PixelFormat := pf24Bit;
      Target.Width := Image1.Picture.Width;
      Target.Height := Image1.Picture.Height;
      Target.Canvas.Draw(0, 0, Image1.Picture.Graphic);
      Image1.Picture.Graphic := Target;
      Target.Free;
    end;
    Image1.Picture.Bitmap.PixelFormat := pf24bit;
      {Make a thumnail for next time}
    mybit:=tbitmap.create;
    mybit.assign(Image1.Picture.Bitmap);
    mybit.PixelFormat:=pf24bit;
    Application.ProcessMessages;
    largW:=mybit.width;
    altH:=mybit.height;
    dim:={DBImage2.Width;}Thumbsize;
    if largW=0 then
    largW:=10;
    if altH=0 then
    altH:=10;
    blob:=tbitmap.create;
    blob.PixelFormat:=pf24bit;
    blob.Width:=dim;
    blob.height:=dim;
    Target := TBitmap.Create;
    Target.PixelFormat := pf24Bit;
    if largW>altH then
    begin
      Target.Width:=dim;
      Target.height:=round(altH/largW*dim);
      AdjustWidth:=0;
      AdjustHeight:= Target.width-Target.height;
    end
    else
    begin
      Target.height:=dim;
      Target.width:=round(largW/altH*dim);
      AdjustWidth:=Target.height-Target.width;
      AdjustHeight:=0;
    end;
    Application.ProcessMessages;
    Stretch(Target.width{NewX}, Target.height{NewY},
    TResamplingFilter(GraphexFilter), 0,
                        mybit, Target);
    blob.Canvas.Brush.Color:=ThumbColor;
    blob.Canvas.FillRect(Rect(0,0,dim,dim));
    blob.canvas.Draw(0+(AdjustWidth div 2),
                     0+(AdjustHeight div 2),
                     Target);
    {Save Thumb}
    blob.SaveToFile(ThumbPath+'\'+ExtractFileName(InName));
    mybit.free;
    Target.free;
    blob.free;
    Application.ProcessMessages;
    Screen.Cursor := crDefault;
  End;
End;{Display image sub Procedure}
begin
  if (ITDeleteBox.Checked and (Sender is TTreeView)) then
  begin
    with Sender as TTreeView do
    begin
      HT := GetHitTestInfoAt(X, Y);
      if (htOnItem in HT) then
        Items.Delete(GetNodeAt(X, Y));
      dec(NodeCounter);
    end;
  end else
  if (ITAddBox.Checked and (Sender is TTreeView)) then
  begin
      with Sender as TTreeView do
      begin
        HT := GetHitTestInfoAt(X, Y);
        if (htOnItem in HT) then
        begin
          MyTreeNode2 := (GetNodeAt(X, Y));
          Case TreeType of
          0:Begin
          New(MyNDRecPtr);
          MyNDRecPtr^.BitFileName := 'Noname.bmp';
          MyNDRecPtr^.TVIndexS :=TVIndexSEdit.Text;{ '123';}
          MyNDRecPtr^.AnIndexS :=TAIndexSEdit.Text; {'456';}
          MyNDRecPtr^.ULX := ITULXEdit.Text;
          MyNDRecPtr^.ULY := ITULYEdit.Text;
          MyNDRecPtr^.LRX := ITLRXEdit.Text;
          MyNDRecPtr^.LRY := ITLRYEdit.Text;
           {If (TreeTypeRG.Itemindex = 1)     Add other stuff}
          TV.Items.AddChildObject(MyTreeNode2, INameTreeEdit.Text,
                                  MyNDRecPtr);
          End;
          1:Begin
          New(MyTLRecPtr);
          MyTLRecPtr^.BitFileName := 'Noname.bmp';
          MyTLRecPtr^.TVIndexS :=TVIndexSEdit.Text;{ '123';}
          MyTLRecPtr^.AnIndexS :=TAIndexSEdit.Text; {'456';}
          MyTLRecPtr^.ULX := ITULXEdit.Text;
          MyTLRecPtr^.ULY := ITULYEdit.Text;
          MyTLRecPtr^.Dir := ITLRXEdit.Text;
           {If (TreeTypeRG.Itemindex = 1)     Add other stuff}
          TV.Items.AddChildObject(MyTreeNode2, INameTreeEdit.Text,
                                  MyTLRecPtr);
          End;
          2:Begin
          New(MyVARecPtr);
          MyVARecPtr^.BitFileName := 'Noname.bmp';
          MyVARecPtr^.TVIndexS :=TVIndexSEdit.Text;{ '123';}
          MyVARecPtr^.AnIndexS :=TAIndexSEdit.Text; {'456';}
           {If (TreeTypeRG.Itemindex = 1)     Add other stuff}
          TV.Items.AddChildObject(MyTreeNode2, INameTreeEdit.Text,
                                  MyVARecPtr);
          End;
          End;{Case}
          inc(NodeCounter);
        end; end;
  end else
  if (ITShowBox.Checked and (Sender is TTreeView)) then
  begin
        with Sender as TTreeView do
        begin
          HT := GetHitTestInfoAt(X, Y);
          if (htOnItem in HT) then
          begin
            MyTreeNode2 := (GetNodeAt(X, Y));
            if (MyTreeNode2.Data <> nil) then
            begin
        {Display the Bitmap}
          Case TreeType of
          0:ImageFileLabel.Caption :=
                PMyNDRec(MyTreeNode2.Data)^.BitFileName;
          1:begin ImageFileLabel.Caption :=
                PMyTLRec(MyTreeNode2.Data)^.BitFileName;
                If (DbFileName<>'') then
                DBAForm.table1.locate('Name',ImageFileLabel.Caption,[]);
            end;
          2:ImageFileLabel.Caption :=
                PMyVARec(MyTreeNode2.Data)^.BitFileName;
          end;
              if fileExists(ImageFileLabel.Caption) then
              begin
   GetMyImage(ImageFileLabel.Caption);
    with PicViewBitmap do
    begin
      DoLoad(ImageFileLabel.Caption);
      FocusedListBox:= nil;
      Show;
      end;
end else
begin
  Image1.Picture.Assign(nil);
  ImageFileLabel.Caption := 'Noname.bmp';
          Case TreeType of
          0:PMyNDRec(MyTreeNode2.Data)^.BitFileName:= 'Noname.bmp';
          1:PMyTLRec(MyTreeNode2.Data)^.BitFileName:= 'Noname.bmp';
          2:PMyVARec(MyTreeNode2.Data)^.BitFileName:= 'Noname.bmp';
          end;
{  PMyTVRec(MyTreeNode2.Data)^.BitFileName := 'Noname.bmp';}
end;
              end;
          end; end;
  end else
  if (ITPrintBox.Checked and (Sender is TTreeView)) then
  begin
        with Sender as TTreeView do
        begin
          HT := GetHitTestInfoAt(X, Y);
          if (htOnItem in HT) then
          begin
            MyTreeNode2 := (GetNodeAt(X, Y));
            if (MyTreeNode2.Data <> nil) then
            begin
        {Display the Bitmap}
          Case TreeType of
          0:ImageFileLabel.Caption :=
                PMyNDRec(MyTreeNode2.Data)^.BitFileName;
          1:ImageFileLabel.Caption :=
                PMyTLRec(MyTreeNode2.Data)^.BitFileName;
          2:ImageFileLabel.Caption :=
                PMyVARec(MyTreeNode2.Data)^.BitFileName;
          end;
              if fileExists(ImageFileLabel.Caption) then
              begin
   GetMyImage(ImageFileLabel.Caption);
    with PicViewBitmap do
    begin
      ViewFileName :=ImageFileLabel.Caption;
      DoLoad(ViewFileName);
      FocusedListBox:= nil;
      Show;
      end;
  PrePrintForm:=TPrePrintForm.Create(Application);
  try
    PrePrintForm.SetupForm(ViewFileName,1);
    PicViewBitmap.Image1.Picture.Graphic:=nil;
    PicViewBitmap.Close;
    PrePrintForm.ShowModal;
  finally
    PrePrintForm.Release;
  end;
end else
begin
  Image1.Picture.Assign(nil);
  ImageFileLabel.Caption := 'Noname.bmp';
          Case TreeType of
          0:PMyNDRec(MyTreeNode2.Data)^.BitFileName:= 'Noname.bmp';
          1:PMyTLRec(MyTreeNode2.Data)^.BitFileName:= 'Noname.bmp';
          2:PMyVARec(MyTreeNode2.Data)^.BitFileName:= 'Noname.bmp';
          end;
end;
              end;
          end; end;
  end else
  if (ITMoveBox.Checked and (Sender is TTreeView)) then
        begin
          with Sender as TTreeView do
          begin
            HT := GetHitTestInfoAt(X, Y);
            if (htOnItem in HT) then BeginDrag(False);
          end;
        end else
          if (ITLocateBox.Checked
            and (not (ITDeleteBox.Checked))
            and (Sender is TTreeView)) then
            begin
            with Sender as TTreeView do
            begin
              HT := GetHitTestInfoAt(X, Y);
              if (htOnItem in HT) then
              begin
                MyTreeNode2 := (GetNodeAt(X, Y));
          Case TreeType of
          0:Begin
                PMyNDRec(MyTreeNode2.Data)^.ULX := ITULXEdit.Text;
                PMyNDRec(MyTreeNode2.Data)^.ULY := ITULYEdit.Text;
                PMyNDRec(MyTreeNode2.Data)^.LRX := ITLRXEdit.Text;
                PMyNDRec(MyTreeNode2.Data)^.LRY := ITLRYEdit.Text;
                PMyNDRec(MyTreeNode2.Data)^.TVIndexS := TVIndexSEdit.Text;
                PMyNDRec(MyTreeNode2.Data)^.AnIndexS := TAIndexSEdit.Text;
          End;
          1:Begin
                PMyTLRec(MyTreeNode2.Data)^.ULX := ITULXEdit.Text;
                PMyTLRec(MyTreeNode2.Data)^.ULY := ITULYEdit.Text;
                PMyTLRec(MyTreeNode2.Data)^.Dir := ITLRXEdit.Text;
                PMyTLRec(MyTreeNode2.Data)^.TVIndexS := TVIndexSEdit.Text;
                PMyTLRec(MyTreeNode2.Data)^.AnIndexS := TAIndexSEdit.Text;
          End;
          2:Begin
                PMyVARec(MyTreeNode2.Data)^.TVIndexS := TVIndexSEdit.Text;
                PMyVARec(MyTreeNode2.Data)^.AnIndexS := TAIndexSEdit.Text;
          End;
          End;{Case}
              end;
              end;
           end else {Data Viewer}
            if ((not (ITLocateBox.Checked))
              and (not (ITShowBox.Checked))
              and (not (ITDeleteBox.Checked))
              and (not (ITMoveBox.Checked))
              and (not (ITAddBox.Checked))
              and (Sender is TTreeView)) then
              begin
              with Sender as TTreeView do
              begin
                HT := GetHitTestInfoAt(X, Y);
                if (htOnItem in HT) then
                begin
                  MyTreeNode2 := (GetNodeAt(X, Y));
                  INameTreeEdit.Text := MyTreeNode2.Text;
                  if (MyTreeNode2.Data <> nil) then
                  begin
          Case TreeType of
          0:Begin
                    ImageFileLabel.Caption :=
                      PMyNDRec(MyTreeNode2.Data)^.BitFileName;
                    ITULXEdit.Text :=
                      PMyNDRec(MyTreeNode2.Data)^.ULX;
                    ITULYEdit.Text :=
                      PMyNDRec(MyTreeNode2.Data)^.ULY;
                    ITLRXEdit.Text :=
                      PMyNDRec(MyTreeNode2.Data)^.LRX;
                    ITLRYEdit.Text :=
                      PMyNDRec(MyTreeNode2.Data)^.LRY;
                    TVIndexSEdit.Text:=
                      PMyNDRec(MyTreeNode2.Data)^.TVIndexS;
                    TAIndexSEdit.Text:=
                      PMyNDRec(MyTreeNode2.Data)^.AnIndexS;
          End;
          1:Begin
                    ImageFileLabel.Caption :=
                      PMyTLRec(MyTreeNode2.Data)^.BitFileName;
                    ITULXEdit.Text :=
                      PMyTLRec(MyTreeNode2.Data)^.ULX;
                    ITULYEdit.Text :=
                      PMyTLRec(MyTreeNode2.Data)^.ULY;
                    ITLRXEdit.Text :=
                      PMyTLRec(MyTreeNode2.Data)^.Dir;
                    TVIndexSEdit.Text:=
                      PMyTLRec(MyTreeNode2.Data)^.TVIndexS;
                    TAIndexSEdit.Text:=
                      PMyTLRec(MyTreeNode2.Data)^.AnIndexS;
          End;
          2:Begin
                    ImageFileLabel.Caption :=
                      PMyVARec(MyTreeNode2.Data)^.BitFileName;
                    TVIndexSEdit.Text:=
                      PMyVARec(MyTreeNode2.Data)^.TVIndexS;
                    TAIndexSEdit.Text:=
                      PMyVARec(MyTreeNode2.Data)^.AnIndexS;
          End;
          End;{Case}
   {use data name to get a thumb and or complete image}
if fileExists(ImageFileLabel.Caption) then
   GetMyImage(ImageFileLabel.Caption)
end else
begin
  Image1.Picture.Assign(nil);
  ImageFileLabel.Caption := 'Noname.bmp';
          Case TreeType of
          0:PMyNDRec(MyTreeNode2.Data)^.BitFileName:= 'Noname.bmp';
          1:PMyTLRec(MyTreeNode2.Data)^.BitFileName:= 'Noname.bmp';
          2:PMyVARec(MyTreeNode2.Data)^.BitFileName:= 'Noname.bmp';
          end;
end;

      end;
    end;
  end;
end;


procedure TTreeForm.ITClearBtnClick(Sender: TObject);
var
  MyTLRecPtr: PMyTLRec;
  MyVARecPtr: PMyVARec;
  MyNDRecPtr: PMyNDRec;
  MyTreeNode1 {, MyTreeNode2}: TTreeNode;
begin
  with TV.Items do begin Clear end;
  DbFileName:='';
  DBCB.Checked:=False;
  NodeCounter := 0;
  TreeType:=TreeFileTypesRG.ItemIndex;
  SETTreeFileTypesRG;
  with TV do begin
          Case TreeType of
          0:Begin
    New(MyNDRecPtr);
    MyNDRecPtr^.BitFileName := 'Noname.bmp ';
    MyNDRecPtr^.TVIndexS := 'Title';
    MyNDRecPtr^.AnIndexS := 'Info';
    MyNDRecPtr^.ULX := '-180.0';
    MyNDRecPtr^.ULY := '90.0';
    MyNDRecPtr^.LRX := '180.0';
    MyNDRecPtr^.LRY := '-90.0';
    MyTreeNode1 := Items.AddObject(nil, 'Root Item', MyNDRecPtr);
    inc(NodeCounter);
    New(MyNDRecPtr);
    MyNDRecPtr^.BitFileName := 'Noname.bmp ';
    MyNDRecPtr^.TVIndexS := 'Title';
    MyNDRecPtr^.AnIndexS := 'Info';
    MyNDRecPtr^.ULX := '-180.0';
    MyNDRecPtr^.ULY := '90.0';
    MyNDRecPtr^.LRX := '180.0';
    MyNDRecPtr^.LRY := '-90.0';
    Items.AddChildObject(MyTreeNode1, 'ChildItem', MyNDRecPtr);
    ActivateDBBtn.Visible:=False;
    ActivateDBBtn.Enabled:=False;
    DBCB.Visible:=False;
    End;
          1:Begin
    New(MyTLRecPtr);
    MyTLRecPtr^.BitFileName := 'Noname.bmp ';
    MyTLRecPtr^.TVIndexS := 'Title';
    MyTLRecPtr^.AnIndexS := 'Info';
    MyTLRecPtr^.ULX := '-180.0';
    MyTLRecPtr^.ULY := '90.0';
    MyTLRecPtr^.Dir := '360';
    MyTreeNode1 := Items.AddObject(nil, 'Root Item', MyTLRecPtr);
    inc(NodeCounter);
    New(MyTLRecPtr);
    MyTLRecPtr^.BitFileName := 'Noname.bmp ';
    MyTLRecPtr^.TVIndexS := 'Title';
    MyTLRecPtr^.AnIndexS := 'Info';
    MyTLRecPtr^.ULX := '-180.0';
    MyTLRecPtr^.ULY := '90.0';
    MyTLRecPtr^.Dir := '360';
    Items.AddChildObject(MyTreeNode1, 'ChildItem', MyTLRecPtr);
{$ifdef ImageDB}
    ActivateDBBtn.Visible:=True;
    ActivateDBBtn.Enabled:=true;
    DBCB.Visible:=true;
{$endif} // ImageDB
    End;
          2:Begin
    New(MyVARecPtr);
    MyVARecPtr^.BitFileName := 'Noname.bmp ';
    MyVARecPtr^.TVIndexS := 'Title';
    MyVARecPtr^.AnIndexS := 'Info';
    MyTreeNode1 := Items.AddObject(nil, 'Root Item', MyVARecPtr);
    inc(NodeCounter);
    New(MyVARecPtr);
    MyVARecPtr^.BitFileName := 'Noname.bmp ';
    MyVARecPtr^.TVIndexS := 'Title';
    MyVARecPtr^.AnIndexS := 'Info';
    Items.AddChildObject(MyTreeNode1, 'ChildItem', MyVARecPtr);
    ActivateDBBtn.Visible:=False;
    ActivateDBBtn.Enabled:=False;
    DBCB.Visible:=False;
    End;
    End;{Case}
    inc(NodeCounter);
  end;
end;


procedure TTreeForm.ImageTreeOpenClick(Sender: TObject);
var
  CurItem: TTreeNode;
{  ANode, NextNode: TTreeNode;}
{  ALevel, i: Integer;  }
{  CurrStr,NodeStr: string;}
  FileS: string;
  MyTLRecPtr: PMyTLRec;
  MyVARecPtr: PMyVARec;
  MyNDRecPtr: PMyNDRec;
  aTMyTLRec: TMyTLRec;
  aTMyVARec: TMyVARec;
  aTMyNDRec: TMyNDRec;
  NewTLTreeFile: file of TMyTLRec;
  NewVATreeFile: file of TMyVARec;
  NewNDTreeFile: file of TMyNDRec;
begin
  OpenDialog1.filter := 'Tree file types (*.itn;*.itt;*.itv)|*.itn;*.itt;*.itv;';
  OpenDialog1.DefaultExt := 'itn';
  OpenDialog1.Filename:='*.it?';
  OpenDialog1.InitialDir:=TreePath;
  if OpenDialog1.Execute then
  begin
  DbFileName:='';
  DBCB.Checked:=False;
    FileS := Lowercase(ExtractFileExt(OpenDialog1.Filename));
    If (FileS='.itn') then TreeType:=0
    else If (FileS='.itt') then TreeType:=1
    else If (FileS='.itv') then TreeType:=2
    else Exit;
    TreeFileTypesRG.ItemIndex:=TreeType;
    SETTreeFileTypesRG;
    TreePath:=ExtractFilePath(OpenDialog1.Filename);
    Screen.Cursor := CRHOURGLASS;
    If TV.Items.Count> 0 then TV.Items.Clear;
    TV.LoadFromFile(OpenDialog1.Filename);
{SWITCH the rest depending on FILE Extension: SET TYPE}
Case TreeType of
0:Begin
    FileS := ChangeFileExt(OpenDialog1.Filename, '.idt');
    AssignFile(NewNDTreeFile, FileS);
    Reset(NewNDTreeFile);
    TV.Items.BeginUpdate;
    CurItem := TV.Items.GetFirstNode;
    NodeCounter := 0;
    while CurItem <> nil do
    begin
      Read(NewNDTreeFile, aTMyNDRec);
      New(MyNDRecPtr);
      MyNDRecPtr^ := aTMyNDRec;
      CurItem.Data := MyNDRecPtr; {PMyTVRec;}
      inc(NodeCounter);
      CurItem := CurItem.GetNext;
    end;
    Closefile(NewNDTreeFile);
    ActivateDBBtn.Visible:=False;
    ActivateDBBtn.Enabled:=False;
    DBCB.Visible:=False;
End;
1:Begin
    FileS := ChangeFileExt(OpenDialog1.Filename, '.ilt');
    AssignFile(NewTLTreeFile, FileS);
    Reset(NewTLTreeFile);
    TV.Items.BeginUpdate;
    CurItem := TV.Items.GetFirstNode;
    NodeCounter := 0;
    while CurItem <> nil do
    begin
      Read(NewTLTreeFile, aTMyTLRec);
      New(MyTLRecPtr);
      MyTLRecPtr^ := aTMyTLRec;
      CurItem.Data := MyTLRecPtr; {PMyTVRec;}
      inc(NodeCounter);
      CurItem := CurItem.GetNext;
    end;
    Closefile(NewTLTreeFile);
    ActivateDBBtn.Visible:=true;
    ActivateDBBtn.Enabled:=true;
    DBCB.Visible:=true;
End;
2:Begin
    FileS := ChangeFileExt(OpenDialog1.Filename, '.iat');
    AssignFile(NewVATreeFile, FileS);
    Reset(NewVATreeFile);
    TV.Items.BeginUpdate;
    CurItem := TV.Items.GetFirstNode;
    NodeCounter := 0;
    while CurItem <> nil do
    begin
      Read(NewVATreeFile, aTMyVARec);
      New(MyVARecPtr);
      MyVARecPtr^ := aTMyVARec;
      CurItem.Data := MyVARecPtr; {PMyTVRec;}
      inc(NodeCounter);
      CurItem := CurItem.GetNext;
    end;
    Closefile(NewVATreeFile);
    ActivateDBBtn.Visible:=False;
    ActivateDBBtn.Enabled:=False;
    DBCB.Visible:=False;
End;
End;{Case}
    TV.Items.EndUpdate;
    Screen.Cursor := crDefault;
  end;
end; {readln(NewTreeFile,TVString);}


{type
PMyTVRec = ^TMyTVRec;
TMyTVRec = record
  BitFileName, TVIndexS,  AnIndexS,
  ULX,ULY,LRX,LRY:String;
end;}


procedure TTreeForm.ImageTreeSaveClick(Sender: TObject);
var
{  i: Integer;
  ANode: TTreeNode;  }
  CurItem: TTreeNode;
  FileS {,NodeStr}: string;
  aTMyTLRec: TMyTLRec;
  aTMyVARec: TMyVARec;
  aTMyNDRec: TMyNDRec;
  NewTLTreeFile: file of TMyTLRec;
  NewVATreeFile: file of TMyVARec;
  NewNDTreeFile: file of TMyNDRec;
begin
  if TV.Items.Count > 0 then
  begin
    {Switch dependent on File Type: Loaded or Cleared to}
Case TreeType of
0:Begin
    SaveDialog1.filter := 'Tree files (*.itn)|*.itn';
    SaveDialog1.DefaultExt := 'itn';
    SaveDialog1.InitialDir:=TreePath;
    if SaveDialog1.Execute then
    begin {Save it}
      TreePath:=ExtractFilePath(SaveDialog1.Filename);
      Screen.Cursor := CRHOURGLASS;
      TV.SaveToFile(SaveDialog1.Filename);
      FileS := ChangeFileExt(SaveDialog1.Filename, '.idt');
      AssignFile(NewNDTreeFile, FileS);
      Rewrite(NewNDTreeFile);
      CurItem := TV.Items.GetFirstNode;
      while CurItem <> nil do
      begin
        aTMyNDRec := PMyNDRec(CurItem.Data)^;
        Write(NewNDTreeFile, aTMyNDRec);
        CurItem := CurItem.GetNext;
      end;
      Closefile(NewNDTreeFile);
      Screen.Cursor := crDefault;
    end;
End;
1:Begin
    SaveDialog1.filter := 'Tree files (*.itt)|*.itt';
    SaveDialog1.DefaultExt := 'itt';
    SaveDialog1.InitialDir:=TreePath;
    if SaveDialog1.Execute then
    begin {Save it}
      TreePath:=ExtractFilePath(SaveDialog1.Filename);
      Screen.Cursor := CRHOURGLASS;
      TV.SaveToFile(SaveDialog1.Filename);
      FileS := ChangeFileExt(SaveDialog1.Filename, '.ilt');
      AssignFile(NewTLTreeFile, FileS);
      Rewrite(NewTLTreeFile);
      CurItem := TV.Items.GetFirstNode;
      while CurItem <> nil do
      begin
        aTMyTLRec := PMyTLRec(CurItem.Data)^;
        Write(NewTLTreeFile, aTMyTLRec);
        CurItem := CurItem.GetNext;
      end;
      Closefile(NewTLTreeFile);
      Screen.Cursor := crDefault;
    end;
End;
2:Begin
    SaveDialog1.filter := 'Tree files (*.itv)|*.itv';
    SaveDialog1.DefaultExt := 'itv';
    SaveDialog1.InitialDir:=TreePath;
    if SaveDialog1.Execute then
    begin {Save it}
      TreePath:=ExtractFilePath(SaveDialog1.Filename);
      Screen.Cursor := CRHOURGLASS;
      TV.SaveToFile(SaveDialog1.Filename);
      FileS := ChangeFileExt(SaveDialog1.Filename, '.iat');
      AssignFile(NewVATreeFile, FileS);
      Rewrite(NewVATreeFile);
      CurItem := TV.Items.GetFirstNode;
      while CurItem <> nil do
      begin
        aTMyVARec := PMyVARec(CurItem.Data)^;
        Write(NewVATreeFile, aTMyVARec);
        CurItem := CurItem.GetNext;
      end;
      Closefile(NewVATreeFile);
      Screen.Cursor := crDefault;
    end;
End;
End;{Case}
  end;
end;

(*
procedure TImageForm1.SpeedButton1Click(Sender: TObject);
var
  MyTVRecPtr: PMyTVRec;
  {i: Integer; }
{  ANode: TTreeNode;}
  CurItem: TTreeNode;
{  FileS,NodeStr: string;}
begin
  NodeCounter := 0;
  CurItem := TV.Items.GetFirstNode;
  while CurItem <> nil do begin
    New(MyTVRecPtr);
    MyTVRecPtr^.BitFileName := 'a.bmp ';
    MyTVRecPtr^.TVIndexS := '1';
    MyTVRecPtr^.AnIndexS := '2';
    MyTVRecPtr^.ULX := '3';
    MyTVRecPtr^.ULY := '4';
    MyTVRecPtr^.LRX := '5';
    MyTVRecPtr^.LRY := '6';
    CurItem.Data := MyTVRecPtr; {PMyTVRec;}
    inc(NodeCounter);
    CurItem := CurItem.GetNext;
  end;
end;             *)



procedure TTreeForm.ComboBox1Change(Sender: TObject);
begin
  WantToBreak := true;
  FileListBox1.Mask := ComboBox1.text;
end;

procedure TTreeForm.ComboBox1Click(Sender: TObject);
begin
  WantToBreak := true;
end;

procedure TTreeForm.DriveComboBox1Click(Sender: TObject);
begin
  WantToBreak := true;
end;

procedure TTreeForm.DriveComboBox1Change(Sender: TObject);
begin
  WantToBreak := true;
  DirectoryListBox1.Drive := DriveComboBox1.Drive;
end;

procedure TTreeForm.DirectoryListBox1Change(Sender: TObject);
{var
  i: longint;}
begin
{  if initial then exit;   }
  WantToBreak := true;

  FileListBox1.Directory := DirectoryListBox1.Directory;

{  if round(FileListBox1.Items.Count / 2.5) > 10 then
    Thumbs.RowCount := round(FileListBox1.Items.Count / 2.5) + 1;}

{  for I := 0 to Thumbs.RowCount - 1 do
  begin
    if not odd(I) then Thumbs.RowHeights[I] := 50 else
      Thumbs.RowHeights[I] := 15;
  end;}

{  ClearUpAll;}

{  if AutoLoaded.Checked then
    LoadAllThumbs;}
end;
{------------------------------------------------------------------------}


procedure TTreeForm.DirectoryListBox1Click(Sender: TObject);
begin
  WantToBreak := true;
end;

procedure TTreeForm.FileListBox1Change(Sender: TObject);
{var
  A: Integer;}
begin
  if Working then exit;
  WantToBreak := true;
  ReturnName := FileListBox1.Filename;
{  if IsFileInGrid(ExtractFileName(FileListBox1.FileName), A) then
    Thumbs.TopRow := A - 1;}
       {Label1}
{  HintPanel.Caption := LowerCase(ReturnName);}
  ImageFileLabel.Caption := LowerCase(ReturnName);
end;
{------------------------------------------------------------------------}


procedure TTreeForm.FileListBox1Click(Sender: TObject);
begin
  WantToBreak := true;
end;

procedure TTreeForm.FileListBox1DblClick(Sender: TObject);
begin
  if Working then exit;
  Working := true;
  {Globalpalette := ILOldPallete;}
  ReturnName := FileListBox1.Filename;
  {Modalresult := mrOk;}
end;

procedure TTreeForm.FileListBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Working then exit;
  case key of
    vk_return:
      begin
        {Globalpalette := ILOldPallete;}
        ReturnName := FileListBox1.FileName;
        Modalresult := mrOk;
      end;
  end;
end;

procedure TTreeForm.FileListBox1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Working then exit;
  if Button = mbLeft then
    with Sender as TFileListBox do
    begin
      if ItemAtPos(Point(X, Y), True) >= 0 then
        BeginDrag(False);
    end;
end;

procedure TTreeForm.ITPrintBtnClick(Sender: TObject);
Var
  F: Textfile;
Begin
  AssignPrn( F );
  Rewrite(F);
  try
    DumpTreeviewToTextfile( F, TV );
  finally
    closefile(F);
  end;
end;

Procedure TTreeForm.DumpTreeviewToTextfile( Var F: Textfile; tree: TTreeview );
var
  CurItem: TTreeNode;{Node: TTreeNode;   }
  aTMyTLRec: TMyTLRec;
  aTMyVARec: TMyVARec;
  aTMyNDRec: TMyNDRec;
begin
  if TV.Items.Count > 0 then
  begin
    TV.Items.BeginUpdate;
      Screen.Cursor := CRHOURGLASS;
      CurItem := TV.Items.GetFirstNode;
      while CurItem <> nil do
      begin
Case TreeType of
0:Begin
        aTMyNDRec := PMyNDRec(CurItem.Data)^;    { MyTVRecPtr.Level }
        WriteLn(F,
        StringOfChar(' ', 2*(CurItem.Level * TV.Indent))+
                          CurItem.Text+'  '+
                          aTMyNDRec.BitFileName
                          +'  '+aTMyNDRec.TVIndexS
                          +'  '+aTMyNDRec.AnIndexS  );
End;
1:Begin
        aTMyTLRec := PMyTLRec(CurItem.Data)^;    { MyTVRecPtr.Level }
        WriteLn(F,
        StringOfChar(' ', 2*(CurItem.Level * TV.Indent))+
                          CurItem.Text+'  '+
                          aTMyTLRec.BitFileName
                          +'  '+aTMyTLRec.TVIndexS
                          +'  '+aTMyTLRec.AnIndexS  );
End;
2:Begin
        aTMyVARec := PMyVARec(CurItem.Data)^;    { MyTVRecPtr.Level }
        WriteLn(F,
        StringOfChar(' ', 2*(CurItem.Level * TV.Indent))+
                          CurItem.Text+'  '+
                          aTMyVARec.BitFileName
                          +'  '+aTMyVARec.TVIndexS
                          +'  '+aTMyVARec.AnIndexS  );
End;
End;{Case}
        CurItem := CurItem.GetNext;
      end;
      {TMyTVRec = record
       BitFileName, TVIndexS,  AnIndexS,
       ULX,ULY,LRX,LRY:String; }
      TV.Items.EndUpdate;
      Screen.Cursor := crDefault;
  end;
end;

{  MyTVRecPtr^:= tree.Items.GetFirstnode;
  While MyTVRecPtr <> Nil Do Begin
ImageFileLabel.Caption :=
                PMyTVRec(MyTreeNode2.Data)^.BitFileName;
    WriteLn(F, StringOfChar(' ', 2* MyTVRecPtr.Level ), MyTVRecPtr.Text );
    MyTVRecPtr := MyTVRecPtr.GetNext;
  End;} { While }



procedure TTreeForm.btnHelpClick(Sender: TObject);
begin
  Application.HelpContext(6000);
end;

procedure TTreeForm.btnInfoClick(Sender: TObject);
begin
  PicAboutBox.Init(10);
  PicAboutBox.ShowModal;
end;

procedure TTreeForm.SETTreeFileTypesRG;
begin
{TreeFileTypesRG
4 Corners, Pt-Dir w/Db, Name only
itn , itt, itv}
Case TreeFileTypesRG.ItemIndex of
0:     {2 Corners}
  Begin
    Label4.Caption:= 'LowR X';
    TVIndexSEdit.Visible:=True;
    TAIndexSEdit.Visible:=True;
    ITULXEdit.Visible:=True;
    ITULYEdit.Visible:=True;
    ITLRXEdit.Visible:=True;
    ITLRYEdit.Visible:=True;
    ActivateDBBtn.Visible:=False;
    ActivateDBBtn.Enabled:=False;
    DBCB.Visible:=False;
  End;
1:   {X,Y,Dir}
  Begin
    Label4.Caption:= 'Dir';
    TVIndexSEdit.Visible:=True;
    TAIndexSEdit.Visible:=True;
    ITULXEdit.Visible:=True;  {Lat}
    ITULYEdit.Visible:=True;  {Lon}
    ITLRXEdit.Visible:=True;  {Dir}
    ITLRYEdit.Visible:=False;
    ActivateDBBtn.Visible:=True;
    ActivateDBBtn.Enabled:=True;
    DBCB.Visible:=True;
  End;
2:   {2 Name Tree}
  Begin
    Label4.Caption:= '';
    TVIndexSEdit.Visible:=True;
    TAIndexSEdit.Visible:=True;
    ITULXEdit.Visible:=False;  {Lat}
    ITULYEdit.Visible:=False;  {Lon}
    ITLRXEdit.Visible:=False;  {Dir}
    ITLRYEdit.Visible:=False;
    ActivateDBBtn.Visible:=False;
    ActivateDBBtn.Enabled:=False;
    DBCB.Visible:=False;
  End;
  End;{Case}
end;

procedure TTreeForm.ActivateDBBtnClick(Sender: TObject);
begin
        {WHY THIS kind ????}
  OpenDialog1.Filter := 'Family Image database|*.db';
  OpenDialog1.DefaultExt := 'db';
  OpenDialog1.FileName:='????imag.db';
  OpenDialog1.InitialDir:=ThumbPath;
  if OpenDialog1.Execute then
  begin
    DbFileName:=OpenDialog1.Filename;
    DBCB.Checked:=False;
    {FileS := Lowercase(ExtractFileExt(OpenDialog1.Filename));}
    DBCB.Visible:=True;
    DBAForm.OpenFromAfar(OpenDialog1.Filename);
  end;
end;

end.
