unit JPEGFrm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  jpeg, PNGImage, StdCtrls, Buttons;

type
  TJPEGForm = class(TForm)
    Scale: TComboBox;
    PixelFormat: TComboBox;
    ColorSpace: TComboBox;
    Performance: TComboBox;
    ProgressiveDisplay: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    OpenDialog: TOpenDialog;
    SpeedButton3: TSpeedButton;
    JpegCB: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  JPEGForm: TJPEGForm;

implementation

uses TongGlobals,TongsFrm;

{$R *.DFM}

procedure TJPEGForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  JPEGFormX := JPEGForm.left;
  JPEGFormY := JPEGForm.top;
end;
procedure TJPEGForm.SpeedButton3Click(Sender: TObject);
begin
  close;
end;
procedure TJPEGForm.FormCreate(Sender: TObject);
begin
  top := JPEGFormY;
  left := JPEGFormX;
  {Set per Global Variables}
  Scale.ItemIndex := 0; {1:1}
  PixelFormat.ItemIndex := 0;  {24 bit}
  Colorspace.ItemIndex := 0; {RGB}
  Performance.ItemIndex := 0; {Quality}
end;
{
    with TJPEGImage(GCForm.Image1.Picture.Graphic) do
    begin
      JPEGImagePixelFormat := 0;
24 bit
8 bit

      JPEGImageScale := 0;
1:1
1:2
1:4
1:8
      JPEGImageGrayscale := False;
RGB
Grayscale
      JPEGImagePerformance := 0;
Quality
Speed
      JPEGImageProgressiveDisplay := False;
    end;  }

procedure TJPEGForm.SpeedButton2Click(Sender: TObject);
begin
  Application.HelpContext(1600);
end;

procedure TJPEGForm.SpeedButton1Click(Sender: TObject);
var
  PNG:TPNGObject;
  jp: TJpegImage;
  Tempbmp: TBitmap;
  i:Integer;
  TempFilename : String;
begin  {[ofHideReadOnly,ofEnableSizing]}
  OpenDialog.Options := [ofAllowMultiSelect, ofFileMustExist];
  OpenDialog.InitialDir := ImagePath;
  OpenDialog.Filter := 'All (*.bmp;*.png)|*.bmp;*.png;*.jpg';
  if OpenDialog.Execute then
  begin
    ImagePath:=Extractfilepath(OpenDialog.Filename);
    jp := TJpegImage.Create;
    Screen.Cursor := crHourGlass;
    with OpenDialog.Files do
    for I := 0 to Count - 1 do
    begin
      SpeedButton1.Caption :=
      Inttostr(i+1)+ ' of '+Inttostr(Count);
      Application.ProcessMessages;
      TempFilename:= Strings[I];  { next file in Files property }
      {Load the image}
      if (lowercase(extractfileext(TempFilename)) = '.bmp') then
      begin
        Tempbmp:= TBitmap.Create;
        Tempbmp.LoadFromFile(TempFilename);
         with jp do
         begin
        jp.Assign(Tempbmp);
        If JpegCB.Checked then with jp do
    begin
      PixelFormat := TJPEGPixelFormat(JPEGForm.PixelFormat.ItemIndex);
      Scale := TJPEGScale(JPEGForm.Scale.ItemIndex);
      Grayscale := Boolean(Colorspace.ItemIndex);
      Performance := TJPEGPerformance(JPEGForm.Performance.ItemIndex);
      ProgressiveDisplay := JPEGForm.ProgressiveDisplay.Checked;
    end;
        jp.SaveToFile(ChangeFileExt(TempFilename,'.jpg'));
        Tempbmp.Free;
        end;
      end else
      if (lowercase(extractfileext(TempFilename)) = '.png') then
      begin
        PNG := TPNGObject.Create;
        Tempbmp:= TBitmap.Create;
        try
          PNG.LoadFromFile(TempFilename);
          Tempbmp.Assign(PNG);
         with jp do
         begin
          jp.Assign(Tempbmp);
 {   with TJPEGImage(TongsForm.Image1.Picture.Graphic) do}
    If JpegCB.Checked then with jp do
    begin
      PixelFormat := TJPEGPixelFormat(JPEGForm.PixelFormat.ItemIndex);
      Scale := TJPEGScale(JPEGForm.Scale.ItemIndex);
      Grayscale := Boolean(Colorspace.ItemIndex);
      Performance := TJPEGPerformance(JPEGForm.Performance.ItemIndex);
      ProgressiveDisplay := JPEGForm.ProgressiveDisplay.Checked;
    end;
          jp.SaveToFile(ChangeFileExt(TempFilename,'.jpg'));
         end;
        finally
          PNG.Free;
          Tempbmp.Free;
        end;
      end;
    end;
    jp.Free;
  end;
  SpeedButton1.Caption :='Finished';
  Screen.Cursor := crDefault;
  OpenDialog.Options := [ofHideReadOnly,ofEnableSizing];
end;




end.

