unit NelsonCorrespondenceFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs,
 { Placemnt,} Menus, Nelson2DGeometry, BKStringGrid, Grids;

type
  TNelsonCorrespondenceForm = class(TForm)
    PopupMenu1: TPopupMenu;
    Load1: TMenuItem;
    Save1: TMenuItem;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    Grid1: TBKStringGrid;
    N1: TMenuItem;
    Clear1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Load1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Clear1Click(Sender: TObject);
    procedure Grid1KeyPress(Sender: TObject; var Key: Char);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure LoadGrid(filename:string);
    procedure CopyEntries(var P:array of TVector; Cshift, Rshift: integer);
  end;

var
  NelsonCorrespondenceForm: TNelsonCorrespondenceForm;

implementation

uses TongGlobals, NelsonMorpherFrm;

{$R *.DFM}

{Load, Save, Clear Operations from a Pop up Menu}
procedure TNelsonCorrespondenceForm.FormCreate(Sender: TObject);
var i : integer;
begin
  top := NelsonCorrespondenceFormY;
  left := NelsonCorrespondenceFormX;
  for i:= 1 to Grid1.RowCount div 2 do
    Grid1.Cells[0, i*2-1]:=inttostr(i);

  Grid1.Cells[1, 0]:='x1';
  Grid1.Cells[2, 0]:='y1';
  Grid1.Cells[3, 0]:='x2';
  Grid1.Cells[4, 0]:='y2';
end;

procedure TNelsonCorrespondenceForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  NelsonCorrespondenceFormY := NelsonCorrespondenceForm.top;
  NelsonCorrespondenceFormX := NelsonCorrespondenceForm.left;
end;

procedure TNelsonCorrespondenceForm.Load1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then LoadGrid(OpenDialog1.filename);
end;

procedure TNelsonCorrespondenceForm.Save1Click(Sender: TObject);
begin
  if SaveDialog1.Execute then
    begin
     grid1.Filename:=SaveDialog1.filename;
     grid1.FileStrings;
    end;
end;

procedure TNelsonCorrespondenceForm.Clear1Click(Sender: TObject);
var i, j: integer;
begin
  NelsonMorpherForm.ActClearCor.Execute;

  with grid1 do
  begin
    for i:=1 to rowcount-1 do
      for j:=1 to colcount-1 do
        Cells[j, i]:='';
    cells[0,0]:='0';
  end;

  with NelsonMorpherForm do
   begin
     DrawLines(FastIMG0, Image0);
     DrawLines(FastIMG1, Image1);
   end;
end;

procedure TNelsonCorrespondenceForm.Grid1KeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then
   with NelsonMorpherForm do
    begin
       DrawLines( FastIMG0, Image0);
       DrawLines( FastIMG1, Image1);
    end;
end;

procedure TNelsonCorrespondenceForm.LoadGrid(filename: string);
begin
      grid1.Filename:=filename;
      grid1.RetrieveStrings;
      Nlines[0]:=strtoint(grid1.cells[1, grid1.rowcount-1]);
      Nlines[1]:=strtoint(grid1.cells[3, grid1.rowcount-1]);

      cindex[0]:=Nlines[0] * 2 + 1;
      cindex[1]:=Nlines[1] * 2 + 1;

      with NelsonMorpherForm do
        begin
          DrawLines(FastIMG0, Image0);
          DrawLines(FastIMG1, Image1);
        end;
end;


procedure TNelsonCorrespondenceForm.CopyEntries(var P: array of TVector; Cshift, Rshift: integer);
// size of P is already set assumed
var i:integer;
begin
  for i:=0 to high(P) do
    begin
      P[i][0]:=strtoint( grid1.cells[1+Cshift,   i*2+1+Rshift] );
      P[i][1]:=strtoint( grid1.cells[1+Cshift+1, i*2+1+Rshift] );
    end;
end;



end.
