unit NelsonMorpherFrm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  ImgList, ToolWin, ComCtrls, ExtCtrls, ExtDlgs,
  StdCtrls, Mask, math, vfw2,
  { ToolEdit,}{Placemnt, FastDIBJPG, }{,DIBitmap, FastFX}
  {FastIMG, FastDIB, FastQuant, jpeg,}
  Nelson2DGeometry, Spin, ActnList;

type
  TNelsonMorpherForm = class(TForm)
    Panel1: TPanel;
    Splitter1: TSplitter;
    ControlBar1: TControlBar;
    ToolBar1: TToolBar;
    ImageList1: TImageList;
    LoadProjectBtn: TToolButton;
    SaveProjectBtn: TToolButton;
    ExitBtn: TToolButton;
    OneTrickPonyBtn: TToolButton;
    ToolButton6: TToolButton;
    ToolButton8: TToolButton;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    OpenPictureDialog1: TOpenPictureDialog;
    Label1: TLabel;
    Image0: TImage;
    Image1: TImage;
    Label2: TLabel;
    ActionList1: TActionList;
    ActSaveProject: TAction;
    ActClearCor: TAction;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    Panel6: TPanel;
    TrackBar1: TTrackBar;
    Label3: TLabel;
    Panel7: TPanel;
    Label4: TLabel;
    TrackBar2: TTrackBar;
    Panel8: TPanel;
    Label5: TLabel;
    TrackBar3: TTrackBar;
    Panel9: TPanel;
    Label6: TLabel;
    TrackBar4: TTrackBar;
    SaveAVIBtn: TToolButton;
    ToolButton4: TToolButton;
    DrawLinesBtn: TToolButton;
    ToolButton10: TToolButton;
    SpinEdit1: TSpinEdit;
    CheckBox1: TCheckBox;
    FilenameEdit0: TEdit;
    FilenameEdit1: TEdit;
    FastIMG0: TImage;
    FastIMG1: TImage;
    procedure FilenameEdit1BeforeDialog(Sender: TObject);
               { var Name: String; var Action: Boolean);}
    procedure FilenameEdit1DropFiles(Sender: TObject);
    procedure Image0MouseDown(Sender: TObject; Button: TMouseButton;
               Shift: TShiftState; X, Y: Integer);
    procedure Image0MouseUp(Sender: TObject; Button: TMouseButton;
               Shift: TShiftState; X, Y: Integer);
    procedure Image0MouseMove(Sender: TObject;
               Shift: TShiftState; X,Y: Integer);
    procedure ExitBtnClick(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject;
                Shift: TShiftState; X,Y: Integer);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ActClearCorExecute(Sender: TObject);
    procedure SaveProjectBtnClick(Sender: TObject);
    procedure LoadProjectBtnClick(Sender: TObject);
    procedure OneTrickPonyBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SaveAVIBtnClick(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure DrawLinesBtnClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    procedure LoadImage(FastIMG:TImage; Image:TImage; fn: string);
    procedure SaveProjectFile(filename:string);
    procedure OpenProjectFile(filename:string);

    function OneLineMap(X, P, Q, Pp, Qp : TVector; var dist:single) : TVector;
    function MorphMap( P, Q, Pp, Qp: array of TVector; X: TVector;
                       a,  b,  pow : single): TVector;
    function weight( length, dist, a, b, p : single) : single;
    function Perpendicular(v : TVector): TVector;

    procedure OutputAVI(filename:string);

    procedure UpdateVar;

  public
    { Public declarations }
    stop : boolean;

    procedure DrawLines(ISrc:TImage; Ides:TImage);
    procedure DoMorph( ISrc0, ISrc1 : TImage;
                       IDst         : TImage;
                       P, Q, Pp, Qp : array of TVector;
                       a, b, pow, t: single);
  end;

var
  NelsonMorpherForm     : TNelsonMorpherForm;
  cindex    : array[0..1] of integer;
  NLines    : array[0..1] of integer;

  P, Q      : array of TVector; // correspondence lines
  bm        : TBitmap;
  a, b, pow, t  : single;
  lastX0: TVector;

implementation

{$R *.DFM}

uses TongGlobals, NelsonCorrespondenceFrm,
NelsonOutputFrm;

procedure TNelsonMorpherForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  bm.free;
  NelsonMorpherFormY := NelsonMorpherForm.top;
  NelsonMorpherFormX := NelsonMorpherForm.left;
end;
procedure TNelsonMorpherForm.ExitBtnClick(Sender: TObject);
begin
  close;
end;
procedure TNelsonMorpherForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
  stop:=key=#27;
end;

procedure TNelsonMorpherForm.ActClearCorExecute(Sender: TObject);
begin
  NLines[0]:=0;
  NLines[1]:=0;
  cindex[0]:=1;
  cindex[1]:=1;
end;

procedure TNelsonMorpherForm.FormShow(Sender: TObject);
begin
  NelsonCorrespondenceForm.show; // correspondence
end;

procedure TNelsonMorpherForm.FormCreate(Sender: TObject);
begin
  top := NelsonMorpherFormY;
  left := NelsonMorpherFormX;

  ActClearCor.Execute;

  with Image0.Picture.bitmap.Canvas do
  begin
    Pen.color:=clwhite;
    brush.Color:=clRed;
  end;
  Image0.Picture.bitmap.PixelFormat:=pf24bit;

  with Image1.Picture.bitmap.Canvas do
  begin
    Pen.color:=clwhite;
    brush.Color:=clRed;
  end;
  Image1.Picture.bitmap.PixelFormat:=pf24bit;

  BM:=Tbitmap.create;
  bm.PixelFormat:=pf24bit;
end;
(********************************************)


(********************************************)
procedure TNelsonMorpherForm.SaveProjectBtnClick(Sender: TObject);
begin
 with savedialog1 do
    if execute then SaveProjectFile(filename);
end;
procedure TNelsonMorpherForm.SaveProjectFile(filename: string);
var fn : textfile;
begin
 assignFile(fn, filename);
 rewrite(fn);

 writeln(fn, FilenameEdit0.text);
 writeln(fn, FilenameEdit1.text);
 writeln(fn, NelsonCorrespondenceForm.grid1.Filename);

 with NelsonCorrespondenceForm do
  begin
    if Filename<>'' then
      grid1.FileStrings
    else
      with SaveDialog1 do
        if Execute then
          begin
            grid1.Filename:=filename;
            grid1.FileStrings;
          end;
  end;
 closefile(fn);
end;

procedure TNelsonMorpherForm.LoadProjectBtnClick(Sender: TObject);
begin
 with opendialog1 do
    if execute then OpenProjectFile(filename);
end;
procedure TNelsonMorpherForm.OpenProjectFile(filename: string);
var fn : textfile;
    s : string;
begin
 assignFile(fn, filename);
 reset(fn);

 readln(fn, s);
 FilenameEdit0.text:=s;
 if s<>'' then
   LoadImage(FastIMG0, Image0, FilenameEdit0.text);

 readln(fn, s);
 FilenameEdit1.text:=s;
 if s<>'' then
   LoadImage(FastIMG1, Image1, FilenameEdit1.text);

 readln(fn, s);
 NelsonCorrespondenceForm.grid1.Filename:=s;
 NelsonCorrespondenceForm.LoadGrid(NelsonCorrespondenceForm.grid1.Filename);

 closefile(fn);
end;


procedure TNelsonMorpherForm.FilenameEdit1BeforeDialog(Sender: TObject);
{  var Name: String; var Action: Boolean); }
begin
{  action:=false;}
  if OpenPictureDialog1.Execute then
    begin            {TFilenameedit}
     with (sender as Tedit) do
       begin
         {filename}Text:=OpenPictureDialog1.filename;
         case tag of
           0: LoadImage(FastIMG0, Image0, OpenPictureDialog1.filename);
           1: LoadImage(FastIMG1, Image1, OpenPictureDialog1.filename);
         end;
       end;
    end;
end;

procedure TNelsonMorpherForm.FilenameEdit1DropFiles(Sender: TObject);
var FE :Tedit {TFilenameedit};
begin
 FE:=sender as Tedit {TFilenameedit};
 case FE.tag of
   0: LoadImage(FastIMG0, Image0, FE.Text{filename});
   1: LoadImage(FastIMG1, Image1, FE.Text{filename});
 end;
end;

procedure TNelsonMorpherForm.LoadImage(FastIMG:TImage; Image:TImage; fn: string);
begin
{ LoadFastImage(FastIMG, fn);}
  FastIMG.Picture.Bitmap.LoadFromFile(fn);
  with Image.Picture do
   begin
     graphic.Width:=FastIMG.Picture.Bitmap.width;
     graphic.height:=FastIMG.Picture.Bitmap.height;
   end;

  Image.Width:=FastIMG.Picture.Bitmap.width;
  Image.height:=FastIMG.Picture.Bitmap.height;

  DrawLines(FastIMG, Image);
{                 Form1.Canvas.Draw(50,50,BitMap);}
  FastIMG.Picture.Bitmap.Canvas.draw(0, 0, Image.Picture.bitmap);

  bm.width:=FastIMG.Picture.Bitmap.width;
  bm.height:=FastIMG.Picture.Bitmap.height;

  NelsonOutputForm.SetSize(FastIMG.Picture.Bitmap.width, FastIMG.Picture.Bitmap.height);
{  FastIMGOut.Picture.Bitmap.SetSize( FastIMG.Picture.Bitmap.width, FastIMG.Picture.Bitmap.height, 24, 0);}
end;
(********************************************)


(********************************************)
procedure TNelsonMorpherForm.Image0MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var i : integer;
begin
  i:=(sender as TImage).tag;

  NelsonCorrespondenceForm.Grid1.Cells[1+i*2, cindex[i]]:=inttostr(x);
  NelsonCorrespondenceForm.Grid1.Cells[2+i*2, cindex[i]]:=inttostr(y);

  inc(cindex[i]);

  if (cindex[i] mod 2)=0 then inc(NLines[i]);

  with NelsonCorrespondenceForm.Grid1 do
    cells[1+i*2, rowcount-1]:=inttostr(NLines[i]);
end;

procedure TNelsonMorpherForm.Image0MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var i : integer;
begin
  i:=(sender as TImage).tag;

  if (cindex[i] mod 2)=1 then
    case i of
     0: DrawLines( FastIMG0, Image0);
     1: DrawLines( FastIMG1, Image1);
    end;
end;

procedure TNelsonMorpherForm.Image0MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  label1.Caption:=format( '(%d, %d)' , [x, y] );
end;


procedure TNelsonMorpherForm.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  label2.Caption:=format( '(%d, %d)' , [x, y] );
end;
(********************************************)


(********************************************)
procedure TNelsonMorpherForm.DrawLines(ISrc:TImage; Ides:TImage);
var i, x, y, shift : integer;
const r = 4;
begin
  if not Assigned(ISrc.Picture.bitmap) then exit;
 ISrc.Picture.Bitmap.Canvas.draw(0, 0, Ides.Picture.bitmap);

{  ISrc.BMP.draw( Ides.Picture.bitmap.canvas.handle, 0,0);}

  shift:=ides.tag*2;

  with Ides.Picture.bitmap.Canvas do
   for i:=1 to NLines[ides.tag] do
    begin
       x:=strtoint(NelsonCorrespondenceForm.Grid1.cells[1+shift, i*2-1]);
       y:=strtoint(NelsonCorrespondenceForm.Grid1.cells[2+shift, i*2-1]);

       MoveTo(x, y);

       brush.Color:=clblue;
       Ellipse(x-r, y-r, x+r, y+r);

       x:=strtoint(NelsonCorrespondenceForm.Grid1.cells[1+shift, i*2]);
       y:=strtoint(NelsonCorrespondenceForm.Grid1.cells[2+shift, i*2]);

       brush.Color:=clRed;
       Ellipse(x-r, y-r, x+r, y+r);

       LineTo(x, y);
     end;

  Ides.Refresh;
end;
(********************************************)



(********************************************)
function TNelsonMorpherForm.MorphMap( P, Q, Pp, Qp: array of TVector; X: TVector;
                          a, b, pow : single): TVector;
var DSUM : TVector;
    l, ws, dist, w : single;
    TEMP, Di, Xpi  : TVector;
    i    : integer;
begin
  DSUM[0]:=0;
  DSUM[1]:=0;

  ws:=0;

  for i:=0 to high(P) do
    begin
      Xpi:=OneLineMap(X, P[i], Q[i], Pp[i], Qp[i], dist);

      Di:=VectorSubtract(Xpi, X);

      TEMP:=VectorSubtract( P[i], Q[i]);
      l:=VectorLength( TEMP );

      w:=weight(l, dist, a, b, pow);
      VectorScale( Di, w);
      DSUM:=VectorAdd(DSUM, Di);
      ws:=ws + w;
    end;

  VectorScale( DSUM, 1/ws);

  result:= VectorAdd(X, DSUM );
end;

function TNelsonMorpherForm.weight(length, dist, a, b, p: single): single;
begin
 result:= Power( Power(length, p) / (a+dist), b);
end;

function TNelsonMorpherForm.Perpendicular(v: TVector): TVector;
begin
  result[0]:=v[1];
  result[1]:=-v[0];
end;

function TNelsonMorpherForm.OneLineMap(X, P, Q, Pp, Qp: TVector; var dist:single): TVector;
var u, v, l, lp: single;
    A, B, TEMP : TVector;
begin
  A:= VectorSubtract(Q, P);
  l:= VectorLength( A );

  u:= VectorDotProduct( VectorSubtract(X, P), VectorSubtract(Q, P) ) / l / l;

  A:=Perpendicular( VectorSubtract(Q, P) );

  v:= VectorDotProduct( VectorSubtract(X, P), A ) / l;

  //
  if u<0 then
       begin
         TEMP:=VectorSubtract(X, P);
         dist:=VectorLength(TEMP);
       end else
  if u>1 then
       begin
         TEMP:=VectorSubtract(X, Q);
         dist:=VectorLength(TEMP);
       end else
    dist:=abs(v);
  //

  if abs(dist)<SpinEdit1.value then
     begin result[0]:=-100; result[1]:=-100; exit; end;

  A:= VectorSubtract(Qp, Pp);
  lp:= VectorLength( A );

  A:=Perpendicular( VectorSubtract(Qp, Pp) );
  // it is possible for the Qp and Pp to be the same when interpolated from
  // the lines in image0 and image1.
 //  if lp=0 then lp:=0.0000001;
  VectorScale( A, v/lp);

  B:=VectorSubtract(Qp, Pp);

  VectorScale( B, u );

  result:=VectorAdd( Pp, B);
  result:=VectorAdd( result, A);
end;
(********************************************)


(********************************************)
procedure TNelsonMorpherForm.OneTrickPonyBtnClick(Sender: TObject);
var P, Q, Pp, Qp : array of TVector;
begin
  NelsonOutputForm.show;
  // fill in the arrays
  setlength(P,  NLines[0]); // assuming both entries of NLines the same
  setlength(Pp, NLines[0]);
  setlength(Q,  NLines[0]);
  setlength(Qp, NLines[0]);

  with NelsonCorrespondenceForm do
    begin
      CopyEntries(P,  0, 0);
      CopyEntries(Q,  0, 1);
      CopyEntries(Pp, 2, 0);
      CopyEntries(Qp, 2, 1);
    end;

  screen.Cursor:=crHourGlass;

  try
    DoMorph( FastIMG0{.bmp}, FastIMG1{.bmp}, NelsonOutputForm.FastIMGOut{.bmp}, P, Q, Pp, Qp, a, b, pow, t);
    NelsonOutputForm.FastIMGOut.refresh;
  finally
    screen.Cursor:=crDefault;
    MessageBeep(mb_OK);{Windows call}
  end;
end;

procedure TNelsonMorpherForm.DoMorph( ISrc0, ISrc1 : TImage;
                          IDst         : TImage;
                          P, Q, Pp, Qp : array of TVector;
                          a, b, pow, t: single);
var
rcolor,gcolor,bcolor:byte;
X0, X1, X  : TVector;
    c0, c1     : TColor; {TFColor;}
    dx, dy     : integer;
    dP, dQ     : array of TVector;
    _x, _y, i, W, H  : integer;
    take0, take1 : boolean;

begin
 W:=ISrc0.width;
 H:=ISrc0.height;
 c1:=clRed;c0:=clRed;{Shut up compiler...}
 setlength(dP, length(P));
 setlength(dQ, length(P));

 if t<1{=0} then
   begin
     {ISrc0.Draw( IDst.Handle, 0, 0); }
     ISrc0.Picture.Bitmap.Canvas.draw(0, 0, IDst.Picture.bitmap);
     exit;
   end
  else
 if t>0{=1} then
   begin
     {ISrc1.Draw( IDst.Handle, 0, 0);}
     ISrc1.Picture.Bitmap.Canvas.draw(0, 0, IDst.Picture.bitmap);
     exit;
   end;

 for i:=0 to high(dP) do // get the interpolated lines from Q[], P[]
 begin
   dP[i]:=VectorCombine( P[i], Pp[i], 1-t, t ); //
   dQ[i]:=VectorCombine( Q[i], Qp[i], 1-t, t );
 end;

 stop:=false;

 for dy:=0 to H-1 do
  begin
   Application.ProcessMessages;
   if stop then exit;
   if (dy mod 10) = 0 then NelsonOutputForm.FastIMGOut.Refresh;

   for dx:=0 to W-1 do
      begin
        X[0]:=dx;
        X[1]:=dy;

        X0:=MorphMap( dP, dQ, P,  Q, X, a, b, pow);

        _x:=round(X0[0]);
        _y:=round(X0[1]);

        take0:=(_x>0) and (_x<W) and (_y>0) and (_y<H);

        if take0 then c0:=ISrc0.Picture.Bitmap.Canvas.pixels{24}[_y, _x];

        X1:=MorphMap( dP, dQ, Pp, Qp, X, a, b, pow);

        _x:=round(X1[0]);
        _y:=round(X1[1]);

        take1:=(_x>0) and (_x<W) and (_y>0) and (_y<H);

        if take1 then c1:=ISrc1.Picture.Bitmap.Canvas.pixels{24}[_y, _x];

        if take1 and take0 then
        begin
        {with IDst.Picture.Bitmap.Canvas.Pixels[dy, dx] do
        begin}          { rgb        getbvalue}
rcolor:=round(GetRValue(c1)*t  + GetRValue(c0)*(1-t));
gcolor:=round(GetGValue(c1)*t  + GetGValue(c0)*(1-t));
bcolor:=round(GetBValue(c1)*t  + GetBValue(c0)*(1-t));
IDst.Picture.Bitmap.Canvas.Pixels[dy, dx]:=
rgb(rcolor,gcolor,bcolor);
          { r:=round( c1.r*t + c0.r*(1-t) );
           g:=round( c1.g*t + c0.g*(1-t) );
           b:=round( c1.b*t + c0.b*(1-t) );    }
           continue;
        end;

        if take1 then IDst.Picture.Bitmap.Canvas.pixels{24}[dy, dx]:=c1
        else
        if take0 then IDst.Picture.Bitmap.Canvas.pixels{24}[dy, dx]:=c0
;(*              else
               if (_x=-100) and (_y=-100) then
               IDst.Picture.Bitmap.Canvas.pixels{24}[dy, dx]:=clGreen{tfgreen} else
                 IDst.Picture.Bitmap.Canvas.pixels{24}[dy, dx]:=clRed;{tfred;}
*)
      end;
  end;
end;
(********************************************)


(********************************************)
procedure TNelsonMorpherForm.OutputAVI(filename: string);
var
  tt : Integer;
  pfile: PAVIFile;
  asi: TAVIStreamInfo;
  nul: Longint;

  ps, ps_c : PAVIStream;

  BitmapInfo: PBitmapInfoHeader;
  BitmapInfoSize: Integer;
  BitmapBits: Pointer;
  BitmapSize: Dword;

  gaAVIOptions   : TAVICOMPRESSOPTIONS;
  galpAVIOptions : PAVICOMPRESSOPTIONS;

  ii            : integer; // current-frame index for AVI-write

  P, Q, Pp, Qp : array of TVector;

{sub}procedure AVIFileDestroy;
begin
  AVIStreamRelease(ps);
  AVIStreamRelease(ps_c);
  AVIFileRelease(pfile);
  AVIFileExit; // finalize the AVI lib.
end;

{sub}procedure AVIFileCreate;
{var NColor : integer;}
begin
{ NColor:=65536;     }

 AVIFileInit; // init. the AVI lib.

 try
  if AVIFileOpen(pfile, PChar(filename), OF_WRITE or OF_CREATE, nil)<>AVIERR_OK then
   raise Exception.Create('Cannot create AVI file.');

  with bm do
   begin
{    InternalGetDIBSizes( Handle, BitmapInfoSize, BitmapSize, NColor);}
    BitmapInfo:=AllocMem(BitmapInfoSize);
    BitmapBits:=AllocMem(BitmapSize);
{    InternalGetDIB(Handle, 0, BitmapInfo^, BitmapBits^, NColor);}
   end;

  FillChar(asi,sizeof(asi),0);
  asi.fccType   := streamtypeVIDEO; //  Now prepare the stream
  asi.fccHandler:= 0;
  asi.dwScale   := 1;         // dwRate / dwScale == samples/second
  asi.dwRate    := 10;
  asi.dwSuggestedBufferSize:=BitmapSize;
  asi.rcFrame.Right  := BitmapInfo^.biWidth;
  asi.rcFrame.Bottom := BitmapInfo^.biHeight;

  if AVIFileCreateStream(pfile, ps, @asi)<>AVIERR_OK then
    raise Exception.Create('Cannot create AVI stream.');

  with BM do
   begin
{     InternalGetDIB(Handle,0,BitmapInfo^,BitmapBits^, NColor);}
      galpAVIOptions:=@gaAVIOptions;
      fillchar(gaAVIOptions, sizeof(gaAVIOptions), 0);
      AVISaveOptions(Handle, ICMF_CHOOSE_KEYFRAME or ICMF_CHOOSE_DATARATE, 1, ps, galpAVIOptions);
      if AVIMakeCompressedStream(ps_c, ps, galpAVIOptions, nil) <> AVIERR_OK then
           raise Exception.Create('cannot make compressed stream');
      if AVIStreamSetFormat(ps_c, 0, BitmapInfo, BitmapInfoSize) <> AVIERR_OK then
           raise Exception.Create('AVIStreamSetFormat Error');
   end;

 except
  FreeMem(BitmapInfo);
  FreeMem(BitmapBits);

  AVIFileDestroy;
 end;
end;

begin // CreateAVI()

 AVIFileCreate;

 NelsonCorrespondenceForm.show;
  // fill in the arrays
 setlength(P,  NLines[0]); // assuming both entries of NLines the same
 setlength(Pp, NLines[0]);
 setlength(Q,  NLines[0]);
 setlength(Qp, NLines[0]);

 with NelsonCorrespondenceForm do
    begin
      CopyEntries(P,  0, 0); // with zeros for Z,W
      CopyEntries(Q,  0, 1);
      CopyEntries(Pp, 2, 0);
      CopyEntries(Qp, 2, 1);
    end;

 ii:=0; // current frame for AVI outputing
 Screen.Cursor := crHourGlass;  // Display the hourglass cursor
 try
   for tt:=0 to trackbar4.max do
    begin

      trackbar4.position:=tt;

      UpdateVar;

      DoMorph( FastIMG0, FastIMG1, NelsonOutputForm.FastIMGOut, P, Q, Pp, Qp, a, b, pow, t);

      NelsonOutputForm.FastIMGOut.refresh;
{      Form3.FastIMGOut.bmp.Draw(bm.Canvas.Handle, 0, 0);}
     NelsonOutputForm.FastIMGOut.Picture.Bitmap.Canvas.draw(0, 0, bm);

      with BM do
         begin
{           InternalGetDIB( Handle, 0, BitmapInfo^, BitmapBits^,65536 );}
           if AVIStreamWrite( ps_c, ii, 1, BitmapBits, BitmapSize,
                              AVIIF_KEYFRAME, @nul, @nul)<> AVIERR_OK then
                                    raise Exception.Create('Add Frame Error');
           inc(ii);
         end;

    end; // for ScenePart

 finally
     FreeMem(BitmapInfo);
     FreeMem(BitmapBits);

     AVIFileDestroy;

     Screen.Cursor := crDefault; // restore the cursor
 end;
end;



procedure TNelsonMorpherForm.SaveAVIBtnClick(Sender: TObject);
begin
  with savedialog1 do
   begin
     filename:='out.avi';
     if execute then
         OutputAVI(filename);
   end;
end;
(********************************************)



(********************************************)
procedure TNelsonMorpherForm.TrackBar1Change(Sender: TObject);
begin
  UpdateVar;
  label3.caption:=format('a=%2.2f', [a]);
  label4.caption:=format('b=%2.2f', [b]);
  label5.caption:=format('p=%2.2f', [pow]);
  label6.caption:=format('t=%2.2f', [t]);
end;

procedure TNelsonMorpherForm.UpdateVar;
begin
 a:=trackbar1.position/10+0.00000000001;
 b:=trackbar2.position/10+0.5;
 pow:=trackbar3.position/trackbar3.max;
 t:=trackbar4.position/trackbar4.max;
end;

procedure TNelsonMorpherForm.DrawLinesBtnClick(Sender: TObject);
var w, i:integer;
begin
  w:=FastIMG0.Picture.Bitmap.width;

  for i:=1 to NLines[0]*2 do
   with NelsonCorrespondenceForm.grid1 do
     begin
       cells[4, i]:=cells[2, i];
     end;

  for i:=1 to NLines[0]*2 do
   with NelsonCorrespondenceForm.grid1 do
     begin
      cells[3, i-1+cindex[0]]:= inttostr( w - strtoint(cells[1, i]) );
      cells[4, i-1+cindex[0]]:= cells[2, i];

      cells[1, i-1+cindex[0]]:= inttostr( w - strtoint(cells[3, i]) );
      cells[2, i-1+cindex[0]]:= cells[4, i];
     end;

  NLines[0]:=NLines[0]*2;
  NLines[1]:=NLines[1]*2;

  cindex[0]:=NLines[0]*2+1;
  cindex[1]:=NLines[1]*2+1;

  DrawLines(FastIMG0, Image0);
  DrawLines(FastIMG1, Image1);
end;
(********************************************)


end.
