unit SatelliteImportFrm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, ComCtrls;

type
  TSatelliteImportForm = class(TForm)
    BandOpenDialog: TOpenDialog;
    Label9: TLabel;
    SaveDialog1: TSaveDialog;
    Label26: TLabel;
    RIHOpenBtn: TSpeedButton;
    RIHHeaderFileEdit: TEdit;
    Panel1: TPanel;
    Label10: TLabel;
    DIPHeightLabel: TLabel;
    Label17: TLabel;
    Label16: TLabel;
    DIPWidthLabel: TLabel;
    Label15: TLabel;
    Label14: TLabel;
    Label331: TLabel;
    DISTEdit: TEdit;
    DISBEdit: TEdit;
    IMHEdit: TEdit;
    DISLEdit: TEdit;
    DISREdit: TEdit;
    IMWEdit: TEdit;
    ProgressBar1: TProgressBar;
    Panel2: TPanel;
    Label7: TLabel;
    Label4: TLabel;
    Label39: TLabel;
    Label5: TLabel;
    PBandFileBtn1: TSpeedButton;
    Label2: TLabel;
    Label6: TLabel;
    PBandFileBtn2: TSpeedButton;
    Label3: TLabel;
    Label8: TLabel;
    PBandFileBtn3: TSpeedButton;
    Label1: TLabel;
    BandFileEdit1: TEdit;
    BandFileEdit2: TEdit;
    BandFileEdit3: TEdit;
    BandFileSaveAs: TEdit;
    PBOKBtn: TBitBtn;
    PBHelpBtn: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RIHOpenBtnClick(Sender: TObject);
    procedure PBandFileBtn1Click(Sender: TObject);
    procedure PBandFileBtn2Click(Sender: TObject);
    procedure PBandFileBtn3Click(Sender: TObject);
    procedure PBOKBtnClick(Sender: TObject);
    procedure PBHelpBtnClick(Sender: TObject);
  private
    { Private declarations }
    BandFileSaveAsStr, OutputFileName,
    BandFile1,BandFile2,BandFile3:String;
{procedure RIHOpenHDFHeader(InFileName: string);}
procedure RIHOpenFSTHeader(InFileName: string);
procedure RIHOpenIDXHeader(InFileName: string);

procedure Do_BandstoRGBImage;
procedure Do_JER_Radar;
  public
    { Public declarations }
  end;

var
  SatelliteImportForm: TSatelliteImportForm;

implementation

{$R *.DFM}
uses TongGlobals, TongsFrm;


procedure TSatelliteImportForm.FormCreate(Sender: TObject);
begin
  top := SatelliteImportFormY;
  left := SatelliteImportFormX;
end;

procedure TSatelliteImportForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  SatelliteImportFormY := SatelliteImportForm.top;
  SatelliteImportFormX := SatelliteImportForm.left;
end;

procedure TSatelliteImportForm.PBHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(2460);
end;

procedure TSatelliteImportForm.RIHOpenBtnClick(Sender: TObject);
var
temp2,  WhichS: string;
var
 { i, ii,
  ErrorCode: Integer;}
  {InString,}
  temp, LCol, RCol, TRow, BRow: string;
begin
  BandOpenDialog.Filter :=
    'Header file (DDR,IDX,DIH,FST,TXT,DAT)|*.DDR;*.IDX;*.DIH;*.HDF;*.DAT;*.FST;*.TXT';
  BandOpenDialog.InitialDir := ImagePath;
  if BandOpenDialog.execute then
  begin
    RIHHeaderFileEdit.Text:= ExtractFileName(BandOpenDialog.filename);
        WhichS := lowercase(ExtractFileExt(BandOpenDialog.filename));
        if (WhichS = '.idx') then
          RIHOpenIDXHeader(BandOpenDialog.filename)
  {None actually DO anything yet anyway...
       else if (WhichS = '.ddr') then
          RIHOpenDDRHeader(BandOpenDialog.filename)
        else if (WhichS = '.dat') then
          RIHOpenDATHeader(BandOpenDialog.filename) }
        else if (WhichS = '.fst') then
          RIHOpenFSTHeader(BandOpenDialog.filename)
        {else if (WhichS = '.hdf') then
          RIHOpenHDFHeader(BandOpenDialog.filename)};

{      BandHdrEdit.Text}
temp2 := ExtractFileName(BandOpenDialog.filename);
ImagePath := ExtractFilepath(BandOpenDialog.filename);
        {DIS NAME}
      temp := ChangeFileExt(temp2, '.png');
      {SetFileName(temp);}
      BandFileSaveAsStr := temp;
      BandFileSaveAs.Text := temp;
      BandFileEdit3.Text := '';
      BandFileEdit2.Text := '';
      BandFileEdit1.Text := '';
      IMHEdit.Text := '';
      IMWEdit.Text := '';
      LCol :='';// DISSubsetLeft.Text;
      DISLEdit.Text :='';// DISSubsetLeft.Text;
      RCol :='';// DISSubsetRight.Text;
      DISREdit.Text := '';//DISSubsetRight.Text;
      TRow :='';// DISSubsetTop.Text;
      DISTEdit.Text :='';// DISSubsetTop.Text;
      BRow :='';// DISSubsetBottom.Text;
      DISBEdit.Text :='';// DISSubsetBottom.Text;
       {
      val(BRow, BottomRow, ErrorCode);
      if (ErrorCode <> 0) then
        DoMessages(39971);
      val(TRow, TopRow, ErrorCode);
      if (ErrorCode <> 0) then
        DoMessages(39971);
      val(RCol, RightColumn, ErrorCode);
      if (ErrorCode <> 0) then
        DoMessages(39971);
      val(LCol, LeftColumn, ErrorCode);
      if (ErrorCode <> 0) then
        DoMessages(39971);
      i := (RightColumn - LeftColumn) + 1;
      str(i, InString);
      if (InString <> DISSubsetWidth.Text) then
        DoMessages(39967);
      IMWEdit.Text := InString;
      ii := (BottomRow - TopRow) + 1;
      str(ii, InString);
      if (InString <> DISSubsetHeight.Text) then
        DoMessages(39967);
      IMHEdit.Text := InString;
      }
  end;
end;




procedure TSatelliteImportForm.RIHOpenFSTHeader(InFileName: string);
{var
  F1: TextFile;
  Endi, ErrorCode, I, II: Integer;
  HeadStr, temp: string;}
begin
(*  {Read in the header file}
  HeadStr := '';
  II := 1;
  AssignFile(F1, InFileName);
  Reset(F1);
  while not eof(F1) do
  begin
    Readln(F1, Temp);
    HeadStr := HeadStr + Temp;
  end;
  CloseFile(F1);
  {Actually process the file}
  RIHIDEdit.Text := DIHVersion;
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 21);
  Temp := Trim(Temp);
  RIHProjectData.Text := Temp;
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 18);
  Temp := Trim(Temp);
  RIHPath.Text := copy(Temp, 1, 3);
  RIHStartRow.Text := copy(Temp, 5, 3);
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 8);
  Temp := Trim(Temp);
  RIHAcquiredEdit.Text := Temp;
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 10);
  Temp := Trim(Temp);
  RIHImageTypeEdit.Text := Temp;
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 8);
  Temp := Trim(Temp);
  RIHSensorType.Text := Temp;
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 7);
  Temp := Trim(Temp);
  RIHSensorModeEdit.Text := Temp;
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 5);
  Temp := Trim(Temp);
  RIHLookAngleEdit.Text := Temp;
  for I := 1 to 18 do
  begin
    while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
    Delete(HeadStr, 1, 1);
  end;
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 19);
  Temp := Trim(Temp);
  ProductTypeEdit.Text := Temp;
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 10);
  Temp := Trim(Temp);
  ProductTypeEdit.Text := Temp;
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 10);
  Temp := Trim(Temp);
  PreProcessingEdit.Text := Temp;
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 10);
  Temp := Trim(Temp);
  ResamplingTechniqueEdit.Text := Temp;
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 10);
  Temp := Trim(Temp);
  RIHVolumeEdit.Text := copy(Temp, 1, 2);
  RIHinSetEdit.Text := copy(Temp, 4, 2);

  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 6);
  Temp := Trim(Temp);
  RIHIW.Text := Temp;
  val(Temp, Endi, ErrorCode);
  RIHLC.text := '1';
  RIHRC.text := InttoStr(Endi);
  RIHinLine.text := InttoStr(Endi);
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 5);
  Temp := Trim(Temp);
  RIHIH.Text := Temp;
  RIHinColumn.Text := Temp;
  val(Temp, Endi, ErrorCode);
{FIGURE OUT THE WIDTH and HEIGHT}
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 6);
  Temp := Trim(Temp);
  if Length(Temp) < 1 then
  begin
    RIHTR.text := '1';
    RIHBR.text := InttoStr(Endi);
  end else
  begin
    RIHTR.Text := Temp;
    val(Temp, I, ErrorCode);
    RIHBR.text := InttoStr(Endi + I);
  end;
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 3);
  Temp := Trim(Temp);
  if Length(Temp) < 1 then RIHBlockEdit.Text := '1';
  RIHBlockEdit.Text := Temp;
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 10);
  Temp := Trim(Temp);
  RIHRecordSizeEdit.Text := Temp;
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 5);
  Temp := Trim(Temp);
  PixelXSizeEdit.Text := Temp;
  PixelYSizeEdit.Text := Temp;
  RIHSwathHeightRezEdit.Text := Temp;
  RIHSwathWidthRezEdit.Text := Temp;
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 3);
  Temp := Trim(Temp);
  RIHCurrentBitsEdit.Text := Temp;
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 3);
  Temp := Trim(Temp);
  RIHAcquiredBitsEdit.Text := Temp;
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 7);
  Temp := Trim(Temp);
  I := Length(Temp);
  if Temp = '8' then II := 8 else
    if Temp = '123457' then II := 1 else
      if Temp = 'LH' then II := 6;
  RIHNBEdit.Text := IntToStr(I);
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 29);
  Temp := Trim(Temp);
  if II = 1 then RIHBFName1.Text := Temp else
    if II = 8 then RIHBFName8.Text := Temp else
      if II = 6 then RIHBFName6L.Text := Temp;
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 29);
  Temp := Trim(Temp);
  if II = 1 then RIHBFName2.Text := Temp else
    if II = 6 then RIHBFName6H.Text := Temp;
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 29);
  Temp := Trim(Temp);
  RIHBFName3.Text := Temp;
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 29);
  Temp := Trim(Temp);
  RIHBFName4.Text := Temp;
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 29);
  Temp := Trim(Temp);
  RIHBFName5.Text := Temp;
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 29);
  Temp := Trim(Temp);
  if II = 1 then RIHBFName7.Text := Temp;
{NO  = }
  while (HeadStr[1] <> 'V') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 13);
  Temp := Trim(Temp);
  RevEdit.Text := Temp;
  while (HeadStr[1] <> 'G') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 47); {47}
  while (ord(HeadStr[1]) < 36) do Delete(HeadStr, 1, 1);
  if (II = 8) then
  begin
    Temp := copy(HeadStr, 1, 19);
    Temp := Trim(Temp);
    RIHGain8.Text := Temp;
    Delete(HeadStr, 1, 19);
    while (ord(HeadStr[1]) < 36) do Delete(HeadStr, 1, 1);
    Temp := copy(HeadStr, 1, 19);
    Temp := Trim(Temp);
    RIHBias8.Text := Temp;
    Delete(HeadStr, 1, 19);
  end else
    if II = 6 then
    begin
      Temp := copy(HeadStr, 1, 19);
      Temp := Trim(Temp);
      RIHGain6L.Text := Temp;
      Delete(HeadStr, 1, 19);
      while (ord(HeadStr[1]) < 36) do Delete(HeadStr, 1, 1);
      Temp := copy(HeadStr, 1, 19);
      Temp := Trim(Temp);
      RIHBias6L.Text := Temp;
      Delete(HeadStr, 1, 19);
      while (ord(HeadStr[1]) < 36) do Delete(HeadStr, 1, 1);

      Temp := copy(HeadStr, 1, 19);
      Temp := Trim(Temp);
      RIHGain6H.Text := Temp;
      Delete(HeadStr, 1, 19);
      while (ord(HeadStr[1]) < 36) do Delete(HeadStr, 1, 1);
      Temp := copy(HeadStr, 1, 19);
      Temp := Trim(Temp);
      RIHBias6H.Text := Temp;
      Delete(HeadStr, 1, 19);
      while (ord(HeadStr[1]) < 36) do Delete(HeadStr, 1, 1);
    end else
      if II = 1 then
      begin
        Temp := copy(HeadStr, 1, 19);
        Temp := Trim(Temp);
        RIHGain1.Text := Temp;
        Delete(HeadStr, 1, 19);
        while (ord(HeadStr[1]) < 36) do Delete(HeadStr, 1, 1);
        Temp := copy(HeadStr, 1, 19);
        Temp := Trim(Temp);
        RIHBias1.Text := Temp;
        Delete(HeadStr, 1, 19);
        while (ord(HeadStr[1]) < 36) do Delete(HeadStr, 1, 1);
        Temp := copy(HeadStr, 1, 19);
        Temp := Trim(Temp);
        RIHGain2.Text := Temp;
        Delete(HeadStr, 1, 19);
        while (ord(HeadStr[1]) < 36) do Delete(HeadStr, 1, 1);
        Temp := copy(HeadStr, 1, 19);
        Temp := Trim(Temp);
        RIHBias2.Text := Temp;
        Delete(HeadStr, 1, 19);
        while (ord(HeadStr[1]) < 36) do Delete(HeadStr, 1, 1);
        Temp := copy(HeadStr, 1, 19);
        Temp := Trim(Temp);
        RIHGain3.Text := Temp;
        Delete(HeadStr, 1, 19);
        while (ord(HeadStr[1]) < 36) do Delete(HeadStr, 1, 1);
        Temp := copy(HeadStr, 1, 19);
        Temp := Trim(Temp);
        RIHBias3.Text := Temp;
        Delete(HeadStr, 1, 19);
        while (ord(HeadStr[1]) < 36) do Delete(HeadStr, 1, 1);
        Temp := copy(HeadStr, 1, 19);
        Temp := Trim(Temp);
        RIHGain4.Text := Temp;
        Delete(HeadStr, 1, 19);
        while (ord(HeadStr[1]) < 36) do Delete(HeadStr, 1, 1);
        Temp := copy(HeadStr, 1, 19);
        Temp := Trim(Temp);
        RIHBias4.Text := Temp;
        Delete(HeadStr, 1, 19);
        while (ord(HeadStr[1]) < 36) do Delete(HeadStr, 1, 1);
        Temp := copy(HeadStr, 1, 19);
        Temp := Trim(Temp);
        RIHGain5.Text := Temp;
        Delete(HeadStr, 1, 19);
        while (ord(HeadStr[1]) < 36) do Delete(HeadStr, 1, 1);
        Temp := copy(HeadStr, 1, 19);
        Temp := Trim(Temp);
        RIHBias5.Text := Temp;
        Delete(HeadStr, 1, 19);
        while (ord(HeadStr[1]) < 36) do Delete(HeadStr, 1, 1);

        Temp := copy(HeadStr, 1, 19);
        Temp := Trim(Temp);
        RIHGain7.Text := Temp;
        Delete(HeadStr, 1, 19);
        while (ord(HeadStr[1]) < 36) do Delete(HeadStr, 1, 1);
        Temp := copy(HeadStr, 1, 19);
        Temp := Trim(Temp);
        RIHBias7.Text := Temp;
        Delete(HeadStr, 1, 19);
        while (ord(HeadStr[1]) < 36) do Delete(HeadStr, 1, 1);
      end;
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 5);
  Temp := Trim(Temp);
  ProjectionEdit.Text := Temp;
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 19);
  Temp := Trim(Temp);
  SpheroidEdit.Text := Temp;
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 5);
  Temp := Trim(Temp);
  DatumEdit.Text := Temp;
{Projection: ALOT of NUMBERS and NO IDEAS}
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 18);
  Temp := Trim(Temp);
  A1Edit.Text := Temp;
  Delete(HeadStr, 1, 19);
  while (ord(HeadStr[1]) < 36) do Delete(HeadStr, 1, 1);
{         While (HeadStr[1]<>' ')do Delete(HeadStr,1,1);}
  Temp := copy(HeadStr, 1, 18);
  Temp := Trim(Temp);
  A2Edit.Text := Temp;
  Delete(HeadStr, 1, 19);
  while (ord(HeadStr[1]) < 36) do Delete(HeadStr, 1, 1);
{         While (HeadStr[1]<>' ')do Delete(HeadStr,1,1);}
  Temp := copy(HeadStr, 1, 18);
  Temp := Trim(Temp);
  A3Edit.Text := Temp;
  Delete(HeadStr, 1, 19);
  while (ord(HeadStr[1]) < 36) do Delete(HeadStr, 1, 1);
{         While (HeadStr[1]<>' ')do Delete(HeadStr,1,1);}
  Temp := copy(HeadStr, 1, 18);
  Temp := Trim(Temp);
  B1Edit.Text := Temp;
  Delete(HeadStr, 1, 19);
  while (ord(HeadStr[1]) < 36) do Delete(HeadStr, 1, 1);
{         While (HeadStr[1]<>' ')do Delete(HeadStr,1,1);}
  Temp := copy(HeadStr, 1, 18);
  Temp := Trim(Temp);
  B2Edit.Text := Temp;
  Delete(HeadStr, 1, 19);
  while (ord(HeadStr[1]) < 36) do Delete(HeadStr, 1, 1);
{         While (HeadStr[1]<>' ')do Delete(HeadStr,1,1);}
  Temp := copy(HeadStr, 1, 18);
  Temp := Trim(Temp);
  B3Edit.Text := Temp;
  Delete(HeadStr, 1, 19);
  while (ord(HeadStr[1]) < 36) do Delete(HeadStr, 1, 1);
{         While (HeadStr[1]<>' ')do Delete(HeadStr,1,1);}
  Temp := copy(HeadStr, 1, 18);
  Temp := Trim(Temp);
  C1Edit.Text := Temp;
  Delete(HeadStr, 1, 19);
  while (ord(HeadStr[1]) < 36) do Delete(HeadStr, 1, 1);
{         While (HeadStr[1]<>' ')do Delete(HeadStr,1,1);}
  Temp := copy(HeadStr, 1, 18);
  Temp := Trim(Temp);
  C2Edit.Text := Temp;
  Delete(HeadStr, 1, 19);
  while (ord(HeadStr[1]) < 36) do Delete(HeadStr, 1, 1);
{         While (HeadStr[1]<>' ')do Delete(HeadStr,1,1);}
  Temp := copy(HeadStr, 1, 18);
  Temp := Trim(Temp);
  C3Edit.Text := Temp;
  Delete(HeadStr, 1, 19);
  while (ord(HeadStr[1]) < 36) do Delete(HeadStr, 1, 1);
{         While (HeadStr[1]<>' ')do Delete(HeadStr,1,1);}
  Temp := copy(HeadStr, 1, 18);
  Temp := Trim(Temp);
  D1Edit.Text := Temp;
  Delete(HeadStr, 1, 19);
  while (ord(HeadStr[1]) < 36) do Delete(HeadStr, 1, 1);
{         While (HeadStr[1]<>' ')do Delete(HeadStr,1,1);}
  Temp := copy(HeadStr, 1, 18);
  Temp := Trim(Temp);
  D2Edit.Text := Temp;
  Delete(HeadStr, 1, 19);
  while (ord(HeadStr[1]) < 36) do Delete(HeadStr, 1, 1);
{         While (HeadStr[1]<>' ')do Delete(HeadStr,1,1);}
  Temp := copy(HeadStr, 1, 18);
  Temp := Trim(Temp);
  D3Edit.Text := Temp;
  Delete(HeadStr, 1, 19);
  while (ord(HeadStr[1]) < 36) do Delete(HeadStr, 1, 1);
{         While (HeadStr[1]<>' ')do Delete(HeadStr,1,1);}
  Temp := copy(HeadStr, 1, 18);
  Temp := Trim(Temp);
  E1Edit.Text := Temp;
  Delete(HeadStr, 1, 19);
  while (ord(HeadStr[1]) < 36) do Delete(HeadStr, 1, 1);
{         While (HeadStr[1]<>' ')do Delete(HeadStr,1,1);}
  Temp := copy(HeadStr, 1, 18);
  Temp := Trim(Temp);
  E2Edit.Text := Temp;
  Delete(HeadStr, 1, 19);
  while (ord(HeadStr[1]) < 36) do Delete(HeadStr, 1, 1);
{         While (HeadStr[1]<>' ')do Delete(HeadStr,1,1);}
  Temp := copy(HeadStr, 1, 18);
  Temp := Trim(Temp);
  E3Edit.Text := Temp;
{COORDINATES}
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 3);
  Temp := Trim(Temp);
  UTMZoneEdit.Text := Temp;
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 14);
  Temp := Trim(Temp);
  ULLongitudeEdit.Text := Temp;
  Temp := copy(HeadStr, 15, 13);
  Temp := Trim(Temp);
  ULLatitudeEdit.Text := Temp;
  Temp := copy(HeadStr, 28, 14);
  Temp := Trim(Temp);
  ULCoXEdit.Text := Temp;
  Temp := copy(HeadStr, 40, 14);
  Temp := Trim(Temp);
  ULCoYEdit.Text := Temp;
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 14);
  Temp := Trim(Temp);
  URLongitudeEdit.Text := Temp;
  Temp := copy(HeadStr, 15, 13);
  Temp := Trim(Temp);
  URLatitudeEdit.Text := Temp;
  Temp := copy(HeadStr, 28, 14);
  Temp := Trim(Temp);
  URCoXEdit.Text := Temp;
  Temp := copy(HeadStr, 40, 14);
  Temp := Trim(Temp);
  URCoYEdit.Text := Temp;
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 14);
  Temp := Trim(Temp);
  LRLongitudeEdit.Text := Temp;
  Temp := copy(HeadStr, 15, 13);
  Temp := Trim(Temp);
  LRLatitudeEdit.Text := Temp;
  Temp := copy(HeadStr, 28, 14);
  Temp := Trim(Temp);
  LRCoXEdit.Text := Temp;
  Temp := copy(HeadStr, 40, 14);
  Temp := Trim(Temp);
  LRCoYEdit.Text := Temp;
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 14);
  Temp := Trim(Temp);
  LLLongitudeEdit.Text := Temp;
  Temp := copy(HeadStr, 15, 13);
  Temp := Trim(Temp);
  LLLatitudeEdit.Text := Temp;
  Temp := copy(HeadStr, 28, 14);
  Temp := Trim(Temp);
  LLCoXEdit.Text := Temp;
  Temp := copy(HeadStr, 40, 14);
  Temp := Trim(Temp);
  LLCoYEdit.Text := Temp;

  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 14);
  Temp := Trim(Temp);
  CenLongitudeEdit.Text := Temp;
  Temp := copy(HeadStr, 15, 13);
  Temp := Trim(Temp);
  CenLatitudeEdit.Text := Temp;
  Temp := copy(HeadStr, 28, 14);
  Temp := Trim(Temp);
  CenCoXEdit.Text := Temp;
  Temp := copy(HeadStr, 40, 14);
  Temp := Trim(Temp);
  CenCoYEdit.Text := Temp;

  Temp := copy(HeadStr, 54, 7);
  Temp := Trim(Temp);
  CenCoPixXEdit.Text := Temp;
  Temp := copy(HeadStr, 61, 7);
  Temp := Trim(Temp);
  CenCoPixYEdit.Text := Temp;

  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 7);
  Temp := Trim(Temp);
  RIHOffsetEdit.Text := Temp;
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 5);
  Temp := Trim(Temp);
  RIHOrientationAngleEdit.Text := Temp;
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 5);
  Temp := Trim(Temp);
  RIHSunElevationAngleEdit.Text := Temp;
  while (HeadStr[1] <> '=') do Delete(HeadStr, 1, 1);
  Delete(HeadStr, 1, 1);
  Temp := copy(HeadStr, 1, 5);
  Temp := Trim(Temp);
  RIHSunAzimuthAngleEdit.Text := Temp;
*)
end;


procedure TSatelliteImportForm.RIHOpenIDXHeader(InFileName: string);
{var
  F1: TextFile;
  ErrorCode, i, ii: Integer;
LCol, RCol, TRow, BRow, InTString, InString, In2String: string;
}
begin
(*    If (not PBandHdrFormActive) then
    PBandHdrForm := TPBandHdrForm.Create(Application);
    PBandHdrFormActive:=True;
  PBandHdrForm.Show;
  PBandHdrForm.Load(InFileName);
  RIHIDEdit.Text := DIHVersion;
  RIHRIHEdit.Text := ExtractFileName(InFileName);
  RIHHeaderFileEdit.Text :=
    ChangeFileExt(ExtractFileName(InFileName),
    '.dih');
  AssignFile(F1, InFileName);
  Reset(F1);
  Readln(F1, InTString); {Title.. }
  RIHSceneTitle.Text := InTString;
  Readln(F1, InString);
  Readln(F1, In2String); {Number of Bands to process}
  val(In2String, NumberOfBands, ErrorCode);
  if (ErrorCode <> 0) then DoMessages(39970);
  RIHNBEdit.Text := In2String;
  if (NumberOfBands > 0) then begin
    Readln(F1, InTString);
    RIHBName1.Text := InTString;
    Readln(F1, In2String);
    RIHBFName1.Text := In2String;
  end;
  if (NumberOfBands > 1) then begin
    Readln(F1, InTString);
    RIHBName2.Text := InTString;
    Readln(F1, In2String);
    RIHBFName2.Text := In2String;
  end;
  if (NumberOfBands > 2) then begin
    Readln(F1, InTString);
    RIHBName3.Text := InTString;
    Readln(F1, In2String);
    RIHBFName3.Text := In2String;
  end;
  if (NumberOfBands > 3) then begin
    Readln(F1, InTString);
    RIHBName4.Text := InTString;
    Readln(F1, In2String);
    RIHBFName4.Text := In2String;
  end;
  if (NumberOfBands > 4) then begin
    Readln(F1, InTString);
    RIHBName5.Text := InTString;
    Readln(F1, In2String);
    RIHBFName5.Text := In2String;
  end;
  if (NumberOfBands > 5) then begin
    Readln(F1, InTString);
    RIHBName6L.Text := InTString;
    Readln(F1, In2String);
    RIHBFName6L.Text := In2String;
  end;
  if (NumberOfBands > 6) then begin
    Readln(F1, InTString);
    RIHBName7.Text := InTString;
    Readln(F1, In2String);
    RIHBFName7.Text := In2String;
  end;
  CloseFile(F1);


  LCol := '00000'; RCol := '00000'; TRow := '00000'; BRow := '00000';
  i := Length(InString); ii := 5;
  while (InString[i] <> ' ') do begin
    BRow[ii] := InString[i]; dec(i); dec(ii);
  end; dec(i); ii := 5;
  RIHBR.Text := BRow;
  while (InString[i] <> ' ') do begin
    TRow[ii] := InString[i]; dec(i); dec(ii);
  end; dec(i); ii := 5;
  RIHTR.Text := TRow;
  while (InString[i] <> ' ') do begin
    RCol[ii] := InString[i]; dec(i); dec(ii);
  end; dec(i); ii := 5;
  RIHRC.Text := RCol;
  while ((InString[i] <> ' ') and (i > 0)) do begin
    LCol[ii] := InString[i]; dec(i); dec(ii);
  end;
  RIHLC.Text := LCol;
  val(BRow, BottomRow, ErrorCode);
  if (ErrorCode <> 0) then DoMessages(39971);
  val(TRow, TopRow, ErrorCode);
  if (ErrorCode <> 0) then DoMessages(39971);
  val(RCol, RightColumn, ErrorCode);
  if (ErrorCode <> 0) then DoMessages(39971);
  val(LCol, LeftColumn, ErrorCode);
  if (ErrorCode <> 0) then DoMessages(39971);
  i := (RightColumn - LeftColumn) + 1;
  str(i, InString);
  RIHIW.Text := InString;
  RIHinLine.Text := InString;
  ii := (BottomRow - TopRow) + 1; str(ii, InString);
  RIHIH.Text := InString;
  RIHinColumn.Text := InString;
  RIHLC.Text := LCol;
  RIHRC.Text := RCol;
  RIHTR.Text := TRow;
  RIHBR.Text := Brow;
  RIHSaveIt;
  *)
end;

procedure TSatelliteImportForm.PBandFileBtn1Click(Sender: TObject);
begin
{Open files to select a # 1  band}
  BandOpenDialog.InitialDir := ImagePath;
  BandOpenDialog.Filter := 'Spectral Bands (B??, P??)|*.B??;*.P??;*.*';
  if BandOpenDialog.execute then
  begin
    BandFile1 := BandOpenDialog.filename;
    BandFileEdit1.Text := ExtractFileName(BandOpenDialog.filename);
  end;
end;

procedure TSatelliteImportForm.PBandFileBtn2Click(Sender: TObject);
begin
{Open files to select a # 2  band}
  BandOpenDialog.InitialDir := ImagePath;
  BandOpenDialog.Filter := 'Spectral Bands (B??, P??)|*.B??;*.P??;*.*';
  if BandOpenDialog.execute then begin
    BandFile2 := BandOpenDialog.filename;
    BandFileEdit2.Text := ExtractFileName(BandOpenDialog.filename);
  end;
end;

procedure TSatelliteImportForm.PBandFileBtn3Click(Sender: TObject);
begin
{Open files to select a # 3  band}
  BandOpenDialog.InitialDir := ImagePath;
  BandOpenDialog.Filter := 'Spectral Bands (B??, P??)|*.B??;*.P??;*.*';
  if BandOpenDialog.execute then begin
    BandFile3 := BandOpenDialog.filename;
    BandFileEdit3.Text := ExtractFileName(BandOpenDialog.filename);
  end;
end;

procedure TSatelliteImportForm.PBOKBtnClick(Sender: TObject);
var
  temp: string;
ErrorCode:Integer;
{  F1: TextFile;}
begin
  {if DISisValid then
  begin }
  SatelliteImportForm.Cursor:=CRHOURGLASS;
  Application.ProcessMessages;
  {Process the Selected Bands into an image}
  temp := BandFileSaveAs.Text;
  OutputFileName := ChangeFileExt(temp, '.png');
  BandFileSaveAsStr:=ImagePath+temp;

  val(IMWEdit.Text, ImageWidth, ErrorCode);
  if (ErrorCode <> 0) then DoMessages(39971);
  val(IMHEdit.Text, ImageHeight, ErrorCode);
  if (ErrorCode <> 0) then DoMessages(39971);

  val(DISBEdit.Text, BottomRow, ErrorCode);
  if (ErrorCode <> 0) then DoMessages(39971);
  val(DISTEdit.Text, TopRow, ErrorCode);
  if (ErrorCode <> 0) then DoMessages(39971);
  val(DISREdit.Text, RightColumn, ErrorCode);
  if (ErrorCode <> 0) then DoMessages(39971);
  val(DISLEdit.Text, LeftColumn, ErrorCode);
  if (ErrorCode <> 0) then DoMessages(39971);

{If only 1 band has a name then do Radar}
    if ((BandFileEdit3.Text = '')
      and (BandFileEdit2.Text = '')
      and (BandFileEdit1.Text <> '')) then
    begin
      if (BandFileSaveAsStr = 'BandFileSaveAs') then
        DoMessages(28) else
        if (not FileExists(BandFile1)) then
          DoMessages(29) else
        begin
          Do_JER_Radar;
        end;
    end else
{Check that data is filled in and do 3 band image}
    begin
{      if BandHdrEdit.Text = '' then
        DoMessages(30) else}
        if (BandFileSaveAsStr = 'BandFileSaveAs') then
          DoMessages(28) else
          if BandFile1 = '' then
            DoMessages(31) else
            if BandFile2 = '' then
              DoMessages(32) else
              if BandFile3 = '' then
                DoMessages(33) else
                if (not FileExists(BandFile1)) then
                  DoMessages(29) else
                  if (not FileExists(BandFile2)) then
                    DoMessages(34) else
                    if (not FileExists(BandFile3)) then
                      DoMessages(35) else
                    begin
                      Do_BandstoRGBImage;
                    end;
    end;
  {end else DoMessages(39993);}
  SatelliteImportForm.Cursor:=CRDefault;
  Application.ProcessMessages;
end;


   {PIXELS PER LINE =7911  LINES PER BAND =7081 }
procedure TSatelliteImportForm.Do_BandstoRGBImage;
{BandFile1,BandFile2,BandFile3,BandFileSaveAsStr,
LeftColumn,RightColumn,TopRow,BottomRow}
{Blockread}
var
  RedF, GreenF, BlueF: file;
  NumRead : Integer;
  temp, tempath: string;
  hPixelBuffer: THandle; {Handle to the pixel buffer}
  lpPixelBuffer: pointer; {pointer to the pixel buffer}
  lpBitmapInfo: PBitmapInfo; {The bitmap info header}
  BitmapInfoSize: longint; {Size of the bitmap info header}
  i,  IL, IW, LineSize, LeftColumnD,
  guaged, Height, Width,
  BitmapSize: DWord; {Size of the pixel array}
  templ: longint;
  hBm: hBitmap; {handle to our bitmap}
  Bm: TBitmap; {temporary TBitmap}
  Dc: hdc; {used to convert the DOB to a DDB}
begin
  {$IFOPT R+}
  {$DEFINE CKRANGE}
  {$R-}
  {$ENDIF}
  PBOKBtn.Caption:='Processing';
  Application.ProcessMessages;
  try
    BitmapInfoSize := sizeof(TBitmapInfo);
    {The bitmap size must be the width of the bitmap rounded}
     {up to the nearest 32 bit boundary}
    {LeftColumn,RightColumn,TopRow,BottomRow}
    LeftColumnD:=LeftColumn;
    Width := ((RightColumn - LeftColumn) + 1);
    Height := ((BottomRow - TopRow) + 1);
    templ := trunc(((Width * 24) + 31) / 32);
    BytesPerLine := (templ * 4);
    BitmapSize := ((sizeof(byte) * Height) * BytesPerLine);

    {Get the memory for the BitmapInfo, the PixelBuffer,and RGB lines }
    GetMem(lpBitmapInfo, BitmapInfoSize);
    hPixelBuffer := GlobalAlloc(GHND, BitmapSize);
    lpPixelBuffer := GlobalLock(hPixelBuffer);

    LineSize := (sizeof(byte) * ImageWidth);
    hRedBitmap := GlobalAlloc(GHND, LineSize);
    hGreenBitmap := GlobalAlloc(GHND, LineSize);
    hBlueBitmap := GlobalAlloc(GHND, LineSize);
    RedBitmap := GlobalLock(hRedBitmap);
    GreenBitmap := GlobalLock(hGreenBitmap);
    BlueBitmap := GlobalLock(hBlueBitmap);

    {Zero out the BitmapInfo, the PixelBuffer, and the Palette}
    FillChar(lpBitmapInfo^, BitmapInfoSize, #0);
    FillChar(lpPixelBuffer^, BitmapSize, #0);
    {Fill in the BitmapInfo structure}
    lpBitmapInfo^.bmiHeader.biSize := sizeof(TBitmapInfoHeader);
    lpBitmapInfo^.bmiHeader.biWidth := Width;
    lpBitmapInfo^.bmiHeader.biHeight := Height;
    lpBitmapInfo^.bmiHeader.biPlanes := 1;
    lpBitmapInfo^.bmiHeader.biBitCount := 24;
    lpBitmapInfo^.bmiHeader.biCompression := BI_RGB;
    lpBitmapInfo^.bmiHeader.biSizeImage := BitmapSize;
    lpBitmapInfo^.bmiHeader.biXPelsPerMeter := 0;
    lpBitmapInfo^.bmiHeader.biYPelsPerMeter := 0;
    lpBitmapInfo^.bmiHeader.biClrUsed := 0;
    lpBitmapInfo^.bmiHeader.biClrImportant := 0;
    try

      {Fill in the pixel buffer array from loaded images}
      AssignFile(RedF, BandFile1);
      Reset(RedF, LineSize);
      AssignFile(GreenF, BandFile2);
      Reset(GreenF, LineSize);
      AssignFile(BlueF, BandFile3);
      Reset(BlueF, LineSize);
      guaged := 1;
      for i:= 0 to TopRow do
      begin
        BlockRead(RedF, RedBitmap^, 1, NumRead);
        BlockRead(GreenF, GreenBitmap^, 1, NumRead);
        BlockRead(BlueF, BlueBitmap^, 1, NumRead);
      end;
      for IL := Height - 1 downto 0 do
      begin
        ProgressBar1.Position:=(((guaged div Height) * 100));
        Application.ProcessMessages;
        inc(guaged);
        BlockRead(RedF, RedBitmap^, 1, NumRead);
        BlockRead(GreenF, GreenBitmap^, 1, NumRead);
        BlockRead(BlueF, BlueBitmap^, 1, NumRead);
        for IW := 0 to Width - 1 do
        begin
          WherePixel := ((IW * 3) + (IL * BytesPerLine));
          lpPixelB := @PHugeByteArray(lpPixelBuffer)^[WherePixel];
          lpPixelG := @PHugeByteArray(lpPixelBuffer)^[WherePixel + 1];
          lpPixelR := @PHugeByteArray(lpPixelBuffer)^[WherePixel + 2];
          lpPixelB^ := PHugeByteArray(BlueBitmap)^[IW+LeftColumnD];
          lpPixelG^ := PHugeByteArray(GreenBitmap)^[IW+LeftColumnD];
          lpPixelR^ := PHugeByteArray(RedBitmap)^[IW+LeftColumnD];
        end;
      end;
      CloseFile(RedF);
      CloseFile(GreenF);
      CloseFile(BlueF);

      {Get the screen's dc to use for the conversion since}
      {memory dc's are not reliable to use for conversions}
      dc := GetDc(0); {Do the conversion}
      hBm := CreateDiBitmap(dc, lpBitmapInfo^.bmiHeader,
             CBM_INIT, pChar(lpPixelBuffer), lpBitmapInfo^,
             DIB_RGB_COLORS);
      ReleaseDc(0, dc); {Give back the screen dc}
      bm := TBitmap.Create; {Create a temporory TBitmap}
      bm.Handle := hBm; {Assign the handle}
      {Size Image1}
      TongsForm.Image1.Width := Width;
      TongsForm.Image1.Height := Height;
       {Assign the bitmap}
      TongsForm.Image1.Picture.Bitmap := bm; {Assign the bitmap}
      SelectPalette(TongsForm.Image1.Picture.Bitmap.Canvas.Handle,
        TongsForm.Image1.Picture.Bitmap.Palette,
        false);
      bm.free;
      TongsForm.Image1.Picture.Bitmap.PixelFormat := pf24bit;
      TongFilename := ChangeFileExt(BandFileSaveAs.Text, '.png');
      {FilePath := ImagePath;}
      TongsForm.SaveImage;
      TongsForm.LoadFromFile(TongFilename);
    finally
      {Free up the memory we used}
      GlobalUnlock(hPixelBuffer);
      GlobalFree(hPixelBuffer);
      FreeMem(lpBitmapInfo, BitmapInfoSize);
    end;
  finally
    GlobalUnLock(hRedBitmap); GlobalFree(hRedBitmap);
    GlobalUnLock(hGreenBitmap); GlobalFree(hGreenBitmap);
    GlobalUnLock(hBlueBitmap); GlobalFree(hBlueBitmap);
    PBOKBtn.Caption:= '4. Press Button';
    {Turn range checking back on if it was on when we started}
    {$IFDEF CKRANGE}
    {$UNDEF CKRANGE}
    {$R+}
    {$ENDIF}
  end;
  ProgressBar1.Position:=0;
  SatelliteImportForm.Caption:='Satellite Import: '+ImagePath + TongFilename;
end;


procedure TSatelliteImportForm.Do_JER_Radar;
var
  RedF: file;
  i,NumRead {, NumWritten}: Integer;
  hPixelBuffer: THandle; {Handle to the pixel buffer}
  lpPixelBuffer: pointer; {pointer to the pixel buffer}
{  lpPalBuffer : PLogPalette; }{The palette buffer}
  lpBitmapInfo: PBitmapInfo; {The bitmap info header}
  BitmapInfoSize: longint; {Size of the bitmap info header}
  BitmapSize: longint; {Size of the pixel array}
{  PaletteSize : integer;}{Size of the palette buffer}
LeftColumnD,
  Guaged, Height, Width, IL, IW, LineSize: Dword;
  templ: longint; {loop variable}
{  j : longint;}{loop variable}
{  OldPal : hPalette;}{temp palette}
{  hPal : hPalette; }{handle to our palette}
  hBm: hBitmap; {handle to our bitmap}
  Bm: TBitmap; {temporary TBitmap}
  Dc: hdc; {used to convert the DOB to a DDB}
{  IsPaletteDevice : bool;  }
begin
  Application.ProcessMessages;
  {$IFOPT R+}
  {$DEFINE CKRANGE}
  {$R-}
  {$ENDIF}
  try
    BitmapInfoSize := sizeof(TBitmapInfo);
    {The bitmap size must be the width of the bitmap rounded}
    {up to the nearest 32 bit boundary}
    {LeftColumn,RightColumn,TopRow,BottomRow}
    LeftColumnD:=LeftColumn;
    Width := ((RightColumn - LeftColumn) + 1);
    Height := ((BottomRow - TopRow) + 1);
    templ := trunc(((Width * 24) + 31) / 32);
    BytesPerLine := (templ * 4);
    BitmapSize := ((sizeof(byte) * Height) * BytesPerLine);
    LineSize := (sizeof(byte) * Width);
    {Get the memory for the BitmapInfo, the PixelBuffer,and RGB lines }
    GetMem(lpBitmapInfo, BitmapInfoSize);
    hPixelBuffer := GlobalAlloc(GHND, BitmapSize);
    if (hPixelBuffer = 0) then
    begin
      FreeMem(lpBitmapInfo, BitmapInfoSize);
      GlobalFree(hPixelBuffer);
      DoMessages(39977);
      exit;
    end else
    begin
      lpPixelBuffer := GlobalLock(hPixelBuffer);
      hRedBitmap := GlobalAlloc(GHND, LineSize);
      if (hRedBitmap = 0) then
      begin
        GlobalUnlock(hPixelBuffer);
        GlobalFree(hPixelBuffer);
        FreeMem(lpBitmapInfo, BitmapInfoSize);
        GlobalFree(hRedBitmap);
        DoMessages(39977);
        exit;
      end else
      begin
        RedBitmap := GlobalLock(hRedBitmap);
      end;
    end;
    {Zero out the BitmapInfo, the PixelBuffer, and the Palette}
    FillChar(lpBitmapInfo^, BitmapInfoSize, #0);
    FillChar(lpPixelBuffer^, BitmapSize, #0);
    {Fill in the BitmapInfo structure}
    lpBitmapInfo^.bmiHeader.biSize := sizeof(TBitmapInfoHeader);
    lpBitmapInfo^.bmiHeader.biWidth := Width;
    lpBitmapInfo^.bmiHeader.biHeight := Height;
    lpBitmapInfo^.bmiHeader.biPlanes := 1;
    lpBitmapInfo^.bmiHeader.biBitCount := 24;
    lpBitmapInfo^.bmiHeader.biCompression := BI_RGB;
    lpBitmapInfo^.bmiHeader.biSizeImage := BitmapSize;
    lpBitmapInfo^.bmiHeader.biXPelsPerMeter := 0;
    lpBitmapInfo^.bmiHeader.biYPelsPerMeter := 0;
    lpBitmapInfo^.bmiHeader.biClrUsed := 0;
    lpBitmapInfo^.bmiHeader.biClrImportant := 0;

    AssignFile(RedF, TongFilename);
    Reset(RedF, LineSize);
    for i:= 0 to TopRow do
    begin
        BlockRead(RedF, RedBitmap^, 1, NumRead);
    end;
    begin guaged := 1;
      for IL := Height - 1 downto 0 do begin
        ProgressBar1.Position:=(((guaged div Height) * 100));
        Application.ProcessMessages;
        inc(guaged);
        BlockRead(RedF, RedBitmap^, 1, NumRead);
        for IW := 0 to Width - 1 do begin
          WherePixel := ((IW * 3) + (IL * BytesPerLine));
          lpPixelB := @PHugeByteArray(lpPixelBuffer)^[WherePixel];
          lpPixelG := @PHugeByteArray(lpPixelBuffer)^[WherePixel +
            1];
          lpPixelR := @PHugeByteArray(lpPixelBuffer)^[WherePixel +
            2];
          lpPixelB^ := PHugeByteArray(RedBitmap)^[IW+LeftColumnD];
          lpPixelG^ := PHugeByteArray(RedBitmap)^[IW+LeftColumnD];
          lpPixelR^ := PHugeByteArray(RedBitmap)^[IW+LeftColumnD];
        end;
      end;
    end;
    CloseFile(RedF);
    {Get the screen's dc to use for the conversion since}
     {memory dc's are not reliable to use for conversions}
    dc := GetDc(0); {Do the conversion}
    hBm := CreateDiBitmap(dc, lpBitmapInfo^.bmiHeader,
      CBM_INIT, pChar(lpPixelBuffer), lpBitmapInfo^, DIB_RGB_COLORS);
    ReleaseDc(0, dc); {Give back the screen dc}
    bm := TBitmap.Create; {Create a temporory TBitmap}
    bm.Handle := hBm; {Assign the handle}
    {Size Image1}
    TongsForm.Image1.Width := Width;
    TongsForm.Image1.Height := Height;
    {Assign the bitmap}
    TongsForm.Image1.Picture.Bitmap := bm; {Assign the bitmap}
    SelectPalette(TongsForm.Image1.Picture.Bitmap.Canvas.Handle,
      TongsForm.Image1.Picture.Bitmap.Palette,
      false);
    bm.free;
    GlobalUnlock(hPixelBuffer);
    GlobalFree(hPixelBuffer);
    GlobalUnLock(hRedBitmap);
    GlobalFree(hRedBitmap);
    FreeMem(lpBitmapInfo, BitmapInfoSize);
    TongsForm.Image1.Picture.Bitmap.PixelFormat := pf24bit;
    TongFilename := ChangeFileExt(BandFileSaveAs.Text, '.png');
    {FilePath := ImagePath;}
    TongsForm.SaveImage;
    TongsForm.LoadFromFile(TongFilename);
  finally
    {Turn range checking back on if it was on when we started}
    {$IFDEF CKRANGE}
    {$UNDEF CKRANGE}
    {$R+}
    {$ENDIF}
  end;
  {reset the gauge to 0 } ProgressBar1.Position:=0;
  SatelliteImportForm.Caption:='Satellite Import: ' +ImagePath + TongFilename;
end;




end.
