unit TongDatabaseFrm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  jpeg, PNGImage,
  Menus, StdCtrls, DBCtrls, ExtCtrls,
  Grids, DBGrids, Db, DBTables;

type
  TTongDatabaseForm = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    DBImage1: TDBImage;
    DBMemo1: TDBMemo;
    MainMenu1: TMainMenu;
    Open1: TMenuItem;
    Print1: TMenuItem;
    Help1: TMenuItem;
    Exit1: TMenuItem;
    AddImage1: TMenuItem;
    OpenDialog: TOpenDialog;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Exit1Click(Sender: TObject);
    procedure Help1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
procedure SetNames;
    procedure Print1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure AddImage1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  TongDatabaseForm: TTongDatabaseForm;

implementation
uses TongGlobals, TongPeopleDbFrm, TongImageDbFrm;
{$R *.DFM}

procedure TTongDatabaseForm.FormCreate(Sender: TObject);
begin
  left := ImageDatabaseFormX;
  top := ImageDatabaseFormY;
end;
procedure TTongDatabaseForm.FormShow(Sender: TObject);
begin
  {Database1.Connected:=True;}
  {showmessage(ExtractFilePath(ParamStr(0))+'TongImage.DB'); }
  Table1.Active:=False;
  Table1.TableName:=ExtractFilePath(ParamStr(0))+'TongImage.DB';
  OpenDialog.FileName:=Table1.TableName;//ExtractFileName(OpenDialog.FileName);
  Table1.Active:=True;
  SetNames;
end;
procedure TTongDatabaseForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ImageDatabaseFormX := TongDatabaseForm.left;
  ImageDatabaseFormY := TongDatabaseForm.top;
  DoSaver;
  {Database1.Connected:=False;}
  Table1.Active:=False;
end;

procedure TTongDatabaseForm.Exit1Click(Sender: TObject);
begin
  close;
end;

procedure TTongDatabaseForm.Help1Click(Sender: TObject);
begin
  Application.HelpContext(234);
end;

procedure TTongDatabaseForm.Open1Click(Sender: TObject);
begin
  OpenDialog.Filter := 'TongImage or TongPeople(*.db)|*.db';
  OpenDialog.InitialDir:=ProgramPath;
  if OpenDialog.Execute then
  begin
    Table1.Active:=False;
    {Database1.Connected:=False; }
    Table1.TableName:=OpenDialog.FileName;//ExtractFileName(OpenDialog.FileName);
    Table1.Active:=True;
    {Database1.Connected:=True; }
    SetNames;
  end;
end;

procedure TTongDatabaseForm.SetNames;
Begin
    If ExtractFileName(Table1.TableName)= 'TongImage.DB' then
    begin
      Label1.Caption:='IDNAME';
      Label2.Caption:='ID';
      Label3.Visible:=False;
      Edit3.Visible:=False;
    end else
    If ExtractFileName(Table1.TableName)= 'TongPeople.DB' then
    begin
      Label1.Caption:='LastName';
      Label2.Caption:='FirstName';
      Label3.Visible:=True;
      Edit3.Visible:=True;
      Label3.Caption:='ID';
    end;
End;
procedure TTongDatabaseForm.Print1Click(Sender: TObject);
begin       {Print the FORM }
    If ExtractFileName(Table1.TableName)= 'TongImage.DB' then
    begin
  TongImageDbFrm.TongImageDbForm.QuickRep1.Preview;
{  TongImageDbForm := TTongImageDbForm.Create(Application);
  TongImageDbForm.ShowModal;
  TongImageDbForm.Free;}
    end
    else
    If ExtractFileName(Table1.TableName)= 'TongPeople.DB' then
    begin   {       TongPeopleDbForm   }
  TongPeopleDbFrm.TongPeopleDbForm.QuickRep1.Preview;
{  TongPeopleDbForm := TTongPeopleDbForm.Create(Application);
  TongPeopleDbForm.ShowModal;
  TongPeopleDbForm.Free;}
    end;
end;


{Use TDBImage to represent the value of graphic fields.
TDBImage allows a form to display graphical data from a dataset.
TDBImage can allow the user to edit graphical data using the clipboard.
While the application is running and the database image control has focus,
 users can cut, copy, and paste using the standard windows accelerator keys
 (Ctrl+X, Ctrl+C, and Ctrl+V).
 Users can return to the original state of the database image control
  by pressing Esc before moving to another record.

If the application doesnt require the data-aware capabilities of TDBImage,
 use an image control (TImage) instead to conserve system resources.}
procedure TTongDatabaseForm.AddImage1Click(Sender: TObject);
{Select an Image, Convert to 128x128 and Input File name and Path}
var
  FractalFilename: string;
  BitMap : TBitMap;
  PNG:TPNGObject;
  jp: TJpegImage;
var
  Ratio, Ratso: Double;
 H, W: Integer;
  Bitmap2: TBitmap;
begin
  OpenDialog.Filter := 'All (*.bmp;*.png;*.jpg)|*.bmp;*.png;*.jpg';
  OpenDialog.InitialDir:=ImagePath;
  if OpenDialog.Execute then
  begin
    ImagePath:=ExtractFilePath(OpenDialog.FileName);
    FractalFilename := OpenDialog.FileName;
    BitMap := TBitMap.create;
    Bitmap2 := TBitmap.Create;
    try
      if (lowercase(extractfileext(FractalFilename)) = '.jpg') then
      begin
        jp := TJpegImage.Create;
        try
          with jp do
          begin
            jp.LoadFromFile(FractalFilename);
            BitMap.Assign(jp);
          end;
        finally
          jp.Free;
        end;
      end else
      if (lowercase(extractfileext(FractalFilename)) = '.png') then
      begin
        PNG := TPNGObject.Create;
        {In case something goes wrong, free both PNG and Bitmap}
        try
          PNG.LoadFromFile(FractalFilename);
          BitMap.Assign(PNG); //Convert data into bitmap
        finally
         PNG.Free;
        end;
      end else
      if (lowercase(extractfileext(FractalFilename)) = '.bmp') then
      begin
        BitMap.LoadFromFile(FractalFilename);
      end else exit; {Gotta have something}
      {Paint Bitmap}
      {  PixelScanSize := 3;   pf24bit  PixelScanSize := 4;   pf32bit  }
      BitMap.PixelFormat := pf24bit;
      {Resize to 128x128}
      {Create a new bitmap and set its size}
      W := Bitmap.Width;
      H := Bitmap.Height;
      if (W > H) then
      begin
        Ratio := (W / 128);
        Ratso := (H / Ratio);
        H := trunc(Ratso);
        W := 128;
      end else
      begin
        Ratio := (H / 128);
        Ratso := (W / Ratio);
        W := trunc(Ratso);
        H := 128;
      end;
      Bitmap2.Width := W;
      Bitmap2.Height := H;
      {Copy the palette}
      Bitmap2.Palette := Bitmap.Palette;
      {Delete the lines needed to shrink}
      SetStretchBltMode(Bitmap.Canvas.Handle, {HALFTONE}
                        STRETCH_DELETESCANS);
      {Resize it}
      {Draws the graphic specified by the Graphic parameter
       in the rectangle specified by the Rect parameter.
       procedure StretchDraw(const Rect: TRect; Graphic: TGraphic );}
      Bitmap2.Canvas.StretchDraw(Rect(0,0,
            W - 1 {Bitmap.Width},
            H - 1 {Bitmap.Height}),
            Bitmap);
      {Place Image into Data record}
    If ExtractFileName(Table1.TableName)= 'TongImage.DB' then
    begin
{IDNAME * ID * Subject LLat  LLon Ldir LDis
ImageName ImagePath Notes Image}
  table1.InsertRecord([Edit1.Text,Edit2.Text,
Null, Null,Null, Null,Null,
ExtractFileName(OpenDialog.FileName),
ExtractFilePath(OpenDialog.FileName),
Null,BitMap2]);
    end else
    If ExtractFileName(Table1.TableName)= 'TongPeople.DB' then
    begin
{LastName * FirstName * ID * Address City State Zip Phone EMail
ImageName ImagePath  Notes Image}
  table1.InsertRecord([Edit1.Text,Edit2.Text,Edit3.Text,
Null, Null,Null, Null,Null, Null,
ExtractFileName(OpenDialog.FileName),
ExtractFilePath(OpenDialog.FileName),
Null,BitMap2]);
    end;
{  table1.InsertRecord([extractfilename(MyFileName),
               uppercase(extractfileext(MyFileName)),
               Date,Time,blob]);
Edit3.
IDNAME * ID * Subject LLat  LLon Ldir LDis
ImageName ImagePath Notes Image
       Null, Null,
LastName * FirstName * ID * Address City State Zip Phone EMail
ImageName ImagePath  Notes Image
               }
  (*    Table1.Edit;
{      Table1Image.Assign(BitMap2);}
{Table1['Image'].Value:= BitMap2;}
{      ImagTableBLOBIMAGE.Assign(blob);}
{Table1.FieldValues['Image']:= BitMap2;}
{Table1.Fields.Fields[6].AsBlob:= BitMap2;}
      {Place Name into Data record}
      FractalFilename := ExtractFilePath(OpenDialog.FileName);
      Table1['ImagePath'] := FractalFilename;
      FractalFilename := ExtractFileName(OpenDialog.FileName);
      Table1['ImageName'] := FractalFilename;
      Table1.Post;
*)
    finally
      BitMap.Free;
      BitMap2.Free;
    end;
  end;
end;

end.
