unit ZipFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs,
  StdCtrls, Buttons, ZipMstr, ComCtrls;

type
  TZipForm = class(TForm)
    ZipFileBtn: TSpeedButton;
    ZipFileEdit: TEdit;
    ZipFilesBtn: TSpeedButton;
    ZipListDelBtn: TButton;
    ZipListBox: TListBox;
    ZipDelBtn: TButton;
    UnzipBtn: TButton;
    ZipBtn: TButton;
    ZipVersionBtn: TButton;
    ZipHelpBtn: TBitBtn;
    ChrisEricLabel: TLabel;
    ZipEricLabel: TLabel;
    ZipInfoLabel: TLabel;
    Label161: TLabel;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    ZipMaster1: TZipMaster;
    StatusBar: TStatusBar;
    Label1: TLabel;
    Label2: TLabel;
    SpeedButton1: TSpeedButton;
    procedure ZipFileBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ZipFilesBtnClick(Sender: TObject);
    procedure ZipListDelBtnClick(Sender: TObject);
    procedure ZipDelBtnClick(Sender: TObject);
    procedure ZipBtnClick(Sender: TObject);
    procedure UnzipBtnClick(Sender: TObject);
    procedure ZipVersionBtnClick(Sender: TObject);
    procedure ZipHelpBtnClick(Sender: TObject);
    procedure ZipEricLabelClick(Sender: TObject);
    procedure ZipInfoLabelClick(Sender: TObject);
    procedure ZipMaster1Message(Sender: TObject; ErrCode: Integer;
      Message: String);
    procedure Label2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ZipForm: TZipForm;

implementation

{$R *.DFM}

uses   TongGlobals, FileCtrl, ShellAPI;

procedure TZipForm.SpeedButton1Click(Sender: TObject);
begin
Close;
end;

procedure TZipForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ZipFormX := ZipForm.left;
  ZipFormY := ZipForm.top;
end;

procedure TZipForm.FormDestroy(Sender: TObject);
begin
  ZipMaster1.Unload_Zip_Dll;
  ZipMaster1.Unload_Unz_Dll;
end;

procedure TZipForm.FormCreate(Sender: TObject);
begin
  left := ZipFormX;
  top := ZipFormY;
  ZipMaster1.Load_Zip_Dll;
  ZipMaster1.Load_Unz_Dll;
end;

procedure TZipForm.ZipHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(2800);
{ DEMO 2 for Delphi Zip by Eric W. Engler }
end;


procedure TZipForm.ZipFileBtnClick(Sender: TObject);
var I: Integer;
begin
OpenDialog1.Filename:=ZipFileEdit.Text;
  OpenDialog1.Filter := 'Zip file|*.zip';
  OpenDialog1.Options := [];
  OpenDialog1.InitialDir := ZipPath;
  if OpenDialog1.execute then
  begin
    if (lowercase(ExtractFileExt(OpenDialog1.filename)) = '.zip')
      then
    begin
      ZipFileEdit.Text := ExtractFileName(OpenDialog1.filename);
      OpenDialog1.InitialDir :=
        ExtractFilePath(OpenDialog1.filename);
      ZipPath := ExtractFilePath(OpenDialog1.filename);
      SetCurrentDir(ExtractFilePath(OpenDialog1.filename));
      ZipListBox.Clear;
      if FileExists(OpenDialog1.filename) then
      begin
       {Add to ZipListBox list}
        ZipMaster1.ZipFileName :=
          ExtractFileName(OpenDialog1.filename);
        with ZipMaster1 do
        begin
          if Count > 0 then
          begin
            for i := 1 to ZipMaster1.Count do
            begin
              with ZipDirEntry(ZipMaster1.ZipContents[i - 1]^) do
              begin
                ZipListBox.Items.Append(ExtractFileName(FileName));
              end;
            end;
          end;
        end;
      end else
        ZipMaster1.ZipFileName :=
          ExtractFileName(OpenDialog1.filename);
    end;
  end;
end;



procedure TZipForm.ZipFilesBtnClick(Sender: TObject);
var I: Integer;
begin
  OpenDialog1.Filter := 'anything goes|*.*';
  OpenDialog1.Filename:='*.*';
  OpenDialog1.Options :=
    [ofHideReadOnly, ofAllowMultiSelect, ofPathMustExist,
    ofFileMustExist];
  OpenDialog1.InitialDir := ZipPath;
  if OpenDialog1.execute then
  begin
    ZipListBox.Clear; {noname.zip}
    with OpenDialog1.Files do
      for I := 0 to Count - 1 do
      begin
        ZipListBox.Items.Append(ExtractFileName(Strings[I]));
      end;
  end;
  OpenDialog1.Options := [];
end;

procedure TZipForm.ZipListDelBtnClick(Sender: TObject);
var i: Integer;
begin
  for i := 0 to (ZipListBox.Items.Count - 1) do
  begin
    if ZipListBox.Selected[i] then
    begin
      ZipListBox.Items.Strings[i] := '';
      ZipListBox.Items.Move(i, ZipListBox.Items.Count-1);
    end;
  end;
end;

procedure TZipForm.ZipDelBtnClick(Sender: TObject);
var i, j: Integer;
begin
  for i := 0 to (ZipListBox.Items.Count - 1) do
  begin
    if ZipListBox.Selected[i] then
    begin
      ZipMaster1.FSpecArgs.Add(ZipListBox.Items.Strings[i]);
      ZipMaster1.Delete;

      with ZipMaster1 do
      begin
        if Count > 0 then
        begin
          for j := 1 to ZipMaster1.Count do
          begin
            with ZipDirEntry(ZipMaster1.ZipContents[j - 1]^) do
            begin
              ZipListBox.Items.Append(ExtractFileName(FileName));
            end;
          end;
        end;
      end;
    end;
  end;
{   ShowMessage('Files deleted = ' + IntToStr(ZipMaster1.SuccessCnt));}
end;

procedure TZipForm.ZipBtnClick(Sender: TObject);
var I: Integer;
begin
  if ZipListBox.Items.Count = 0 then
  begin
    ShowMessage('Nobody home');
    {DoMessages(39973);}
    Exit;
  end;

{   if not FileExists(ZipFileEdit.Text) then
   begin
      ShowMessage('Error '+ZipFileEdit.Text+' not found');
      Exit;
   end;  }

  for i := 0 to (ZipListBox.Items.Count - 1) do
  begin
    if ZipListBox.Items.Strings[i] <> '' then
      ZipMaster1.FSpecArgs.Add(ZipListBox.Items.Strings[i]);
  end;
  ZipMaster1.Add;
  MessageDlgPos('Files added = ' + IntToStr(ZipMaster1.SuccessCnt),
    mtInformation,
    [mbOK], {mbYesNoCancel,}
    0, MessageX, MessageY);
end;

procedure TZipForm.UnzipBtnClick(Sender: TObject);
begin
  with ZipMaster1 do
  begin
    if Count = 0 then
    begin
      ShowMessage('Nobody home');
      {DoMessages(39973);}
      Exit;
    end;
     { If we don't specify filenames, we will extract them all. }
     { Of course, in this little demo there is only 1 file in the ZIP. }
    FSpecArgs.Add('*.*');
    ExtrBaseDir := GetCurrentDir;
     { if the file to be extracted already exists, overwrite it }
    ExtrOptions := ExtrOptions + [ExtrOverwrite];
    Extract;
    Statusbar.SimpleText := 'Files extracted = ' + IntToStr(SuccessCnt);
  end;
end;

procedure TZipForm.ZipVersionBtnClick(Sender: TObject);
begin
  MessageDlgPos('ZIPDLL version: ' + IntToStr(ZipMaster1.ZipVers)
    + #13#10 + 'UNZDLL version: ' + IntToStr(ZipMaster1.UnzVers)
    + #13#10#13#10 +
    'Chris Vleghert is not to be blamed, only commended!'
    + #13#10 + 'http://www.geocities.com/SiliconValley/Orchard/8607/'
    + #13#10 + 'http://members.tripod.lycos.nl/Vleghert/'
    + #13#10#13#10 + 'Info-Zip: http://www.cdrom.com/pub/infozip/'
    ,
    mtInformation,
    [mbOK], {mbYesNoCancel,}
    0,  MessageX, MessageY);

{  Chris Vleghert
  http://www.geocities.com/SiliconValley/Orchard/8607/
  http://members.tripod.lycos.nl/Vleghert/
Info-Zip:   http://www.cdrom.com/pub/infozip/}
end;


procedure TZipForm.Label2Click(Sender: TObject);
begin
  ShellExecute(0, 'open',
    'http://www.users.bigpond.com/russellpeters/delphizip.html', '', '',
    SW_SHOW);
end;

procedure TZipForm.ZipEricLabelClick(Sender: TObject);
begin
  ShellExecute(0, 'open',
    'http://www.geocities.com/SiliconValley/Orchard/8607/', '', '',
    SW_SHOW);
end;

procedure TZipForm.ZipInfoLabelClick(Sender: TObject);
begin
  ShellExecute(0, 'open', 'http://www.info-zip.org/pub/infozip/', '',
    '', SW_SHOW);
end;

procedure TZipForm.ZipMaster1Message(Sender: TObject; ErrCode: Integer;
  Message: String);
begin
   { if ErrCode <> 0 then }{ uncomment this line to show errors ONLY }
  MessageDlgPos(Message,
    mtInformation,
    [mbOK], {mbYesNoCancel,}
    0, MessageX, MessageY);

{ This procedure displays messages received from the DLLs.  If you really
  want to minimize the amount of messages you show the user, you don't
  even need to assign this event handler.  However, I'd still recommend
  that you assign this to catch errors.  You can test the ErrCode
  before you display the message - if ErrCode is non-zero, make sure you
  display the message.  If it's 0, then you can ignore the message.
    Also, if ZipMaster1's "Verbose" property is true, you'll get more
  informational message callbacks here. By default, it's false to
  minimize user messages. }
end;
(******************************************************)
(******************************************************)


(******************************************************)
(******************************************************)








end.
