{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
//DUMP this and use IPtool..it actually works.
unit gFFTFrm;
{
Process a Band or Png (3)
X+Y Size power 0f 2 128,256,512,1024,2048,
Process all Rows then all columns = X*Y FFT processes
Display the FFT (for fun) Do the filter
Unprocess FFT then display
}
{FFTPrograms    performing real and complex FFT
fast Fourier transform, convolution and correlation
FFT87B2 Radix-2 8087 version
FFT87B4 Radix-4 8087 version
$I FFT.inc
  procedure MakeSinCosTable
  BitInvert
  FFT
  procedure RealFFT
  procedure RealConvolution
  procedure RealCorrelation
  procedure ComplexFFT
  procedure ComplexConvolution
  procedure ComplexCorrelation}

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  pngimage,Math,
  StdCtrls, ExtCtrls, Forms, Buttons, Dialogs, Gauges, ComCtrls;

type Complex = record
  real, imag:Double;
  end;
type
  TFFTForm = class(TForm)
    FFTOpenDialog: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Panel1: TPanel;
    FFTScrollBox: TScrollBox;
    FFTImage: TImage;
    FFTPanel: TPanel;
    CloseBtn: TSpeedButton;
    HelpBtn: TSpeedButton;
    SaveFFTBtn: TSpeedButton;
    ProcessFFTBtn: TSpeedButton;
    OpenBtn: TSpeedButton;
    BandBtn: TSpeedButton;
    PngBtn: TSpeedButton;
    FFTRGold: TRadioGroup;
    DISNameEdit: TEdit;
    BandEdit: TEdit;
    PngEdit: TEdit;
    FFTCB: TComboBox;
    Panel2: TPanel;
    OutScrollBox: TScrollBox;
    OutImage: TImage;
    InScrollBox: TScrollBox;
    InImage: TImage;
    Edit1: TEdit;
    Edit2: TEdit;
    RadarGauge: TGauge;
    StatusBar1: TStatusBar;
    Splitter1: TSplitter;
    FFTDCCentroidCB: TCheckBox;
    InverseCB: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CloseBtnClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure FormResize(Sender: TObject);

    procedure OpenBtnClick(Sender: TObject);
    procedure BandBtnClick(Sender: TObject);
    procedure PngBtnClick(Sender: TObject);
    procedure ProcessFFTBtnClick(Sender: TObject);
procedure ProcessFFTPng;
procedure ProcessFFTBand;
    procedure SaveFFTBtnClick(Sender: TObject);
procedure SavePng;
procedure SaveBand;
procedure SaveBandAid;
    procedure FFTImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    private
    AlreadyWorking, BandIsPng, DISisValid, BandCounted:Boolean;
    PixelTotal, NumPoints:Integer;
    PixelMin, PixelMax:Double;
    StartTimer: TDateTime;
    FFTBandFile:String;
    grid:array of array of Complex;
  end;


var
  FFTForm: TFFTForm;

implementation

{$R *.DFM}
uses gGlobal, gGrip, gMacro, gPBands,
  gFFT87B2 {gFFT87B4 Radix 4 = Power of 4};


procedure TFFTForm.FormCreate(Sender: TObject);
begin
  left := FFTFormX;
  top := FFTFormY;
  FFTCB.ItemIndex:=1;
  DISisValid:=False;
  BandCounted:=False;
  BandIsPng:=False;
  AlreadyWorking:=False;
  FFTBandFile:='';
  PixelTotal:=0;
end;

procedure TFFTForm.FormResize(Sender: TObject);
begin
  Panel1.Width := FFTForm.ClientWidth div 2;
  Splitter1.Left := Panel1.Left + Panel1.Width + 1;
end;

procedure TFFTForm.FormClose(Sender: TObject;
                             var Action: TCloseAction);
begin
  setlength(grid,0,0); 
  FFTFormX := FFTForm.left;
  FFTFormY := FFTForm.top;
  DoSaver;
  FormControl:=14;
  GRIPForm.FreeForm;
end;
procedure TFFTForm.CloseBtnClick(Sender: TObject);
begin
  If AlreadyWorking then exit;
  Close;
end;

procedure TFFTForm.HelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(10000);
end;


procedure TFFTForm.OpenBtnClick(Sender: TObject);
{var FilterName :String;}
begin
  {Open files to select a header} {DAT or BIN ?}
  FFTOpenDialog.Filter := 'DIS Header file (DIS)|*.DIS';
  FFTOpenDialog.InitialDir := ImagePath;
  if FFTOpenDialog.execute then
  begin
    if (lowercase(ExtractFileExt(FFTOpenDialog.filename)) = '.dis')
      then
    begin
      PBands.OpenDISHeader(FFTOpenDialog.filename);
      PBands.RIHOpenRIHHeader(ImagePath + PBands.DISSubsetDIH.Text);
      ImagePath := ExtractFilePath(FFTOpenDialog.filename);
      DISNameEdit.Text := ExtractFileName(FFTOpenDialog.Filename);
      PBands.DISFileEdit.Text := FFTOpenDialog.Filename;
      NumPoints:= Strtoint(PBands.DISSubsetWidth.text);
      If (not (NumPoints = Strtoint(PBands.DISSubsetHeight.text)))
         then begin
           DoMessages( 39959);{('Not square');}
           exit;
         end;
      If ((2049 < Strtoint(PBands.DISSubsetWidth.text))or
         (2049 < Strtoint(PBands.DISSubsetHeight.text))
         )then
         begin
           DoMessages( 39961);{('too big');}
           exit;
         end;
      DISisValid := True;
      BandCounted:=False;
      BandBtn.Enabled:=True;
      if LoggingToMacro then
      begin
        MacroForm.MacroRE.Lines.Add('=0003  Open');
        MacroForm.MacroRE.Lines.Add(ImagePath);
        MacroForm.MacroRE.Lines.Add( DISNameEdit.Text);
      end;
    end;
  end;
end;

procedure TFFTForm.BandBtnClick(Sender: TObject);
var
  Bitmap: TBitmap;
  F1: file; {of Byte}
  NumRead, {ErrorCode,} I,  III{,II, IV}: Integer;
  Red: Byte;
  LineSize: Longint;
begin
  If DISisValid then
  begin{Open files to select a # 1  band}
  FFTOpenDialog.InitialDir := ImagePath;
  FFTOpenDialog.Filter := 'Spectral Bands (B??, P??)|*.B??;*.P??';
  if FFTOpenDialog.execute then
  begin
{$IFOPT R+}
{$DEFINE CKRANGE}
{$R-}
{$ENDIF}
    FFTBandFile := FFTOpenDialog.filename;
    ImagePath := ExtractFilePath(FFTOpenDialog.filename);
    BandEdit.Text := ExtractFileName(FFTOpenDialog.filename);
    {Load the band into Image}
    {NumPoints is image width and height}
        Bitmap := TBitmap.Create;
        Bitmap.Width := NumPoints;
        Bitmap.Height := NumPoints;
        InImage.Width := NumPoints;
        InImage.Height := NumPoints;
        InImage.Picture.Bitmap.PixelFormat := pf24bit;
        InImage.Picture.Bitmap.Assign(Bitmap);
  LineSize := (sizeof(byte) * (NumPoints));
  hRedBitmap := GlobalAlloc(GHND, LineSize);
  RedBitmap := GlobalLock(hRedBitmap);
  AssignFile(F1, FFTOpenDialog.filename);
  Reset(F1, LineSize);
  RadarGauge.Visible:=True;
  StatusBar1.SimpleText:='Loading Band';
  setlength(grid,NumPoints,NumPoints); {real imag}
  PixelTotal:=0;
  PixelMin:=1.7 * power(10,308);
  PixelMax:=5.0 * power(10, -324); {double}
  for I := 0 to NumPoints-1 do begin
    RadarGauge.Progress := Round((I / NumPoints)*100);
    Application.ProcessMessages;
    BlockRead(F1, RedBitmap^, 1, NumRead);
    for III := 0 to NumPoints-1 do begin
      {IV := ((III * Sample));}
      Red := PHugeByteArray(RedBitmap)^[III];
      PixelTotal:=PixelTotal+Red;
      grid[iii,i].real:=Red;
      grid[iii,i].imag:=Red;
      PixelMin:= Min(PixelMin,grid[iii,i].real);
      PixelMax:= Max(PixelMax,grid[iii,i].real);
      InImage.Canvas.Pixels[III, I] := RGB(Red, Red, Red);
    end;
  end;
  CloseFile(F1);
  RadarGauge.Progress := 0;
        InImage.Width := NumPoints;
        InImage.Height := NumPoints;
        FFTImage.Width := NumPoints;
        FFTImage.Height := NumPoints;
        OutImage.Width := NumPoints;
        OutImage.Height := NumPoints;
        FFTImage.Picture.Bitmap.Assign(InImage.Picture.Bitmap);
        OutImage.Picture.Bitmap.Assign(InImage.Picture.Bitmap);
        Edit1.Text:=Inttostr(Round(PixelMin));
        Edit2.Text:=Inttostr(Round(PixelMax));
  Bitmap.Free;
  GlobalUnlock(hRedBitmap);
  GlobalFree(hRedBitmap);
    BandCounted:=true;
      if LoggingToMacro then
      begin
        MacroForm.MacroRE.Lines.Add('=0003  Open');
        MacroForm.MacroRE.Lines.Add(ImagePath);
        MacroForm.MacroRE.Lines.Add( BandEdit.Text);
      end;
  end;
end;
{$IFDEF CKRANGE}
{$UNDEF CKRANGE}
{$R+}
{$ENDIF}
  RadarGauge.Progress :=0;
  RadarGauge.Visible:=False;
  StatusBar1.SimpleText:='';
end;

procedure TFFTForm.PngBtnClick(Sender: TObject);
var
  PNG: TPNGObject;
  LoadedOK:Boolean;
begin {Open files to select a png file}
  LoadedOK:=False;
  FFTOpenDialog.InitialDir := ImagePath;
  FFTOpenDialog.Filter := 'All (*.bmp;*.png)|*.bmp;*.png';
  if FFTOpenDialog.execute then
  begin
    FFTBandFile := FFTOpenDialog.filename;
    ImagePath := ExtractFilePath(FFTOpenDialog.filename);
    BandEdit.Text := ExtractFileName(FFTOpenDialog.filename);
    {Load the image}
    if (lowercase(extractfileext(BandEdit.Text)) = '.bmp') then
    begin
    try
      InImage.Picture.LoadFromFile(ImagePath + BandEdit.Text);
      LoadedOK:=True;
    finally end;
    end else
    if (lowercase(extractfileext(BandEdit.Text)) = '.png') then
    begin
      PNG := TPNGObject.Create;
      try
        PNG.LoadFromFile(ImagePath + BandEdit.Text);
        InImage.Picture.Bitmap.Assign(PNG); //Convert data into bitmap
        LoadedOK:=True;
      finally
        PNG.Free;
      end;
    end;
    If LoadedOK then
    BEGIN
      NumPoints:= InImage.Picture.Width;
      If (not (NumPoints = Strtoint(PBands.DISSubsetHeight.text)))
         then begin
           DoMessages( 39959);{('Not square');}
           exit;
         end;
      If ( (2049 < NumPoints)or
           (2049 < InImage.Picture.Height) )then
      begin
        DoMessages( 39961);{('too big 2048x2048 Maximum');}
        exit;
      end;
      if (InImage.Picture.Bitmap.PixelFormat <> pf24bit) then
      begin
        if (InImage.Picture.Bitmap.PixelFormat = pf4bit)
        then DoMessages(41);
        if (InImage.Picture.Bitmap.PixelFormat = pf8bit)
        then DoMessages(42);
        if (InImage.Picture.Bitmap.PixelFormat = pf15bit)
        then DoMessages(43);
        if (InImage.Picture.Bitmap.PixelFormat = pf16bit)
        then DoMessages(44);
        if (InImage.Picture.Bitmap.PixelFormat = pf32bit)
        then DoMessages(45);
        InImage.Picture.Bitmap.PixelFormat := pf24bit;
      end;
      DISisValid:=false;
      BandCounted:=false;
      BandIsPng:=True;
      if LoggingToMacro then
      begin
        MacroForm.MacroRE.Lines.Add('=0003  Open');
        MacroForm.MacroRE.Lines.Add(ImagePath);
        MacroForm.MacroRE.Lines.Add(BandEdit.Text);
      end;
        InImage.Width := NumPoints;
        InImage.Height := NumPoints;
        FFTImage.Width := NumPoints;
        FFTImage.Height := NumPoints;
        OutImage.Width := NumPoints;
        OutImage.Height := NumPoints;
       FFTImage.Picture.Bitmap.Assign(InImage.Picture.Bitmap);
       OutImage.Picture.Bitmap.Assign(InImage.Picture.Bitmap);
    end;
  end;
end;



procedure TFFTForm.ProcessFFTBtnClick(Sender: TObject);
var
  Red: Byte;
  x,y,z : Integer;
  Present: TDateTime;
  Hour, Mini, Sec, MSec: Word;
begin
  If AlreadyWorking then exit;
  AlreadyWorking:=True;
  StartTimer:=Now;
  FFTForm.Caption :='Started: '+TimeToStr(Now);
  RadarGauge.Visible:=True;
  RadarGauge.Progress :=0;
  StatusBar1.SimpleText:='';
  If BandIsPng then ProcessFFTPng
  else If (DISisValid and BandCounted) then
  begin
    ProcessFFTBand;
   {Display Resultant Image}
    StatusBar1.SimpleText:='Display Resultant Image Count';
  PixelMin:=1.7 * power(10,308);
  PixelMax:=5.0 * power(10, -324); {double}
  For x:= 0 to NumPoints-1 do  begin
    RadarGauge.Progress := Round((x / NumPoints)*100);
    Application.ProcessMessages;
    For y:= 0 to NumPoints-1 do  begin
      PixelMin:= Min(PixelMin,grid[x][y].real);
      PixelMax:= Max(PixelMax,grid[x][y].real);
    end;
  end;
  If (PixelMin >= PixelMax) then begin
    StatusBar1.SimpleText:='WARNING Min > MAX !!';
    Application.ProcessMessages;
    PixelMin:=PixelMin-0.01;
    PixelMax:=PixelMax+0.0101;
  end;
    StatusBar1.SimpleText:='Display Resultant Image';
    for y := 0 to OutImage.Picture.BitMap.height -1 do
    begin
    RadarGauge.Progress := Round((y / NumPoints)*100);
    Application.ProcessMessages;
      for x := 0 to OutImage.Picture.BitMap.width -1 do
      begin
        z:=round(255*((grid[x,y].real-PixelMin )/(PixelMax -PixelMin )));
        If z>255 then z:=255 else if  z<0 then z:=0;
        Red:=z;
        OutImage.Picture.BitMap.Canvas.pixels[x,y]:=RGB(Red, Red, Red);
      end;
    end;
  end else exit;{how did you get here?}
  RadarGauge.Progress :=0;
  RadarGauge.Visible:=False;
  StatusBar1.SimpleText:='';
  AlreadyWorking:=False;
  Present:= (Now-StartTimer);
  DecodeTime(Present, Hour, Mini, Sec, MSec);
  FFTForm.Caption :='Hours '+IntToStr(Hour)+
                    'Minutes '+IntToStr(Mini)+
                    '.'+IntToStr(Sec)+
                    '.'+IntToStr(MSec);
end;
procedure TFFTForm.ProcessFFTPng; {Gotta do 3 bands}
var
  Red,Blue,Green: Byte;
  x,y,z : Integer;
  P : PByteArray;
begin
  setlength(grid,NumPoints,NumPoints); {real imag}
  PixelTotal:=0;
    StatusBar1.SimpleText:='Load Red Image';
    for y := 0 to InImage.Picture.BitMap.height -1 do
    begin
    RadarGauge.Progress := Round((y / NumPoints)*100);
    Application.ProcessMessages;
      P := InImage.Picture.BitMap.ScanLine[y];
      for x := 0 to InImage.Picture.BitMap.width -1 do
      begin
        Red:=GetRValue(P[x]);
        PixelTotal:=PixelTotal+Red;
        grid[x,y].real:=Red;
        grid[x,y].imag:=Red;
      end;
    end;
   ProcessFFTBand;
   {Display Resultant Image}
    StatusBar1.SimpleText:='Display Resultant Red Image';
  PixelMin:=1.7 * power(10,308);
  PixelMax:=5.0 * power(10, -324); {double}
  For x:= 0 to NumPoints-1 do  begin
    RadarGauge.Progress := Round((x / NumPoints)*100);
    Application.ProcessMessages;
    For y:= 0 to NumPoints-1 do  begin
      PixelMin:= Min(PixelMin,grid[x][y].real);
      PixelMax:= Max(PixelMax,grid[x][y].real);
    end;
  end;
  If (PixelMin > PixelMax) then begin
    StatusBar1.SimpleText:='WARNING Min > MAX !!';
    Application.ProcessMessages;
    PixelMin:=PixelMin-0.01;
    PixelMax:=PixelMax+0.01;
  end;
    for y := 0 to OutImage.Picture.BitMap.height -1 do
    begin
    RadarGauge.Progress := Round((y / NumPoints)*100);
    Application.ProcessMessages;
      P := OutImage.Picture.BitMap.ScanLine[y];
      for x := 0 to OutImage.Picture.BitMap.width -1 do
      begin
        {Red:=GetRValue(P[x]);}
        Blue:=GetBValue(P[x]);
        Green:=GetGValue(P[x]);
        {z:=round(grid[x,y].real);}
        z:=round(255*(grid[x,y].real-PixelMin )/(PixelMax -PixelMin ));
        If z>255 then z:=255 else if  z<0 then z:=0;
        Red:=z;
        {P[x]:= RGB(Red, Green, Blue);}
        OutImage.Picture.BitMap.Canvas.pixels[x,y]:=RGB(Red, Green, Blue);
      end;
    end;
  PixelTotal:=0;
    StatusBar1.SimpleText:='Load Green Image';
    for y := 0 to InImage.Picture.BitMap.height -1 do
    begin
    RadarGauge.Progress := Round((y / NumPoints)*100);
    Application.ProcessMessages;
      P := InImage.Picture.BitMap.ScanLine[y];
      for x := 0 to InImage.Picture.BitMap.width -1 do
      begin
        Red:=GetGValue(P[x]);
        PixelTotal:=PixelTotal+Red;
        grid[x,y].real:=Red;
        grid[x,y].imag:=Red;
      end;
    end;
   ProcessFFTBand;
   {Display Resultant Image}
    StatusBar1.SimpleText:='Display Resultant Green Image';
    StatusBar1.SimpleText:='Display Resultant Image';
  PixelMin:=1.7 * power(10,308);
  PixelMax:=5.0 * power(10, -324); {double}
  For x:= 0 to NumPoints-1 do  begin
    RadarGauge.Progress := Round((x / NumPoints)*100);
    Application.ProcessMessages;
    For y:= 0 to NumPoints-1 do  begin
      PixelMin:= Min(PixelMin,grid[x][y].real);
      PixelMax:= Max(PixelMax,grid[x][y].real);
    end;
  end;
  If (PixelMin > PixelMax) then begin
    StatusBar1.SimpleText:='WARNING Min > MAX !!';
    Application.ProcessMessages;
    PixelMin:=PixelMin-0.01;
    PixelMax:=PixelMax+0.01;
  end;
    for y := 0 to OutImage.Picture.BitMap.height -1 do
    begin
    RadarGauge.Progress := Round((y / NumPoints)*100);
    Application.ProcessMessages;
      P := OutImage.Picture.BitMap.ScanLine[y];
      for x := 0 to OutImage.Picture.BitMap.width -1 do
      begin
        Red:=GetRValue(P[x]);
        Blue:=GetBValue(P[x]);
        {Green:=GetGValue(P[x]);}
        {z:=round(grid[x,y].real);}
        z:=round(255*(grid[x,y].real-PixelMin )/(PixelMax -PixelMin ));
        If z>255 then z:=255 else if  z<0 then z:=0;
        Green:=z;
        {P[x]:= RGB(Red, Green, Blue);}
        OutImage.Picture.BitMap.Canvas.pixels[x,y]:=RGB(Red, Green, Blue);
      end;
    end;
  PixelTotal:=0;
    StatusBar1.SimpleText:='Load Blue Image';
    for y := 0 to InImage.Picture.BitMap.height -1 do
    begin
    RadarGauge.Progress := Round((y / NumPoints)*100);
    Application.ProcessMessages;
      P := InImage.Picture.BitMap.ScanLine[y];
      for x := 0 to InImage.Picture.BitMap.width -1 do
      begin
        Red:=GetBValue(P[x]);
        PixelTotal:=PixelTotal+Red;
        grid[x,y].real:=Red;
        grid[x,y].imag:=Red;
      end;
    end;
   ProcessFFTBand;
   {Display Resultant Image}
    StatusBar1.SimpleText:='Display Resultant Blue Image';
    StatusBar1.SimpleText:='Display Resultant Image';
  PixelMin:=1.7 * power(10,308)	;
  PixelMax:=5.0 * power(10, -324); {double}
  For x:= 0 to NumPoints-1 do  begin
    RadarGauge.Progress := Round((x / NumPoints)*100);
    Application.ProcessMessages;
    For y:= 0 to NumPoints-1 do  begin
      PixelMin:= Min(PixelMin,grid[x][y].real);
      PixelMax:= Max(PixelMax,grid[x][y].real);
    end;
  end;
  If (PixelMin > PixelMax) then begin
    StatusBar1.SimpleText:='WARNING Min > MAX !!';
    Application.ProcessMessages;
    PixelMin:=PixelMin-0.01;
    PixelMax:=PixelMax+0.01;
  end;
    for y := 0 to OutImage.Picture.BitMap.height -1 do
    begin
    RadarGauge.Progress := Round((y / NumPoints)*100);
    Application.ProcessMessages;
      P := OutImage.Picture.BitMap.ScanLine[y];
      for x := 0 to OutImage.Picture.BitMap.width -1 do
      begin
        Red:=GetRValue(P[x]);
        {Blue:=GetBValue(P[x]);}
        Green:=GetGValue(P[x]);
        {z:=round(grid[x,y].real);}
        z:=round(255*(grid[x,y].real-PixelMin )/(PixelMax -PixelMin ));
        If z>255 then z:=255 else if  z<0 then z:=0;
        Blue:=z;
        {P[x]:= RGB(Red, Green, Blue);}
        OutImage.Picture.BitMap.Canvas.pixels[x,y]:=RGB(Red, Green, Blue);
      end;
    end;
End;

procedure TFFTForm.ProcessFFTBand;
var
  Red,Blue,Green: Byte;
  Error,NumberOfBits : byte;
  Inverse      : boolean;
  NumPointsEdge,
  ix,iy,x,y,z, j,I, Cutoff1,Cutoff2, Choice : integer;
  scale, mag, MeanMrMustard,
  r,r1,r2,r3,r4:double;
  XReal        : TNvectorPtr;
  XImag        : TNvectorPtr;
begin
  NumPointsEdge:=(NumPoints-1);
  New(XReal);
  New(XImag);
  FillChar(XReal^, SizeOf(XReal^), 0);
  FillChar(XImag^, SizeOf(XImag^), 0);
  Choice := FFTCB.ItemIndex;{Which Filter to use}
  Cutoff1:=strtoint(Edit1.text);{Filter parameters}
  Cutoff2:=strtoint(Edit2.text);
           {NumPoints is same as width and height }
  TestInput(NumPoints,NumberOfBits,Error);
  If Error>0 then
  begin
    DoMessages( 39960); {Not a power of 2}
    exit;
  end;
  StatusBar1.SimpleText:='Mean Mr. Mustard';
  MeanMrMustard:=PixelTotal/(NumPoints*NumPoints);
  For I:= 0 to NumPointsEdge do
  begin
    RadarGauge.Progress := Round((I / NumPoints)*100);
    Application.ProcessMessages;
    for z:= 0 to NumPointsEdge do begin
     grid[I,z].real:=grid[I,z].real-MeanMrMustard;{real imag}
    end;
  end;
  If InverseCB.Checked then Inverse := False
  else Inverse := True;{FORWARD FFT}
  StatusBar1.SimpleText:='FORWARD FFT Vertical (1of4)';
  For I:= 0 to NumPointsEdge do
  begin
    RadarGauge.Progress := Round((I / NumPoints)*100);
    Application.ProcessMessages;
    {Fill All Vertical arrays each time}
    for z:= 0 to NumPointsEdge do begin
     XReal[z]:=grid[I,z].real;{real imag}
     XImag[z]:=grid[I,z].imag;
    RealFFT(NumPoints, Inverse, XReal, XImag, Error);
     grid[I,z].real:=XReal[z];
     grid[I,z].imag:=XImag[z];
     end;
  end;
  StatusBar1.SimpleText:='FORWARD FFT Horizontal (2of4)';
  For I:= 0 to NumPointsEdge do
  begin
    RadarGauge.Progress := Round((I / NumPoints)*100);
    Application.ProcessMessages;
    {Fill All Horizontal arrays each time}
    for z:= 0 to NumPointsEdge do  begin
     XReal[z]:=grid[z,i].real;{real imag}
     XImag[z]:=grid[z,i].imag;
    RealFFT(NumPoints, Inverse, XReal, XImag, Error);
     grid[z,i].real:=XReal[z];
     grid[z,i].imag:=XImag[z];
     end;
  end;

  {Process Filter}
  Case Choice of 1..4 : begin {0 does no filtering}
  StatusBar1.SimpleText:='Processing Filter ';
  For I:= 0 to NumPointsEdge do  begin
    RadarGauge.Progress := Round((I / NumPoints)*100);
    Application.ProcessMessages;
    For j:= 0 to NumPointsEdge do  begin
         r1 := i*i + j*j;
         r2 := (i-NumPoints)*(i-NumPoints) + j*j;
         r3 := i*i + (j-NumPoints)*(j-NumPoints);
         r4 := (((i-NumPoints)*(i-NumPoints)) + ((j-NumPoints)*(j-NumPoints)));
         r := MIN(r1,r2);
         r := MIN(r,r3);
         r := MIN(r,r4);

      Case Choice of
        1: begin  // Low pass
             if (r > cutoff1*cutoff1) then
             begin
               grid[i][j].real := 0;
               grid[i][j].imag := 0;
             end;
           end;
        2: begin  // Band pass
             if ((r < cutoff1*cutoff1)or (r > cutoff2*cutoff2))then
             begin
               grid[i][j].real := 0;
               grid[i][j].imag := 0;
             end;
           end;
        3: begin  // High  pass
             if (r < cutoff1*cutoff1) then
             begin
               grid[i][j].real := 0;
               grid[i][j].imag := 0;
             end;
           end;
        4: begin  // power
             if (r >0) then
             begin
               grid[i][j].real := grid[i][j].real *power(1/r,cutoff1{power});
               grid[i][j].imag := grid[i][j].imag *power(1/r,cutoff1{power});
             end;
           end;
      end;{Case}
    end;
  end;
 {Display FFTPanel}
  StatusBar1.SimpleText:='Display Resultant FFT Image';
  scale:=0;{  mag:=0;}
  PixelMin:=5.0 * power(10, -324); {double}
  PixelMax:=1.7 * power(10,308)	;
  For I:= 0 to NumPointsEdge do  begin
    RadarGauge.Progress := Round((I / NumPoints)*100);
    Application.ProcessMessages;
    For j:= 0 to NumPointsEdge do  begin
      mag:=sqrt((grid[i][j].real*grid[i][j].real) +
                (grid[i][j].imag*grid[i][j].imag));
      scale:=max(mag,scale);
      PixelMin:= Min(PixelMin,grid[i][j].real);
      PixelMax:= Max(PixelMax,grid[i][j].real);
    end;
  end;
  If (PixelMin >= PixelMax) then begin
    StatusBar1.SimpleText:='WARNING Min > MAX !!';
    Application.ProcessMessages;
    PixelMin:=PixelMin-0.01;
    PixelMax:=PixelMax+0.0101;
  end;
  If scale=0 then scale:=1;{no divide by zero}
   {Display Resultant Image PixelMin, PixelMax}
    for y := 0 to NumPointsEdge do
    begin
    RadarGauge.Progress := Round((y / NumPoints)*100);
    Application.ProcessMessages;
      for x := 0 to NumPointsEdge do
      begin
      {ix:= x+1;
      iy:= y+1;
        z:=round(grid[x,y].real);}
        mag:=sqrt((grid[x][y].real*grid[x][y].real) +
                (grid[x][y].imag*grid[x][y].imag));
       If FFTDCCentroidCB.Checked then
       begin
        If (x <= (NumPoints / 2) ) then
        begin
          if (y <= (NumPoints / 2) ) then
          begin
             ix:= x +round(NumPoints / 2)-1;
             iy:= y +round(NumPoints / 2)-1;
          end else
          begin
             ix:= x +round(NumPoints / 2)-1;
             iy:= y -round(NumPoints / 2)-1;
          end;
        end else
        if (y <= (NumPoints / 2) ) then
        begin
             ix:= x -round(NumPoints / 2)-1;
             iy:= y +round(NumPoints / 2)-1;
        end else
        begin
             ix:= x -round(NumPoints / 2)-1;
             iy:= y -round(NumPoints / 2)-1;
        end;
         z:= round(255*mag/scale);
        If z>255 then z:=255 else if  z<0 then z:=0;
        Red:=z;FFTImage.Picture.BitMap.Canvas.Pen.Color:= RGB(Red, Red, Red);
        {If (x<0) then x:=0;
        If (y<0) then y:=0;}
        If (ix<0) then ix:=0;
        If (iy<0) then iy:=0;
        {If (x>NumPointsEdge) then x:=NumPointsEdge;
        If (y<NumPointsEdge) then y:=NumPointsEdge;}
        If (ix<NumPointsEdge) then ix:=NumPointsEdge;
        If (iy<NumPointsEdge) then iy:=NumPointsEdge;
        FFTImage.Picture.BitMap.Canvas.Moveto(x,y);
        FFTImage.Picture.BitMap.Canvas.Lineto(ix,iy);
      end else
      begin
        z:= round(255*mag/scale);
        If z>255 then z:=255 else if  z<0 then z:=0;
        Red:=z;
        FFTImage.Picture.Bitmap.Canvas.Pixels[x,y]:=RGB(Red, Red, Red);
      end;
      end;
    end;
  end;end;{Filtering}

  If InverseCB.Checked then Inverse := False
  else Inverse := True;{Inverse FFT... return to Image}
    StatusBar1.SimpleText:='Inverse FFT Vertical (3of4)';
  For I:= 0 to NumPointsEdge do
  begin
    RadarGauge.Progress := Round((I / NumPoints)*100);
    Application.ProcessMessages;
    {Fill All Vertical arrays each time}
    for z:= 0 to NumPointsEdge do begin
     XReal[z]:=grid[I,z].real;{real imag}
     XImag[z]:=grid[I,z].imag;
    RealFFT(NumPoints, Inverse, XReal, XImag, Error);
     grid[I,z].real:=XReal[z];
     grid[I,z].imag:=XImag[z];
     end;
  end;
    StatusBar1.SimpleText:='Inverse FFT Horizontal (4of4)';
  For I:= 0 to NumPointsEdge do
  begin
    RadarGauge.Progress := Round((I / NumPoints)*100);
    Application.ProcessMessages;
    {Fill All Horizontal arrays each time}
    for z:= 0 to NumPointsEdge do  begin
     XReal[z]:=grid[z,i].real;{real imag}
     XImag[z]:=grid[z,i].imag;
    RealFFT(NumPoints, Inverse, XReal, XImag, Error);
     grid[z,i].real:=XReal[z];
     grid[z,i].imag:=XImag[z];
     end;
  end;
  Dispose(XReal);
  Dispose(XImag);
end;

procedure TFFTForm.SaveFFTBtnClick(Sender: TObject);
begin
  If AlreadyWorking then exit;
  SaveDialog1.InitialDir := ImagePath;
  SaveDialog1.Filter :=  FFTOpenDialog.Filter;
  SaveDialog1.filename :=  FFTOpenDialog.filename;
  {'Spectral Bands (B??, P??)|*.B??;*.P??';}
  if SaveDialog1.execute then
  begin
    If (lowercase(ExtractFileExt(SaveDialog1.filename))='.png') then
      SavePng  else
    If (lowercase(ExtractFileExt(SaveDialog1.filename))='.bmp') then
      SaveBand else SaveBandAid;
  end;
end;
procedure TFFTForm.SavePng;
var   PNG: TPNGObject;
Begin{SaveDialog1.filename OutImage}
  PNG := TPNGObject.Create;
  {In case something goes wrong, free PNG}
  try
    PNG.Assign(OutImage.Picture.Bitmap); //Convert data into png
    PNG.SaveToFile(SaveDialog1.filename);
  finally
    PNG.Free;
  end
End;
procedure TFFTForm.SaveBand;
Begin {SaveDialog1.filename OutImage}
  OutImage.Picture.SaveToFile(SaveDialog1.filename);
End;
procedure TFFTForm.SaveBandAid;
var
  F1: file of Byte;
  Red: Byte;
  x,y : Integer;
  P : PByteArray;
Begin
  AssignFile(F1, FFTOpenDialog.filename);
  Rewrite(F1);
    for y := 0 to OutImage.Picture.BitMap.height -1 do
    begin
    RadarGauge.Progress := Round((y / NumPoints)*100);
    Application.ProcessMessages;
      P := OutImage.Picture.BitMap.ScanLine[y];
      for x := 0 to OutImage.Picture.BitMap.width -1 do
      begin
        Red:=GetRValue(P[x]);
        BlockWrite(F1, Red, 1);
      end;
    end;
  CloseFile(F1);
  RadarGauge.Progress := 0;
End;


procedure TFFTForm.FFTImageMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  If AlreadyWorking then exit;
  If FFTImage.Picture.Bitmap.Empty then begin end else
  begin
  {SaveDialog1.filename OutImage}
  SaveDialog1.InitialDir := ImagePath;
  SaveDialog1.Filter :='BMP files (*.bmp)|*.bmp';{ FFTOpenDialog.Filter;}
  SaveDialog1.filename :=  ChangeFileExt(FFTOpenDialog.filename,'.bmp');
  if SaveDialog1.execute then
  FFTImage.Picture.SaveToFile(SaveDialog1.filename);
  end;
end;

end.
