{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit gPixelAlgebra;
{Pixel CIR VI
Pixel X0: c/All
Pixel X1: A-B/a+b
Pixel X2: A-B/a+b
Pixel X3: A+B/a-b
Pixel X4: A/B
Pixel X5: A+B/c
Pixel X6: All/c
Pixel X7: A+B/Blue
Pixel X8: A+B/a*c
Pixel X9: A*B/c
Pixel X10: A+B/a*b
Pixel X11: Multiple
Pixel X15
Pixel XR71}

interface

uses
  SysUtils, Windows, Messages, Classes,
  Graphics, Controls, Math,
  StdCtrls, ExtCtrls, Forms, ComCtrls,
  Dialogs, Buttons, Gauges;

type
  TReal = Single;
type
  TPixelAlgebraForm = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    PixelRatiosRG: TRadioGroup;

    PixelAlgebraHelpBtn: TBitBtn;
    PAPixelOperationsHelpBtn: TBitBtn;
    PARatioHelpBtn: TBitBtn;


    PA_RatiosBtn: TSpeedButton;
    PACloseBtn: TBitBtn;
    PAPODOBtn: TSpeedButton;
    OpRGB1: TRadioGroup;
    BA0: TRadioGroup;
    BB0: TRadioGroup;
    BA1: TRadioGroup;
    OpRGA1: TRadioGroup;
    OpRGA2: TRadioGroup;
    OpRGMain: TRadioGroup;
    OpRGB2: TRadioGroup;
    OpRGB3: TRadioGroup;
    OpRGA3: TRadioGroup;
    BA3: TRadioGroup;
    BA2: TRadioGroup;
    BA6: TRadioGroup;
    BA4: TRadioGroup;
    BA5: TRadioGroup;
    BB2: TRadioGroup;
    BB1: TRadioGroup;
    BB3: TRadioGroup;
    BB4: TRadioGroup;
    BB5: TRadioGroup;
    BB6: TRadioGroup;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label9: TLabel;
    Bevel3: TBevel;
    Bevel4: TBevel;
    Bevel5: TBevel;
    Bevel6: TBevel;
    PARBtn: TSpeedButton;
    PARatioingHelpBtn: TBitBtn;
    Label22: TLabel;
    PARRG: TRadioGroup;
    PARBEdit2: TEdit;
    PARBEdit3: TEdit;
    PARBEdit1: TEdit;
    Label15: TLabel;
    Label14: TLabel;
    PARGEdit1: TEdit;
    PARGEdit2: TEdit;
    PARGEdit3: TEdit;
    PARREdit3: TEdit;
    PARREdit2: TEdit;
    PARREdit1: TEdit;
    Label13: TLabel;
    Label21: TLabel;
    Label20: TLabel;
    Label19: TLabel;
    Label18: TLabel;
    Label17: TLabel;
    Label16: TLabel;
    PMultiplyBtn: TSpeedButton;
    PARatioingMHelpBtn: TBitBtn;
    Label23: TLabel;
    PMRG: TRadioGroup;
    PMEdit3: TEdit;
    Label5: TLabel;
    PMEdit2: TEdit;
    Label4: TLabel;
    PMEdit1: TEdit;
    Label3: TLabel;
    Label12: TLabel;
    Label11: TLabel;
    Label10: TLabel;
    BlueMeanieLabel: TLabel;
    BlueMeanieTBar: TTrackBar;
    BlueMeanieValueLabel: TLabel;
    GMaxValueLabel: TLabel;
    GMaxTBar: TTrackBar;
    GMaxLabel: TLabel;
    RMinLabel: TLabel;
    RMinTBar: TTrackBar;
    RMinValueLabel: TLabel;
    AllTogetherCB: TCheckBox;
    PositiveCurveCB: TCheckBox;
    ButtonCommandCB: TCheckBox;
    ProcessSliderBtn: TSpeedButton;
    Panel1: TPanel;
    PACGraphImage: TImage;
    PACUseColorSliceBtn: TSpeedButton;
    PACDrawRG: TRadioGroup;
    PACColorCRG: TRadioGroup;
    PAGammaHelpBtn: TSpeedButton;
    HCGauge: TGauge;
    HCNegative: TSpeedButton;
    HCActivateColor: TSpeedButton;
    HCHSV: TSpeedButton;
    HCCMYK: TSpeedButton;
    HCRGB: TSpeedButton;
    HCGamma: TSpeedButton;
    HCStretchLinear: TSpeedButton;
    HCSineWave: TSpeedButton;
    HCLog: TSpeedButton;
    HCExponent: TSpeedButton;
    HCContrast: TSpeedButton;
    HCGreyScale: TSpeedButton;
    PACLoadColorBins: TSpeedButton;
    PACSaveColorBins: TSpeedButton;
    PACPanel: TPanel;
    PACScrollBox: TScrollBox;
    PACImage: TImage;
    PACApplyToImage: TSpeedButton;
    PACCB: TComboBox;
    PACClearBtn: TSpeedButton;
    TogglesRG: TRadioGroup;
    PAColorLabel: TLabel;
    HCHistogramEQ: TSpeedButton;
    HCHLS: TSpeedButton;
    HCYIQ: TSpeedButton;
    RadioGroupColorPlane: TRadioGroup;
    CheckBoxMonochrome: TCheckBox;
    HCMinMax: TSpeedButton;
    UseFunctionsBtn: TSpeedButton;
    FunctionLabel: TLabel;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    AddedCB: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);

    procedure PAPODOBtnClick(Sender: TObject);
    procedure DOPAPODO;
    procedure PA_RatiosBtnClick(Sender: TObject);
    procedure PAPixelOperationsHelpBtnClick(Sender: TObject);
    procedure PACloseBtnClick(Sender: TObject);
    procedure PARatioingMHelpBtnClick(Sender: TObject);
    procedure PARatioHelpBtnClick(Sender: TObject);
    procedure PAGammaHelpBtnClick(Sender: TObject);
    procedure PMultiplyBtnClick(Sender: TObject);

    procedure PixelAlgebraHelpBtnClick(Sender: TObject);
    procedure PARatioingHelpBtnClick(Sender: TObject);
    procedure PARBtnClick(Sender: TObject);

    procedure TogglesRGClick(Sender: TObject);

    procedure HCHistogramEQClick(Sender: TObject);
    procedure HCHLSClick(Sender: TObject);
    procedure HCYIQClick(Sender: TObject);
    procedure CheckBoxMonochromeClick(Sender: TObject);
    procedure UseFunctionsBtnClick(Sender: TObject);
    procedure PACCBChange(Sender: TObject);
    procedure BlueMeanieTBarChange(Sender: TObject);
    procedure GMaxTBarChange(Sender: TObject);
    procedure RMinTBarChange(Sender: TObject);
    procedure ProcessSliderBtnClick(Sender: TObject);
    procedure HideSliders;
    procedure DoLUT;
    procedure MakeHisHCImage;
    procedure SetHisHCImage;
    procedure MyRGBToHSV(const R, G, B: TReal; var H, S, V: TReal);
    procedure MyRGBToHLS(const R, G, B: TReal; var H, L, S: TReal);
    procedure ColorPlaneSetup;
    procedure RadioGroupColorPlaneClick(Sender: TObject);
    procedure HCMinMaxClick(Sender: TObject);
    procedure HCGreyScaleClick(Sender: TObject);
    procedure HCNegativeClick(Sender: TObject);
    procedure HCContrastClick(Sender: TObject);
    procedure HCExponentClick(Sender: TObject);
    procedure HCLogClick(Sender: TObject);
    procedure HCSineWaveClick(Sender: TObject);
    procedure HCStretchLinearClick(Sender: TObject);
    procedure HCGammaClick(Sender: TObject);
    procedure HCRGBClick(Sender: TObject);
    procedure HCCMYKClick(Sender: TObject);
    procedure HCHSVClick(Sender: TObject);
(******************************************************)
    procedure DoLUTGraph;
    procedure HCActivateColorClick(Sender: TObject);
    procedure PACUseColorSliceBtnClick(Sender: TObject);
    procedure PACGraphImageMouseDown(Sender: TObject; Button:
      TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PACGraphImageMouseMove(Sender: TObject; Shift:
      TShiftState; X,
      Y: Integer);
    procedure PACGraphImageMouseUp(Sender: TObject; Button:
      TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DrawRubberband;
    procedure PACLoadColorBinsClick(Sender: TObject);
    procedure PACSaveColorBinsClick(Sender: TObject);
    procedure PACColorCRGClick(Sender: TObject);
    procedure PACClearBtnClick(Sender: TObject);
    procedure PACApplyToImageClick(Sender: TObject);


  end;

var
  PixelAlgebraForm: TPixelAlgebraForm;

implementation

{$R *.DFM}
uses
  gURealColorLibrary, // RGBToHSV
  gUGraphicsConversionsLibrary, // LoadGraphicFile
  gUHistogramLibrary, // THistogram
  gUImageProcessingPrimitives, // GetBitmapDimensionsString
  gUPixAl, gGlobal, gMacro, {gColor,} gGrip, gPBands;

type
  TColorPlane = (cpRGB, {really a composite of csRed, csGreen, csBlue}
    cpRed, cpGreen, cpBlue,
    cpHueHSV, cpSaturationHSV, cpValue, // HSV
    cpHueHLS, cpLightness, cpSaturationHLS, // HLS
    cpCyan, cpMagenta, cpYellow, cpBlack, // CMYK
    cpIntensity,
    cpY); // Y in YIQ coordinates
var
  ColorPlane: TColorPlane;
  ColorOutput, HCReady: Boolean; {Processing Control Interrupt}
  HisCaption: string = 'Histogram Corrections ';
  LUTActive: array of Double;
  LUTR, LUTG, LUTB: array[0..255] of Double;
  WhoseLineIsIt, WhichHis, PACRed, PACGreen, PACBlue, PACCBItemIndex:
  Integer;
{HisMin,HisMax,HisMean,HisMedian,HisMode,HisSum,HisNum,HisRange:Integer;}
{HisVariance,HisSD:Double;}
var
  CStartX, CStartY, CLeftX, CLeftY, CRightX, CRightY: Integer;
  CpointStart, CpointEnd: TPoint; {Moving}
  CDrawing, CStartDrawing: Boolean;


procedure TPixelAlgebraForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  SetLength(LUTActive, 0);
  CStartDrawing := False;
  PixelAlgebraFormX := PixelAlgebraForm.left;
  PixelAlgebraFormY := PixelAlgebraForm.top;
  DoSaver;
  FormControl:=7;  
  GRIPForm.FreeForm;
end;

procedure TPixelAlgebraForm.PACloseBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TPixelAlgebraForm.FormCreate(Sender: TObject);
begin
  left := PixelAlgebraFormX;
  top := PixelAlgebraFormY;
  CStartDrawing := False;
  PACUseColorSliceBtn.Enabled := False;
  PACApplyToImage.Enabled := False;
  HideSliders;
end;

procedure TPixelAlgebraForm.FormShow(Sender: TObject);
begin
  if (Do_Ex_com = True) then TogglesRG.ItemIndex := 1 else
    if (BelowZero = True) then TogglesRG.ItemIndex := 2 else
      if (AutoRange = True) then TogglesRG.ItemIndex := 3 else
      begin ClipR := True; TogglesRG.ItemIndex := 0; end;
end;

procedure TPixelAlgebraForm.PixelAlgebraHelpBtnClick(Sender:
  TObject);
begin
  Application.HelpContext(8000);
end;

procedure TPixelAlgebraForm.PAPixelOperationsHelpBtnClick(Sender:
  TObject);
begin
  Application.HelpContext(8100);
end;

procedure TPixelAlgebraForm.PARatioingHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(8800);
end;

procedure TPixelAlgebraForm.PARatioingMHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(8850);
end;

procedure TPixelAlgebraForm.PARatioHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(8700); {8700}
end;

procedure TPixelAlgebraForm.PAGammaHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(8900); {8900}
end;

procedure TPixelAlgebraForm.TogglesRGClick(Sender: TObject);
begin
  ClipR := False;
  Do_Ex_com := False;
  BelowZero := False;
  AutoRange := False;
  case TogglesRG.ItemIndex of
    0: ClipR := True;
    1: Do_Ex_com := True;
    2: BelowZero := True;
    3: AutoRange := True;
  end;
end;
(******************************************************)
(******************************************************)

procedure TPixelAlgebraForm.PAPODOBtnClick(Sender: TObject);
begin
  DOPAPODO;
end;

procedure TPixelAlgebraForm.DOPAPODO;
var {,OpMain,AG1,AG2,AG3,AO1,AO2,BG1,BG2,BG3,BO1,BO2}
  RGroupA, RGroupB: Integer;
  AOPArray: Array13I;
begin {Topic} {ChangeName('A', 'B'); RGB ALGEBRA}
  {Do_Error(1226,1227);}
  RGroupA := BA0.ItemIndex;
  RGroupB := BB0.ItemIndex;
  AOPArray[1] := RGroupA;
  AOPArray[2] := RGroupB;
  AOPArray[3] := OpRGMain.ItemIndex;
  {AOPArray[A,B,Op,AG1,AG2,AG3,AO1,AO2,BG1,BG2,BG3,BO1,BO2]}
  case RGroupA of
    0:
      begin
        AOPArray[4] := BA1.ItemIndex;
        AOPArray[5] := 9;
        AOPArray[6] := 9;
        AOPArray[7] := 9;
        AOPArray[8] := 9;
      end;
    1:
      begin
        AOPArray[4] := BA2.ItemIndex;
        AOPArray[5] := BA3.ItemIndex;
        AOPArray[6] := 9;
        AOPArray[7] := OpRGA1.ItemIndex;
        AOPArray[8] := 9;
      end;
    2:
      begin
        AOPArray[4] := BA4.ItemIndex;
        AOPArray[5] := BA5.ItemIndex;
        AOPArray[6] := BA6.ItemIndex;
        AOPArray[7] := OpRGA2.ItemIndex;
        AOPArray[8] := OpRGA3.ItemIndex;
      end;
  end; {Case}
  case RGroupB of
    0:
      begin
        AOPArray[9] := BB1.ItemIndex;
        AOPArray[10] := 9;
        AOPArray[11] := 9;
        AOPArray[12] := 9;
        AOPArray[13] := 9;
      end;
    1:
      begin
        AOPArray[9] := BB2.ItemIndex;
        AOPArray[10] := BB3.ItemIndex;
        AOPArray[11] := 9;
        AOPArray[12] := OpRGB1.ItemIndex;
        AOPArray[13] := 9;
      end;
    2:
      begin
        AOPArray[9] := BB4.ItemIndex;
        AOPArray[10] := BB5.ItemIndex;
        AOPArray[11] := BB6.ItemIndex;
        AOPArray[12] := OpRGB2.ItemIndex;
        AOPArray[13] := OpRGB3.ItemIndex;
      end;
  end; {Case}
  if LoggingToMacro then
  begin
    MacroForm.MacroRE.Lines.Add('=0201   Do_PixelAlgebra');
    MacroForm.MacroRE.Lines.Add(IntToStr(BA0.ItemIndex));
    MacroForm.MacroRE.Lines.Add(IntToStr(OpRGMain.ItemIndex));
    MacroForm.MacroRE.Lines.Add(IntToStr(BB0.ItemIndex));

    MacroForm.MacroRE.Lines.Add(IntToStr(BA1.ItemIndex));
    MacroForm.MacroRE.Lines.Add(IntToStr(BA2.ItemIndex));
    MacroForm.MacroRE.Lines.Add(IntToStr(BA3.ItemIndex));
    MacroForm.MacroRE.Lines.Add(IntToStr(BA4.ItemIndex));
    MacroForm.MacroRE.Lines.Add(IntToStr(BA5.ItemIndex));
    MacroForm.MacroRE.Lines.Add(IntToStr(BA6.ItemIndex));
    MacroForm.MacroRE.Lines.Add(IntToStr(OpRGA1.ItemIndex));
    MacroForm.MacroRE.Lines.Add(IntToStr(OpRGA2.ItemIndex));
    MacroForm.MacroRE.Lines.Add(IntToStr(OpRGA3.ItemIndex));

    MacroForm.MacroRE.Lines.Add(IntToStr(BB1.ItemIndex));
    MacroForm.MacroRE.Lines.Add(IntToStr(BB2.ItemIndex));
    MacroForm.MacroRE.Lines.Add(IntToStr(BB3.ItemIndex));
    MacroForm.MacroRE.Lines.Add(IntToStr(BB4.ItemIndex));
    MacroForm.MacroRE.Lines.Add(IntToStr(BB5.ItemIndex));
    MacroForm.MacroRE.Lines.Add(IntToStr(BB6.ItemIndex));
    MacroForm.MacroRE.Lines.Add(IntToStr(OpRGB1.ItemIndex));
    MacroForm.MacroRE.Lines.Add(IntToStr(OpRGB2.ItemIndex));
    MacroForm.MacroRE.Lines.Add(IntToStr(OpRGB3.ItemIndex));
  end;
  if LoggingToDIP then
  begin
    PBands.DIPMemo.Lines.Add('=0201   Do_PixelAlgebra');
    PBands.DIPMemo.Lines.Add(IntToStr(BA0.ItemIndex));
    PBands.DIPMemo.Lines.Add(IntToStr(OpRGMain.ItemIndex));
    PBands.DIPMemo.Lines.Add(IntToStr(BB0.ItemIndex));

    PBands.DIPMemo.Lines.Add(IntToStr(BA1.ItemIndex));
    PBands.DIPMemo.Lines.Add(IntToStr(BA2.ItemIndex));
    PBands.DIPMemo.Lines.Add(IntToStr(BA3.ItemIndex));
    PBands.DIPMemo.Lines.Add(IntToStr(BA4.ItemIndex));
    PBands.DIPMemo.Lines.Add(IntToStr(BA5.ItemIndex));
    PBands.DIPMemo.Lines.Add(IntToStr(BA6.ItemIndex));
    PBands.DIPMemo.Lines.Add(IntToStr(OpRGA1.ItemIndex));
    PBands.DIPMemo.Lines.Add(IntToStr(OpRGA2.ItemIndex));
    PBands.DIPMemo.Lines.Add(IntToStr(OpRGA3.ItemIndex));

    PBands.DIPMemo.Lines.Add(IntToStr(BB1.ItemIndex));
    PBands.DIPMemo.Lines.Add(IntToStr(BB2.ItemIndex));
    PBands.DIPMemo.Lines.Add(IntToStr(BB3.ItemIndex));
    PBands.DIPMemo.Lines.Add(IntToStr(BB4.ItemIndex));
    PBands.DIPMemo.Lines.Add(IntToStr(BB5.ItemIndex));
    PBands.DIPMemo.Lines.Add(IntToStr(BB6.ItemIndex));
    PBands.DIPMemo.Lines.Add(IntToStr(OpRGB1.ItemIndex));
    PBands.DIPMemo.Lines.Add(IntToStr(OpRGB2.ItemIndex));
    PBands.DIPMemo.Lines.Add(IntToStr(OpRGB3.ItemIndex));
    PBands.DIPMemo.Lines.Add(DateTimetoStr(Now));
    PBands.DIPSaveIt;
  end;
  Do_PixelAlgebra(AOPArray);
end;

{
Pixel CIR VI
Pixel X0: c/All
Pixel X1: A-B/a+b
Pixel X2: A-B/a+b
Pixel X3: A+B/a-b
Pixel X4: A/B
Pixel X5: A+B/c
Pixel X6: All/c
Pixel X7: A+B/Blue
Pixel X8: A+B/a*c
Pixel X9: A*B/c
Pixel X10: A+B/a*b
Pixel X11: Multiple
Pixel X15
Pixel XR71
}

procedure TPixelAlgebraForm.PA_RatiosBtnClick(Sender: TObject);
var Choice: Integer;
begin
  Choice := PixelRatiosRG.ItemIndex;
  if LoggingToMacro then
  begin
    MacroForm.MacroRE.Lines.Add('=0202  PixelRatios');
    MacroForm.MacroRE.Lines.Add(IntToStr(Choice));
  end;
  if LoggingToDIP then
  begin
    PBands.DIPMemo.Lines.Add('=0202  PixelRatios');
    PBands.DIPMemo.Lines.Add(IntToStr(Choice));
    PBands.DIPMemo.Lines.Add(DateTimetoStr(Now));
    PBands.DIPSaveIt;
  end;
  case Choice of
    0: Do_Pixel(1); {ChangeName('A', 'I');IR NDVI}
    1: Do_Pixel(2); {ChangeName('A', 'J');X1}
    2: Do_Pixel(3); {ChangeName('A', 'K');  NOT ANYMORE ELATED}
    3: Do_Pixel(4); {ChangeName('A', 'L');X}
    4: Do_Pixel(5); {ChangeName('A', 'M');X}
    5: Do_Pixel(6); {ChangeName('A', 'N'); X4}
    6: Do_Pixel(7); {ChangeName('A', 'O'); X5}
    7: Do_Pixel(8); {ChangeName('A', 'P'); X6}
    8: Do_Pixel(9); {ChangeName('A', 'Q'); X7}
    9: Do_Pixel(10); {ChangeName('A', 'R'); X8}
    10: Do_Pixel(11); {ChangeName('A', 'S'); X}
    11: Do_Pixel(12); {ChangeName('A', 'T');X}
    12: Do_Pixel(13); {ChangeName('A', 'U');X}
    13: Do_Pixel(14); {ChangeName('A', 'V');X}
    14: Do_Pixel(15); {ChangeName('A', 'W');X}
  end;
end;

procedure TPixelAlgebraForm.PARBtnClick(Sender: TObject);
var
  PARR1, PARR2, PARR3,
    PARG1, PARG2, PARG3,
    PARB1, PARB2, PARB3: string;
  dPARR1, dPARR2, dPARR3,
    dPARG1, dPARG2, dPARG3,
    dPARB1, dPARB2, dPARB3: Double;
  Choice, ErrorPos: Integer;
begin
  Choice := PARRG.ItemIndex;
  PARR1 := PARREdit1.Text;
  Val(PARR1, dPARR1, ErrorPos);
  PARR2 := PARREdit2.Text;
  Val(PARR2, dPARR2, ErrorPos);
  PARR3 := PARREdit3.Text;
  Val(PARR3, dPARR3, ErrorPos);
  PARG1 := PARGEdit1.Text;
  Val(PARG1, dPARG1, ErrorPos);
  PARG2 := PARGEdit2.Text;
  Val(PARG2, dPARG2, ErrorPos);
  PARG3 := PARGEdit3.Text;
  Val(PARG3, dPARG3, ErrorPos);
  PARB1 := PARBEdit1.Text;
  Val(PARB1, dPARB1, ErrorPos);
  PARB2 := PARBEdit2.Text;
  Val(PARB2, dPARB2, ErrorPos);
  PARB3 := PARBEdit3.Text;
  Val(PARB3, dPARB3, ErrorPos);
  if LoggingToMacro then
  begin
    MacroForm.MacroRE.Lines.Add('=0203  Do_PARBMultiply');
    MacroForm.MacroRE.Lines.Add(FloatToStr(dPARR1));
    MacroForm.MacroRE.Lines.Add(FloatToStr(dPARR2));
    MacroForm.MacroRE.Lines.Add(FloatToStr(dPARR3));
    MacroForm.MacroRE.Lines.Add(FloatToStr(dPARG1));
    MacroForm.MacroRE.Lines.Add(FloatToStr(dPARG2));
    MacroForm.MacroRE.Lines.Add(FloatToStr(dPARG3));
    MacroForm.MacroRE.Lines.Add(FloatToStr(dPARB1));
    MacroForm.MacroRE.Lines.Add(FloatToStr(dPARB2));
    MacroForm.MacroRE.Lines.Add(FloatToStr(dPARB3));
    MacroForm.MacroRE.Lines.Add(IntToStr(Choice));
  end;
  if LoggingToDIP then
  begin
    PBands.DIPMemo.Lines.Add('=0203  Do_PARBMultiply');
    PBands.DIPMemo.Lines.Add(FloatToStr(dPARR1));
    PBands.DIPMemo.Lines.Add(FloatToStr(dPARR2));
    PBands.DIPMemo.Lines.Add(FloatToStr(dPARR3));
    PBands.DIPMemo.Lines.Add(FloatToStr(dPARG1));
    PBands.DIPMemo.Lines.Add(FloatToStr(dPARG2));
    PBands.DIPMemo.Lines.Add(FloatToStr(dPARG3));
    PBands.DIPMemo.Lines.Add(FloatToStr(dPARB1));
    PBands.DIPMemo.Lines.Add(FloatToStr(dPARB2));
    PBands.DIPMemo.Lines.Add(FloatToStr(dPARB3));
    PBands.DIPMemo.Lines.Add(IntToStr(Choice));
    PBands.DIPMemo.Lines.Add(DateTimetoStr(Now));
    PBands.DIPSaveIt;
  end;
  Do_PARBMultiply(dPARR1, dPARR2, dPARR3,
    dPARG1, dPARG2, dPARG3,
    dPARB1, dPARB2, dPARB3, Choice);
end;

procedure TPixelAlgebraForm.PMultiplyBtnClick(Sender: TObject);
var
  PM1, PM2, PM3: string;
  dPM1, dPM2, dPM3: Double;
  Choice, ErrorPos: Integer;
begin
  Choice := PMRG.ItemIndex;
  PM1 := PMEdit1.Text;
  Val(PM1, dPM1, ErrorPos);
  PM2 := PMEdit2.Text;
  Val(PM2, dPM2, ErrorPos);
  PM3 := PMEdit3.Text;
  Val(PM3, dPM3, ErrorPos);
  if LoggingToMacro then
  begin
    MacroForm.MacroRE.Lines.Add('=0204  Do_PMultiply');
    MacroForm.MacroRE.Lines.Add(FloatToStr(dPM1));
    MacroForm.MacroRE.Lines.Add(FloatToStr(dPM2));
    MacroForm.MacroRE.Lines.Add(FloatToStr(dPM3));
    MacroForm.MacroRE.Lines.Add(IntToStr(Choice));
  end;
  if LoggingToDIP then
  begin
    PBands.DIPMemo.Lines.Add('=0204  Do_PMultiply');
    PBands.DIPMemo.Lines.Add(FloatToStr(dPM1));
    PBands.DIPMemo.Lines.Add(FloatToStr(dPM2));
    PBands.DIPMemo.Lines.Add(FloatToStr(dPM3));
    PBands.DIPMemo.Lines.Add(IntToStr(Choice));
    PBands.DIPMemo.Lines.Add(DateTimetoStr(Now));
    PBands.DIPSaveIt;
  end;
  Do_PMultiply(dPM1, dPM2, dPM3, Choice);
end;
(******************************************************)
(******************************************************)

(******************************************************)
(******************************************************)



(*
{Redone to be Gamma - Log only}
{Gamma; actually a histogram type correction: Watkins page 132}
procedure TPixelAlgebraForm.Gamma1BtnClick(Sender: TObject);
var {GGS,}GRS:String;  Gamma{,Gamma2}:Double; ErrorPos:Integer;
begin{Topic}{GetGamma;}
 GRS:=  Gamma1Edit.Text;
      Val(GRS, Gamma, ErrorPos);
      If ( Gamma >3) Then Gamma:= 2.9;
      If ( Gamma <1) Then Gamma:= 1.0;
  If LoggingToMacro then
  begin
  MacroForm.MacroRE.Lines.Add('=0211  Do_Gamma');
  IF AUTORANGE THEN MacroForm.MacroRE.Lines.Add(IntToStr(1))
  else MacroForm.MacroRE.Lines.Add(IntToStr(0));
  MacroForm.MacroRE.Lines.Add(IntToStr(1));
  MacroForm.MacroRE.Lines.Add(FloatToStr(Gamma));
  MacroForm.MacroRE.Lines.Add(IntToStr(0));
  end;
  IF AUTORANGE THEN Do_Gamma(1,1,Gamma,0)
  ELSE Do_Gamma(0,1,Gamma,0);{ChangeName('A', 'G');}
end;

procedure TPixelAlgebraForm.Gamma2BtnClick(Sender: TObject);
var GGS,GRS:String;  Gamma,Gamma2:Double; ErrorPos:Integer;
begin  {Topic}{GetGamma;GetGamma2;}
 GRS:=  Gamma2Edit1.Text;
      Val(GRS, Gamma, ErrorPos);
 GGS:=  Gamma2Edit2.Text;
      Val(GGS, Gamma2, ErrorPos);
      If ( Gamma >3) Then Gamma:= 2.9;
      If ( Gamma <1) Then Gamma:= 1.0;
      If ( Gamma2 >3) Then Gamma2:= 2.9;
      If ( Gamma2 <1) Then Gamma2:= 1.0;
  If LoggingToMacro then
  begin
  MacroForm.MacroRE.Lines.Add('=0212  Do_Gamma2');
  IF AUTORANGE THEN MacroForm.MacroRE.Lines.Add(IntToStr(1))
  else MacroForm.MacroRE.Lines.Add(IntToStr(0));
  MacroForm.MacroRE.Lines.Add(IntToStr(2));
  MacroForm.MacroRE.Lines.Add(FloatToStr(Gamma));
  MacroForm.MacroRE.Lines.Add(FloatToStr(Gamma2));
  end;
  IF AUTORANGE THEN Do_Gamma(1,2,Gamma,Gamma2)
  ELSE Do_Gamma(0,2,Gamma,Gamma2);{ChangeName('A', 'L');}
end;

procedure TPixelAlgebraForm.Gamma3BtnClick(Sender: TObject);
var GGS,GRS:String;  Gamma,Gamma2:Double; ErrorPos:Integer;
begin   {Topic}{GetGamma;GetGamma2;}
 GRS:=  Gamma3Edit1.Text;
      Val(GRS, Gamma, ErrorPos);
 GGS:=  Gamma3Edit2.Text;
      Val(GGS, Gamma2, ErrorPos);
      If ( Gamma >3) Then Gamma:= 2.9;
      If ( Gamma <1) Then Gamma:= 1.0;
      If ( Gamma2 >3) Then Gamma2:= 2.9;
      If ( Gamma2 <1) Then Gamma2:= 1.0;
  If LoggingToMacro then
  begin
  MacroForm.MacroRE.Lines.Add('=0213  Do_Gamma3');
  IF AUTORANGE THEN MacroForm.MacroRE.Lines.Add(IntToStr(1))
  else MacroForm.MacroRE.Lines.Add(IntToStr(0));
  MacroForm.MacroRE.Lines.Add(IntToStr(3));
  MacroForm.MacroRE.Lines.Add(FloatToStr(Gamma));
  MacroForm.MacroRE.Lines.Add(FloatToStr(Gamma2));
  end;
  IF AUTORANGE THEN Do_Gamma(1,3,Gamma,Gamma2)
  ELSE Do_Gamma(0,3,Gamma,Gamma2);{ChangeName('A', 'D');}
end;

DO_PIXEL
  If LoggingToMacro then
  begin
  MacroForm.MacroRE.Lines.Add('=0214  DoPixel');
  end;
randomize;
DoPixel;


CONTRAST
var {GGS,}GRS:String;  Gamma, ErrorPos:Integer;
begin{Topic}{GetGamma;}
 GRS:=  ContrastEdit.Text;
      Val(GRS, Gamma, ErrorPos);
  If LoggingToMacro then
  begin
  MacroForm.MacroRE.Lines.Add('=0215  DoContrast');
  MacroForm.MacroRE.Lines.Add(IntToStr(Gamma));
  end;
  Screen.Cursor:=CRHOURGLASS;
  DoContrast(Gamma);
  Screen.Cursor:=CRDEFAULT;
*)
(******************************************************)
(******************************************************)

procedure TPixelAlgebraForm.BlueMeanieTBarChange(Sender: TObject);
begin
  BlueMeanieValueLabel.Caption := IntToStr(BlueMeanieTBar.Position);
  if (AllTogetherCB.Checked) then
  begin
    PACGreen := BlueMeanieTBar.Position;
    PACBlue := BlueMeanieTBar.Position;
    GMaxTBar.Position := BlueMeanieTBar.Position;
    GMaxValueLabel.Caption := IntToStr(GMaxTBar.Position);
    RMinTBar.Position := BlueMeanieTBar.Position;
    RMinValueLabel.Caption := IntToStr(RMinTBar.Position);
  end;
  Application.ProcessMessages;
  if ((HCReady) and (PACBlue <> BlueMeanieTBar.Position)
    and (not (ButtonCommandCB.Checked))) then
  begin
    PACBlue := BlueMeanieTBar.Position;
    HCReady := False;
    DoLUT;
    MakeHisHCImage;
  end;
end;

procedure TPixelAlgebraForm.GMaxTBarChange(Sender: TObject);
begin
  GMaxValueLabel.Caption := IntToStr(GMaxTBar.Position);
  if (AllTogetherCB.Checked) then
  begin
    PACGreen := GMaxTBar.Position;
    PACBlue := GMaxTBar.Position;
    RMinTBar.Position := GMaxTBar.Position;
    RMinValueLabel.Caption := IntToStr(RMinTBar.Position);
    BlueMeanieTBar.Position := GMaxTBar.Position;
    BlueMeanieValueLabel.Caption :=
      IntToStr(BlueMeanieTBar.Position);
  end;
  Application.ProcessMessages;
  if ((HCReady) and (PACGreen <> GMaxTBar.Position)
    and (not (ButtonCommandCB.Checked))) then
  begin
    PACGreen := GMaxTBar.Position;
    HCReady := False;
    DoLUT;
    MakeHisHCImage;
  end;
end;

procedure TPixelAlgebraForm.RMinTBarChange(Sender: TObject);
begin
  RMinValueLabel.Caption := IntToStr(RMinTBar.Position);
  if (AllTogetherCB.Checked) then
  begin
    PACGreen := RMinTBar.Position;
    PACBlue := RMinTBar.Position;
    GMaxTBar.Position := RMinTBar.Position;
    GMaxValueLabel.Caption := IntToStr(GMaxTBar.Position);
    BlueMeanieTBar.Position := RMinTBar.Position;
    BlueMeanieValueLabel.Caption :=
      IntToStr(BlueMeanieTBar.Position);
  end;
  Application.ProcessMessages;
  if ((HCReady) and (PACRed <> RMinTBar.Position)
    and (not (ButtonCommandCB.Checked))) then
  begin
    PACRed := RMinTBar.Position;
    HCReady := False;
    DoLUT;
    MakeHisHCImage;
  end;
end;

procedure TPixelAlgebraForm.ProcessSliderBtnClick(Sender: TObject);
begin
  if ((HCReady)) then
  begin
    HCReady := False;
    DoLUT;
    MakeHisHCImage;
  end;
end;
(******************************************************)
(******************************************************)

procedure TPixelAlgebraForm.HideSliders;
begin
  RMinTBar.Visible := False;
  RMinTBar.Enabled := False;
  RMinLabel.Visible := False;
  RMinValueLabel.Visible := False;
  GMaxTBar.Visible := False;
  GMaxTBar.Enabled := False;
  GMaxLabel.Visible := False;
  GMaxValueLabel.Visible := False;
  BlueMeanieTBar.Visible := False;
  BlueMeanieTBar.Enabled := False;
  BlueMeanieLabel.Visible := False;
  BlueMeanieValueLabel.Visible := False;
  AllTogetherCB.Checked := False; {Gamma only}
  AllTogetherCB.Enabled := False;
  AllTogetherCB.Visible := False;
  ProcessSliderBtn.Visible := False;
  ProcessSliderBtn.Enabled := False;
  ButtonCommandCB.Checked := False; {3 bar color only}
  ButtonCommandCB.Enabled := False;
  ButtonCommandCB.Visible := False;
  PositiveCurveCB.Checked := True; {Most curved corrections}
  PositiveCurveCB.Enabled := False;
  PositiveCurveCB.Visible := False;
  AddedCB.Enabled := False;
  AddedCB.Visible := False;
  RadioGroupColorPlane.Enabled := False;
  RadioGroupColorPlane.Visible := False;
  CheckBoxMonochrome.Enabled := False;
  CheckBoxMonochrome.Visible := False;
  CheckBoxMonochrome.Checked := False;
  ColorOutput := True;
  Application.ProcessMessages;
end;
(******************************************************)
(******************************************************)

procedure TPixelAlgebraForm.PACApplyToImageClick(Sender: TObject);
begin
  SetHisHCImage;
{   RasterForm.Image1.Assign(PACImage);}
end;

procedure TPixelAlgebraForm.SetHisHCImage;
type
  TReal = Single;
var
  SpatError: Boolean;
  R_Min, G_Min, B_Min: Single;
  H2, S2, V2, L2,
    Rt_Filtered, Gt_Filtered, Bt_Filtered, H, S, V, L: TReal;
  PAC_Filtered,
    R_Range, R_Max, G_Range, G_Max, B_Range, B_Max,
    Ri, Gi, Bi, K_Filtered, R_Filtered, G_Filtered, B_Filtered:
  Double;
  RedColor, BlueColor, GreenColor: Byte;
  ILStart, ILEnd, IWStart, IWEnd, Range,
    AutoTimes, {Center, } Size, sX, sY, Where: Integer;
  IL, IW: DWord;
begin {Get current Window DC}
  AutoTimes := 0;
  HCGauge.Progress := 0;
  if AUTORANGE then AutoTimes := 1;
  SpatError := FALSE;
  R_Max := 0;
  R_Min := 255;
  G_Max := 0;
  G_Min := 255;
  B_Max := 0;
  B_Min := 255;
     {Begin of Whole Autorange = True... Do Twice}
  ILStart := 0;
  IWStart := 0;
  ILEnd := (ImageHeight);
  IWEnd := (ImageWidth);
  MakeImage;
  if ImageMade = TRUE then begin
    for RANGE := 0 to AutoTimes do begin
      R_Range := R_Max - R_Min;
      R_Range := R_Range / 255;
      G_Range := G_Max - G_Min;
      G_Range := G_Range / 255;
      B_Range := B_Max - B_Min;
      B_Range := B_Range / 255;

      for IL := ILStart to ILEnd do begin
        if R_Max > All_Max then All_Max := R_Max;
        if G_Max > All_Max then All_Max := G_Max;
        if B_Max > All_Max then All_Max := B_Max;
        if R_Min < All_Min then All_Min := R_Min;
        if G_Min < All_Min then All_Min := G_Min;
        if B_Min < All_Min then All_Min := B_Min;
        for IW := IWStart to IWEnd do begin
          R_Filtered := 0;
          G_Filtered := 0;
          B_Filtered := 0;
          WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
          lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
          lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
          lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
          BlueColor := lpPixelB^;
          GreenColor := lpPixelG^;
          RedColor := lpPixelR^;
          case WhichHis of
            0..3: begin
                R_Filtered := LUTR[RedColor];
                G_Filtered := LUTG[GreenColor];
                B_Filtered := LUTB[BlueColor];
              end;
            4: begin
                R_Filtered := LUTR[RedColor];
                G_Filtered := LUTG[GreenColor];
                B_Filtered := LUTB[BlueColor];
                PAC_Filtered := ((0.001 + R_Filtered + G_Filtered +
                  B_Filtered) / 100);
                R_Filtered := PAC_Filtered;
                G_Filtered := PAC_Filtered;
                B_Filtered := PAC_Filtered;
              end;
            5..10: begin
                R_Filtered := LUTR[RedColor];
                G_Filtered := LUTG[GreenColor];
                B_Filtered := LUTB[BlueColor];
              end;
            11: begin {RGB}
                case ColorPlane of
                  cpRGB:
                    if ColorOutput then
                    begin
                      R_Filtered := LUTR[RedColor];
                      G_Filtered := LUTG[GreenColor];
                      B_Filtered := LUTB[BlueColor];
                    end else
                    begin
                      R_Filtered := (LUTR[RedColor] + LUTG[GreenColor]
                        + LUTB[BlueColor]) / 3;
                      G_Filtered := R_Filtered;
                      B_Filtered := R_Filtered;
                    end;
                  cpRed:
                    if ColorOutput then
                    begin
                      R_Filtered := LUTR[RedColor];
                      G_Filtered := 0;
                      B_Filtered := 0;
                    end else
                    begin
                      R_Filtered := LUTR[RedColor];
                      G_Filtered := R_Filtered;
                      B_Filtered := R_Filtered;
                    end;
                  cpGreen:
                    if ColorOutput then
                    begin
                      R_Filtered := 0;
                      G_Filtered := LUTG[GreenColor];
                      B_Filtered := 0;
                    end else
                    begin
                      R_Filtered := LUTG[GreenColor];
                      G_Filtered := R_Filtered;
                      B_Filtered := R_Filtered;
                    end;
                  cpBlue:
                    if ColorOutput then
                    begin
                      R_Filtered := 0;
                      G_Filtered := 0;
                      B_Filtered := LUTB[BlueColor];
                    end else
                    begin
                      R_Filtered := LUTB[BlueColor];
                      G_Filtered := R_Filtered;
                      B_Filtered := R_Filtered;
                    end;
                end;
              end;
            12: begin
              {HCHSV 3 bar H -359..359 S -255..255 V -255..255}
{     HSVtoRGB(H,S,V,Rt_Filtered,Gt_Filtered,Bt_Filtered);     }
                if RedColor = 0 then RedColor := 1;
                if GreenColor = 0 then GreenColor := 1;
                if BlueColor = 0 then BlueColor := 1;
                MyRGBToHSV(RedColor / 255,
                  GreenColor / 255,
                  BlueColor / 255, H, S, V);
                MyRGBToHSV((0.1 + RMinTBar.Position) / 359,
                  (0.1 + GMaxTBar.Position) / 255,
                  (0.1 + BlueMeanieTBar.Position) / 255, H2, S2, V2);
                case ColorPlane of
                  cpHueHSV:
                    begin
                      R_Filtered := H + H2;
                      G_Filtered := 255;
                      B_Filtered := 255;
                      if not ColorOutput then
                      begin
                        R_Filtered := (R_Filtered + G_Filtered +
                          B_Filtered) / 3;
                        G_Filtered := R_Filtered;
                        B_Filtered := R_Filtered;
                      end;
                    end;
                  cpSaturationHSV:
                    begin
                      G_Filtered := S + S2;
                      R_Filtered := G_Filtered;
                      B_Filtered := G_Filtered;
                    end;
                  cpValue:
                    begin
                      B_Filtered := V + V2;
                      R_Filtered := B_Filtered;
                      G_Filtered := B_Filtered;
                    end;
                end;
                if R_Filtered <= 0 then R_Filtered := 0.0 else
                  if R_Filtered >= 360.0 then R_Filtered := 360.0;
                if G_Filtered <= 0.0 then G_Filtered := 0.0001 else
                  if G_Filtered >= 1.0 then G_Filtered := 1.0;
                if B_Filtered <= 0 then B_Filtered := 0.0 else
                  if B_Filtered >= 1.0 then B_Filtered := 1.0;
                HSVtoRGB(R_Filtered, G_Filtered, B_Filtered,
                  Rt_Filtered, Gt_Filtered, Bt_Filtered);
                B_Filtered := Rt_Filtered * 255;
                R_Filtered := Gt_Filtered * 255;
                G_Filtered := Bt_Filtered * 255;
              end;
            13: begin {HLS 3 bar H -359..359 S -255..255 V -255..255
          HLStoRGB(H,L,S,Rt_Filtered,Gt_Filtered,Bt_Filtered);}
                if RedColor = 0 then RedColor := 1;
                if GreenColor = 0 then GreenColor := 1;
                if BlueColor = 0 then BlueColor := 1;
                MyRGBToHLS((RedColor) / 255,
                  (GreenColor) / 255,
                  (BlueColor) / 255, H, L, S);
                MyRGBToHLS((0.1 + RMinTBar.Position) / 359,
                  (0.1 + GMaxTBar.Position) / 255,
                  (0.1 + BlueMeanieTBar.Position) / 255, H2, L2, S2);
                case ColorPlane of
                  cpHueHLS:
                    begin
                      R_Filtered := H + H2;
                      G_Filtered := 128;
                      B_Filtered := 255;
                      if not ColorOutput then
                      begin
                        R_Filtered := (R_Filtered + G_Filtered +
                          B_Filtered) / 3;
                        G_Filtered := R_Filtered;
                        B_Filtered := R_Filtered;
                      end;
                    end;
                  cpLightness:
                    begin
                      G_Filtered := L + L2;
                      R_Filtered := G_Filtered;
                      B_Filtered := G_Filtered;
                    end;
                  cpSaturationHLS:
                    begin
                      B_Filtered := S + S2;
                      R_Filtered := B_Filtered;
                      G_Filtered := B_Filtered;
                    end;
                end;
                if R_Filtered <= 0 then R_Filtered := 0.0 else
                  if R_Filtered >= 360.0 then R_Filtered := 360.0;
                if G_Filtered <= 0 then G_Filtered := 0.0 else
                  if G_Filtered >= 1.0 then G_Filtered := 1.0;
                if B_Filtered <= 0 then B_Filtered := 0.0 else
                  if B_Filtered >= 1.0 then B_Filtered := 1.0001;
                HLStoRGB(R_Filtered, G_Filtered, B_Filtered,
                  Rt_Filtered, Gt_Filtered, Bt_Filtered);
                B_Filtered := Rt_Filtered * 255;
                R_Filtered := Gt_Filtered * 255;
                G_Filtered := Bt_Filtered * 255;
              end;
            14: begin
              {HC CMYK ?4? 3 bar H -255..255 S -255..255 V -255..255}
       { C GetCValue(RGB(RedColor,GreenColor,BlueColor))}
                case ColorPlane of
                  cpCyan:
                    begin
                      R_Filtered :=
                        ((GetCValue(RGB(RMinTBar.Position,
                        GMaxTBar.Position,
                        BlueMeanieTBar.Position)))
                        + (GetCValue(RGB(RedColor, GreenColor,
                        BlueColor))));
                      G_Filtered := R_Filtered;
                      B_Filtered := R_Filtered;
                    end;
                  cpMagenta:
                    begin
                      R_Filtered :=
                        ((GetMValue(RGB(RMinTBar.Position,
                        GMaxTBar.Position,
                        BlueMeanieTBar.Position)))
                        + (GetMValue(RGB(RedColor, GreenColor,
                        BlueColor))));
                      G_Filtered := R_Filtered;
                      B_Filtered := R_Filtered;
                    end;
                  cpYellow:
                    begin
                      G_Filtered :=
                        ((GetYValue(RGB(RMinTBar.Position,
                        GMaxTBar.Position,
                        BlueMeanieTBar.Position)))
                        + (GetYValue(RGB(RedColor, GreenColor,
                        BlueColor))));
                      R_Filtered := G_Filtered;
                      B_Filtered := G_Filtered;
                    end;
                  cpBlack:
                    begin
                      B_Filtered :=
                        ((GetKValue(RGB(RMinTBar.Position,
                        GMaxTBar.Position,
                        BlueMeanieTBar.Position)))
                        + (GetKValue(RGB(RedColor, GreenColor,
                        BlueColor))));
                      R_Filtered := B_Filtered;
                      G_Filtered := B_Filtered;
                    end;
                end;
              end;
            15: begin
              {HC YIQ 3 bar H -255..255 S -255..255 V -255..255}
   // See [Foley96, pp. 589]
                R_Filtered := ((0.299 * RedColor)
                  + (0.587 * GreenColor)
                  + (0.114 * BlueColor))
                  + ((0.299 * RMinTBar.Position)
                  + (0.587 * GMaxTBar.Position)
                  + (0.114 * BlueMeanieTBar.Position));
                G_Filtered := ((0.596 * RedColor)
                  - (0.275 * GreenColor)
                  - (0.321 * BlueColor))
                  + ((0.596 * RMinTBar.Position)
                  - (0.275 * GMaxTBar.Position)
                  - (0.321 * BlueMeanieTBar.Position));
                B_Filtered := ((0.212 * BlueColor)
                  - (0.523 * GreenColor)
                  + (0.311 * BlueColor))
                  + ((0.212 * BlueMeanieTBar.Position)
                  - (0.523 * GMaxTBar.Position)
                  + (0.311 * BlueMeanieTBar.Position));
{   R_Filtered :=((0.299*RedColor) + (0.587*GreenColor) + (0.114*BlueColor))+RMinTBar.Position;
   G_Filtered :=((0.596*RedColor) - (0.275*GreenColor) - (0.321*BlueColor))+GMaxTBar.Position;
   B_Filtered :=((0.212*BlueColor) - (0.523*GreenColor) + (0.311*BlueColor))+BlueMeanieTBar.Position;}
              end;
            16: begin {Colorgraph}
                R_Filtered := LUTR[RedColor];
                G_Filtered := LUTG[GreenColor];
                B_Filtered := LUTB[BlueColor];
              end;
          end;


          if AUTORANGE then begin
            if Range = 0 then begin
              if R_Filtered > R_Max then R_Max := R_Filtered;
              if G_Filtered > G_Max then G_Max := G_Filtered;
              if B_Filtered > B_Max then B_Max := B_Filtered;
              if R_Filtered < R_Min then R_Min := R_Filtered;
              if G_Filtered < G_Min then G_Min := G_Filtered;
              if B_Filtered < B_Min then B_Min := B_Filtered;
            end;
            if Range = 1 then begin
              R_Filtered := ((R_Filtered - (R_Min)) / R_Range);
              G_Filtered := ((G_Filtered - (G_Min)) / G_Range);
              B_Filtered := ((B_Filtered - (B_Min)) / B_Range);

              if R_Filtered > 255 then R_Filtered := 255;
              if R_Filtered < 0 then R_Filtered := 0;
              RedColor := Round(R_Filtered);
              if G_Filtered > 255 then G_Filtered := 255;
              if G_Filtered < 0 then G_Filtered := 0;
              GreenColor := Round(G_Filtered);
              if B_Filtered > 255 then B_Filtered := 255;
              if B_Filtered < 0 then B_Filtered := 0;
              BlueColor := Round(B_Filtered);
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
              lpPixelR^ := RedColor;

            end;
          end else
            if {Do_Absolute, AutoRange, B_Ex_com}  BelowZero
              {, ClipR, ThresholdR,}
            then begin {Jensen, p. 136}
              R_Filtered := (127 + (R_Filtered * 127));
              if R_Filtered > 255 then R_Filtered := 255;
              if R_Filtered < 0 then R_Filtered := 0;
              RedColor := Round(R_Filtered);
              G_Filtered := (127 + (G_Filtered * 127));
              if G_Filtered > 255 then G_Filtered := 255;
              if G_Filtered < 0 then G_Filtered := 0;
              GreenColor := Round(G_Filtered);
              B_Filtered := (127 + (B_Filtered * 127));
              if B_Filtered > 255 then B_Filtered := 255;
              if B_Filtered < 0 then B_Filtered := 0;
              BlueColor := Round(B_Filtered);
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(Image)^[WherePixel];
              lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
              lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
              lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
              lpPixelR^ := RedColor;

            end else
              if {Do_Absolute, AutoRange, }  Do_Ex_com
                {, ClipR, ThresholdR,}
              then begin {Jensen, p. 136}
                if R_Filtered < 1 then
                  R_Filtered := ((R_Filtered * 127) + 1) else
                  if R_Filtered >= 1 then
                    R_Filtered := (128 + (R_Filtered / 2));
                if R_Filtered > 255 then R_Filtered := 255;
                if R_Filtered < 0 then R_Filtered := 0;
                RedColor := Round(R_Filtered);
                if G_Filtered < 1 then
                  G_Filtered := ((G_Filtered * 127) + 1) else
                  if G_Filtered >= 1 then
                    G_Filtered := (128 + (G_Filtered / 2));
                if G_Filtered > 255 then G_Filtered := 255;
                if G_Filtered < 0 then G_Filtered := 0;
                GreenColor := Round(G_Filtered);
                if B_Filtered < 1 then
                  B_Filtered := ((B_Filtered * 127) + 1) else
                  if B_Filtered >= 1 then
                    B_Filtered := (128 + (B_Filtered / 2));
                if B_Filtered > 255 then B_Filtered := 255;
                if B_Filtered < 0 then B_Filtered := 0;
                BlueColor := Round(B_Filtered);
                WherePixel := ((IW * 3) + (IL * BytesPerLine));
                lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                lpPixelG := @PHugeByteArray(Image)^[WherePixel + 1];
                lpPixelR := @PHugeByteArray(Image)^[WherePixel + 2];
                lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
                lpPixelR^ := RedColor;

              end else
                if {Do_Absolute, AutoRange, B_Ex_com,}  ClipR
                  {, ThresholdR,}
                then begin {Jensen, p. 136}
                  if R_Filtered > 255 then R_Filtered := 255;
                  if R_Filtered < 0 then R_Filtered := 0;
                  RedColor := Round(R_Filtered);
                  if G_Filtered > 255 then G_Filtered := 255;
                  if G_Filtered < 0 then G_Filtered := 0;
                  GreenColor := Round(G_Filtered);
                  if B_Filtered > 255 then B_Filtered := 255;
                  if B_Filtered < 0 then B_Filtered := 0;
                  BlueColor := Round(B_Filtered);
                  WherePixel := ((IW * 3) + (IL * BytesPerLine));
                  lpPixelB := @PHugeByteArray(Image)^[WherePixel];
                  lpPixelG := @PHugeByteArray(Image)^[WherePixel +
                    1];
                  lpPixelR := @PHugeByteArray(Image)^[WherePixel +
                    2];
                  lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
                  lpPixelR^ := RedColor;

                end; { of AutoRange Insider Edition}
        end; {of  Image Width}
        HCGauge.Progress := Round(100 * (IL / (ImageHeight)));
      end; {of Image Length}
    end; {of AutoRange}
    SetImage;
  end; {OF MAKE BITMAP}
  HCGauge.Progress := 0;
  PACApplyToImage.Enabled := True;
end; {of MakeHisHCImage}


{Compute changes, COUNT STATS, Show Image}

procedure TPixelAlgebraForm.MakeHisHCImage;
type
  TReal = Single;
var
  SpatError: Boolean;
  R_Min, G_Min, B_Min: Single;
  Rt_Filtered, Gt_Filtered, Bt_Filtered,
    H2, S2, V2, L2,
    H, S, V, L: TReal;
  PAC_Filtered,
    R_Range, R_Max, G_Range, G_Max, B_Range, B_Max,
    Ri, Gi, Bi, K_Filtered, R_Filtered, G_Filtered, B_Filtered:
  Double;
  RedColor, BlueColor, GreenColor: Byte;
  ILStart, ILEnd, IWStart, IWEnd, Range,
    AutoTimes, {Center, } Size, sX, sY, Where: Integer;
  IL, IW: DWord;
  PACBitmap: Pointer;
  PACh: DWord;
  lpPixelPAC: ^Byte;
  pPACInfo: PBitmapInfo;
  hBm: HBitmap;
  Bm: TBitmap;
  dc: HDC;
  temp: DWord;
begin {Get current Window DC}
  AutoTimes := 0;
  HCGauge.Progress := 0;
  if AUTORANGE then AutoTimes := 1;
  SpatError := FALSE;
  R_Max := 0;
  R_Min := 255;
  G_Max := 0;
  G_Min := 255;
  B_Max := 0;
  B_Min := 255;
     {Begin of Whole Autorange = True... Do Twice}
  ILStart := 0;
  IWStart := 0;
  ILEnd := (ImageHeight);
  IWEnd := (ImageWidth);
  Undo := GlobalLock(Undoh);
  GetDIB(GRIPForm.Image1.Picture.Bitmap.Handle,
    GRIPForm.Image1.Picture.Bitmap.Palette, pUndoInfo^, Undo^);
  GetDIBSizes(GRIPForm.Image1.Picture.Bitmap.Handle,
    InfoSize, ImageSize);
  temp := trunc(((GRIPForm.Image1.Picture.Bitmap.Width * 24) + 31) /
    32);
  BytesPerLine := (temp * 4);
  pPACInfo := AllocMem(InfoSize);
  PACh := GlobalAlloc(GMEM_MOVEABLE, ImageSize);
  if PACh = 0 then
  begin
    FreeMem(pPACInfo, InfoSize);
    DoMessages(40000);
    Application.Terminate;
  end;
  PACBitmap := GlobalLock(PACh);
  GetDIB(GRIPForm.Image1.Picture.Bitmap.Handle,
    GRIPForm.Image1.Picture.Bitmap.Palette, pPACInfo^, PACBitmap^);
  for RANGE := 0 to AutoTimes do begin
    R_Range := R_Max - R_Min;
    R_Range := R_Range / 255;
    G_Range := G_Max - G_Min;
    G_Range := G_Range / 255;
    B_Range := B_Max - B_Min;
    B_Range := B_Range / 255;

    for IL := ILStart to ILEnd do begin
      if R_Max > All_Max then All_Max := R_Max;
      if G_Max > All_Max then All_Max := G_Max;
      if B_Max > All_Max then All_Max := B_Max;
      if R_Min < All_Min then All_Min := R_Min;
      if G_Min < All_Min then All_Min := G_Min;
      if B_Min < All_Min then All_Min := B_Min;
      for IW := IWStart to IWEnd do begin
        R_Filtered := 0;
        G_Filtered := 0;
        B_Filtered := 0;
        WherePixel := (3 * (IW)) + (BytesPerLine * (((IL))));
        lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
        lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
        lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
        BlueColor := lpPixelB^;
        GreenColor := lpPixelG^;
        RedColor := lpPixelR^;
        case WhichHis of
          0..3: begin
              R_Filtered := LUTR[RedColor];
              G_Filtered := LUTG[GreenColor];
              B_Filtered := LUTB[BlueColor];
            end;
          4: begin
              R_Filtered := LUTR[RedColor];
              G_Filtered := LUTG[GreenColor];
              B_Filtered := LUTB[BlueColor];
              PAC_Filtered := ((0.001 + R_Filtered + G_Filtered +
                B_Filtered) / 100);
              R_Filtered := PAC_Filtered;
              G_Filtered := PAC_Filtered;
              B_Filtered := PAC_Filtered;
            end;
          5..10: begin
              R_Filtered := LUTR[RedColor];
              G_Filtered := LUTG[GreenColor];
              B_Filtered := LUTB[BlueColor];
            end;
          11: begin {RGB}
              case ColorPlane of
                cpRGB:
                  if ColorOutput then
                  begin
                    R_Filtered := LUTR[RedColor];
                    G_Filtered := LUTG[GreenColor];
                    B_Filtered := LUTB[BlueColor];
                  end else
                  begin
                    R_Filtered := (LUTR[RedColor] + LUTG[GreenColor]
                      + LUTB[BlueColor]) / 3;
                    G_Filtered := R_Filtered;
                    B_Filtered := R_Filtered;
                  end;
                cpRed:
                  if ColorOutput then
                  begin
                    R_Filtered := LUTR[RedColor];
                    G_Filtered := 0;
                    B_Filtered := 0;
                  end else
                  begin
                    R_Filtered := LUTR[RedColor];
                    G_Filtered := R_Filtered;
                    B_Filtered := R_Filtered;
                  end;
                cpGreen:
                  if ColorOutput then
                  begin
                    R_Filtered := 0;
                    G_Filtered := LUTG[GreenColor];
                    B_Filtered := 0;
                  end else
                  begin
                    R_Filtered := LUTG[GreenColor];
                    G_Filtered := R_Filtered;
                    B_Filtered := R_Filtered;
                  end;
                cpBlue:
                  if ColorOutput then
                  begin
                    R_Filtered := 0;
                    G_Filtered := 0;
                    B_Filtered := LUTB[BlueColor];
                  end else
                  begin
                    R_Filtered := LUTB[BlueColor];
                    G_Filtered := R_Filtered;
                    B_Filtered := R_Filtered;
                  end;
              end;
            end;
          12: begin {HCHSV 3 bar H -359..359 S -255..255 V -255..255}
{     HSVtoRGB(H,S,V,Rt_Filtered,Gt_Filtered,Bt_Filtered);     }
              if RedColor = 0 then RedColor := 1;
              if GreenColor = 0 then GreenColor := 1;
              if BlueColor = 0 then BlueColor := 1;
              MyRGBToHSV(RedColor / 255,
                GreenColor / 255,
                BlueColor / 255, H, S, V);
              MyRGBToHSV((0.1 + RMinTBar.Position) / 359,
                (0.1 + GMaxTBar.Position) / 255,
                (0.1 + BlueMeanieTBar.Position) / 255, H2, S2, V2);
              case ColorPlane of
                cpHueHSV:
                  begin
                    R_Filtered := H + H2;
                    G_Filtered := 255;
                    B_Filtered := 255;
                    if not ColorOutput then
                    begin
                      R_Filtered := (R_Filtered + G_Filtered +
                        B_Filtered) / 3;
                      G_Filtered := R_Filtered;
                      B_Filtered := R_Filtered;
                    end;
                  end;
                cpSaturationHSV:
                  begin
                    G_Filtered := S + S2;
                    R_Filtered := G_Filtered;
                    B_Filtered := G_Filtered;
                  end;
                cpValue:
                  begin
                    B_Filtered := V + V2;
                    R_Filtered := B_Filtered;
                    G_Filtered := B_Filtered;
                  end;
              end;
              if R_Filtered <= 0 then
                R_Filtered := R_Filtered + 1.0 else
                if R_Filtered >= 360.0 then
                  R_Filtered := R_Filtered - 360.0;
              if G_Filtered <= 0.0 then
                G_Filtered := G_Filtered + 1.0 else
                if G_Filtered >= 1.0 then
                  G_Filtered := G_Filtered - 1.0;
              if B_Filtered <= 0 then
                B_Filtered := B_Filtered + 1.0 else
                if B_Filtered >= 1.0 then
                  B_Filtered := B_Filtered - 1.0;
              if R_Filtered <= 0 then R_Filtered := 0.0 else
                if R_Filtered >= 360.0 then R_Filtered := 360.0;
              if G_Filtered <= 0.004 then G_Filtered := 0.004 else
                if G_Filtered >= 1.0 then G_Filtered := 1.0;
              if B_Filtered <= 0 then B_Filtered := 0.0 else
                if B_Filtered >= 1.0 then B_Filtered := 1.0;
              HSVtoRGB(R_Filtered, G_Filtered, B_Filtered,
                Rt_Filtered, Gt_Filtered, Bt_Filtered);
              B_Filtered := Rt_Filtered * 255;
              R_Filtered := Gt_Filtered * 255;
              G_Filtered := Bt_Filtered * 255;
            end;
          13: begin {HLS 3 bar H -359..359 S -255..255 V -255..255
          HLStoRGB(H,L,S,Rt_Filtered,Gt_Filtered,Bt_Filtered);}
              if RedColor = 0 then RedColor := 1;
              if GreenColor = 0 then GreenColor := 1;
              if BlueColor = 0 then BlueColor := 1;
              MyRGBToHLS((RedColor) / 255,
                (GreenColor) / 255,
                (BlueColor) / 255, H, L, S);
              MyRGBToHLS((0.1 + RMinTBar.Position) / 359,
                (0.1 + GMaxTBar.Position) / 255,
                (0.1 + BlueMeanieTBar.Position) / 255, H2, L2, S2);
              case ColorPlane of
                cpHueHLS:
                  begin
                    R_Filtered := H + H2;
                    G_Filtered := 128;
                    B_Filtered := 255;
                    if not ColorOutput then
                    begin
                      R_Filtered := (R_Filtered + G_Filtered +
                        B_Filtered) / 3;
                      G_Filtered := R_Filtered;
                      B_Filtered := R_Filtered;
                    end;
                  end;
                cpLightness:
                  begin
                    G_Filtered := L + L2;
                    R_Filtered := G_Filtered;
                    B_Filtered := G_Filtered;
                  end;
                cpSaturationHLS:
                  begin
                    B_Filtered := S + S2;
                    R_Filtered := B_Filtered;
                    G_Filtered := B_Filtered;
                  end;
              end;
              if R_Filtered <= 0 then
                R_Filtered := R_Filtered + 1.0 else
                if R_Filtered >= 360.0 then
                  R_Filtered := R_Filtered - 360.0;
              if G_Filtered <= 0.0 then
                G_Filtered := G_Filtered + 1.0 else
                if G_Filtered >= 1.0 then
                  G_Filtered := G_Filtered - 1.0;
              if B_Filtered <= 0 then
                B_Filtered := B_Filtered + 1.0 else
                if B_Filtered >= 1.0 then
                  B_Filtered := B_Filtered - 1.0;
              if R_Filtered <= 0 then R_Filtered := 0.0 else
                if R_Filtered >= 360.0 then R_Filtered := 360.0;
              if G_Filtered <= 0 then G_Filtered := 0.0 else
                if G_Filtered >= 1.0 then G_Filtered := 1.0;
              if B_Filtered <= 0.004 then B_Filtered := 0.004 else
                if B_Filtered >= 1.0 then B_Filtered := 1.0001;
              HLStoRGB(R_Filtered, G_Filtered, B_Filtered,
                Rt_Filtered, Gt_Filtered, Bt_Filtered);
              B_Filtered := Rt_Filtered * 255;
              R_Filtered := Gt_Filtered * 255;
              G_Filtered := Bt_Filtered * 255;
            end;
          14: begin
            {HC CMYK ?4? 3 bar H -255..255 S -255..255 V -255..255}
       { C GetCValue(RGB(RedColor,GreenColor,BlueColor))}
              case ColorPlane of
                cpCyan:
                  begin
                    R_Filtered := ((GetCValue(RGB(RMinTBar.Position,
                      GMaxTBar.Position,
                      BlueMeanieTBar.Position)))
                      + (GetCValue(RGB(RedColor, GreenColor,
                      BlueColor))));
                    G_Filtered := R_Filtered;
                    B_Filtered := R_Filtered;
                  end;
                cpMagenta:
                  begin
                    R_Filtered := ((GetMValue(RGB(RMinTBar.Position,
                      GMaxTBar.Position,
                      BlueMeanieTBar.Position)))
                      + (GetMValue(RGB(RedColor, GreenColor,
                      BlueColor))));
                    G_Filtered := R_Filtered;
                    B_Filtered := R_Filtered;
                  end;
                cpYellow:
                  begin
                    G_Filtered := ((GetYValue(RGB(RMinTBar.Position,
                      GMaxTBar.Position,
                      BlueMeanieTBar.Position)))
                      + (GetYValue(RGB(RedColor, GreenColor,
                      BlueColor))));
                    R_Filtered := G_Filtered;
                    B_Filtered := G_Filtered;
                  end;
                cpBlack:
                  begin
                    B_Filtered := ((GetKValue(RGB(RMinTBar.Position,
                      GMaxTBar.Position,
                      BlueMeanieTBar.Position)))
                      + (GetKValue(RGB(RedColor, GreenColor,
                      BlueColor))));
                    R_Filtered := B_Filtered;
                    G_Filtered := B_Filtered;
                  end;
              end;
            end;
          15: begin {HC YIQ 3 bar H -255..255 S -255..255 V -255..255}
   // See [Foley96, pp. 589]
              R_Filtered := ((0.299 * RedColor)
                + (0.587 * GreenColor)
                + (0.114 * BlueColor))
                + ((0.299 * RMinTBar.Position)
                + (0.587 * GMaxTBar.Position)
                + (0.114 * BlueMeanieTBar.Position));
              G_Filtered := ((0.596 * RedColor)
                - (0.275 * GreenColor)
                - (0.321 * BlueColor))
                + ((0.596 * RMinTBar.Position)
                - (0.275 * GMaxTBar.Position)
                - (0.321 * BlueMeanieTBar.Position));
              B_Filtered := ((0.212 * BlueColor)
                - (0.523 * GreenColor)
                + (0.311 * BlueColor))
                + ((0.212 * BlueMeanieTBar.Position)
                - (0.523 * GMaxTBar.Position)
                + (0.311 * BlueMeanieTBar.Position));
{   R_Filtered :=((0.299*RedColor) + (0.587*GreenColor) + (0.114*BlueColor))+RMinTBar.Position;
   G_Filtered :=((0.596*RedColor) - (0.275*GreenColor) - (0.321*BlueColor))+GMaxTBar.Position;
   B_Filtered :=((0.212*BlueColor) - (0.523*GreenColor) + (0.311*BlueColor))+BlueMeanieTBar.Position;}
            end;
          16: begin {Colorgraph}
              R_Filtered := LUTR[RedColor];
              G_Filtered := LUTG[GreenColor];
              B_Filtered := LUTB[BlueColor];
            end;
        end;

        if AUTORANGE then begin
          if Range = 0 then begin
            if R_Filtered > R_Max then R_Max := R_Filtered;
            if G_Filtered > G_Max then G_Max := G_Filtered;
            if B_Filtered > B_Max then B_Max := B_Filtered;
            if R_Filtered < R_Min then R_Min := R_Filtered;
            if G_Filtered < G_Min then G_Min := G_Filtered;
            if B_Filtered < B_Min then B_Min := B_Filtered;
          end;
          if Range = 1 then begin
            R_Filtered := ((R_Filtered - (R_Min)) / R_Range);
            G_Filtered := ((G_Filtered - (G_Min)) / G_Range);
            B_Filtered := ((B_Filtered - (B_Min)) / B_Range);

            if R_Filtered > 255 then R_Filtered := 255;
            if R_Filtered < 0 then R_Filtered := 0;
            RedColor := Round(R_Filtered);
            if G_Filtered > 255 then G_Filtered := 255;
            if G_Filtered < 0 then G_Filtered := 0;
            GreenColor := Round(G_Filtered);
            if B_Filtered > 255 then B_Filtered := 255;
            if B_Filtered < 0 then B_Filtered := 0;
            BlueColor := Round(B_Filtered);
            WherePixel := ((IW * 3) + (IL * BytesPerLine));
            lpPixelB := @PHugeByteArray(PACBitmap)^[WherePixel];
            lpPixelG := @PHugeByteArray(PACBitmap)^[WherePixel + 1];
            lpPixelR := @PHugeByteArray(PACBitmap)^[WherePixel + 2];
            lpPixelB^ := BlueColor; lpPixelG^ := GreenColor; lpPixelR^
            := RedColor;

          end;
        end else
          if {Do_Absolute, AutoRange, B_Ex_com}  BelowZero
            {, ClipR, ThresholdR,}
          then begin {Jensen, p. 136}
            R_Filtered := (127 + (R_Filtered * 127));
            if R_Filtered > 255 then R_Filtered := 255;
            if R_Filtered < 0 then R_Filtered := 0;
            RedColor := Round(R_Filtered);
            G_Filtered := (127 + (G_Filtered * 127));
            if G_Filtered > 255 then G_Filtered := 255;
            if G_Filtered < 0 then G_Filtered := 0;
            GreenColor := Round(G_Filtered);
            B_Filtered := (127 + (B_Filtered * 127));
            if B_Filtered > 255 then B_Filtered := 255;
            if B_Filtered < 0 then B_Filtered := 0;
            BlueColor := Round(B_Filtered);
            WherePixel := ((IW * 3) + (IL * BytesPerLine));
            lpPixelB := @PHugeByteArray(PACBitmap)^[WherePixel];
            lpPixelG := @PHugeByteArray(PACBitmap)^[WherePixel + 1];
            lpPixelR := @PHugeByteArray(PACBitmap)^[WherePixel + 2];
            lpPixelB^ := BlueColor; lpPixelG^ := GreenColor; lpPixelR^
            := RedColor;

          end else
            if {Do_Absolute, AutoRange, }  Do_Ex_com
              {, ClipR, ThresholdR,}
            then begin {Jensen, p. 136}
              if R_Filtered < 1 then
                R_Filtered := ((R_Filtered * 127) + 1) else
                if R_Filtered >= 1 then
                  R_Filtered := (128 + (R_Filtered / 2));
              if R_Filtered > 255 then R_Filtered := 255;
              if R_Filtered < 0 then R_Filtered := 0;
              RedColor := Round(R_Filtered);
              if G_Filtered < 1 then
                G_Filtered := ((G_Filtered * 127) + 1) else
                if G_Filtered >= 1 then
                  G_Filtered := (128 + (G_Filtered / 2));
              if G_Filtered > 255 then G_Filtered := 255;
              if G_Filtered < 0 then G_Filtered := 0;
              GreenColor := Round(G_Filtered);
              if B_Filtered < 1 then
                B_Filtered := ((B_Filtered * 127) + 1) else
                if B_Filtered >= 1 then
                  B_Filtered := (128 + (B_Filtered / 2));
              if B_Filtered > 255 then B_Filtered := 255;
              if B_Filtered < 0 then B_Filtered := 0;
              BlueColor := Round(B_Filtered);
              WherePixel := ((IW * 3) + (IL * BytesPerLine));
              lpPixelB := @PHugeByteArray(PACBitmap)^[WherePixel];
              lpPixelG := @PHugeByteArray(PACBitmap)^[WherePixel +
                1];
              lpPixelR := @PHugeByteArray(PACBitmap)^[WherePixel +
                2];
              lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
              lpPixelR^ := RedColor;

            end else
              if {Do_Absolute, AutoRange, B_Ex_com,}  ClipR
                {, ThresholdR,}
              then begin {Jensen, p. 136}
                if R_Filtered > 255 then R_Filtered := 255;
                if R_Filtered < 0 then R_Filtered := 0;
                RedColor := Round(R_Filtered);
                if G_Filtered > 255 then G_Filtered := 255;
                if G_Filtered < 0 then G_Filtered := 0;
                GreenColor := Round(G_Filtered);
                if B_Filtered > 255 then B_Filtered := 255;
                if B_Filtered < 0 then B_Filtered := 0;
                BlueColor := Round(B_Filtered);
                WherePixel := ((IW * 3) + (IL * BytesPerLine));
                lpPixelB := @PHugeByteArray(PACBitmap)^[WherePixel];
                lpPixelG := @PHugeByteArray(PACBitmap)^[WherePixel +
                  1];
                lpPixelR := @PHugeByteArray(PACBitmap)^[WherePixel +
                  2];
                lpPixelB^ := BlueColor; lpPixelG^ := GreenColor;
                lpPixelR^ := RedColor;

              end; { of AutoRange Insider Edition}
      end; {of  Image Width}
      HCGauge.Progress := Round(100 * (IL / (ImageHeight)));
    end; {of Image Length}
  end; {of AutoRange}
{SetImage;}
  dc := GetDc(0);
  hBm := CreateDiBitmap(dc,
    pPACInfo^.bmiHeader,
    CBM_INIT,
    pChar(PACBitmap),
    pPACInfo^,
    DIB_RGB_COLORS);
{  dc :=} ReleaseDc(0, dc); {Give back the screen dc}
  {Give back the screen dc ... compiler complains}
  bm := TBitmap.Create; {Create a temporory TBitmap}
  bm.Handle := hBm; {Assign the handle}
  GlobalUnlock(Undoh);
  GlobalUnlock(PACh);
  PACImage.Picture.Bitmap := bm; {Assign the bitmap}
  SelectPalette(PACImage.Picture.Bitmap.Canvas.Handle,
    PACImage.Picture.Bitmap.Palette,
    false);
  bm.free;
  GlobalFree(PACh);
  FreeMem(pPACInfo, InfoSize);
  HCGauge.Progress := 0;
  PACApplyToImage.Enabled := True;
  HCReady := True;
end; {of MakeHisHCImage}


procedure TPixelAlgebraForm.MyRGBToHSV(const R, G, B: TReal; var H,
  S, V: TReal);
var
  Delta: TReal;
  Min: TReal;
begin
  Min := MinValue([R, G, B]);
  V := MaxValue([R, G, B]);
  Delta := V - Min;
    // Calculate saturation:  saturation is 0 if r, g and b are all 0
  if V = 0.0
    then S := 0
  else S := Delta / V;

  if S = 0.0
    then H := 0 { NaN} // Achromatic:  When s = 0, h is undefined
  else begin // Chromatic
    if R = V
      then // between yellow and magenta [degrees]
      H := 60.0 * (G - B) / Delta
    else
      if G = V
        then // between cyan and yellow
        H := 120.0 + 60.0 * (B - R) / Delta
      else
        if B = V
          then // between magenta and cyan
          H := 240.0 + 60.0 * (R - G) / Delta;

    if H < 0.0
      then H := H + 360.0
  end
end {RGBtoHSV};

procedure TPixelAlgebraForm.MyRGBToHLS(const R, G, B: TReal; var H,
  L, S: TReal);
var
  Delta: TReal;
  Max: TReal;
  Min: TReal;
begin
  Max := MaxValue([R, G, B]);
  Min := MinValue([R, G, B]);

  L := (Max + Min) / 2.0; // Lightness

  if Max = Min // Achromatic case since r = g = b
    then begin
    S := 0.0;
    H := 0.0; // Undefined
  end
  else begin
    Delta := Max - Min;

    if L <= 0.5
      then S := Delta / (Max + Min)
    else S := Delta / (2.0 - (Max + Min));

    if R = Max
      then // degrees between yellow and magenta
      H := (60.0 * (G - B)) / Delta
    else
      if G = Max
        then // degrees between cyan and yellow
        H := 120.0 + (60.0 * (B - R)) / Delta
      else
        if B = Max
          then // degrees between magenta and cyan
          H := 240.0 + (60.0 * (R - G)) / Delta;

    if H < 0
      then H := H + 360.0; // Keep in interval [0, 360)

  end
end {RGBtoHLS};

(******************************************************)
(******************************************************)

procedure TPixelAlgebraForm.DoLUT;
var
  Area, TempMin, TempMax, TempRange, I, J, k, kSum: Integer;
  AreaWorking: array[0..256] of Integer;
begin
  case WhichHis of
{0 is else.. HCZeroClick back to original nothing}
    0: for I := 0 to 255 do
      begin
        LUTR[I] := I;
        LUTG[I] := I;
        LUTB[I] := I;
      end;
    1: begin { Min-Max}
  {RedMin,RedMax,RedMean,RedMedian,RedMode,RSum,RNum,RedRange,
  GreenMin,GreenMax,GreenMean,GreenMedian,GreenMode,GSum,GNum,GreenRange,
  BlueMin,BlueMax,BlueMean,BlueMedian,BlueMode,BSum,BNum,BlueRange:Integer;}
        for I := 0 to 255 do
          LUTR[I] := (((I - RedMin) / RedRange) * 256);
        for I := 0 to 255 do
          LUTG[I] := (((I - GreenMin) / GreenRange) * 256);
        for I := 0 to 255 do
          LUTB[I] := (((I - BlueMin) / BlueRange) * 256);
      end;
    2: begin {Histogram EQ... Stats Steps}
  {AREA: equal number of pixels per range}
        Area := (RSum div RMinTBar.Position);
        for J := 0 to RMinTBar.Position - 1 do
        begin AreaWorking[J] := (Area * J); end;
        for J := 0 to RMinTBar.Position - 1 do
        begin
          kSum := 0;
          I := 1;
          k := (AreaWorking[J]);
          repeat
            kSum := (kSum + (I * CountR[I]));
            Inc(I);
          until kSum >= k;
          LUTR[J] := Round(I);
        end;
        LUTR[RMinTBar.Position] := 255;
        for J := RMinTBar.Position to 255 do LUTR[J] := 255;

        Area := (GSum div RMinTBar.Position);
        for J := 0 to RMinTBar.Position - 1 do
        begin AreaWorking[J] := (Area * J); end;
        for J := 0 to RMinTBar.Position - 1 do
        begin
          kSum := 0;
          I := 1;
          k := (AreaWorking[J]);
          repeat
            kSum := (kSum + (I * CountG[I]));
            Inc(I);
          until kSum >= k;
          LUTG[J] := Round(I);
        end;
        LUTG[RMinTBar.Position] := 255;
        for J := RMinTBar.Position to 255 do LUTG[J] := 255;

        Area := (BSum div RMinTBar.Position);
        for J := 0 to RMinTBar.Position - 1 do
        begin AreaWorking[J] := (Area * J); end;
        for J := 0 to RMinTBar.Position - 1 do
        begin
          kSum := 0;
          I := 1;
          k := (AreaWorking[J]);
          repeat
            kSum := (kSum + (I * CountB[I]));
            Inc(I);
          until kSum >= k;
          LUTB[J] := Round(I);
        end;
        LUTB[RMinTBar.Position] := 255;
        for J := RMinTBar.Position to 255 do LUTB[J] := 255;
      end;
    3: begin {Negative}
        for I := 0 to 255 do
        begin
          LUTR[I] := 255 - I;
          LUTG[I] := 255 - I;
          LUTB[I] := 255 - I;
        end;
      end;
    4: begin {gray scale.. computed in place}
         {Negative or gray? 2 Red=Green-Blue}{3 Luminance}{4 V of HSV}
        for I := 0 to 255 do
        begin
          LUTR[I] := 30 * I;
          LUTG[I] := 59 * I;
          LUTB[I] := 11 * I;
        end;
      end;

    5: begin {2 bars HCStretchLinear
  percentage linear  p.128... ends clipped per scrollbars}
        TempMin := RMinTBar.Position;
        TempMax := GMaxTBar.Position;
        TempRange := (TempMax - TempMin);
        if TempRange = 0 then TempRange := 1;
        for I := 0 to 255 do
        begin
          LUTR[I] := ((((I - TempMin) + 0.01) / TempRange) * 256);
          LUTG[I] := ((((I - TempMin) + 0.01) / TempRange) * 256);
          LUTB[I] := ((((I - TempMin) + 0.01) / TempRange) * 256);
        end;
      end;
    6: begin { Sine 3 bar -255..255}
        if PositiveCurveCB.Checked then TempRange := 1 else
          TempRange := -1;
        for I := 0 to 255 do
        begin
          LUTR[I] := TempRange * I + ((RMinTBar.Position) * sin(0.0245
            * I - 3.14));
          LUTG[I] := TempRange * I + ((GMaxTBar.Position) * sin(0.0245
            * I - 3.14));
          LUTB[I] := TempRange * I + ((BlueMeanieTBar.Position) *
            sin(0.0245 * I - 3.14));
        end;
  {If PositiveCurveCB.Checked then TempRange:=1 else TempRange:=-1;
   For I:= 0 to 255 do
   begin
     LUTR[I]:= I+((-1*TempRange)*sin(0.0245*I -3.14))+RMinTBar.Position;
     LUTG[I]:= I+((-1*TempRange)*sin(0.0245*I -3.14))+RMinTBar.Position;
     LUTB[I]:= I+((-1*TempRange)*sin(0.0245*I -3.14))+RMinTBar.Position;
   end;}
      end;
    7: begin {HCContrast  3 bar -255..255}
        if PositiveCurveCB.Checked then TempRange := 1 else
          TempRange := -1;
        for I := 0 to 255 do
        begin
          LUTR[I] := ((TempRange * I) * sin(0.0245 * I - 3.14)) +
            RMinTBar.Position;
          LUTG[I] := ((TempRange * I) * sin(0.0245 * I - 3.14)) +
            GMaxTBar.Position;
          LUTB[I] := ((TempRange * I) * sin(0.0245 * I - 3.14)) +
            BlueMeanieTBar.Position;
        end;
      end;

{Exponent Logs}
    8: begin {HCExponent  1..500 / 100= 0.01..5}
        if AddedCB.Checked then
        begin
          for I := 0 to 255 do
            LUTR[I] := I + ((exp(ln(RMinTBar.Position) / ((0.01 + I)
              /
              10))) * I);
          for I := 0 to 255 do
            LUTG[I] := I + ((exp(ln(GMaxTBar.Position) / ((0.01 + I)
              /
              10))) * I);
          for I := 0 to 255 do
            LUTB[I] := I + ((exp(ln(BlueMeanieTBar.Position) / ((0.01
              +
              I) / 10))) * I);
        end else
        begin
          for I := 0 to 255 do
            LUTR[I] := ((exp(ln(RMinTBar.Position) / ((0.01 + I) /
              10)))
              * I);
          for I := 0 to 255 do
            LUTG[I] := ((exp(ln(GMaxTBar.Position) / ((0.01 + I) /
              10)))
              * I);
          for I := 0 to 255 do
            LUTB[I] := ((exp(ln(BlueMeanieTBar.Position) / ((0.01 + I)
              / 10))) * I);
        end;
      end;
    9: begin { HCLog  Log 1..500 / 100= 0.01..5}
        if AddedCB.Checked then
        begin
          LUTR[0] := ((exp(ln(1) / ((1 + 0.1) / 100))) * ((0.01 +
            RMinTBar.Position) / 10));
          LUTG[0] := ((exp(ln(1) / ((1 + 0.1) / 100))) * ((0.01 +
            GMaxTBar.Position) / 10));
          LUTB[0] := ((exp(ln(1) / ((1 + 0.1) / 100))) * ((0.01 +
            BlueMeanieTBar.Position) / 10));
          for I := 1 to 255 do
            LUTR[I] := I + ((exp(ln(I) / ((I + 0.1) / 100))) *
              ((RMinTBar.Position) / 10));
          for I := 1 to 255 do
            LUTG[I] := I + ((exp(ln(I) / ((I + 0.1) / 100))) *
              ((GMaxTBar.Position) / 10));
          for I := 1 to 255 do
            LUTB[I] := I + ((exp(ln(I) / ((I + 0.1) / 100))) *
              ((BlueMeanieTBar.Position) / 10));
        end else
        begin
          LUTR[0] := ((exp(ln(1) / ((1 + 0.1) / 100))) * ((0.01 +
            RMinTBar.Position) / 10));
          LUTG[0] := ((exp(ln(1) / ((1 + 0.1) / 100))) * ((0.01 +
            GMaxTBar.Position) / 10));
          LUTB[0] := ((exp(ln(1) / ((1 + 0.1) / 100))) * ((0.01 +
            BlueMeanieTBar.Position) / 10));
          for I := 1 to 255 do
            LUTR[I] := ((exp(ln(I) / ((I + 0.1) / 100))) *
              ((RMinTBar.Position) / 10));
          for I := 1 to 255 do
            LUTG[I] := ((exp(ln(I) / ((I + 0.1) / 100))) *
              ((GMaxTBar.Position) / 10));
          for I := 1 to 255 do
            LUTB[I] := ((exp(ln(I) / ((I + 0.1) / 100))) *
              ((BlueMeanieTBar.Position) / 10));
        end;
      end;
    10: begin {HCGamma RGB Gamma 1..500 / 100= 0.01..5}
        if AddedCB.Checked then
        begin
          LUTR[0] := ((exp(ln(1) / ((RMinTBar.Position + 0.1) /
            100))));
          LUTG[0] := ((exp(ln(1) / ((GMaxTBar.Position + 0.1) /
            100))));
          LUTB[0] := ((exp(ln(1) / ((BlueMeanieTBar.Position + 0.1) /
            100))));
          for I := 1 to 255 do
            LUTR[I] := ((exp(ln(I) / ((RMinTBar.Position + 0.1) /
              100)))
              + I);
          for I := 1 to 255 do
            LUTG[I] := ((exp(ln(I) / ((GMaxTBar.Position + 0.1) /
              100)))
              + I);
          for I := 1 to 255 do
            LUTB[I] := ((exp(ln(I) / ((BlueMeanieTBar.Position + 0.1)
              /
              100))) + I);

        end else
        begin
          LUTR[0] := ((exp(ln(1) / ((RMinTBar.Position + 0.1) / 100)))
            * 10.0);
          LUTG[0] := ((exp(ln(1) / ((GMaxTBar.Position + 0.1) / 100)))
            * 10.0);
          LUTB[0] := ((exp(ln(1) / ((BlueMeanieTBar.Position + 0.1) /
            100))) * 10.0);
          for I := 1 to 255 do
            LUTR[I] := ((exp(ln(I) / ((RMinTBar.Position + 0.1) /
              100)))
              * 10.0);
          for I := 1 to 255 do
            LUTG[I] := ((exp(ln(I) / ((GMaxTBar.Position + 0.1) /
              100)))
              * 10.0);
          for I := 1 to 255 do
            LUTB[I] := ((exp(ln(I) / ((BlueMeanieTBar.Position + 0.1)
              /
              100))) * 10.0);
        end;
      end;
{COLOR Corrections}
    11: begin {HC RGB 3 bars -255..255}
        for I := 0 to 255 do
        begin
          LUTR[I] := I + RMinTBar.Position;
          LUTG[I] := I + GMaxTBar.Position;
          LUTB[I] := I + BlueMeanieTBar.Position;
        end;
      end;
    12..16: ;
{Done inside... must have RGB per each.. no LUT, Graph makes own LUT}
  else {0}
    for I := 0 to 255 do
    begin
      LUTR[I] := I;
      LUTG[I] := I;
      LUTB[I] := I;
    end;
  end; {Case}
end;
(******************************************************)

procedure TPixelAlgebraForm.ColorPlaneSetup;
begin
  RadioGroupColorPlane.Items.Clear;
  case WhichHis of
    11: // RGB
      begin
        with RadioGroupColorPlane.Items do
        begin
          Add('RGB Composite');
          Add('Red');
          Add('Green');
          Add('Blue')
        end
      end;

    12: // HSV
      begin
        with RadioGroupColorPlane.Items do
        begin
          Add('Hue');
          Add('Saturation');
          Add('Value')
        end
      end;

    13: // HLS
      begin
        with RadioGroupColorPlane.Items do
        begin
          Add('Hue');
          Add('Lightness');
          Add('Saturation')
        end
      end;

    14: // CMYK
      begin
        with RadioGroupColorPlane.Items do
        begin
          Add('Cyan');
          Add('Magenta');
          Add('Yellow');
          Add('blacK')
        end
      end;
  end;
  RadioGroupColorPlane.ItemIndex := 0
end;


procedure TPixelAlgebraForm.RadioGroupColorPlaneClick(Sender:
  TObject);
var
  tempBool: Boolean;
begin
  tempBool := HCReady;
  ColorPlane := cpIntensity; // avoid compiler warning
  case WhichHis of
    11: // csRGB
      begin
        case RadioGroupColorPlane.ItemIndex of
          0: ColorPlane := cpRGB;
          1: ColorPlane := cpRed;
          2: ColorPlane := cpGreen;
          3: ColorPlane := cpBlue
        end;
        CheckBoxMonochrome.Visible := TRUE;
        HCReady := False;
        RMinTBar.Position := 0;
        GMaxTBar.Position := 0;
        BlueMeanieTBar.Position := 0;
        PACRed := 0;
        PACGreen := 0;
        PACBlue := 0;
        Application.ProcessMessages;
        HCReady := tempBool;
      end;
    12: // csHSV
      begin
        case RadioGroupColorPlane.ItemIndex of
          0: ColorPlane := cpHueHSV;
          1: ColorPlane := cpSaturationHSV;
          2: ColorPlane := cpValue
        end;
        CheckBoxMonochrome.Visible := (ColorPlane = cpHueHSV);
        HCReady := False;
        RMinTBar.Position := 0;
        GMaxTBar.Position := 0;
        BlueMeanieTBar.Position := 0;
        PACRed := 0;
        PACGreen := 0;
        PACBlue := 0;
        Application.ProcessMessages;
        HCReady := tempBool;
      end;

    13: // csHLS
      begin
        case RadioGroupColorPlane.ItemIndex of
          0: ColorPlane := cpHueHLS;
          1: ColorPlane := cpLightness;
          2: ColorPlane := cpSaturationHLS;
        end;
        CheckBoxMonochrome.Visible := (ColorPlane = cpHueHLS);
        HCReady := False;
        RMinTBar.Position := 0;
        GMaxTBar.Position := 0;
        BlueMeanieTBar.Position := 0;
        PACRed := 0;
        PACGreen := 0;
        PACBlue := 0;
        Application.ProcessMessages;
        HCReady := tempBool;
      end;

    14: // csCMYK
      begin
        case RadioGroupColorPlane.ItemIndex of
          0: ColorPlane := cpCyan;
          1: ColorPlane := cpMagenta;
          2: ColorPlane := cpYellow;
          3: ColorPlane := cpBlack;
        end;
        CheckBoxMonochrome.Visible := FALSE;
        HCReady := False;
        RMinTBar.Position := 0;
        GMaxTBar.Position := 0;
        BlueMeanieTBar.Position := 0;
        PACRed := 0;
        PACGreen := 0;
        PACBlue := 0;
        Application.ProcessMessages;
        HCReady := tempBool;
      end;
  end;
  if ((HCReady) and (not (ButtonCommandCB.Checked))) then
  begin
    HCReady := False;
    DoLUT;
    MakeHisHCImage;
  end;
end;
(******************************************************)
(******************************************************)

procedure TPixelAlgebraForm.HCMinMaxClick(Sender: TObject);
begin
  HCReady := False;
  HideSliders;
  WhichHis := 1; {Min-Max p.127}
  DoLUT;
  MakeHisHCImage;
end;

procedure TPixelAlgebraForm.HCHistogramEQClick(Sender: TObject);
begin
  HCReady := False;
  HideSliders;
  WhichHis := 2; {Histogram EQ p.127}
  ProcessSliderBtn.Enabled := True;
  ProcessSliderBtn.Visible := True;
  ButtonCommandCB.Enabled := True;
  ButtonCommandCB.Visible := True;

  RMinTBar.Hint := 'Number of Histogram Classes';
  RMinTBar.Min := 1;
  RMinTBar.Max := 255;
  RMinTBar.Position := 128;
  RMinTBar.Pagesize := ((RMinTBar.Max) + abs(RMinTBar.Min)) div 10;
  RMinTBar.Linesize := 1;
  RMinTBar.Frequency := RMinTBar.Pagesize;
  RMinTBar.Visible := True;
  RMinTBar.Enabled := True;

  RMinLabel.Caption := 'Cls';
  RMinLabel.Visible := True;
  RMinValueLabel.Caption := '128';
  RMinValueLabel.Visible := True;

  PACRed := 128;
  PACGreen := 0;
  PACBlue := 0;
  Application.ProcessMessages;
  HCReady := True;
end;

procedure TPixelAlgebraForm.HCNegativeClick(Sender: TObject);
begin
  HCReady := False;
  HideSliders;
  WhichHis := 3; {Negative Toggle, NO bars...
             Colors the same but reversed light dark}
  DoLUT;
  MakeHisHCImage;
end;

procedure TPixelAlgebraForm.HCGreyScaleClick(Sender: TObject);
begin
  HCReady := False;
  HideSliders;
  WhichHis := 4; {Grey Toggle}
  DoLUT;
  MakeHisHCImage;
end;

procedure TPixelAlgebraForm.HCStretchLinearClick(Sender: TObject);
begin
  HCReady := False;
  HideSliders;
  WhichHis := 5; {2 bars HCStretchLinear
  percentage linear  p.128... ends clipped per scrollbars}
  ProcessSliderBtn.Enabled := True;
  ProcessSliderBtn.Visible := True;
  ButtonCommandCB.Enabled := True;
  ButtonCommandCB.Visible := True;

  RMinTBar.Hint := 'Stretch Linear Minimum';
  RMinTBar.Min := 0;
  RMinTBar.Max := 255;
  RMinTBar.Position := 0;
  RMinTBar.Pagesize := ((RMinTBar.Max) + abs(RMinTBar.Min)) div 10;
  RMinTBar.Linesize := 1;
  RMinTBar.Frequency := RMinTBar.Pagesize;
  RMinTBar.Visible := True;
  RMinTBar.Enabled := True;

  RMinLabel.Caption := 'Min';
  RMinLabel.Visible := True;
  RMinValueLabel.Caption := '0';
  RMinValueLabel.Visible := True;

  GMaxTBar.Hint := 'Stretch Linear Maximum';
  GMaxTBar.Min := 0;
  GMaxTBar.Max := 255;
  GMaxTBar.Position := 255;
  GMaxTBar.Pagesize := ((GMaxTBar.Max) + abs(GMaxTBar.Min)) div 10;
  GMaxTBar.Linesize := 1;
  GMaxTBar.Frequency := GMaxTBar.Pagesize;
  GMaxTBar.Visible := True;
  GMaxTBar.Enabled := True;

  GMaxLabel.Caption := 'Max';
  GMaxLabel.Visible := True;
  GMaxValueLabel.Caption := '255';
  GMaxValueLabel.Visible := True;
  PACRed := 0;
  PACGreen := 255;
  PACBlue := 0;
  Application.ProcessMessages;
  HCReady := True;
end;

procedure TPixelAlgebraForm.HCSineWaveClick(Sender: TObject);
begin
  HCReady := False;
  HideSliders;
  WhichHis := 6; {3 bar Sine -255..255}
  AllTogetherCB.Enabled := True;
  AllTogetherCB.Visible := True;
  ProcessSliderBtn.Enabled := True;
  ProcessSliderBtn.Visible := True;
  ButtonCommandCB.Enabled := True;
  ButtonCommandCB.Visible := True;
  PositiveCurveCB.Enabled := True;
  PositiveCurveCB.Visible := True;

  RMinTBar.Hint := 'Red Sine';
  RMinTBar.Min := -255;
  RMinTBar.Max := 255;
  RMinTBar.Position := 0;
  RMinTBar.Pagesize := ((RMinTBar.Max) + abs(RMinTBar.Min)) div 10;
  RMinTBar.Linesize := 1;
  RMinTBar.Frequency := RMinTBar.Pagesize;

  RMinTBar.Visible := True;
  RMinTBar.Enabled := True;
  RMinLabel.Caption := 'Red';
  RMinLabel.Visible := True;
  RMinValueLabel.Caption := '0';
  RMinValueLabel.Visible := True;

  GMaxTBar.Hint := 'Green Sine';
  GMaxTBar.Min := -255;
  GMaxTBar.Max := 255;
  GMaxTBar.Position := 0;
  GMaxTBar.Pagesize := ((GMaxTBar.Max) + 1 + abs(GMaxTBar.Min)) div
    10;
  GMaxTBar.Linesize := 1;
  GMaxTBar.Frequency := GMaxTBar.Pagesize;
  GMaxTBar.Visible := True;
  GMaxTBar.Enabled := True;

  GMaxLabel.Caption := 'Grn';
  GMaxLabel.Visible := True;
  GMaxValueLabel.Caption := '0';
  GMaxValueLabel.Visible := True;

  BlueMeanieTBar.Hint := 'Blue Sine';
  BlueMeanieTBar.Min := -255;
  BlueMeanieTBar.Max := 255;
  BlueMeanieTBar.Position := 0;
  BlueMeanieTBar.Pagesize := ((BlueMeanieTBar.Max) + 1 +
    abs(BlueMeanieTBar.Min)) div 10;
  BlueMeanieTBar.Linesize := 1;
  BlueMeanieTBar.Frequency := BlueMeanieTBar.Pagesize;
  BlueMeanieTBar.Visible := True;
  BlueMeanieTBar.Enabled := True;

  BlueMeanieLabel.Caption := 'Blue';
  BlueMeanieLabel.Visible := True;
  BlueMeanieValueLabel.Caption := '0';
  BlueMeanieValueLabel.Visible := True;

  PACRed := 0;
  PACGreen := 0;
  PACBlue := 0;
  Application.ProcessMessages;
  HCReady := True;
end;


procedure TPixelAlgebraForm.HCContrastClick(Sender: TObject);
begin
  HCReady := False;
  HideSliders;
  WhichHis := 7; {HCContrast  3 bar -255..255}
  AllTogetherCB.Enabled := True;
  AllTogetherCB.Visible := True;
  ProcessSliderBtn.Enabled := True;
  ProcessSliderBtn.Visible := True;
  ButtonCommandCB.Enabled := True;
  ButtonCommandCB.Visible := True;
  PositiveCurveCB.Enabled := True;
  PositiveCurveCB.Visible := True;


  RMinTBar.Hint := 'Red Contrast';
  RMinTBar.Min := -255;
  RMinTBar.Max := 255;
  RMinTBar.Position := 0;
  RMinTBar.Pagesize := ((RMinTBar.Max) + 1 + abs(RMinTBar.Min)) div
    10;
  RMinTBar.Linesize := 1;
  RMinTBar.Frequency := RMinTBar.Pagesize;

  RMinTBar.Visible := True;
  RMinTBar.Enabled := True;
  RMinLabel.Caption := 'Red';
  RMinLabel.Visible := True;
  RMinValueLabel.Caption := '0';
  RMinValueLabel.Visible := True;

  GMaxTBar.Hint := 'Green Contrast';
  GMaxTBar.Min := -255;
  GMaxTBar.Max := 255;
  GMaxTBar.Position := 0;
  GMaxTBar.Pagesize := ((GMaxTBar.Max) + 1 + abs(GMaxTBar.Min)) div
    10;
  GMaxTBar.Linesize := 1;
  GMaxTBar.Frequency := GMaxTBar.Pagesize;
  GMaxTBar.Visible := True;
  GMaxTBar.Enabled := True;

  GMaxLabel.Caption := 'Grn';
  GMaxLabel.Visible := True;
  GMaxValueLabel.Caption := '0';
  GMaxValueLabel.Visible := True;

  BlueMeanieTBar.Hint := 'Blue Contrast';
  BlueMeanieTBar.Min := -255;
  BlueMeanieTBar.Max := 255;
  BlueMeanieTBar.Position := 0;
  BlueMeanieTBar.Pagesize := ((BlueMeanieTBar.Max) + 1 +
    abs(BlueMeanieTBar.Min)) div 10;
  BlueMeanieTBar.Linesize := 1;
  BlueMeanieTBar.Frequency := BlueMeanieTBar.Pagesize;
  BlueMeanieTBar.Visible := True;
  BlueMeanieTBar.Enabled := True;

  BlueMeanieLabel.Caption := 'Blue';
  BlueMeanieLabel.Visible := True;
  BlueMeanieValueLabel.Caption := '0';
  BlueMeanieValueLabel.Visible := True;
  PACRed := 0;
  PACGreen := 0;
  PACBlue := 0;
  Application.ProcessMessages;
  HCReady := True;
end;

procedure TPixelAlgebraForm.HCExponentClick(Sender: TObject);
begin
  HCReady := False;
  HideSliders;
  WhichHis := 8; {HCExponent  3 bar 1..500 /100= .01..5.00}
  AllTogetherCB.Enabled := True;
  AllTogetherCB.Visible := True;
  ProcessSliderBtn.Enabled := True;
  ProcessSliderBtn.Visible := True;
  ButtonCommandCB.Enabled := True;
  ButtonCommandCB.Visible := True;
  AddedCB.Enabled := True;
  AddedCB.Visible := True;
{PositiveCurveCB.Enabled:=True;
PositiveCurveCB.Visible:=True; }


  RMinTBar.Hint := 'Red Exponent';
  RMinTBar.Min := 1;
  RMinTBar.Max := 500;
  RMinTBar.Position := 200;
  RMinTBar.Pagesize := ((RMinTBar.Max) + 1 + abs(RMinTBar.Min)) div
    10;
  RMinTBar.Linesize := 1;
  RMinTBar.Frequency := RMinTBar.Pagesize;
  RMinTBar.Visible := True;
  RMinTBar.Enabled := True;

  RMinLabel.Caption := 'Red';
  RMinLabel.Visible := True;
  RMinValueLabel.Caption := '200';
  RMinValueLabel.Visible := True;

  GMaxTBar.Hint := 'Green Exponent';
  GMaxTBar.Min := 1;
  GMaxTBar.Max := 500;
  GMaxTBar.Position := 200;
  GMaxTBar.Pagesize := ((GMaxTBar.Max) + 1 + abs(GMaxTBar.Min)) div
    10;
  GMaxTBar.Linesize := 1;
  GMaxTBar.Frequency := GMaxTBar.Pagesize;
  GMaxTBar.Visible := True;
  GMaxTBar.Enabled := True;

  GMaxLabel.Caption := 'Grn';
  GMaxLabel.Visible := True;
  GMaxValueLabel.Caption := '200';
  GMaxValueLabel.Visible := True;

  BlueMeanieTBar.Hint := 'Blue Exponent';
  BlueMeanieTBar.Min := 1;
  BlueMeanieTBar.Max := 500;
  BlueMeanieTBar.Position := 200;
  BlueMeanieTBar.Pagesize := ((BlueMeanieTBar.Max) + 1 +
    abs(BlueMeanieTBar.Min)) div 10;
  BlueMeanieTBar.Linesize := 1;
  BlueMeanieTBar.Frequency := BlueMeanieTBar.Pagesize;
  BlueMeanieTBar.Visible := True;
  BlueMeanieTBar.Enabled := True;

  BlueMeanieLabel.Caption := 'Blue';
  BlueMeanieLabel.Visible := True;
  BlueMeanieValueLabel.Caption := '200';
  BlueMeanieValueLabel.Visible := True;
  PACRed := 200;
  PACGreen := 200;
  PACBlue := 200;
  Application.ProcessMessages;
  HCReady := True;
end;

procedure TPixelAlgebraForm.HCLogClick(Sender: TObject);
begin
  HCReady := False;
  HideSliders;
  WhichHis := 9; {HCLog  Log 3 bar 1..500 /100= .01..5.00}
  AllTogetherCB.Enabled := True;
  AllTogetherCB.Visible := True;
  ProcessSliderBtn.Enabled := True;
  ProcessSliderBtn.Visible := True;
  ButtonCommandCB.Enabled := True;
  ButtonCommandCB.Visible := True;
  AddedCB.Enabled := True;
  AddedCB.Visible := True;
{PositiveCurveCB.Enabled:=True;
PositiveCurveCB.Visible:=True; }


  RMinTBar.Hint := 'Red Log';
  RMinTBar.Min := 1;
  RMinTBar.Max := 500;
  RMinTBar.Position := 200;
  RMinTBar.Pagesize := ((RMinTBar.Max) + 1 + abs(RMinTBar.Min)) div
    10;
  RMinTBar.Linesize := 1;
  RMinTBar.Frequency := RMinTBar.Pagesize;
  RMinTBar.Visible := True;
  RMinTBar.Enabled := True;

  RMinLabel.Caption := 'Red';
  RMinLabel.Visible := True;
  RMinValueLabel.Caption := '200';
  RMinValueLabel.Visible := True;

  GMaxTBar.Hint := 'Green Log';
  GMaxTBar.Min := 1;
  GMaxTBar.Max := 500;
  GMaxTBar.Position := 200;
  GMaxTBar.Pagesize := ((GMaxTBar.Max) + 1 + abs(GMaxTBar.Min)) div
    10;
  GMaxTBar.Linesize := 1;
  GMaxTBar.Frequency := GMaxTBar.Pagesize;
  GMaxTBar.Visible := True;
  GMaxTBar.Enabled := True;

  GMaxLabel.Caption := 'Grn';
  GMaxLabel.Visible := True;
  GMaxValueLabel.Caption := '200';
  GMaxValueLabel.Visible := True;

  BlueMeanieTBar.Hint := 'Blue Log';
  BlueMeanieTBar.Min := 1;
  BlueMeanieTBar.Max := 500;
  BlueMeanieTBar.Position := 200;
  BlueMeanieTBar.Pagesize := ((BlueMeanieTBar.Max) + 1 +
    abs(BlueMeanieTBar.Min)) div 10;
  BlueMeanieTBar.Linesize := 1;
  BlueMeanieTBar.Frequency := BlueMeanieTBar.Pagesize;
  BlueMeanieTBar.Visible := True;
  BlueMeanieTBar.Enabled := True;

  BlueMeanieLabel.Caption := 'Blue';
  BlueMeanieLabel.Visible := True;
  BlueMeanieValueLabel.Caption := '200';
  BlueMeanieValueLabel.Visible := True;
  PACRed := 200;
  PACGreen := 200;
  PACBlue := 200;
  Application.ProcessMessages;
  HCReady := True;
end;



procedure TPixelAlgebraForm.HCGammaClick(Sender: TObject);
begin
  HCReady := False;
  HideSliders;
  WhichHis := 10; {HCGamma RGB Gamma 1 .. 500 / 100= .01..5.00}
  AllTogetherCB.Enabled := True;
  AllTogetherCB.Visible := True;
  ProcessSliderBtn.Enabled := True;
  ProcessSliderBtn.Visible := True;
  ButtonCommandCB.Enabled := True;
  ButtonCommandCB.Visible := True;
  AddedCB.Enabled := True;
  AddedCB.Visible := True;
{PositiveCurveCB.Enabled:=True;
PositiveCurveCB.Visible:=True; }


  RMinTBar.Hint := 'Red Gamma';
  RMinTBar.Min := 1;
  RMinTBar.Max := 500;
  RMinTBar.Position := 200;
  RMinTBar.Pagesize := ((RMinTBar.Max) + 1 + abs(RMinTBar.Min)) div
    10;
  RMinTBar.Linesize := 1;
  RMinTBar.Frequency := RMinTBar.Pagesize;
  RMinTBar.Visible := True;
  RMinTBar.Enabled := True;

  RMinLabel.Caption := 'Red';
  RMinLabel.Visible := True;
  RMinValueLabel.Caption := '200';
  RMinValueLabel.Visible := True;

  GMaxTBar.Hint := 'Green Gamma';
  GMaxTBar.Min := 1;
  GMaxTBar.Max := 500;
  GMaxTBar.Position := 200;
  GMaxTBar.Pagesize := ((GMaxTBar.Max) + 1 + abs(GMaxTBar.Min)) div
    10;
  GMaxTBar.Linesize := 1;
  GMaxTBar.Frequency := GMaxTBar.Pagesize;
  GMaxTBar.Visible := True;
  GMaxTBar.Enabled := True;

  GMaxLabel.Caption := 'Grn';
  GMaxLabel.Visible := True;
  GMaxValueLabel.Caption := '200';
  GMaxValueLabel.Visible := True;

  BlueMeanieTBar.Hint := 'Blue Gamma';
  BlueMeanieTBar.Min := 1;
  BlueMeanieTBar.Max := 500;
  BlueMeanieTBar.Position := 200;
  BlueMeanieTBar.Pagesize := ((BlueMeanieTBar.Max) + 1 +
    abs(BlueMeanieTBar.Min)) div 10;
  BlueMeanieTBar.Linesize := 1;
  BlueMeanieTBar.Frequency := BlueMeanieTBar.Pagesize;
  BlueMeanieTBar.Visible := True;
  BlueMeanieTBar.Enabled := True;

  BlueMeanieLabel.Caption := 'Blue';
  BlueMeanieLabel.Visible := True;
  BlueMeanieValueLabel.Caption := '200';
  BlueMeanieValueLabel.Visible := True;
  PACRed := 200;
  PACGreen := 200;
  PACBlue := 200;
  Application.ProcessMessages;
  HCReady := True;
end;



procedure TPixelAlgebraForm.HCRGBClick(Sender: TObject);
begin
  HCReady := False;
  HideSliders;
  WhichHis := 11; {HC RGB ColorBalance 3 bars -255..255}
  CheckBoxMonochrome.Enabled := True;
  RadioGroupColorPlane.Enabled := True;
  RadioGroupColorPlane.Visible := True;
  ColorPlaneSetup;
  AllTogetherCB.Enabled := True;
  AllTogetherCB.Visible := True;
  ProcessSliderBtn.Enabled := True;
  ProcessSliderBtn.Visible := True;
  ButtonCommandCB.Enabled := True;
  ButtonCommandCB.Visible := True;
{PositiveCurveCB.Enabled:=True;
PositiveCurveCB.Visible:=True; }

  RMinTBar.Hint := 'Red Balance';
  RMinTBar.Min := -255;
  RMinTBar.Max := 255;
  RMinTBar.Position := 0;
  RMinTBar.Pagesize := ((RMinTBar.Max) + 1 + abs(RMinTBar.Min)) div
    10;
  RMinTBar.Linesize := 1;
  RMinTBar.Frequency := RMinTBar.Pagesize;
  RMinTBar.Visible := True;
  RMinTBar.Enabled := True;

  RMinLabel.Caption := 'Red';
  RMinLabel.Visible := True;
  RMinValueLabel.Caption := '0';
  RMinValueLabel.Visible := True;

  GMaxTBar.Hint := 'Green Balance';
  GMaxTBar.Min := -255;
  GMaxTBar.Max := 255;
  GMaxTBar.Position := 0;
  GMaxTBar.Pagesize := ((GMaxTBar.Max) + 1 + abs(GMaxTBar.Min)) div
    10;
  GMaxTBar.Linesize := 1;
  GMaxTBar.Frequency := GMaxTBar.Pagesize;
  GMaxTBar.Visible := True;
  GMaxTBar.Enabled := True;

  GMaxLabel.Caption := 'Grn';
  GMaxLabel.Visible := True;
  GMaxValueLabel.Caption := '0';
  GMaxValueLabel.Visible := True;

  BlueMeanieTBar.Hint := 'Blue Balance';
  BlueMeanieTBar.Min := -255;
  BlueMeanieTBar.Max := 255;
  BlueMeanieTBar.Position := 0;
  BlueMeanieTBar.Pagesize := ((BlueMeanieTBar.Max) + 1 +
    abs(BlueMeanieTBar.Min)) div 10;
  BlueMeanieTBar.Linesize := 1;
  BlueMeanieTBar.Frequency := BlueMeanieTBar.Pagesize;
  BlueMeanieTBar.Visible := True;
  BlueMeanieTBar.Enabled := True;

  BlueMeanieLabel.Caption := 'Blue';
  BlueMeanieLabel.Visible := True;
  BlueMeanieValueLabel.Caption := '0';
  BlueMeanieValueLabel.Visible := True;
  PACRed := 10;
  PACGreen := 0;
  PACBlue := 0;
  Application.ProcessMessages;
  HCReady := True;
end;

procedure TPixelAlgebraForm.HCHSVClick(Sender: TObject);
begin
  HCReady := False;
  HideSliders;
  WhichHis := 12; {HCHSV 3 bar H -359..359 S -255..255 V -255..255}
  CheckBoxMonochrome.Enabled := True;
  RadioGroupColorPlane.Enabled := True;
  RadioGroupColorPlane.Visible := True;
  ColorPlaneSetup;
  AllTogetherCB.Enabled := True;
  AllTogetherCB.Visible := True;
  ProcessSliderBtn.Enabled := True;
  ProcessSliderBtn.Visible := True;
  ButtonCommandCB.Enabled := True;
  ButtonCommandCB.Visible := True;
{PositiveCurveCB.Enabled:=True;
PositiveCurveCB.Visible:=True; }


  RMinTBar.Hint := 'Hue';
  RMinTBar.Min := -359;
  RMinTBar.Max := 359;
  RMinTBar.Position := 0;
  RMinTBar.Pagesize := ((RMinTBar.Max) + 1 + abs(RMinTBar.Min)) div
    10;
  RMinTBar.Linesize := 1;
  RMinTBar.Frequency := RMinTBar.Pagesize;
  RMinTBar.Visible := True;
  RMinTBar.Enabled := True;

  RMinLabel.Caption := 'H';
  RMinLabel.Visible := True;
  RMinValueLabel.Caption := '0';
  RMinValueLabel.Visible := True;

  GMaxTBar.Hint := 'Saturation';
  GMaxTBar.Min := -255;
  GMaxTBar.Max := 255;
  GMaxTBar.Position := 0;
  GMaxTBar.Pagesize := ((GMaxTBar.Max) + 1 + abs(GMaxTBar.Min)) div
    10;
  GMaxTBar.Linesize := 1;
  GMaxTBar.Frequency := GMaxTBar.Pagesize;
  GMaxTBar.Visible := True;
  GMaxTBar.Enabled := True;

  GMaxLabel.Caption := 'S';
  GMaxLabel.Visible := True;
  GMaxValueLabel.Caption := '0';
  GMaxValueLabel.Visible := True;

  BlueMeanieTBar.Hint := 'Value';
  BlueMeanieTBar.Min := -255;
  BlueMeanieTBar.Max := 255;
  BlueMeanieTBar.Position := 0;
  BlueMeanieTBar.Pagesize := ((BlueMeanieTBar.Max) + 1 +
    abs(BlueMeanieTBar.Min)) div 10;
  BlueMeanieTBar.Linesize := 1;
  BlueMeanieTBar.Frequency := BlueMeanieTBar.Pagesize;
  BlueMeanieTBar.Visible := True;
  BlueMeanieTBar.Enabled := True;

  BlueMeanieLabel.Caption := 'V';
  BlueMeanieLabel.Visible := True;
  BlueMeanieValueLabel.Caption := '0';
  BlueMeanieValueLabel.Visible := True;
  PACRed := 10;
  PACGreen := 0;
  PACBlue := 0;
  Application.ProcessMessages;
  HCReady := True;
end;

procedure TPixelAlgebraForm.HCHLSClick(Sender: TObject);
begin
  HCReady := False;
  HideSliders;
  WhichHis := 13; {HC HLS Hue Lightness Saturation 3 bars -255..255}
  CheckBoxMonochrome.Enabled := True;
  RadioGroupColorPlane.Enabled := True;
  RadioGroupColorPlane.Visible := True;
  ColorPlaneSetup;
  AllTogetherCB.Enabled := True;
  AllTogetherCB.Visible := True;
  ProcessSliderBtn.Enabled := True;
  ProcessSliderBtn.Visible := True;
  ButtonCommandCB.Enabled := True;
  ButtonCommandCB.Visible := True;
{PositiveCurveCB.Enabled:=True;
PositiveCurveCB.Visible:=True; }

  RMinTBar.Hint := 'Hue Balance';
  RMinTBar.Min := -359;
  RMinTBar.Max := 359;
  RMinTBar.Position := 0;
  RMinTBar.Pagesize := ((RMinTBar.Max) + 1 + abs(RMinTBar.Min)) div
    10;
  RMinTBar.Linesize := 1;
  RMinTBar.Frequency := RMinTBar.Pagesize;
  RMinTBar.Visible := True;
  RMinTBar.Enabled := True;

  RMinLabel.Caption := 'Hue';
  RMinLabel.Visible := True;
  RMinValueLabel.Caption := '0';
  RMinValueLabel.Visible := True;

  GMaxTBar.Hint := 'Lightness Balance';
  GMaxTBar.Min := -255;
  GMaxTBar.Max := 255;
  GMaxTBar.Position := 0;
  GMaxTBar.Pagesize := ((GMaxTBar.Max) + 1 + abs(GMaxTBar.Min)) div
    10;
  GMaxTBar.Linesize := 1;
  GMaxTBar.Frequency := GMaxTBar.Pagesize;
  GMaxTBar.Visible := True;
  GMaxTBar.Enabled := True;

  GMaxLabel.Caption := 'Lit';
  GMaxLabel.Visible := True;
  GMaxValueLabel.Caption := '0';
  GMaxValueLabel.Visible := True;

  BlueMeanieTBar.Hint := 'Saturation Balance';
  BlueMeanieTBar.Min := -255;
  BlueMeanieTBar.Max := 255;
  BlueMeanieTBar.Position := 0;
  BlueMeanieTBar.Pagesize := ((BlueMeanieTBar.Max) + 1 +
    abs(BlueMeanieTBar.Min)) div 10;
  BlueMeanieTBar.Linesize := 1;
  BlueMeanieTBar.Frequency := BlueMeanieTBar.Pagesize;
  BlueMeanieTBar.Visible := True;
  BlueMeanieTBar.Enabled := True;

  BlueMeanieLabel.Caption := 'Sat';
  BlueMeanieLabel.Visible := True;
  BlueMeanieValueLabel.Caption := '0';
  BlueMeanieValueLabel.Visible := True;
  PACRed := 10;
  PACGreen := 0;
  PACBlue := 0;
  Application.ProcessMessages;
  HCReady := True;
end;




procedure TPixelAlgebraForm.HCCMYKClick(Sender: TObject);
begin
  HCReady := False;
  HideSliders;
  WhichHis := 14; {CMYK ?4 bars? 3 bars -255..255 }
  CheckBoxMonochrome.Enabled := True;
  RadioGroupColorPlane.Enabled := True;
  RadioGroupColorPlane.Visible := True;
  ColorPlaneSetup;
  AllTogetherCB.Enabled := True;
  AllTogetherCB.Visible := True;
  ProcessSliderBtn.Enabled := True;
  ProcessSliderBtn.Visible := True;
  ButtonCommandCB.Enabled := True;
  ButtonCommandCB.Visible := True;
{PositiveCurveCB.Enabled:=True;
PositiveCurveCB.Visible:=True; }


  RMinTBar.Hint := 'Cyan';
  RMinTBar.Min := -255;
  RMinTBar.Max := 255;
  RMinTBar.Position := 0;
  RMinTBar.Pagesize := ((RMinTBar.Max) + 1 + abs(RMinTBar.Min)) div
    10;
  RMinTBar.Linesize := 1;
  RMinTBar.Frequency := RMinTBar.Pagesize;
  RMinTBar.Visible := True;
  RMinTBar.Enabled := True;

  RMinLabel.Caption := 'Cy';
  RMinLabel.Visible := True;
  RMinValueLabel.Caption := '0';
  RMinValueLabel.Visible := True;

  GMaxTBar.Hint := 'Magenta';
  GMaxTBar.Min := -255;
  GMaxTBar.Max := 255;
  GMaxTBar.Position := 0;
  GMaxTBar.Pagesize := ((GMaxTBar.Max) + 1 + abs(GMaxTBar.Min)) div
    10;
  GMaxTBar.Linesize := 1;
  GMaxTBar.Frequency := GMaxTBar.Pagesize;
  GMaxTBar.Visible := True;
  GMaxTBar.Enabled := True;

  GMaxLabel.Caption := 'Mg';
  GMaxLabel.Visible := True;
  GMaxValueLabel.Caption := '0';
  GMaxValueLabel.Visible := True;

  BlueMeanieTBar.Hint := 'Yellow';
  BlueMeanieTBar.Min := -255;
  BlueMeanieTBar.Max := 255;
  BlueMeanieTBar.Position := 0;
  BlueMeanieTBar.Pagesize := ((BlueMeanieTBar.Max) + 1 +
    abs(BlueMeanieTBar.Min)) div 10;
  BlueMeanieTBar.Linesize := 1;
  BlueMeanieTBar.Frequency := BlueMeanieTBar.Pagesize;
  BlueMeanieTBar.Visible := True;
  BlueMeanieTBar.Enabled := True;

  BlueMeanieLabel.Caption := 'Y';
  BlueMeanieLabel.Visible := True;
  BlueMeanieValueLabel.Caption := '0';
  PACRed := 10;
  PACGreen := 0;
  PACBlue := 0;
  BlueMeanieValueLabel.Visible := True;
  Application.ProcessMessages;
  HCReady := True;
end;


procedure TPixelAlgebraForm.HCYIQClick(Sender: TObject);
begin
  HCReady := False;
  HideSliders;
  WhichHis := 15; {YIQ  3 bars -255..255 }
{CheckBoxMonochrome.Enabled:=True;
RadioGroupColorPlane.Enabled:=True;
RadioGroupColorPlane.Visible:=True;
ColorPlaneSetup;}
  AllTogetherCB.Enabled := True;
  AllTogetherCB.Visible := True;
  ProcessSliderBtn.Enabled := True;
  ProcessSliderBtn.Visible := True;
  ButtonCommandCB.Enabled := True;
  ButtonCommandCB.Visible := True;

  RMinTBar.Hint := 'Y';
  RMinTBar.Min := -255;
  RMinTBar.Max := 255;
  RMinTBar.Position := 0;
  RMinTBar.Pagesize := ((RMinTBar.Max) + 1 + abs(RMinTBar.Min)) div
    10;
  RMinTBar.Linesize := 1;
  RMinTBar.Frequency := RMinTBar.Pagesize;
  RMinTBar.Visible := True;
  RMinTBar.Enabled := True;

  RMinLabel.Caption := 'Y';
  RMinLabel.Visible := True;
  RMinValueLabel.Caption := '0';
  RMinValueLabel.Visible := True;

  GMaxTBar.Hint := 'I';
  GMaxTBar.Min := -255;
  GMaxTBar.Max := 255;
  GMaxTBar.Position := 0;
  GMaxTBar.Pagesize := ((GMaxTBar.Max) + 1 + abs(GMaxTBar.Min)) div
    10;
  GMaxTBar.Linesize := 1;
  GMaxTBar.Frequency := GMaxTBar.Pagesize;
  GMaxTBar.Visible := True;
  GMaxTBar.Enabled := True;

  GMaxLabel.Caption := 'I';
  GMaxLabel.Visible := True;
  GMaxValueLabel.Caption := '0';
  GMaxValueLabel.Visible := True;

  BlueMeanieTBar.Hint := 'Q';
  BlueMeanieTBar.Min := -255;
  BlueMeanieTBar.Max := 255;
  BlueMeanieTBar.Position := 0;
  BlueMeanieTBar.Pagesize := ((BlueMeanieTBar.Max) + 1 +
    abs(BlueMeanieTBar.Min)) div 10;
  BlueMeanieTBar.Linesize := 1;
  BlueMeanieTBar.Frequency := BlueMeanieTBar.Pagesize;
  BlueMeanieTBar.Visible := True;
  BlueMeanieTBar.Enabled := True;

  BlueMeanieLabel.Caption := 'Q';
  BlueMeanieLabel.Visible := True;
  BlueMeanieValueLabel.Caption := '0';
  PACRed := 10;
  PACGreen := 0;
  PACBlue := 0;
  BlueMeanieValueLabel.Visible := True;
  Application.ProcessMessages;
  HCReady := True;
end;
(******************************************************)

procedure TPixelAlgebraForm.CheckBoxMonochromeClick(Sender: TObject);
begin
  ColorOutput := (not CheckBoxMonochrome.Checked);
end;
(******************************************************)

(******************************************************)
(******************************************************)

procedure TPixelAlgebraForm.DoLUTGraph;
var
  Area, TempMin, TempMax, TempRange, I, J, k, kSum: Integer;
  AreaWorking: array[0..256] of Integer;
begin
  case WhichHis of
{0 is RGB.. HCZeroClick back to original nothing}
    0: for I := 0 to 255 do
      begin
        LUTR[I] := I;
        LUTG[I] := I;
        LUTB[I] := I;
      end;
    1: begin { Min-Max}
  {RedMin,RedMax,RedMean,RedMedian,RedMode,RSum,RNum,RedRange,
  GreenMin,GreenMax,GreenMean,GreenMedian,GreenMode,GSum,GNum,GreenRange,
  BlueMin,BlueMax,BlueMean,BlueMedian,BlueMode,BSum,BNum,BlueRange:Integer;}
        for I := 0 to 255 do
          LUTR[I] := (((I - RedMin) / RedRange) * 256);
        for I := 0 to 255 do
          LUTG[I] := (((I - GreenMin) / GreenRange) * 256);
        for I := 0 to 255 do
          LUTB[I] := (((I - BlueMin) / BlueRange) * 256);
      end;
    2: begin {Histogram EQ... Stats Steps}
  {AREA: equal number of pixels per range}
        Area := (RSum div 255);
        for J := 0 to 255 - 1 do
        begin AreaWorking[J] := (Area * J); end;
        for J := 0 to 255 - 1 do
        begin
          kSum := 0;
          I := 1;
          k := (AreaWorking[J]);
          repeat
            kSum := (kSum + (I * CountR[I]));
            Inc(I);
          until kSum >= k;
          LUTR[J] := Round(I);
        end;
        LUTR[255] := 255;

        Area := (GSum div 255);
        for J := 0 to 255 - 1 do
        begin AreaWorking[J] := (Area * J); end;
        for J := 0 to 255 - 1 do
        begin
          kSum := 0;
          I := 1;
          k := (AreaWorking[J]);
          repeat
            kSum := (kSum + (I * CountG[I]));
            Inc(I);
          until kSum >= k;
          LUTG[J] := Round(I);
        end;
        LUTG[255] := 255;

        Area := (BSum div 255);
        for J := 0 to 255 - 1 do
        begin AreaWorking[J] := (Area * J); end;
        for J := 0 to 255 - 1 do
        begin
          kSum := 0;
          I := 1;
          k := (AreaWorking[J]);
          repeat
            kSum := (kSum + (I * CountB[I]));
            Inc(I);
          until kSum >= k;
          LUTB[J] := Round(I);
        end;
        LUTB[255] := 255;
      end;
    3: begin {Negative}
        for I := 0 to 255 do
        begin
          LUTR[I] := 255 - I;
          LUTG[I] := 255 - I;
          LUTB[I] := 255 - I;
        end;
      end;
    4: begin {gray scale.. computed in place}
         {Negative or gray? 2 Red=Green-Blue}{3 Luminance}{4 V of HSV}
        for I := 0 to 255 do
        begin
          LUTR[I] := 30 * I;
          LUTG[I] := 59 * I;
          LUTB[I] := 11 * I;
        end;
      end;

    5: begin {2 bars HCStretchLinear
  percentage linear  p.128... ends clipped per scrollbars}
        TempMin := 0;
        TempMax := 255;
        TempRange := (TempMax - TempMin);
        if TempRange = 0 then TempRange := 1;
        for I := 0 to 255 do
        begin
          LUTR[I] := ((((I - TempMin) + 0.01) / TempRange) * 256);
          LUTG[I] := ((((I - TempMin) + 0.01) / TempRange) * 256);
          LUTB[I] := ((((I - TempMin) + 0.01) / TempRange) * 256);
        end;
      end;
    6: begin { Sine 3 bar -255..255}
{  If PositiveCurveCB.Checked then TempRange:=1 else TempRange:=-1;
   For I:= 0 to 255 do
   begin
     LUTR[I]:= TempRange*I+((RMinTBar.Position)*sin(0.0245*I -3.14));
     LUTG[I]:= TempRange*I+((GMaxTBar.Position)*sin(0.0245*I -3.14));
     LUTB[I]:= TempRange*I+((BlueMeanieTBar.Position)*sin(0.0245*I -3.14));
   end;}
        for I := 0 to 255 do
        begin
          LUTR[I] := I + ((I) * sin(0.0245 * I - 3.14));
          LUTG[I] := I + ((I) * sin(0.0245 * I - 3.14));
          LUTB[I] := I + ((I) * sin(0.0245 * I - 3.14));
        end;
      end;
    7: begin {HCContrast  3 bar -255..255}
        for I := 0 to 255 do
        begin
          LUTR[I] := ((I) * cos(0.0245 * I - 3.14)) + I;
          LUTG[I] := ((I) * cos(0.0245 * I - 3.14)) + I;
          LUTB[I] := ((I) * cos(0.0245 * I - 3.14)) + I;
        end;
      end;

{Exponent Logs}
    8: begin {HCExponent  1..500 / 100= 0.01..5}
        for I := 0 to 255 do LUTR[I] := ((255 - I) / 10);
        for I := 0 to 255 do LUTG[I] := I + LUTR[I];
        for I := 0 to 255 do LUTB[I] := LUTG[I];
        for I := 0 to 255 do LUTR[I] := LUTG[I];
      end;
    9: begin { HCLog  Log 1..500 / 100= 0.01..5}
        begin
          LUTR[0] := 0;
          LUTG[0] := 0;
          LUTB[0] := 0;
          for I := 1 to 255 do LUTR[I] := I - (LUTR[I - 1] / 10);
          for I := 1 to 255 do LUTG[I] := LUTR[I];
          for I := 1 to 255 do LUTB[I] := LUTR[I];
        end
      end;
    10: begin {HCGamma RGB Gamma 1..500 / 100= 0.01..5}
        LUTR[0] := 0;
        LUTG[0] := 0;
        LUTB[0] := 0;
        for I := 1 to 255 do
          LUTR[I] := (((exp(ln(I) / (3 - (I / 100)))))) * 3.0;
{ LUTR[I]:=(((exp(ln(I)/(1+(I/100))))*2.0));}
{ (((exp(ln(I)/((I+0.1))))));}
        for I := 1 to 255 do LUTG[I] := LUTR[I];
        for I := 1 to 255 do LUTB[I] := LUTR[I];
      end;
  else {0}
    for I := 0 to 255 do
    begin
      LUTR[I] := I;
      LUTG[I] := I;
      LUTB[I] := I;
    end;
  end; {Case}
end;
(******************************************************)

(******************************************************)

procedure TPixelAlgebraForm.HCActivateColorClick(Sender: TObject);
var I: Integer;
begin
  HCReady := False;
  HideSliders;
  PACClearBtn.Enabled := True;
  PACUseColorSliceBtn.Enabled := True;
  PACLoadColorBins.Enabled := True;
  PACSaveColorBins.Enabled := True;
  PACColorCRG.Visible := True;
  PACDrawRG.Visible := True;
  PACCB.Visible := True;
  PACColorCRG.Enabled := True;
  PACDrawRG.Enabled := True;
  PACCB.Enabled := True;
  PACCB.ItemIndex := 0;
  PACCBItemIndex := 0;
  FunctionLabel.Visible := True;
  UseFunctionsBtn.Enabled := True;
  WhichHis := 16;
  SetLength(LUTActive, 256);
  PACUseColorSliceBtn.Enabled := True;
  for I := 0 to 255 do
  begin
    LUTActive[I] := I;
    LUTR[I] := I;
    LUTG[I] := I;
    LUTB[I] := I;
  end;
  with PACGraphImage do begin
    Canvas.Brush.Color := clWhite;
    Canvas.Brush.Style := bsSolid;
    PACGraphImage.Canvas.FillRect(Rect(0, 0, 255, 255));
  end;
  SetROP2(PACGraphImage.Canvas.handle, R2_COPYPEN);
  PACGraphImage.Canvas.Pen.Color := clGray;
  PACGraphImage.Canvas.moveto(0, 255 - Round(LUTActive[0]));
  for I := 1 to 255 do
    PACGraphImage.Canvas.lineto(I, 255 - Round(LUTActive[I]));
  CStartDrawing := True;
  WhoseLineIsIt := 0;
end;

procedure TPixelAlgebraForm.PACLoadColorBinsClick(Sender: TObject);
var
  I: Integer;
  LUTFile: file of Double;
  LUTTemp: Double;
begin
  OpenDialog1.InitialDir := ImagePath;
  if OpenDialog1.Execute then { Display Open dialog box }
  begin { File selected in dialog box }
    PACClearBtnClick(Self);
    AssignFile(LUTFile, OpenDialog1.FileName);
    Reset(LUTFile);

    for I := 0 to 255 do
    begin Read(LUTFile, LUTTemp); LUTR[I] := LUTTemp; end;
    for I := 0 to 255 do
    begin Read(LUTFile, LUTTemp); LUTG[I] := LUTTemp; end;
    for I := 0 to 255 do
    begin Read(LUTFile, LUTTemp); LUTB[I] := LUTTemp; end;
    CloseFile(LUTFile);

    SetROP2(PACGraphImage.Canvas.handle, R2_COPYPEN);
    for I := 0 to 255 do LUTActive[I] := LUTG[I];
    PACGraphImage.Canvas.Pen.Color := clGreen;
    PACGraphImage.Canvas.moveto(0, 255 - Round(LUTActive[0]));
    for I := 1 to 255 do
      PACGraphImage.Canvas.lineto(I, 255 - Round(LUTActive[I]));
    for I := 0 to 255 do LUTActive[I] := LUTB[I];
    PACGraphImage.Canvas.Pen.Color := clBlue;
    PACGraphImage.Canvas.moveto(0, 255 - Round(LUTActive[0]));
    for I := 1 to 255 do
      PACGraphImage.Canvas.lineto(I, 255 - Round(LUTActive[I]));
    for I := 0 to 255 do LUTActive[I] := LUTR[I];
    PACGraphImage.Canvas.Pen.Color := clRed;
    PACGraphImage.Canvas.moveto(0, 255 - Round(LUTActive[0]));
    for I := 1 to 255 do
      PACGraphImage.Canvas.lineto(I, 255 - Round(LUTActive[I]));
    CStartDrawing := True;
    WhoseLineIsIt := 1;
    PACColorCRG.ItemIndex := 1;
  end;
end;

procedure TPixelAlgebraForm.PACSaveColorBinsClick(Sender: TObject);
var
  I: Integer;
  LUTFile: file of Double;
  LUTTemp: Double;
begin {Save Color Bins}
  SaveDialog1.InitialDir := ImagePath;
  if SaveDialog1.Execute then { Display Open dialog box }
  begin
{Load any transient values}
    case WhoseLineIsIt of
      0:
        for I := 0 to 255 do
        begin
          LUTR[I] := LUTActive[I];
          LUTG[I] := LUTActive[I];
          LUTB[I] := LUTActive[I];
        end;
      1: begin
          for I := 0 to 255 do LUTR[I] := LUTActive[I];
        end;
      2: begin
          for I := 0 to 255 do LUTG[I] := LUTActive[I];
        end;
      3: begin
          for I := 0 to 255 do LUTB[I] := LUTActive[I];
        end;
    end;

  {actually load File selected in dialog box }
    AssignFile(LUTFile, SaveDialog1.FileName);
    Rewrite(LUTFile);
    for I := 0 to 255 do
    begin LUTTemp := LUTR[I]; Write(LUTFile, LUTTemp); end;
    for I := 0 to 255 do
    begin LUTTemp := LUTG[I]; Write(LUTFile, LUTTemp); end;
    for I := 0 to 255 do
    begin LUTTemp := LUTB[I]; Write(LUTFile, LUTTemp); end;
    CloseFile(LUTFile);
  end;
end;


procedure TPixelAlgebraForm.PACCBChange(Sender: TObject);
begin
  PACCBItemIndex := PACCB.ItemIndex;
  UseFunctionsBtn.Caption := 'Use Function: ' +
    IntToStr(PACCBItemIndex);
end;


procedure TPixelAlgebraForm.UseFunctionsBtnClick(Sender: TObject);
var
  I: Integer;
  R_Filtered, G_Filtered, B_Filtered, PAC_Filtered: Double;
begin
{Similar to LOAD}
  PACClearBtnClick(Self);
  WhichHis := PACCBItemIndex;
  DoLUTGraph;
  WhichHis := 16;
  if (PACCB.ItemIndex = 4) then
  begin {complete gray}
    for I := 0 to 255 do
    begin
      R_Filtered := LUTR[I];
      G_Filtered := LUTG[I];
      B_Filtered := LUTB[I];
      PAC_Filtered := ((0.001 + R_Filtered + G_Filtered + B_Filtered)
        / 100);
      LUTR[I] := PAC_Filtered;
      LUTG[I] := PAC_Filtered;
      LUTB[I] := PAC_Filtered;
    end;
  end;
  for I := 0 to 255 do
  begin
    if (LUTR[I] < 0) then LUTR[I] := 0
    else if (LUTR[I] > 255) then LUTR[I] := 255;
    if (LUTG[I] < 0) then LUTG[I] := 0
    else if (LUTG[I] > 255) then LUTG[I] := 255;
    if (LUTB[I] < 0) then LUTB[I] := 0
    else if (LUTB[I] > 255) then LUTB[I] := 255;
  end;

  SetROP2(PACGraphImage.Canvas.handle, R2_COPYPEN);
  for I := 0 to 255 do LUTActive[I] := LUTG[I];
  PACGraphImage.Canvas.Pen.Color := clGreen;
  PACGraphImage.Canvas.moveto(0, 255 - Round(LUTActive[0]));
  for I := 1 to 255 do
    PACGraphImage.Canvas.lineto(I, 255 - Round(LUTActive[I]));

  for I := 0 to 255 do LUTActive[I] := LUTB[I];
  PACGraphImage.Canvas.Pen.Color := clBlue;
  PACGraphImage.Canvas.moveto(0, 255 - Round(LUTActive[0]));
  for I := 1 to 255 do
    PACGraphImage.Canvas.lineto(I, 255 - Round(LUTActive[I]));

  for I := 0 to 255 do LUTActive[I] := LUTR[I];
  WhoseLineIsIt := 1;
  PACColorCRG.ItemIndex := 1;
  PACGraphImage.Canvas.Pen.Color := clRed;
  PACGraphImage.Canvas.moveto(0, 255 - Round(LUTActive[0]));
  for I := 1 to 255 do
    PACGraphImage.Canvas.lineto(I, 255 - Round(LUTActive[I]));
end;

procedure TPixelAlgebraForm.PACClearBtnClick(Sender: TObject);
var I: Integer;
begin
  CStartDrawing := True;
  CDrawing := False;
  WhoseLineIsIt := 0;
  PACColorCRG.ItemIndex := 0;
  PACGraphImage.Canvas.Pen.Color := clGray;
  PACDrawRG.ItemIndex := 0;

  for I := 0 to 255 do
  begin
    LUTActive[I] := I;
    LUTR[I] := I;
    LUTG[I] := I;
    LUTB[I] := I;
  end;
  with PACGraphImage do begin
    Canvas.Brush.Color := clWhite;
    Canvas.Brush.Style := bsSolid;
    Canvas.FillRect(Rect(0, 0, 255, 255));
  end;
{    SetROP2(PACGraphImage.Canvas.handle, R2_NOT);}
{    PACGraphImage.Canvas.moveto(0,255-Round(LUTActive[0]));
    For I:= 1 to 255 do
        PACGraphImage.Canvas.lineto(I,255-Round(LUTActive[I]));}
end;

procedure TPixelAlgebraForm.PACColorCRGClick(Sender: TObject);
var I: Integer;
begin
{Change Active Bins}
  case WhoseLineIsIt of
    0:
      for I := 0 to 255 do
      begin
        LUTR[I] := LUTActive[I];
        LUTG[I] := LUTActive[I];
        LUTB[I] := LUTActive[I];
        LUTActive[I] := I; {reset.. no use}
      end;
    1: begin
        for I := 0 to 255 do LUTR[I] := LUTActive[I];
      end;
    2: begin
        for I := 0 to 255 do LUTG[I] := LUTActive[I];
      end;
    3: begin
        for I := 0 to 255 do LUTB[I] := LUTActive[I];
      end;
  end;
  case PACColorCRG.ItemIndex of
    0: begin
        for I := 0 to 255 do LUTActive[I] := I;
        PACGraphImage.Canvas.Pen.Color := clGray;
        WhoseLineIsIt := 0;
      end;
    1: begin
        for I := 0 to 255 do LUTActive[I] := LUTR[I];
        PACGraphImage.Canvas.Pen.Color := clRed;
        WhoseLineIsIt := 1;
      end;
    2: begin
        for I := 0 to 255 do LUTActive[I] := LUTG[I];
        PACGraphImage.Canvas.Pen.Color := clGreen;
        WhoseLineIsIt := 2;
      end;
    3: begin
        for I := 0 to 255 do LUTActive[I] := LUTB[I];
        PACGraphImage.Canvas.Pen.Color := clBlue;
        WhoseLineIsIt := 3;
      end;
  end; {Case}
end;

procedure TPixelAlgebraForm.PACGraphImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{  var I:Integer;}
begin
  if (CStartDrawing) then begin {Activation  turns on}
    if (not CDrawing) then begin {once per mouse line}
      CDrawing := True;
{Clear old stuff}
      with PACGraphImage do begin
        Canvas.Brush.Color := clWhite;
        Canvas.Brush.Style := bsSolid;
        Canvas.FillRect(Rect(0, 0, 255, 255));
      end;
{    PACGraphImage.Canvas.moveto(0,255-Round(LUTActive[0]));
    For I:= 1 to 255 do
        PACGraphImage.Canvas.lineto(I,255-Round(LUTActive[I]));}
{If a color plane then draw ALL planes}

{Capture First Point capture as Needed Location 255-Y}
{  PACGraphImage.Canvas.moveto(X,255-Y); }
      CStartX := X; CStartY := 255 - Y;
      CLeftX := X; CLeftY := 255 - Y;
      CRightX := X; CRightY := 255 - Y;
      CpointStart.X := X;
      CpointStart.Y := 255 - Y;

      CpointEnd.X := X;
      CpointEnd.Y := 255 - Y;

      SetROP2(PACGraphImage.Canvas.handle, R2_NOT);
      DrawRubberband;
    end; end
end;

procedure TPixelAlgebraForm.PACGraphImageMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  PAColorLabel.Caption := 'X: ' + IntToStr(X) + ' Y: ' + IntToStr(255
    - Y);
  if CDrawing then begin
  {Capture moving points}
    DrawRubberband;
    CpointEnd.x := X;
    CpointEnd.y := 255 - Y;
    DrawRubberband;
  end
end;

procedure TPixelAlgebraForm.PACGraphImageMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if CDrawing then
  begin
{Capture last point and KEEP the DATA}
    CpointEnd.X := X;
    CpointEnd.Y := 255 - Y; {Pixel is the pen color.}
    SetROP2(PACGraphImage.Canvas.handle, R2_COPYPEN);
    with PACGraphImage do {Clear old lines}
    begin
      Canvas.Brush.Color := clWhite;
      Canvas.Brush.Style := bsSolid;
      Canvas.FillRect(Rect(0, 0, 255, 255));
    end;
    DrawRubberband; {redraw}
    CDrawing := False; {Turn off for next mouse down}
  end;
end;

{Y has been reversed so STORE !!! in LUT now}
{Select the Points according to Bin Values}
{    CpointStart.X := X;
    CpointStart.Y := Y;
    CpointEnd.X := X;
    CpointEnd.Y := Y;
CStartX:= X;CStartY:= Y;
CLeftX:= X;CLeftY:= Y;
CRightX:= X;CRightY:= Y;}

procedure TPixelAlgebraForm.DrawRubberband;
var I: Integer;
begin
{Bound the values}
  if (CpointEnd.X < 0) then CpointEnd.X := 0
  else if (CpointEnd.X > 255) then CpointEnd.X := 255;
  if (CpointEnd.Y < 0) then CpointEnd.Y := 0
  else if (CpointEnd.Y > 255) then CpointEnd.Y := 255;

  {Capture the values}
  if PACDrawRG.ItemIndex = 0 then
  begin {Line MOTOR}
    LUTActive[CpointEnd.X] := CpointEnd.Y;
  end else
    if PACDrawRG.ItemIndex = 1 then
    begin {STEPPER MOTOR}
      for I := 1 to CpointEnd.X do
      begin
        if (LUTActive[I] > CpointEnd.Y) then
          LUTActive[I] := CpointEnd.Y;
      end;
      for I := CpointEnd.X to 255 do
      begin
        if (LUTActive[I] < CpointEnd.Y) then
          LUTActive[I] := CpointEnd.Y;
      end;
    end else
    begin {old whatever}
      I := 0;
      if (I <= CpointEnd.X) then LUTActive[I] := CpointEnd.Y
      else if (LUTActive[I] <= I) then LUTActive[I] := I;
      for I := 1 to 255 do
      begin
        if (I >= CpointEnd.X) then
        begin
          if (I = CpointEnd.X) then LUTActive[I] := CpointEnd.Y;
          if (LUTActive[I] <= CpointEnd.Y) then
            LUTActive[I] := CpointEnd.Y;
        end;
      end;
    end;


  {Draw the graph}
  PACGraphImage.Canvas.moveto(0, 255 - Round(LUTActive[0]));
  for I := 1 to 255 do
    PACGraphImage.Canvas.lineto(I, 255 - Round(LUTActive[I]));
end;



procedure TPixelAlgebraForm.PACUseColorSliceBtnClick(Sender:
  TObject);
var I: Integer;
begin
  case WhoseLineIsIt of
    0:
      for I := 0 to 255 do
      begin
        LUTR[I] := LUTActive[I];
        LUTG[I] := LUTActive[I];
        LUTB[I] := LUTActive[I];
      end;
    1: begin
        for I := 0 to 255 do LUTR[I] := LUTActive[I];
      end;
    2: begin
        for I := 0 to 255 do LUTG[I] := LUTActive[I];
      end;
    3: begin
        for I := 0 to 255 do LUTB[I] := LUTActive[I];
      end;
  end;
{Apply Bins to Bitmap  PACImage}
  HCReady := False;
  HideSliders;
  WhichHis := 16;
  MakeHisHCImage;
end;
(******************************************************)
{LPRO commands
x^1.5
x^(1/2)
x^(2/3)
x<0.8?x:0.8+(x-0.8)/2
x*0.7+0.15
x/0.7-3/14
log(9*x+1,10)
log(4*x+1,5)
x<=0.5?sin(x*pi)/2:(sin(x*pi+pi)+1)/2+0.5}
(******************************************************)









end.
