unit rMagniForm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, GraphicEx,
  Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls, Buttons, Menus;

type
  TMagniForm = class(TForm)
    Panel1: TPanel;
    Image1: TImage;
    ColorDialog1: TColorDialog;
    Panel2: TPanel;
    ColorPanel: TPanel;
    LabelMagnifiation: TLabel;
    SpinEditMagnification: TSpinEdit;
    ShowXCB: TCheckBox;
    ExitButton: TSpeedButton;
    HelpBtn: TSpeedButton;
    BlockyPixelsCB: TCheckBox;
    PopupMenu1: TPopupMenu;
    VisibleCross1: TMenuItem;
    Transparent1: TMenuItem;
    N1: TMenuItem;
    BlockyPixels1: TMenuItem;
    efgPixels1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ShowMagnifier(xActual, yActual,X1,Y1: INTEGER);
    procedure HelpBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ExitButtonClick(Sender: TObject);
    procedure SpinEditMagnificationChange(Sender: TObject);
    procedure ColorPanelClick(Sender: TObject);
    procedure Transparent1Click(Sender: TObject);
    procedure VisibleCross1Click(Sender: TObject);
    procedure BlockyPixels1Click(Sender: TObject);
    procedure efgPixels1Click(Sender: TObject);
  private
    { Private declarations }
    MagniBitmap: TBitmap;
    efgPixelsOn,
    TransparencyOn :  BOOLEAN;
   { MagnifierSize:Integer;}
    {ViewMagniOn:  BOOLEAN; }
{    MagniBusy  :  BOOLEAN;}
  public
    { Public declarations }

  end;

var
  MagniForm: TMagniForm;

implementation

uses TongGlobals, TongsFrm;

{$R *.DFM}

//===========================================================================

procedure TMagniForm.FormCreate(Sender: TObject);
begin
  left := MagniFormX;
  top := MagniFormY;
  MagniBitmap := TBitmap.Create;
  MagniBitmap.Width := 128;
  MagniBitmap.Height := 128;
  MagniBitmap.PixelFormat := pf24bit;
  Image1.Picture.Graphic := MagniBitmap;
  Image1.Picture.Bitmap.Canvas.Pen.Color:=ColorPanel.Color;
  ShowXCB.Checked := True;
  TransparencyOn:= False;
  efgPixelsOn:= False;
  MagniForm.Formstyle := fsStayOnTop;
  MagnifierSize := (64 div SpinEditMagnification.Value);
end;
procedure TMagniForm.ColorPanelClick(Sender: TObject);
begin
  ColorDialog1.Color:= ColorPanel.Color;
  if ColorDialog1.Execute then
    ColorPanel.Color := ColorDialog1.Color;
  Image1.Picture.Bitmap.Canvas.Pen.Color:=ColorPanel.Color;
end;

procedure TMagniForm.ExitButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TMagniForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  MagniFormX := MagniForm.left;
  MagniFormY := MagniForm.top;
  TongsForm.ZoomWindow1.Checked := False;
  ViewMagniOn := False;
  Screen.Cursor := crDefault;
end;

procedure TMagniForm.FormDestroy(Sender: TObject);
begin
  MagniBitmap.Free
end;

procedure TMagniForm.HelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(5000);
end;

procedure TMagniForm.SpinEditMagnificationChange(Sender: TObject);
begin
  MagnifierSize := (64 div SpinEditMagnification.Value);
end;

procedure TMagniForm.ShowMagnifier(xActual, yActual,X1,Y1: INTEGER);
type
  pRGBTripleArray = ^TRGBTripleArray;
  TRGBTripleArray = array[0..65535] of TRGBTriple;
var
  i: INTEGER;
  j: INTEGER;
  MagCase, Magnifier: INTEGER;
  RowOriginal: pRGBTRipleArray;
  RowRotated: pRGBTRipleArray;
var
  ModBits,ModifiedBitmap: TBitmap;
begin
  MagCase:=SpinEditMagnification.Value;
  Magnifier := MagnifierSize * 2;
  // Copy original bitmap
  ModifiedBitmap := TBitmap.Create;
  ModifiedBitmap.Width := Magnifier;
  ModifiedBitmap.Height := Magnifier;
  ModifiedBitmap.PixelFormat := pf24bit;
  try
    Image1.Picture.Bitmap.Canvas.CopyMode := cmSrcCopy;
  // Step through each row of rotated image.
    If efgPixelsOn then
    begin
    for j := Magnifier - 1 downto 0 do
    begin
      RowRotated := ModifiedBitmap.Scanline[j];
      RowOriginal := TongsForm.Image1.Picture.Bitmap.Scanline[yActual+ j];
      for i := 0 to Magnifier - 1 do
      begin
        RowRotated[i] := RowOriginal[xActual + i]
      end;
    end;
    end else
    ModifiedBitmap.Canvas.CopyRect(
    {Dest}Rect(0,0,Magnifier,Magnifier),
    TongsForm.Image1.Canvas,
    {Source}Rect(xActual,yActual,xActual+Magnifier,yActual+Magnifier));

    If BlockyPixelsCB.Checked then
    begin
    Image1.Picture.Bitmap.Canvas.StretchDraw(Rect(
    0,0,128,128),ModifiedBitmap);
    end else
    begin
    ModBits:= TBitmap.Create;
    ModBits.PixelFormat := pf24bit;
        Stretch(128,128,
        TResamplingFilter(GraphexFilter), 0,
                          ModifiedBitmap,
                          ModBits);
    Image1.Canvas.Draw(0,0,ModBits);
    end;


    if ShowXCB.Checked then begin
{      SetROP2(Image1.Canvas.handle, R2_COPYPEN); }
{      SetROP2(Image1.Canvas.handle, R2_BLACK);}
If TransparencyOn then
  SetROP2(Image1.Canvas.handle, R2_NOT);
{2 lines ALWAYS}
(*
      Image1.Picture.Bitmap.Canvas.Moveto(63+X1, 0+Y1);
      Image1.Picture.Bitmap.Canvas.Lineto(63+X1, 61+Y1);
      Image1.Picture.Bitmap.Canvas.Moveto(64+X1, 0+Y1);
      Image1.Picture.Bitmap.Canvas.Lineto(64+X1, 61+Y1);
      Image1.Picture.Bitmap.Canvas.Moveto(65+X1, 0+Y1);
      Image1.Picture.Bitmap.Canvas.Lineto(65+X1, 61+Y1);

{X ACross at 63,64 , Y from 68 }
      Image1.Picture.Bitmap.Canvas.Moveto(63+X1, 68+Y1);
      Image1.Picture.Bitmap.Canvas.Lineto(63+X1, 128+Y1);
      Image1.Picture.Bitmap.Canvas.Moveto(64+X1, 68+Y1);
      Image1.Picture.Bitmap.Canvas.Lineto(64+X1, 128+Y1);
      Image1.Picture.Bitmap.Canvas.Moveto(65+X1, 68+Y1);
      Image1.Picture.Bitmap.Canvas.Lineto(65+X1, 128+Y1);

{X ACross to 60 , Y at 63 and 64}
      Image1.Picture.Bitmap.Canvas.Moveto(0+X1, 63+Y1);
      Image1.Picture.Bitmap.Canvas.Lineto(61+X1, 63+Y1);
      Image1.Picture.Bitmap.Canvas.Moveto(0+X1, 64+Y1);
      Image1.Picture.Bitmap.Canvas.Lineto(61+X1, 64+Y1);
      Image1.Picture.Bitmap.Canvas.Moveto(0+X1, 65+Y1);
      Image1.Picture.Bitmap.Canvas.Lineto(61+X1, 65+Y1);

{X ACross from 68 , Y at 63 and 64}
      Image1.Picture.Bitmap.Canvas.Moveto(68+X1, 63+Y1);
      Image1.Picture.Bitmap.Canvas.Lineto(128+X1, 63+Y1);
      Image1.Picture.Bitmap.Canvas.Moveto(68+X1, 64+Y1);
      Image1.Picture.Bitmap.Canvas.Lineto(128+X1, 64+Y1);
      Image1.Picture.Bitmap.Canvas.Moveto(68+X1, 65+Y1);
      Image1.Picture.Bitmap.Canvas.Lineto(128+X1, 65+Y1);
*)
For i := 1 to MagCase do
begin
{Y Vertical }
      Image1.Picture.Bitmap.Canvas.Moveto(64+X1-i+MagCase, 0+Y1);
      Image1.Picture.Bitmap.Canvas.Lineto(64+X1-i+MagCase, 64+Y1{-MagCase});
      Image1.Picture.Bitmap.Canvas.Moveto(64+X1-i+MagCase, 64+Y1+MagCase);
      Image1.Picture.Bitmap.Canvas.Lineto(64+X1-i+MagCase, 128+Y1);

{Draw X Horizontal line}
      Image1.Picture.Bitmap.Canvas.Moveto(0+X1, 64+Y1-i+MagCase);
      Image1.Picture.Bitmap.Canvas.Lineto(64+X1{-MagCase}, 64+Y1-i+MagCase);
      Image1.Picture.Bitmap.Canvas.Moveto(64+X1+MagCase, 64+Y1-i+MagCase);
      Image1.Picture.Bitmap.Canvas.Lineto(128+X1, 64+Y1-i+MagCase);
end;
If TransparencyOn then
      SetROP2(Image1.Canvas.handle, R2_COPYPEN);
    end;
  finally
    ModifiedBitmap.Free
  end
end {ShowMagnifier};

(*
  { Binary raster ops }
  {$EXTERNALSYM R2_BLACK}
  R2_BLACK       = 1;     {  0   }
  {$EXTERNALSYM R2_NOTMERGEPEN}
  R2_NOTMERGEPEN = 2;     { DPon }
  {$EXTERNALSYM R2_MASKNOTPEN}
  R2_MASKNOTPEN  = 3;     { DPna }
  {$EXTERNALSYM R2_NOTCOPYPEN}
  R2_NOTCOPYPEN  = 4;     { PN   }
  {$EXTERNALSYM R2_MASKPENNOT}
  R2_MASKPENNOT  = 5;     { PDna }
  {$EXTERNALSYM R2_NOT}
  R2_NOT         = 6;     { Dn   }
  {$EXTERNALSYM R2_XORPEN}
  R2_XORPEN      = 7;     { DPx  }
  {$EXTERNALSYM R2_NOTMASKPEN}
  R2_NOTMASKPEN  = 8;     { DPan }
  {$EXTERNALSYM R2_MASKPEN}
  R2_MASKPEN     = 9;     { DPa  }
  {$EXTERNALSYM R2_NOTXORPEN}
  R2_NOTXORPEN   = 10;    { DPxn }
  {$EXTERNALSYM R2_NOP}
  R2_NOP         = 11;    { D    }
  {$EXTERNALSYM R2_MERGENOTPEN}
  R2_MERGENOTPEN = 12;    { DPno }
  {$EXTERNALSYM R2_COPYPEN}
  R2_COPYPEN     = 13;    { P    }
  {$EXTERNALSYM R2_MERGEPENNOT}
  R2_MERGEPENNOT = 14;    { PDno }
  {$EXTERNALSYM R2_MERGEPEN}
  R2_MERGEPEN    = 15;    { DPo  }
  {$EXTERNALSYM R2_WHITE}
  R2_WHITE       = $10;   {  1   }
  {$EXTERNALSYM R2_LAST}
  R2_LAST        = $10;


 { Ternary raster operations }
  {$EXTERNALSYM SRCCOPY}
  SRCCOPY     = $00CC0020;     { dest = source                    }
  {$EXTERNALSYM SRCPAINT}
  SRCPAINT    = $00EE0086;     { dest = source OR dest            }
  {$EXTERNALSYM SRCAND}
  SRCAND      = $008800C6;     { dest = source AND dest           }
  {$EXTERNALSYM SRCINVERT}
  SRCINVERT   = $00660046;     { dest = source XOR dest           }
  {$EXTERNALSYM SRCERASE}
  SRCERASE    = $00440328;     { dest = source AND (NOT dest )    }
  {$EXTERNALSYM NOTSRCCOPY}
  NOTSRCCOPY  = $00330008;     { dest = (NOT source)              }
  {$EXTERNALSYM NOTSRCERASE}
  NOTSRCERASE = $001100A6;     { dest = (NOT src) AND (NOT dest)  }
  {$EXTERNALSYM MERGECOPY}
  MERGECOPY   = $00C000CA;     { dest = (source AND pattern)      }
  {$EXTERNALSYM MERGEPAINT}
  MERGEPAINT  = $00BB0226;     { dest = (NOT source) OR dest      }
  {$EXTERNALSYM PATCOPY}
  PATCOPY     = $00F00021;     { dest = pattern                   }
  {$EXTERNALSYM PATPAINT}
  PATPAINT    = $00FB0A09;     { dest = DPSnoo                    }
  {$EXTERNALSYM PATINVERT}
  PATINVERT   = $005A0049;     { dest = pattern XOR dest          }
  {$EXTERNALSYM DSTINVERT}
  DSTINVERT   = $00550009;     { dest = (NOT dest)                }
  {$EXTERNALSYM BLACKNESS}
  BLACKNESS   = $00000042;     { dest = BLACK                     }
  {$EXTERNALSYM WHITENESS}
  WHITENESS   = $00FF0062;     { dest = WHITE                     }


*)








procedure TMagniForm.Transparent1Click(Sender: TObject);
begin
 TransparencyOn:= not TransparencyOn;
end;

procedure TMagniForm.VisibleCross1Click(Sender: TObject);
begin
  ShowXCB.Checked := (not ShowXCB.Checked);
end;

procedure TMagniForm.BlockyPixels1Click(Sender: TObject);
begin
  BlockyPixelsCB.Checked := (not BlockyPixelsCB.Checked);
end;

procedure TMagniForm.efgPixels1Click(Sender: TObject);
begin
 efgPixelsOn:= not efgPixelsOn;
 If efgPixelsOn then MagniForm.Caption :='Magnefgico'
 else  MagniForm.Caption :='Magnifico';
end;

end.
