unit rOverViewFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs,
  ExtCtrls;

type
  TOverViewForm = class(TForm)
    OVImage: TImage;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
procedure CreateImage;
    procedure OVImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure OVImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure OVImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    OverCroppingOn, OverViewOn:Boolean;
    WidthSize,
    HeightSize,
    OVImageBitmapWidth,
    OVImageBitmapHeight:Integer;
    WidthRat, HeightRat:Double;
procedure DrawRubberband;
  public
    { Public declarations }
  end;

var
  OverViewForm: TOverViewForm;

implementation
uses  TongGlobals, TongsFrm;
{$R *.DFM}

procedure TOverViewForm.FormCreate(Sender: TObject);
begin
  left := OverViewFormX;
  top := OverViewFormY;
  OverCroppingOn := False;
  OverViewOn := False;
  OVImageBitmapWidth:=0;
  OVImageBitmapHeight:=0;
end;

procedure TOverViewForm.FormShow(Sender: TObject);
begin
  OverViewForm.Caption:='Over View';
end;

procedure TOverViewForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  OverViewFormX := OverViewForm.left;
  OverViewFormY := OverViewForm.top;
end;

procedure TOverViewForm.OVImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin   {ssAlt (ssCtrl in shift)and (ssShift in shift)}
  if ((ssCtrl in shift)) then
  begin
    OverCroppingOn := True;
    Screen.Cursor := crNone;
        if ((X > 0) and (X < OVImageBitmapWidth)) then
          pointStart.X := X else pointStart.X := 0;
        if ((Y > 0) and (Y < OVImageBitmapHeight)) then
          pointStart.Y := Y else pointStart.Y := 0;
      pointEnd.X := (pointStart.X + WidthSize);
      pointEnd.Y := (pointStart.Y + HeightSize);
      DrawRubberband;
  end else
  if button = mbLeft then
  begin
      OverViewOn := True;
      Screen.Cursor := crNone;
      if ((X > 0) and (X < (OVImageBitmapWidth - WidthSize))) then
        pointStart.X := X else pointStart.X := 0;
      if ((Y > 0) and (Y < (OVImageBitmapHeight - HeightSize))) then
        pointStart.Y := Y else pointStart.Y := 0;
      pointEnd.X := (pointStart.X + WidthSize);
      pointEnd.Y := (pointStart.Y + HeightSize);
      DrawRubberband;
  end;
end;

procedure TOverViewForm.OVImageMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  if OverCroppingOn then
  begin
    DrawRubberband;
    if ((X > pointStart.X) and (X < OVImageBitmapWidth)) then
      pointEnd.X := X else pointEnd.X := pointEnd.X;
    if ((Y > pointStart.Y) and (Y < OVImageBitmapHeight)) then
      pointEnd.Y := Y else pointEnd.Y := pointEnd.Y;
    OverViewForm.Caption:='X: '+
      Inttostr( Round(pointStart.X*WidthRat))+'..'+
      Inttostr( Round(pointEnd.X*WidthRat))+' Y: '+
      Inttostr( Round(pointStart.Y*HeightRat))+'..'+
      Inttostr( Round(pointEnd.Y*HeightRat));
    DrawRubberband;
  end else
  if (OverViewOn) then
  begin
      DrawRubberband;
      if ((X > 0) and (X < (OVImageBitmapWidth - WidthSize))) then
        pointStart.X := X else pointStart.X := 0;
      if ((Y > 0) and (Y < (OVImageBitmapHeight - HeightSize))) then
        pointStart.Y := Y else pointStart.Y := 0;
      pointEnd.X := (pointStart.X + WidthSize);
      pointEnd.Y := (pointStart.Y + HeightSize);
      DrawRubberband;
  end;
end;

procedure TOverViewForm.OVImageMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if OverCroppingOn then
  begin
    DrawRubberband;
    OverCroppingOn := False;
    {Get Sizes and change image}
    if (((pointEnd.Y) > pointStart.Y + 23)
      and ((pointEnd.X) > pointStart.X + 23)) then
    begin
      pointStart.X:= Round(pointStart.X*WidthRat);
      pointEnd.X:= Round(pointEnd.X*WidthRat);
      pointStart.Y:= Round(pointStart.Y*HeightRat);
      pointEnd.Y:= Round(pointEnd.Y*HeightRat);
      TongsForm.Cropola;
      OverViewForm.Close; {No longer valid}
    end else
    begin
      OverViewForm.Caption:='Over View';
      showmessage('Too small');
    end;
  end else
  if (OverViewOn) then
  begin
    OverViewOn := False;
    DrawRubberband;
    ViewCursorOn := False;
    Screen.Cursor := crDefault;
    TongsForm.ScrollBox1.HorzScrollBar.Position:=Round(x*WidthRat);
    TongsForm.ScrollBox1.VertScrollBar.Position:=Round(y*HeightRat);
  end
end;

procedure TOverViewForm.CreateImage;
var
  OVImageBitmap:TBitmap;
  AspectRatio: Single;
  OutputWidth, OutputHeight: Single;
begin
  OVImageBitmap := TBitmap.Create;
  OVImageBitmap.Width:=OVImage.Width;
  OVImageBitmap.Height:=OVImage.Height;
  OVImageBitmap.PixelFormat := pf24bit; // Force This
  OVImage.Picture.Bitmap.Assign(OVImageBitmap);
  FillRect(OVImage.Picture.Bitmap.Canvas.Handle,
            ClientRect,
            COLOR_BTNFACE + 1);
    OutputWidth := TongsForm.Image1.Picture.Bitmap.Width;
    OutputHeight := TongsForm.Image1.Picture.Bitmap.Height;
    AspectRatio := OutputWidth / OutputHeight;
    if (OutputWidth < OVImage.Width) and
      (OutputHeight < OVImage.Height) then
    begin
      if OutputWidth < OutputHeight then
      begin
        OutputHeight := OVImage.Height;
        OutputWidth := OutputHeight * AspectRatio;
      end
      else
      begin
        OutputWidth := OVImage.Width;
        OutputHeight := OutputWidth / AspectRatio;
      end
    end;
    if OutputWidth > OVImage.Width then
    begin
      OutputWidth := OVImage.Width;
      OutputHeight := OutputWidth / AspectRatio;
    end;
    if OutputHeight > OVImage.Height then
    begin
      OutputHeight := OVImage.Height;
      OutputWidth := OutputHeight * AspectRatio;
    end;
  OVImage.Canvas.StretchDraw(Rect(0,0,
      Trunc(OutputWidth), Trunc(OutputHeight)),
      TongsForm.Image1.Picture.Graphic);
  OVImageBitmapWidth:=Trunc(OutputWidth);
  OVImageBitmapHeight:=Trunc(OutputHeight);
    WidthRat := TongsForm.Image1.Picture.Bitmap.Width/OVImageBitmapWidth;
    HeightRat := TongsForm.Image1.Picture.Bitmap.Height/OVImageBitmapHeight;
  WidthSize := Round(TongsForm.ScrollBox1.Width/WidthRat);
  HeightSize := Round(TongsForm.ScrollBox1.Height/HeightRat);
  OVImageBitmap.Free;
  {showmessage(inttostr(WidthSize)+ ' , '+ inttostr(HeightSize));}
end;

procedure TOverViewForm.DrawRubberband;
begin
  SetROP2(OVImage.Canvas.handle, R2_NOT);
  OVImage.Canvas.moveto(pointStart.x, pointStart.y);
  OVImage.Canvas.lineto(pointStart.x, pointEnd.y);
  OVImage.Canvas.lineto(pointEnd.x, pointEnd.y);
  OVImage.Canvas.lineto(pointEnd.x, pointStart.y);
  OVImage.Canvas.lineto(pointStart.x, pointStart.y);
end;





end.
