unit t3de;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, GLScene, GLObjects, GLWin32Viewer, GLMisc, GLTexture, GLContext,
  Texture_3D_Unit,
  OpenGL1x, VectorGeometry, GLCadencer, ExtCtrls, StdCtrls, ComCtrls,
  Buttons, Menus;

type
  Tt3dForm = class(TForm)
    GLScene1: TGLScene;
    GLSceneViewer1: TGLSceneViewer;
    GLCamera1: TGLCamera;
    GLDummyCube1: TGLDummyCube;
    GLDirectOpenGL1: TGLDirectOpenGL;
    GLCadencer1: TGLCadencer;
    Timer1: TTimer;
    Panel1: TPanel;
    MinTrackBar: TTrackBar;
    MaxTrackBar: TTrackBar;
    MinLabel: TLabel;
    MaxLabel: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    SliceOnCB: TCheckBox;
    SliceTrackBar: TTrackBar;
    SliceLabel: TLabel;
    CheckBox2: TCheckBox;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Panel2: TPanel;
    ColorDialog1: TColorDialog;
    SpeedButton1: TSpeedButton;
    OpenDialog1: TOpenDialog;
    InVisibleUpDown: TUpDown;
    InVisibleEdit: TEdit;
    procedure GLDirectOpenGL1Render(var rci: TRenderContextInfo);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure GLSceneViewer1MouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure GLCadencer1Progress(Sender: TObject; const deltaTime,
      newTime: Double);
    procedure Timer1Timer(Sender: TObject);
    procedure MinTrackBarChange(Sender: TObject);
    procedure MaxTrackBarChange(Sender: TObject);
    procedure SliceTrackBarChange(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure Panel2Click(Sender: TObject);
    procedure GLSceneViewer1MouseEnter(Sender: TObject);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SpeedButton1Click(Sender: TObject);
Procedure Calculate_Transfer_Function;
    procedure InVisibleUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
    tex3DHandleLoading,
    tex3DHandleLoaded:Boolean;
    INVISIBLE_THRESHOLD,
    mx, my : Integer;
    Diagonal:Single;
    M_3D_Texture : TGLTextureHandle;
    M_Input_Texture_3D : TTexture_3D;
    M_Output_Texture_3D : TTexture_3D;
  end;

var
  t3dForm: Tt3dForm;

implementation

{$R *.dfm}
uses  TongGlobals;//
Type
  P_Byte = ^Byte;
  P_Longword = ^Longword;

var
{    MyGlsPixelFormat :LongWord;
    texSizeX, texSizeY, texSizeZ:Integer; }

{    data : array of LongWord ;}
    LoadedFile:String;

Procedure Tt3dForm.Calculate_Transfer_Function;
Var
  X : Integer;
  Y : Integer;
  Z : Integer;
  Index : Integer;
  Value : Integer;
  Alpha : Integer;

Begin
  { Set texture values }
  For Z := 0 To M_Output_Texture_3D.Z_Size - 1 Do
    Begin { For }
      For Y := 0 To M_Output_Texture_3D.Y_Size - 1 Do
        Begin { For }
          For X := 0 To M_Output_Texture_3D.X_Size - 1 Do
            Begin { For }
              Index := (Z * M_Output_Texture_3D.Y_Size * M_Output_Texture_3D.X_Size) + (Y * M_Output_Texture_3D.X_Size) + X;
              Value := P_Byte (Integer (PChar (M_Input_Texture_3D.Data)) + Index)^ * 2;

              If {(Value < InVisibleUpDown.Position) Or }{(Y > Cutting_Plane_Pos_TB.Position) Or}
               (X = 0)
               Or (X = M_Output_Texture_3D.X_Size - 1)
               Or (Y = 0)
               Or (Y = M_Output_Texture_3D.Y_Size - 1)
               Or (Z = 0)
               Or (Z = M_Output_Texture_3D.Z_Size - 1) Then
                Begin { then }
                  Alpha := 0;
                End { then }
              Else
                Begin { else }
(*                  If Opaque_Hull_CB.Checked = TRUE Then
                    Begin { then }
                      Alpha := 255;
                    End { then }
                  Else   *)
                    Begin { else }
                      Alpha := Value;
                    End; { else }
                End; { else }

(*              If Pseudocolor_CB.Checked = TRUE Then
                Begin { then }
                  P_Longword (Integer (PChar (M_Output_Texture_3D.Data)) + (Index * 4))^ := M_Clut [Value];
                End { then }
              Else*)
                Begin { else }
                  P_Longword (Integer (PChar (M_Output_Texture_3D.Data)) + (Index * 4))^ := Value + (Value Shl 8) + (Value Shl 16);
                End; { else }

              P_Byte (Integer (PChar (M_Output_Texture_3D.Data)) + (Index * 4) + 3)^ := Alpha
            End; { For }
        End; { For }
    End; { For }
End;

procedure Tt3dForm.SpeedButton1Click(Sender: TObject);
{Var
  X : Integer;
  Y : Integer;
  Z : Integer;
  Index : Integer;
  BufV,Value : Longword;
  F: File of Longword;  }
begin
  GLCadencer1.Enabled:=False;
  OpenDialog1.Filter := 'tx3 files (*.tx3)|*.tx3';    
  If OpenDialog1.InitialDir='' then
  OpenDialog1.InitialDir:=ExtractFilePath(Application.exename);
{  Index :=0;}
  If tex3DHandleLoaded then M_3D_Texture.Free;
  tex3DHandleLoaded:=False;
  tex3DHandleLoading:=False;
  if OpenDialog1.Execute then          { Display Open dialog box }
  begin
    LoadedFile:=ExtractFileName(OpenDialog1.FileName);
    OpenDialog1.InitialDir:=ExtractFilePath(OpenDialog1.FileName);
  M_3D_Texture := TGLTextureHandle.Create;

  M_Input_Texture_3D := TTexture_3D.Create;
  M_Input_Texture_3D.Load_From_File (LoadedFile);

  M_Output_Texture_3D := TTexture_3D.Create;
  M_Output_Texture_3D.Data_Type := {M_Input_Texture_3D.Data_Type;}GL_RGBA;
  M_Output_Texture_3D.X_Size := M_Input_Texture_3D.X_Size;
  M_Output_Texture_3D.Y_Size := M_Input_Texture_3D.Y_Size;
  M_Output_Texture_3D.Z_Size := M_Input_Texture_3D.Z_Size;

  Calculate_Transfer_Function;
end;
  GLCadencer1.Enabled:=True;
  tex3DHandleLoading:=True;
end;
procedure Tt3dForm.GLDirectOpenGL1Render(var rci: TRenderContextInfo);
var
   i : Integer;
   step, z : Single;
   mat : TMatrix;
   v : TVector;
   vx, vy, vz : TAffineVector;
begin
  If tex3DHandleLoading then
  begin
    tex3DHandleLoading:=False;
    M_3D_Texture:=TGLTextureHandle.Create;
    M_3D_Texture.AllocateHandle;
    glBindTexture(GL_TEXTURE_3D, M_3D_Texture.Handle);
    glTexParameterf(GL_TEXTURE_3D, GL_TEXTURE_WRAP_S, GL_CLAMP);
    glTexParameterf(GL_TEXTURE_3D, GL_TEXTURE_WRAP_T, GL_CLAMP);
    glTexParameterf(GL_TEXTURE_3D, GL_TEXTURE_WRAP_R, GL_CLAMP);
    glTexParameteri(GL_TEXTURE_3D, GL_TEXTURE_MIN_FILTER,GL_LINEAR);
    glTexParameteri(GL_TEXTURE_3D, GL_TEXTURE_MAG_FILTER,GL_LINEAR);
    {glTexImage3DEXT: procedure(
     target: TGLenum;
     level: TGLint;
     internalformat: TGLenum;
     width, height, depth: TGLsizei;
     border: TGLint;
     Format, AType: TGLenum;
     pixels: Pointer); stdcall;}
{    glTexImage3DEXT(GL_TEXTURE_3D, 0, MyGlsPixelFormat, texSizeX, texSizeY, texSizeZ,
                      0, GL_RGBA, GL_UNSIGNED_BYTE, PByteArray(data));}
    glTexImage3DEXT (GL_TEXTURE_3D, 0, {M_Output_Texture_3D.Data_Type,}GL_RGBA,
    M_Output_Texture_3D.X_Size, M_Output_Texture_3D.Y_Size, M_Output_Texture_3D.Z_Size,
    0, M_Output_Texture_3D.Data_Type, GL_UNSIGNED_BYTE, PChar (M_Output_Texture_3D.Data));

{    Setlength(data,0);}
    MinTrackBar.Max:=M_Output_Texture_3D.Z_Size;
    MaxTrackBar.Max:=M_Output_Texture_3D.Z_Size;
    SliceTrackBar.Max :=M_Output_Texture_3D.Z_Size;
    SliceTrackBar.Position:= (M_Output_Texture_3D.Z_Size div 2);
    SliceOnCB.Checked:=False;
  {InVisibleUpDown.Position:=60;
  INVISIBLE_THRESHOLD:=InVisibleUpDown.Position;}
    tex3DHandleLoaded:=True;
  end;
  if tex3DHandleLoaded then
  begin

    glPushAttrib(GL_ENABLE_BIT);
    glPushMatrix;

    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glDisable(GL_CULL_FACE);
    glDisable(GL_LIGHTING);

    glTexGenf(GL_S, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR);
    glTexGenf(GL_T, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR);
    glTexGenf(GL_R, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR);
    SetVector(v, XVector, 0.5);
    glTexGenfv(GL_S, GL_OBJECT_PLANE, @v);
    SetVector(v, YVector, 0.5);
    glTexGenfv(GL_T, GL_OBJECT_PLANE, @v);
    SetVector(v, ZVector, 0.5);
    glTexGenfv(GL_R, GL_OBJECT_PLANE, @v);
    glEnable(GL_TEXTURE_GEN_S);
    glEnable(GL_TEXTURE_GEN_T);
    glEnable(GL_TEXTURE_GEN_R);

    glBindTexture(GL_TEXTURE_3D, M_3D_Texture.Handle);
    glEnable(GL_TEXTURE_3D);

    glGetFloatv(GL_MODELVIEW_MATRIX, @mat);
    vx[0]:=mat[0][0];  vy[0]:=mat[0][1];  vz[0]:=mat[0][2];
    vx[1]:=mat[1][0];  vy[1]:=mat[1][1];  vz[1]:=mat[1][2];
    vx[2]:=mat[2][0];  vy[2]:=mat[2][1];  vz[2]:=mat[2][2];
    ScaleVector(vx, diagonal*0.5/VectorLength(vx));
    ScaleVector(vy, diagonal*0.5/VectorLength(vy));

    Step:=diagonal/M_Output_Texture_3D.Z_Size;
    z:=-diagonal/2;
    glBegin(GL_QUADS);
    If SliceOnCB.Checked then
    begin
      z:=z+(step*SliceTrackBar.Position);
      glVertex3f( vx[0]+vy[0]+vz[0]*z, vx[1]+vy[1]+vz[1]*z, vx[2]+vy[2]+vz[2]*z);
      glVertex3f(-vx[0]+vy[0]+vz[0]*z,-vx[1]+vy[1]+vz[1]*z,-vx[2]+vy[2]+vz[2]*z);
      glVertex3f(-vx[0]-vy[0]+vz[0]*z,-vx[1]-vy[1]+vz[1]*z,-vx[2]-vy[2]+vz[2]*z);
      glVertex3f( vx[0]-vy[0]+vz[0]*z, vx[1]-vy[1]+vz[1]*z, vx[2]-vy[2]+vz[2]*z);
    end else
    for i:= MinTrackBar.Position to MaxTrackBar.Position do begin
      glVertex3f( vx[0]+vy[0]+vz[0]*z, vx[1]+vy[1]+vz[1]*z, vx[2]+vy[2]+vz[2]*z);
      glVertex3f(-vx[0]+vy[0]+vz[0]*z,-vx[1]+vy[1]+vz[1]*z,-vx[2]+vy[2]+vz[2]*z);
      glVertex3f(-vx[0]-vy[0]+vz[0]*z,-vx[1]-vy[1]+vz[1]*z,-vx[2]-vy[2]+vz[2]*z);
      glVertex3f( vx[0]-vy[0]+vz[0]*z, vx[1]-vy[1]+vz[1]*z, vx[2]-vy[2]+vz[2]*z);
      z:=z+step;
    end;
    glEnd;
    glPopMatrix;
    glPopAttrib;
  end;
end;

procedure Tt3dForm.FormCreate(Sender: TObject);
begin
  { Check for Capable Card}
  Assert (GL_EXT_texture3D, 'Graphic card does not support 3D textures.');
  GLCadencer1.Enabled:=False;
  tex3DHandleLoaded:=False;
  tex3DHandleLoading:=False;
  top := Tongt3dFormY;
  left := Tongt3dFormX;
  diagonal:=1.730000;
  LoadedFile:= 'Texture 3D';
end;
procedure Tt3dForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Tongt3dFormY := t3dForm.top;
  Tongt3dFormX := t3dForm.left;
end;
procedure Tt3dForm.FormDestroy(Sender: TObject);
begin
    If tex3DHandleLoaded then
    begin
      { tex3D.Free;}
      M_3D_Texture.Free;
      M_Input_Texture_3D.Free;
      M_Output_Texture_3D.Free;
    end;
end;

procedure Tt3dForm.GLSceneViewer1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   mx:=x; my:=y;
end;

procedure Tt3dForm.GLSceneViewer1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
   if ((ssLeft in Shift))then
     GLCamera1.MoveAroundTarget(my-y, mx-x);

  {You can move through the head... if positioned properly
  But the Dummy Cube will Bounce you past Infinity if you go past it}
  If Shift = [ssRight] Then
      GLCamera1.Position.AddScaledVector ((my - y) * 0.01, GLCamera1.AbsoluteVectorToTarget);
   if ((ssRight in Shift)and(ssShift in Shift))then
       GLDummyCube1.Position.Y:=GLDummyCube1.Position.Y+ ((my-y)* 0.01);
   if ((ssRight in Shift)and(ssCtrl in Shift))then
       GLDummyCube1.Position.X:=GLDummyCube1.Position.X+ ((mx-x)* 0.01);

  mx:=x; my:=y;
end;

procedure Tt3dForm.GLCadencer1Progress(Sender: TObject; const deltaTime,
  newTime: Double);
begin
   GLSceneViewer1.Invalidate;
end;

procedure Tt3dForm.Timer1Timer(Sender: TObject);
begin
   Caption:=LoadedFile+' : '+ GLSceneViewer1.FramesPerSecondText;
   GLSceneViewer1.ResetPerformanceMonitor;
end;

procedure Tt3dForm.MinTrackBarChange(Sender: TObject);
begin
  If MinTrackBar.Position > MaxTrackBar.Position then
   MinTrackBar.Position:=MaxTrackBar.Position-1;
  MinLabel.Caption:=Inttostr(MinTrackBar.Position);
end;

procedure Tt3dForm.MaxTrackBarChange(Sender: TObject);
begin
  If MaxTrackBar.Position < MinTrackBar.Position then
   MaxTrackBar.Position:=MinTrackBar.Position+1;
  MaxLabel.Caption:=Inttostr(MaxTrackBar.Position);
end;

procedure Tt3dForm.SliceTrackBarChange(Sender: TObject);
begin
  SliceLabel.Caption:=Inttostr(SliceTrackBar.Position);
end;

procedure Tt3dForm.CheckBox2Click(Sender: TObject);
begin
   GLDummyCube1.Visible:=CheckBox2.Checked;
end;

procedure Tt3dForm.Panel2Click(Sender: TObject);
begin
  ColorDialog1.Color:=Panel2.Color;
  if ColorDialog1.Execute then
  begin
    Panel2.Color := ColorDialog1.Color;
    GLSceneViewer1.Buffer.BackgroundColor:=
      Panel2.Color;
  end;
end;

procedure Tt3dForm.GLSceneViewer1MouseEnter(Sender: TObject);
begin
   GLSceneViewer1.SetFocus;
end;

procedure Tt3dForm.FormMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
begin
  Handled:=True; {Keep from affecting other controls}
end;

procedure Tt3dForm.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if key = VK_ESCAPE then close;
end;



procedure Tt3dForm.InVisibleUpDownClick(Sender: TObject; Button: TUDBtnType);
begin
  INVISIBLE_THRESHOLD:=InVisibleUpDown.Position;
end;



end.
