unit tOptionsForm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, ComCtrls;

type
  TOptionsForm = class(TForm)
    OpenDialog1: TOpenDialog;
    ColorDialog1: TColorDialog;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    RecordReader: TTabSheet;
    DotEdit: TEdit;
    SDTSEdit: TEdit;
    TigerEdit: TEdit;
    DXFEdit: TEdit;
    VectorDbEdit: TEdit;
    DLGEdit: TEdit;
    BaseImagesEdit: TEdit;
    ShapeEdit: TEdit;
    ProjectsEdit: TEdit;
    ProjectsBtn: TSpeedButton;
    ShapeBtn: TSpeedButton;
    BaseImagesBtn: TSpeedButton;
    DLGBtn: TSpeedButton;
    VectorDbBtn: TSpeedButton;
    DXFBtn: TSpeedButton;
    TigerBtn: TSpeedButton;
    SDTSBtn: TSpeedButton;
    DotBtn: TSpeedButton;
    Label3: TLabel;
    Label2: TLabel;
    Label50: TLabel;
    Label51: TLabel;
    Label25: TLabel;
    Label17: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label49: TLabel;
    Bevel1: TBevel;
    Label1: TLabel;
    InfoCB: TCheckBox;
    ConfirmationCB: TCheckBox;
    ErrorsCB: TCheckBox;
    WarningCB: TCheckBox;
    CompletionCB: TCheckBox;
    BeepOrWavCB: TCheckBox;
    Label4: TLabel;
    MessageXEdit: TEdit;
    MessageYEdit: TEdit;
    MessageBtn: TSpeedButton;
    POHelpBtn: TSpeedButton;
    POM_ResetMenuBtn: TSpeedButton;
    CloseBitBtn: TBitBtn;
    SelectionRadiusEdit: TEdit;
    Label7: TLabel;
    Panel1: TPanel;
    Label5: TLabel;
    Label6: TLabel;
    EditColorLabel: TLabel;
    Label8: TLabel;
    HighlightColorPanel: TPanel;
    BackgroundColorPanel: TPanel;
    EditColorPanel: TPanel;
    EditingColorPanel: TPanel;
    SaveDialog1: TSaveDialog;
    procedure POHelpBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure POM_ResetMenuBtnClick(Sender: TObject);
    procedure DXFBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CloseBitBtnClick(Sender: TObject);
    procedure Showem;
    procedure ProjectsBtnClick(Sender: TObject);
    procedure TigerBtnClick(Sender: TObject);
    procedure DotBtnClick(Sender: TObject);
    procedure SDTSBtnClick(Sender: TObject);
    procedure DLGBtnClick(Sender: TObject);
    procedure ShapeBtnClick(Sender: TObject);
    procedure VectorDbBtnClick(Sender: TObject);
    procedure BaseImagesBtnClick(Sender: TObject);
    procedure MessageBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BeepOrWavCBClick(Sender: TObject);
    procedure BackgroundColorPanelClick(Sender: TObject);
    procedure HighlightColorPanelClick(Sender: TObject);
    procedure EditColorPanelClick(Sender: TObject);
    procedure EditingColorPanelClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  OptionsForm: TOptionsForm;
{Color256S:Integer;}
implementation
{$R *.DFM}
uses LoGlobals, LoeditFrm,LOResMess, AllShapeLoaderFrm;


procedure TOptionsForm.FormCreate(Sender: TObject);
begin
  top := OptionsfrmY;
  left := OptionsfrmX;
  OpenDialog1.InitialDir := ProjectPath;
  SaveDialog1.InitialDir := ProjectPath;
end;

procedure TOptionsForm.FormShow(Sender: TObject);
begin
  Showem;
end;

procedure TOptionsForm.Showem;
var ShowString: string;
begin
{Set all the boxes and edits}
  EditingColorPanel.Color:=EditingColor;
  BackgroundColorPanel.Color:=BackgroundColor;
  HighlightColorPanel.Color:=HighlightColor;
  EditColorPanel.Color:=EditColor;
{  CurrentColorPanel.Color := CurrentColor;}
  ErrorsCB.Checked:=ErrorBeepOn;
  WarningCB.Checked:=WarningBeepOn;
  InfoCB.Checked:=InfoBeepOn;
  ConfirmationCB.Checked:=ConfirmBeepOn;
  CompletionCB.Checked:=CompletedBeepOn;
  str(MessageX, ShowString);
  MessageXEdit.Text := ShowString;
  str(MessageY, ShowString);
  MessageYEdit.Text := ShowString;
  ProjectsEdit.Text := ProjectPath;
  TigerEdit.Text := TigerPath;
  DotEdit.Text := DotPath;
  SDTSEdit.Text := SDTSPath;
  DLGEdit.Text := DLGPath;
  DXFEdit.Text := DXFPath;
  ShapeEdit.Text := ShapePath;
  VectorDbEdit.Text := VRMDatabase;
  BaseImagesEdit.Text := ImagePath;
end;
procedure TOptionsForm.BeepOrWavCBClick(Sender: TObject);
begin
  ErrorBeepOn := ErrorsCB.Checked;
  WarningBeepOn := WarningCB.Checked;
  InfoBeepOn := InfoCB.Checked;
  ConfirmBeepOn := ConfirmationCB.Checked;
  CompletedBeepOn := CompletionCB.Checked;
  VoicesON:=BeepOrWavCB.Checked;
end;
procedure TOptionsForm.POHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(3000);
end;

procedure TOptionsForm.CloseBitBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TOptionsForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
var code: Integer;
begin
  OptionsfrmY := OptionsForm.top;
  OptionsfrmX := OptionsForm.left;
  ErrorBeepOn := ErrorsCB.Checked;
  WarningBeepOn := WarningCB.Checked;
  InfoBeepOn := InfoCB.Checked;
  ConfirmBeepOn := ConfirmationCB.Checked;
  CompletedBeepOn := CompletionCB.Checked;
{Get the Message locations}
  val(MessageXEdit.Text, MessageX, Code);
  val(MessageYEdit.Text, MessageY, Code);
  val(SelectionRadiusEdit.Text, SelectionRadius, Code);
  DoSaver;
end;

procedure TOptionsForm.POM_ResetMenuBtnClick(Sender: TObject);
begin
  SelectionRadius:=8;
  CurrentColor := clBlack;
  EditingColor:=clFuchsia;
  BackgroundColor:=clWhite;
  HighlightColor:=clYellow;
  EditColor:=clRed;
  ErrorBeepOn := False;
  WarningBeepOn := False;
  InfoBeepOn := False;
  ConfirmBeepOn := False;
  CompletedBeepOn := False;
  MessageX := 123; MessageY := 123;
{Reset Directories defaults  }
  VRMProgramPath := ExtractFilePath(ParamStr(0));
  ProjectPath := VRMProgramPath;
  TigerPath := VRMProgramPath;
  DotPath := VRMProgramPath;
  SDTSPath := VRMProgramPath;
  DLGPath := VRMProgramPath;
  DXFPath := VRMProgramPath;
  ShapePath := VRMProgramPath;
  VRMDatabase := VRMProgramPath;
  ImagePath := VRMProgramPath;
  Showem;
end;

procedure TOptionsForm.ProjectsBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Project files (*.vrp)|*.vrp';
  OpenDialog1.InitialDir := ProjectPath;
  OpenDialog1.Filename:='';
  if OpenDialog1.execute then
  begin
    if (lowercase(ExtractFileExt(OpenDialog1.FileName)) = '.vrp')
      then
    ProjectPath := ExtractFilePath(OpenDialog1.filename);
    ProjectsEdit.Text := ProjectPath;
  end {else DoMessages(1)};
end;

procedure TOptionsForm.TigerBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Tiger files (*.*)|*.*';
  OpenDialog1.InitialDir := TigerPath;
  OpenDialog1.Filename:='';
  if OpenDialog1.execute then
  begin
{    if (lowercase(ExtractFileExt(OpenDialog1.FileName)) = '.x') then
    begin   }
    TigerPath := ExtractFilePath(OpenDialog1.filename);
    TigerEdit.Text := TigerPath;
  end; {else DoMessages(3);}
end;

procedure TOptionsForm.DotBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Dot files (*.*)|*.*';
  OpenDialog1.InitialDir := DotPath;
  OpenDialog1.Filename:='';
  if OpenDialog1.execute then
  begin
{    if (lowercase(ExtractFileExt(OpenDialog1.FileName)) = '.bmp')
      then
    begin }
      DotPath := ExtractFilePath(OpenDialog1.filename);
      DotEdit.Text := DotPath;
  end;{ else DoMessages(9);}
end;

procedure TOptionsForm.SDTSBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'SDTS files (*.*)|*.*';
  OpenDialog1.InitialDir := SDTSPath;
  OpenDialog1.Filename:='';
  if OpenDialog1.execute then
  begin
{    if (lowercase(ExtractFileExt(OpenDialog1.FileName)) = '.bmp')
      then
    begin  }
      SDTSPath := ExtractFilePath(OpenDialog1.filename);
      SDTSEdit.Text := SDTSPath;
  end;{ else DoMessages(4);}
end;

procedure TOptionsForm.DLGBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'DLG files (*.DLG)|*.DLG';
  OpenDialog1.InitialDir := DLGPath;
  OpenDialog1.Filename:='';
  if OpenDialog1.execute then
    if ((lowercase(ExtractFileExt(OpenDialog1.FileName)) = '.dlg')
      or (lowercase(ExtractFileExt(OpenDialog1.FileName)) = '.??f'))
      then
    begin
      DLGPath := ExtractFilePath(OpenDialog1.filename);
      DLGEdit.Text := DLGPath;
    end{ else DoMessages(10)};
end;

procedure TOptionsForm.DXFBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'dxf files (*.dxf)|*.dxf';
  OpenDialog1.InitialDir := DXFPath;
  OpenDialog1.Filename:='';
  if OpenDialog1.execute then
    if (lowercase(ExtractFileExt(OpenDialog1.FileName)) = '.dxf')
      then
    begin
      DXFPath := ExtractFilePath(OpenDialog1.filename);
      DXFEdit.Text := DXFPath;
    end {else DoMessages(11)};
end;

procedure TOptionsForm.ShapeBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Shape files (*.shp)|*.shp';
  OpenDialog1.Filename:='';
  OpenDialog1.InitialDir := ShapePath;
  if OpenDialog1.execute then
    if (lowercase(ExtractFileExt(OpenDialog1.FileName)) = '.shp')
      then
    begin
      ShapePath := ExtractFilePath(OpenDialog1.filename);
      ShapeEdit.Text := ShapePath;
    end {else DoMessages(8)};
end;

procedure TOptionsForm.VectorDbBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Database files (*.db)|*.db;*.dbf';
  OpenDialog1.InitialDir := VRMDatabase;
  OpenDialog1.Filename:='';
  if OpenDialog1.execute then
    if ((lowercase(ExtractFileExt(OpenDialog1.FileName)) = '.db')
      or (lowercase(ExtractFileExt(OpenDialog1.FileName)) = '.dbf'))
        then
    begin
      VRMDatabase := ExtractFilePath(OpenDialog1.filename);
      VectorDbEdit.Text := VRMDatabase;
    end {else DoMessages(12)};
end;

procedure TOptionsForm.BaseImagesBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Image files (*.bmp)|*.bmp';
  OpenDialog1.InitialDir := ImagePath;
  OpenDialog1.Filename:='';
  if OpenDialog1.execute then
    if (lowercase(ExtractFileExt(OpenDialog1.FileName)) = '.bmp')
      then
    begin
      ImagePath := ExtractFilePath(OpenDialog1.filename);
        BaseImagesEdit.Text := ImagePath;
    end {else DoMessages(13)};
end;

procedure TOptionsForm.MessageBtnClick(Sender: TObject);
begin
  DoRezInfo(9999);
end;



procedure TOptionsForm.BackgroundColorPanelClick(Sender: TObject);
begin
   ColorDialog1.Color:= BackgroundColorPanel.Color;
  if ColorDialog1.Execute then
  begin
    BackgroundColorPanel.Color := ColorDialog1.Color;
    BackgroundColor := ColorDialog1.Color;
  end;
end;

procedure TOptionsForm.HighlightColorPanelClick(Sender: TObject);
begin
    ColorDialog1.Color:=HighlightColorPanel.Color;
  if ColorDialog1.Execute then
  begin
    HighlightColorPanel.Color := ColorDialog1.Color;
    HighlightColor := ColorDialog1.Color;
  end;
end;

procedure TOptionsForm.EditColorPanelClick(Sender: TObject);
begin
    ColorDialog1.Color:=EditColor;
  if ColorDialog1.Execute then
  begin
    EditColorPanel.Color := ColorDialog1.Color;
    EditColor := ColorDialog1.Color;
  end;
end;

procedure TOptionsForm.EditingColorPanelClick(Sender: TObject);
begin
  ColorDialog1.Color:=EditingColor;
  if ColorDialog1.Execute then
  begin
    EditingColorPanel.Color := ColorDialog1.Color;
    EditingColor := ColorDialog1.Color;
  end;
end;




end.
